<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.maqmahelpdesk.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// Ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

JHTML::_('behavior.tooltip');
JHTML::_('behavior.modal', 'a.modal');
JHTML::_('stylesheet', 'reset.css', 'administrator/components/com_maqmahelpdesk/css/');
JHTML::_('stylesheet', 'admin.css', 'administrator/components/com_maqmahelpdesk/css/');
JHTML::_('stylesheet', 'uniform.default.css', 'administrator/components/com_maqmahelpdesk/css/');
JHTML::_('stylesheet', 'menu.css', 'administrator/components/com_maqmahelpdesk/css/');
JHTML::_('stylesheet', 'jquery.ui.css', 'administrator/components/com_maqmahelpdesk/css/');
JHTML::_('stylesheet', 'jquery.alerts.css', 'administrator/components/com_maqmahelpdesk/css/');
JHTML::_('stylesheet', 'gh-buttons.css', 'components/com_maqmahelpdesk/css/');

$mainframe = JFactory::getApplication();
$database = JFactory::getDBO();
$tmpl = JRequest::getCmd( 'tmpl', '', '', 'string' );
$format = JRequest::getCmd( 'format', '', '', 'string' );
$task = JRequest::getWord( 'task', '', '', 'string' );

$lang = JFactory::getLanguage();
$language_tag = $lang->getTag();
$lang->load( 'com_maqmahelpdesk', JPATH_SITE, $language_tag, true );
$lang->load( 'com_maqmahelpdesk.info', JPATH_SITE, $language_tag, true );

// Check version
ob_start();
include(JPATH_SITE.'/components/com_maqmahelpdesk/version.txt');
$installed = ob_get_contents();
ob_end_clean();
$current_version = $installed;
$version_updated = true;
$session = JFactory::getSession();
if( $session->get('current_version', '', 'maqmahelpdesk') == '' ) {
	if( function_exists('curl_init') ) {
		$process = curl_init('http://versions.imaqma.com/helpdesk.txt');
		curl_setopt($process, CURLOPT_HEADER, 0);
		curl_setopt($process, CURLOPT_ENCODING, 'gzip');
		curl_setopt($process, CURLOPT_TIMEOUT, 10);
		curl_setopt($process, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($process, CURLOPT_SSL_VERIFYPEER, false);
		@curl_setopt($process, CURLOPT_FOLLOWLOCATION, 1);
		@curl_setopt($process, CURLOPT_MAXREDIRS, 20);
		$current_version = curl_exec($process);
		curl_close($process);
		$session->set('current_version', $current_version, 'maqmahelpdesk');
	}
}else{
	$current_version = $session->get('current_version', '', 'maqmahelpdesk');
}
if( $installed != $current_version ) {
	$version_updated = false;
}

// Include files
require_once( JPATH_SITE.'/components/com_maqmahelpdesk/maqmahelpdesk.class.php' );
require_once( JPATH_SITE."/components/com_maqmahelpdesk/includes/common.php" );

if( $task != 'client_download' && $task != 'tickets_download' && $task != 'product_download' && $task != 'kb_download' && $tmpl != 'component' && $format != 'raw' ) { ?>
	<script type="text/javascript" src="<?php echo JURI::root();?>components/com_maqmahelpdesk/js/jquery-1.7.min.js"></script>
	<?php if( jversion15_check() ) : ?>
	<script type="text/javascript">var $jMaQma = $jMaQma.noConflict();</script>
	<?php endif; ?>
	<script type="text/javascript" src="<?php echo JURI::root();?>components/com_maqmahelpdesk/js/jquery-ui-1.8.16.custom.min.js"></script>
	<script type="text/javascript" src="<?php echo JURI::root();?>components/com_maqmahelpdesk/js/maqma.js"></script>
	<script type="text/javascript" src="<?php echo JURI::root();?>components/com_maqmahelpdesk/js/maqmahelpdesk.js"></script>
	<script type="text/javascript" src="<?php echo JURI::root();?>components/com_maqmahelpdesk/js/jquery.gritter.min.js"></script>
	<script type="text/javascript" src="<?php echo JURI::root();?>components/com_maqmahelpdesk/js/jquery.uniform.min.js"></script>
	<script type="text/javascript" src="<?php echo JURI::root();?>/components/com_maqmahelpdesk/js/jquery.alerts.js"></script>
	<script type="text/javascript" src="<?php echo JURI::root();?>administrator/components/com_maqmahelpdesk/js/jquery.dropdown.js"></script><?php
}

// Get config
$supportConfig = GetConfig();
$GLOBALS['supportConfig'] = $supportConfig;

// Set our location as front end for the global messages, f=front end, a=administration
$GLOBALS['sysmsgs_user_location'] = 'a';

// Get task and function
$task  = JRequest::getCmd( 'task', '', '', 'string' );
@list( $function, $task ) = explode( '_', $task, 2 );

if( $task == '' ) {
	$task = $function;
}

// Create a variable that saves the functions folder
$base_path = JPATH_SITE."/administrator/components/com_maqmahelpdesk";

$print = JRequest::getVar( 'print', 0, '', 'int' );

// Show print button
if( $print ) {
	print '<div align="right"><a href="javascript:;" onClick="javascript:window.print();">'.JText::_('print').' <img src="../images/M_images/printButton.png" align="absmiddle" border="0" /></a>&nbsp;</div>';
}

// Display global system messages
getGlobalMessage();

// Warning system
$warning_message = '';

if( $supportConfig->docspath == '' ) {
	$warning_message.= '<p><a href="index.php?option=com_maqmahelpdesk&task=config" class="mqmbutton red">'.JText::_('warning_fix').'</a> '.JText::_('warning_attach_paths').'</p>';
}

if( $supportConfig->public_attach && $supportConfig->extensions == '' ) {
	$warning_message.= '<p><a href="index.php?option=com_maqmahelpdesk&task=config" class="mqmbutton red">'.JText::_('warning_fix').'</a> '.JText::_('warning_attach_types').'</p>';
}

$sql = "SELECT COUNT(*) FROM `#__support_workgroup` WHERE `show`=1";
$database->setQuery( $sql );
if( !$database->loadResult() ) {
	$warning_message.= '<p><a href="index.php?option=com_maqmahelpdesk&task=workgroup" class="mqmbutton red">'.JText::_('warning_fix').'</a> '.JText::_('warning_wks_enabled').'</p>';
}

$sql = "SELECT COUNT(*) FROM `#__support_workgroup` WHERE `show`=1 AND `id` NOT IN (SELECT `id_workgroup` FROM `#__support_permission`)";
$database->setQuery( $sql );
if( $database->loadResult() ) {
	$warning_message.= '<p><a href="index.php?option=com_maqmahelpdesk&task=staff" class="mqmbutton red">'.JText::_('warning_fix').'</a> '.JText::_('warning_wks_users').'</p>';
}

$sql = "SELECT COUNT(*) FROM `#__support_status` WHERE `show`=1";
$database->setQuery( $sql );
if( !$database->loadResult() ) {
	$warning_message.= '<p><a href="index.php?option=com_maqmahelpdesk&task=status" class="mqmbutton red">'.JText::_('warning_fix').'</a> '.JText::_('warning_status').'</p>';
}

$sql = "SELECT COUNT(*) FROM `#__support_priority` WHERE `show`=1";
$database->setQuery( $sql );
if( !$database->loadResult() ) {
	$warning_message.= '<p><a href="index.php?option=com_maqmahelpdesk&task=priority" class="mqmbutton red">'.JText::_('warning_fix').'</a> '.JText::_('warning_priority').'</p>';
}

$sql = "SELECT COUNT(*) FROM `#__support_workgroup` WHERE `show`=1 AND `contract`=1";
$database->setQuery( $sql );
if( $database->loadResult() ) {
	$sql = "SELECT COUNT(*) FROM `#__support_contract_template`";
	$database->setQuery( $sql );
	if( !$database->loadResult() ) {
		$warning_message.= '<p><a href="index.php?option=com_maqmahelpdesk&task=contracts" class="mqmbutton red">'.JText::_('warning_fix').'</a> '.JText::_('warning_wks_contract').'</p>';
	}
}

$sql = "SELECT COUNT(*) FROM `#__support_workgroup` WHERE `show`=1 AND `use_activity`=1";
$database->setQuery( $sql );
if( $database->loadResult() ) {
	$sql = "SELECT COUNT(*) FROM `#__support_activity_rate` WHERE `published`=1";
	$database->setQuery( $sql );
	if( !$database->loadResult() ) {
		$warning_message.= '<p><a href="index.php?option=com_maqmahelpdesk&task=rates" class="mqmbutton red">'.JText::_('warning_fix').'</a> '.JText::_('warning_wks_rates').'</p>';
	}
	
	$sql = "SELECT COUNT(*) FROM `#__support_activity_type` WHERE `published`=1";
	$database->setQuery( $sql );
	if( !$database->loadResult() ) {
		$warning_message.= '<p><a href="index.php?option=com_maqmahelpdesk&task=types" class="mqmbutton red">'.JText::_('warning_fix').'</a> '.JText::_('warning_wks_types').'</p>';
	}
}

$sql = "SELECT COUNT(*) FROM `#__support_workgroup` WHERE `show`=1 AND `enable_discussions`=1 AND `wkmail_address`=''";
$database->setQuery( $sql );
if( $database->loadResult() ) {
	$warning_message.= '<p><a href="index.php?option=com_maqmahelpdesk&task=workgroup" class="mqmbutton red">'.JText::_('warning_fix').'</a> '.JText::_('warning_wks_discussions').'</p>';
}

if( $warning_message != '' && $task != 'download' && $tmpl != 'component' && $format != 'raw' ) {
	echo '<div id="warning_box">'.$warning_message.'</div>';
}

if( !$print && $task != 'download' && $tmpl != 'component' && $format != 'raw' ) { 
	if( $installed != $current_version ) {
		echo '<p style="margin-bottom:15px;"><a href="http://www.imaqma.com/" class="mqmbutton success">'.JText::_('download').'</a> '.JText::_('warning_version').'</p>';
	}
	
	$contents = '';
	$imagesMenuPath = "../components/com_maqmahelpdesk/images/menu"; ?>
	<div class="ui-app">
		<div class="ui-app-menu">
			<ul id="nav" class="dropdown dropdown-horizontal">
				<li><a href='index.php?option=com_maqmahelpdesk' title='<?php echo (JText::_('control_panel')); ?>'><?php echo (JText::_('control_panel')); ?></a></li>
				<li><span class="dir"><?php echo (JText::_('settings')); ?></span>
					<ul>
						<li><a href='index.php?option=com_maqmahelpdesk&task=config'><img src='<?php echo $imagesMenuPath; ?>/config.png' align='absmiddle' border='0' /> <?php echo JText::_('configuration'); ?></a></li>
						<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/common.png' align='absmiddle' border='0' /> <?php echo (JText::_('common')); ?></span>
							<ul>
								<li><a href='index.php?option=com_maqmahelpdesk&task=priority'><img src='<?php echo $imagesMenuPath; ?>/priorities.png' align='absmiddle' border='0' /> <?php echo (JText::_('priorities')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=status'><img src='<?php echo $imagesMenuPath; ?>/status.png' align='absmiddle' border='0' /> <?php echo (JText::_('status')); ?></a></li>
								<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/activities.png' align='absmiddle' border='0' /> <?php echo (JText::_('actitivity_options')); ?></span>
									<ul>
										<li><a href='index.php?option=com_maqmahelpdesk&task=rates'><img src='<?php echo $imagesMenuPath; ?>/activities_rates.png' align='absmiddle' border='0' /> <?php echo (JText::_('activity_rates')); ?></a></li>
										<li><a href='index.php?option=com_maqmahelpdesk&task=types'><img src='<?php echo $imagesMenuPath; ?>/activity_types.png' align='absmiddle' border='0' /> <?php echo (JText::_('activity_types')); ?></a></li>
									</ul>
								</li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=customfield'><img src='<?php echo $imagesMenuPath; ?>/custom_fields.png' align='absmiddle' border='0' /> <?php echo (JText::_('cfields')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=replies'><img src='<?php echo $imagesMenuPath; ?>/replies.png' align='absmiddle' border='0' /> <?php echo (JText::_('predefined_replies')); ?></a></li>
								<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/expedient.png' align='absmiddle' border='0' /> <?php echo (JText::_('expedient')); ?></span>
									<ul>
										<li><a href='index.php?option=com_maqmahelpdesk&task=holidays'><img src='<?php echo $imagesMenuPath; ?>/holidays.png' align='absmiddle' border='0' /> <?php echo (JText::_('holidays')); ?></a></li>
										<li><a href='index.php?option=com_maqmahelpdesk&task=schedule'><img src='<?php echo $imagesMenuPath; ?>/schedule.png' align='absmiddle' border='0' /> <?php echo (JText::_('schedules')); ?></a></li>
									</ul>
								</li>
							</ul>
						</li>
						<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/workgroup_settings.png' align='absmiddle' border='0' /> <?php echo (JText::_('workgroup_settings')); ?></span>
							<ul>
								<li><a href='index.php?option=com_maqmahelpdesk&task=workgroup'><img src='<?php echo $imagesMenuPath; ?>/workgroups.png' align='absmiddle' border='0' /> <?php echo (JText::_('workgroups')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=category'><img src='<?php echo $imagesMenuPath; ?>/categories.png' align='absmiddle' border='0' /> <?php echo (JText::_('categories')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=wkfields'><img src='<?php echo $imagesMenuPath; ?>/fields.png' align='absmiddle' border='0' /> <?php echo (JText::_('cfield_assign_menu')); ?></a></li>
							</ul>
						</li>
						<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/users.png' align='absmiddle' border='0' /> <?php echo (JText::_('clients_users')); ?></span>
							<ul>
								<li><a href='index.php?option=com_maqmahelpdesk&task=client'><img src='<?php echo $imagesMenuPath; ?>/clients.png' align='absmiddle' border='0' /> <?php echo (JText::_('clients_manager')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=group'><img src='<?php echo $imagesMenuPath; ?>/groups.png' align='absmiddle' border='0' /> <?php echo (JText::_('groups')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=users'><img src='<?php echo $imagesMenuPath; ?>/users.png' align='absmiddle' border='0' /> <?php echo (JText::_('users_manager')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=users_fields'><img src='<?php echo $imagesMenuPath; ?>/fields.png' align='absmiddle' border='0' /> <?php echo (JText::_('users_cfield_menu')); ?></a></li>
							</ul>
						</li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=staff'><img src='<?php echo $imagesMenuPath; ?>/support_staff.png' align='absmiddle' border='0' /> <?php echo (JText::_('support_staff')); ?></a></li>
						<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/contracts.png' align='absmiddle' border='0' /> <?php echo (JText::_('contracts')); ?></span>
							<ul>
								<li><a href='index.php?option=com_maqmahelpdesk&task=contracts'><img src='<?php echo $imagesMenuPath; ?>/contract_type.png' align='absmiddle' border='0' /> <?php echo (JText::_('contract_types')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=components'><img src='<?php echo $imagesMenuPath; ?>/components.png' align='absmiddle' border='0' /> <?php echo (JText::_('contract_components')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=contracts_fields'><img src='<?php echo $imagesMenuPath; ?>/fields.png' align='absmiddle' border='0' /> <?php echo (JText::_('users_cfield_menu')); ?></a></li>
							</ul>
						</li>
					</ul>
				</li>
				<li><a href='index.php?option=com_maqmahelpdesk&task=forms'><?php echo (JText::_('forms')); ?></a></li>
				<li><span class="dir"><?php echo (JText::_('kb')); ?></span>
					<ul>
						<li><a href='index.php?option=com_maqmahelpdesk&task=kb_new'><img src='<?php echo $imagesMenuPath; ?>/add.png' align='absmiddle' border='0' /> <?php echo (JText::_('add')); ?></a></li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=kb_search'><img src='<?php echo $imagesMenuPath; ?>/kb.png' align='absmiddle' border='0' /> <?php echo (JText::_('manage')); ?></a></li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=glossary'><img src='<?php echo $imagesMenuPath; ?>/glossary.png' align='absmiddle' border='0' /> <?php echo (JText::_('glossary')); ?></a></li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=kb_moderate'><img src='<?php echo $imagesMenuPath; ?>/comments.png' align='absmiddle' border='0' /> <?php echo (JText::_('moderate_comments')); ?></a></li>
					</ul>
				</li>
				<li><span class="dir"><?php echo (JText::_('downloads')); ?></span>
					<ul>
						<li><a href='index.php?option=com_maqmahelpdesk&task=dlcategory'><img src='<?php echo $imagesMenuPath; ?>/categories.png' align='absmiddle' border='0' /> <?php echo (JText::_('categories')); ?></a></li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=product'><img src='<?php echo $imagesMenuPath; ?>/files.png' align='absmiddle' border='0' /> <?php echo (JText::_('files')); ?></a></li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=customer'><img src='<?php echo $imagesMenuPath; ?>/access.png' align='absmiddle' border='0' /> <?php echo (JText::_('clients_access')); ?></a></li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=licenses'><img src='<?php echo $imagesMenuPath; ?>/licenses.png' align='absmiddle' border='0' /> <?php echo (JText::_('licenses')); ?></a></li>
					</ul>
				</li>
				<li><span class="dir"><?php echo (JText::_('announcements')); ?></span>
					<ul>
						<li><a href='index.php?option=com_maqmahelpdesk&task=announce'><img src='<?php echo $imagesMenuPath; ?>/announcements.png' align='absmiddle' border='0' /> <?php echo (JText::_('manage')); ?></a></li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=announce_preparesend'><img src='<?php echo $imagesMenuPath; ?>/send.png' align='absmiddle' border='0' /> <?php echo (JText::_('send')); ?></a></li>
					</ul>
				</li>
				<li><span class="dir"><?php echo (JText::_('calendar')); ?></span>
					<ul>
						<li><a href='index.php?option=com_maqmahelpdesk&task=calendar_new'><img src='<?php echo $imagesMenuPath; ?>/add_task.png' align='absmiddle' border='0' /> <?php echo (JText::_('add_task')); ?></a></li>
					</ul>
				</li>
				<li><span class="dir"><?php echo (JText::_('troubleshooter')); ?></span>
					<ul>
						<li><a href='index.php?option=com_maqmahelpdesk&task=troubleshooter'><img src='<?php echo $imagesMenuPath; ?>/troubleshooter.png' align='absmiddle' border='0' /> <?php echo (JText::_('manage')); ?></a></li>
					</ul>
				</li>
				<li><span class="dir"><?php echo (JText::_('reports')); ?></span>
					<ul>
						<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/charts.png' align='absmiddle' border='0' /> <?php echo (JText::_('analysis')); ?></span>
							<ul>
								<li><a href='index.php?option=com_maqmahelpdesk&task=reports&report=wkanalysis'><img src='<?php echo $imagesMenuPath; ?>/charts.png' align='absmiddle' border='0' /> <?php echo (JText::_('wk_analysis')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=reports&report=clientanalysis'><img src='<?php echo $imagesMenuPath; ?>/charts.png' align='absmiddle' border='0' /> <?php echo (JText::_('client_analysis')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=reports&report=supportanalysis'><img src='<?php echo $imagesMenuPath; ?>/charts.png' align='absmiddle' border='0' /> <?php echo (JText::_('support_analysis')); ?></a></li>
							</ul>
						</li>
						<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/table.png' align='absmiddle' border='0' /> <?php echo (JText::_('monthly_reports')); ?></span>
							<ul>
								<li><a href='index.php?option=com_maqmahelpdesk&task=reports&report=clientm'><img src='<?php echo $imagesMenuPath; ?>/table.png' align='absmiddle' border='0' /> <?php echo (JText::_('client_report')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=reports&report=clientmdetail'><img src='<?php echo $imagesMenuPath; ?>/table.png' align='absmiddle' border='0' /> <?php echo (JText::_('detail_client_report')); ?></a></li>
							</ul>
						</li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=reports&report=status'><img src='<?php echo $imagesMenuPath; ?>/table.png' align='absmiddle' border='0' /> <?php echo (JText::_('status_report2')); ?></a>
		
						<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/charts.png' align='absmiddle' border='0' /> <?php echo (JText::_('download_stats')); ?></span>
							<ul>
								<li><a href='index.php?option=com_maqmahelpdesk&task=stats'><img src='<?php echo $imagesMenuPath; ?>/charts.png' align='absmiddle' border='0' /> <?php echo (JText::_('downloads')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=stats_hits'><img src='<?php echo $imagesMenuPath; ?>/charts.png' align='absmiddle' border='0' /> <?php echo (JText::_('pagehits')); ?></a></li>
							</ul>
						</li>
						
						<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/timesheet.png' align='absmiddle' border='0' /> <?php echo (JText::_('timesheet')); ?></span>
							<ul>
								<li><a href='index.php?option=com_maqmahelpdesk&task=reports&report=timesheets'><img src='<?php echo $imagesMenuPath; ?>/timesheet.png' align='absmiddle' border='0' /> <?php echo (JText::_('simple')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=reports&report=timesheetd'><img src='<?php echo $imagesMenuPath; ?>/timesheet.png' align='absmiddle' border='0' /> <?php echo (JText::_('detailed')); ?></a></li>
							</ul>
						</li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=reports&report=duedate'><img src='<?php echo $imagesMenuPath; ?>/priorities.png' align='absmiddle' border='0' /> <?php echo (JText::_('duedate_report')); ?></a></li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=reports_builder'><img src='<?php echo $imagesMenuPath; ?>/report_builder.png' align='absmiddle' border='0' /> <?php echo (JText::_('custom_reports')); ?></a></li><?php
						$database->setQuery( 'SELECT `id`, `title`, `description` FROM #__support_reports ORDER BY `title`' );
						$reports = $database->loadObjectList();
						if( count($reports) > 0 ) { ?>
							<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/report_builder.png' align='absmiddle' border='0' /> <?php echo (JText::_('custom_reports_menu')); ?></span>
								<ul><?php
								$xx = 10;
								for($z=0; $z<count($reports); $z++) { 
									$row = $reports[$z]; ?>
									<li><a href='index.php?option=com_maqmahelpdesk&task=reports_builderreport&id=<?php echo $row->id; ?>'><img src='<?php echo $imagesMenuPath; ?>/report_builder.png' align='absmiddle' border='0' /> <?php echo ($row->title); ?></a></li><?php
									$xx++;
								} ?>
								</ul>
							</li><?php
						} ?>
					</ul>
				</li>
				<li><span class="dir"><?php echo (JText::_('tools')); ?></span>
					<ul>
						<li><a href='index.php?option=com_maqmahelpdesk&task=update'><img src='<?php echo $imagesMenuPath; ?>/installer.png' align='absmiddle' border='0' /> <?php echo (JText::_('tools')); ?></a></li>
						<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/export.png' align='absmiddle' border='0' /> <?php echo (JText::_('export')); ?></span>
							<ul>
								<li><a href='index.php?option=com_maqmahelpdesk&task=reports&report=ticketsexport'><img src='<?php echo $imagesMenuPath; ?>/export.png' align='absmiddle' border='0' /> <?php echo (JText::_('export_data')); ?></a></li>
								<li><a href='index.php?option=com_maqmahelpdesk&task=export'><img src='<?php echo $imagesMenuPath; ?>/config.png' align='absmiddle' border='0' /> <?php echo (JText::_('export_options')); ?></a></li>
							</ul>
						</li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=tools_db1'><img src='<?php echo $imagesMenuPath; ?>/database-clean.png' align='absmiddle' border='0' /> <?php echo (JText::_('database_cleanup')); ?></a></li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=autoclose'><img src='<?php echo $imagesMenuPath; ?>/clean.png' align='absmiddle' border='0' /> <?php echo (JText::_('autoclose')); ?></a></li>
						<!--li class="divider"></li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=tools_ambrasubs1'><img src='<?php echo $imagesMenuPath; ?>/installer.png' align='absmiddle' border='0' /> <?php echo (JText::_('import_ambrasubs')); ?></a></li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=tools_billets1'><img src='<?php echo $imagesMenuPath; ?>/installer.png' align='absmiddle' border='0' /> <?php echo (JText::_('import_billets')); ?></a></li>
						<li><a href='index.php?option=com_maqmahelpdesk&task=tools_rstickets1'><img src='<?php echo $imagesMenuPath; ?>/installer.png' align='absmiddle' border='0' /> <?php echo (JText::_('import_rstickets')); ?></a></li-->
					</ul>
				</li><?php		
				
				$database->setQuery( "SELECT * FROM #__support_addon WHERE menu!='' ORDER BY lname" );
				$addons = $database->loadObjectList(); 
				if( count($addons) > 0 ) { ?>
					<li><span class="dir"><?php echo (JText::_('addons')); ?></span>
						<ul>
							<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/inbox.png' align='absmiddle' border='0' /> <?php echo (JText::_('email_fetch')); ?></span>
								<ul>
									<li><a href='index.php?option=com_maqmahelpdesk&task=mail'><img src='<?php echo $imagesMenuPath; ?>/config.png' align='absmiddle' border='0' /> <?php echo (JText::_('configuration')); ?></a></li>
									<li><a href='index.php?option=com_maqmahelpdesk&task=mails'><img src='<?php echo $imagesMenuPath; ?>/logs.png' align='absmiddle' border='0' /> <?php echo (JText::_('logs')); ?></a></li>
								</ul>
							</li><?php
							$xx = 2;
							for($z=0; $z<count($addons); $z++) { 
								$row = $addons[$z]; 
								$rowOptions = explode( ',', $row->menu ); 
								if( count( $rowOptions ) == 1 ) { ?>
									<li><a href='index.php?option=com_maqmahelpdesk&task=addon-<?php echo $row->sname; ?>_<?php echo $row->menu; ?>'><img src='<?php echo $imagesMenuPath; ?>/config.png' align='absmiddle' border='0' /> <?php echo ($row->lname); ?></a></li><?php
								}else{ ?>
									<li><span class="dir"><img src='<?php echo $imagesMenuPath; ?>/config.png' align='absmiddle' border='0' /> <?php echo ($row->lname); ?></span>
										<ul>
											<?php
											$zz = 1;
											for($zz=0; $zz<count($rowOptions); $zz++) { ?>
												<li><a href='index.php?option=com_maqmahelpdesk&task=addon-<?php echo $row->sname; ?>_<?php echo $rowOptions[$zz]; ?>'><img src='../includes/js/ThemeOffice/component.png' align='absmiddle' border='0' /> <?php echo ucfirst($rowOptions[$zz]); ?></a></li><?php
												$zz++;
											} ?>
										</ul>
									</li><?php
								}
								$xx++;
							} ?>
						</ul>
					</li><?php
				} ?>
		
				<li><a href="index.php?option=com_maqmahelpdesk&task=about&tmpl=component" class="modal" rel="{handler:'iframe', size: {x:600, y:450}}"><?php echo addslashes(JText::_('about')); ?></a></li>
			</ul>
		</div><?php
}

// Check if it's from an add-on or not
if( substr($function, 0, 5) == 'addon' ) {
	$addontask = explode( '-', $function );
	$file = $task;
	// This checks if that variable exist so it can have multiple tasks in same addon file
	if( JRequest::getVar( 'addonfile', '', '', 'string' ) != '' ) {
		$file = JRequest::getVar( 'addonfile', '', '', 'string' );
	}
	require_once( JPATH_SITE.'/components/com_maqmahelpdesk/addon/'.$addontask[1].'/'.$file.'.php' );
} else {
	if (file_exists( $base_path.'/functions/admin.'.$function.'.php' )) {
		require_once( $base_path.'/functions/admin.'.$function.'.php' );
	} else {
		$function = 'cpanel';
		require_once( $base_path.'/functions/admin.cpanel.php' );
	}
}

if( !$print && $task != 'download' && $tmpl != 'component' && $format != 'raw' ) { ?>
	</div>
	<br style="clear:both;" />
	<div style="float:right;margin-left:30px;margin-top:4px;height:40px;">
		Became a Fan on Facebook <a href="http://facebook.com/imaqma" title="Became a Fan on Facebook" target="_blank"><img src="components/com_maqmahelpdesk/images/facebook.png" border="0" align="absmiddle" /></a>
	</div>
	<div style="float:right;margin-left:30px;margin-top:4px;height:40px;">
		Follow us on Twitter <a href="http://twitter.com/imaqma" title="Follow us on Twitter" target="_blank"><img src="components/com_maqmahelpdesk/images/twitter.png" border="0" align="absmiddle" /></a>
	</div>
	<div style="float:right;margin-left:30px;margin-top:4px;height:40px;">
		Post a rating and a review at the Joomla! Extensions Directory <a href="http://extensions.joomla.org/extensions/clients/help-desk/348/details" title="Post a rating and a review at the Joomla! Extensions Directory." target="_blank"><img src="components/com_maqmahelpdesk/images/joomla.png" border="0" align="absmiddle" /></a>
	</div><?php
}
