<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.client.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );
include_once ( '../components/com_maqmahelpdesk/includes/common.php' );

// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );

if (!is_array( $cid )) {
	$cid = array(0);
}

// Activities logger
mqm_activitylog('admin', 'client', $task, $cid[0]);

switch ($task) {
	case "new":
		editClient( 0 );
		break;

	case "edit":
		editClient( $cid[0] );
		break;

	case "save":
		saveClient( $description, 0 );
		break;

	case "apply":
		saveClient( $description, 1 );
		break;

	case "remove":
		removeClient( $cid );
		break;

	case "saveuser":
		saveUser();
		editClient( JRequest::getVar( 'id_client', 0, 'POST', 'int' ) );
		break;

	case "edituser":
		editUser( JRequest::getVar( 'id', 0, '', 'int' ) );
		editClient( JRequest::getVar( 'id_client', 0, 'POST', 'int' ) );
		break;

	case "deluser":
		deleteUser( JRequest::getVar( 'id', 0, '', 'int' ), JRequest::getVar( 'id_client', 0, '', 'int' ) );
		editClient( JRequest::getVar( 'id_client', 0, '', 'int' ) );
		break;

	case "manager":
		changeManager( JRequest::getVar( 'action', 0, '', 'int' ), JRequest::getVar( 'id_user', 0, '', 'int' ), JRequest::getVar( 'id_client', 0, '', 'int' ) );
		editClient( JRequest::getVar( 'id_client', 0, '', 'int' ) );
		break;

	case "savecontract":
		saveContract();
		editClient( JRequest::getVar( 'id_client', 0, '', 'int' ) );
		break;

	case "delcontract":
		deleteContract();
		editClient( JRequest::getVar( 'id_client', 0, '', 'int' ) );
		break;

	case "publishcontract":
		publishContract();
		editClient( JRequest::getVar( 'id_client', 0, '', 'int' ) );
		break;

	case "savefile":
		saveFile();
		editClient( JRequest::getVar( 'id_client', 0, '', 'int' ) );
		break;

	case "delfile":
		deleteClientFile();
		editClient( JRequest::getVar( 'id_client', 0, '', 'int' ) );
		break;

	case "saveinfo":
		saveInfo();
		editClient( JRequest::getVar( 'id_client', 0, '', 'int' ) );
		break;

	case "delinfo":
		deleteInfo();
		editClient( JRequest::getVar( 'id_client', 0, '', 'int' ) );
		break;
	
	case "publishinfo":
		publishInfo();
		editClient( JRequest::getVar( 'id_client', 0, '', 'int' ) );
		break;

	case "download":
		downloadFile( JRequest::getVar( 'id', 0, '', 'int' ), 0, 'C' );
		break;

	default:
		showClient();
		break;
}

function showClient() 
{
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
    $session = JFactory::getSession();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );
    $filter = JRequest::getVar( 'filter', $session->get('filter_client', '', 'maqmahelpdesk'), 'POST', 'string' );
    $session->set('filter_client', $filter, 'maqmahelpdesk');

	// get the total number of records
	$sql = "SELECT count(*) 
			FROM #__support_client 
			WHERE `clientname` LIKE '%".$filter."%'";
	$database->setQuery( $sql );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

	jimport('joomla.html.pagination');;
	$pageNav = new JPagination( $total, $limitstart, $limit );
	
	$sql = "SELECT c.id, c.clientname, c.description, c.country, c.block 
			FROM #__support_client c 
			".( $filter!= '' ? "WHERE c.`clientname` LIKE '%".$filter."%' " : '' )."
			ORDER BY c.clientname";
	$database->setQuery( $sql, $pageNav->limitstart, $pageNav->limit );

	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	client_html::show( $rows, $pageNav, $filter );
}


/**
* Compiles information to add or edit a category
* @param database A database connector object
* @param string The component name
*/
function editClient( $uid=0 ) 
{
	$database = JFactory::getDBO();
	$row = new mosSupportClient( $database );
	$row->load( $uid );

	// Build Workgroups select list
	$sql = "SELECT `id` AS value, `wkdesc` AS text FROM #__support_workgroup ORDER BY wkdesc";
	$database->setQuery($sql);
	$wk = $database->loadObjectList();
	$wk = array_merge(array(JHTML::_('select.option', '0', JText::_('all'))), $wk);
	$lists['workgroup'] = JHTML::_('select.genericlist',$wk, 'id_workgroup', 'class="inputbox" size="6" multiple="multiple"', 'value', 'text', '');
	
	// Build Client Workgroups select list
	$database->setQuery( "SELECT id_workgroup FROM #__support_client_wk WHERE id_client='".$row->id."'" );
	$workgroups = $database->loadObjectList();
	$sel_wks = '';
	for($i=0; $i<count($workgroups); $i++) {
		$wk = $workgroups[$i];
		$sel_wks .= $wk->id_workgroup.',';
	}
	$sel_wks = substr($sel_wks, 0, strlen($sel_wks)-1);
	$lists['wks'] = $sel_wks;
	
	// Build Contract Templates select list
	$sql = "SELECT `id` AS value, `name` AS text FROM #__support_contract_template ORDER BY name";
	$database->setQuery($sql);
	$ctempl = $database->loadObjectList();
	$ctempl = array_merge(array(JHTML::_('select.option', '0', JText::_('select3'))), $ctempl);
	$lists['contract'] = JHTML::_('select.genericlist',$ctempl, 'id_contract', 'class="inputbox" size="1"', 'value', 'text', 0);

	// Build Components select list
	$sql = "SELECT `id` AS value, `name` AS text FROM #__support_components ORDER BY `name`";
	$database->setQuery($sql);
	$comptempl = $database->loadObjectList();
	$lists['components'] = JHTML::_('select.genericlist',$comptempl, 'id_component', 'class="inputbox" size="6" multiple="multiple" onchange="PrepareComponents();"', 'value', 'text', '' );

	// Get the Client Users list
	$database->setQuery( "SELECT u.username, u.name, su.phone, su.fax, su.mobile, u.email, c.manager, u.id, c.id_client FROM #__users u INNER JOIN #__support_client_users c ON u.id=c.id_user LEFT JOIN #__support_users su ON su.id_user = u.id WHERE c.id_client=".(int)$row->id." ORDER BY u.name" );
	$users = $database->loadObjectList();

	// Get the Client Docs list
	$database->setQuery( "SELECT d.* FROM #__support_client_docs d, #__support_client c WHERE d.id_client=c.id AND c.id=".(int)$row->id );
	$clientdocs = $database->loadObjectList();

	// Get the Client Contracts list
	$database->setQuery( "SELECT c.*, u.name, t.name as contracttmpl, u.username FROM #__support_contract_template t, #__support_client cl, #__support_contract c LEFT JOIN #__users u ON c.id_user=u.id WHERE cl.id=c.id_client AND cl.id='".(int)$row->id."' AND t.id=c.id_contract ORDER BY c.date_start DESC" );
	$contracts = $database->loadObjectList();
	
	// Get the Client Downloads list
	$database->setQuery( "SELECT c.cname, d.pname, a.isactive, a.serialno, a.servicefrom, a.serviceuntil, a.id FROM #__support_dl d, #__support_dl_category AS c, #__support_dl_access a WHERE d.id=a.id_download AND d.id_category=c.id AND a.id_user='".(int)$row->id."' ORDER BY c.cname, d.pname" );
	$downloads = $database->loadObjectList();

	// Get the Client Tickets list
	$database->setQuery( "SELECT t.id, t.subject, w.wkdesc, t.date, s.description as status, t.an_name, t.assign_to, t.last_update, t.ticketmask, t.source, t.id_workgroup FROM #__support_ticket t, #__support_workgroup w, #__support_status s WHERE t.id_client='".(int)$row->id."' AND t.id_status=s.id AND t.id_workgroup=w.id ORDER BY t.date DESC" );
	$tickets = $database->loadObjectList();
	
	// Get the Client Information Records
	$database->setQuery( "SELECT * FROM #__support_client_info WHERE id_client='".(int)$row->id."' ORDER BY date ASC" );
	$inforecords = $database->loadObjectList();

	// Build Support Staff select list
	$sql = "SELECT DISTINCT(u.`id`) AS value, u.`name` AS text FROM #__support_permission p, #__users u WHERE p.id_user=u.id ORDER BY u.name";
	$database->setQuery($sql);
	$rows_staff = $database->loadObjectList();
	$rows_staff = array_merge(array(JHTML::_('select.option', '0', JText::_('selectlist'))), $rows_staff);
	$lists['staff'] = JHTML::_('select.genericlist',$rows_staff, 'id_user', 'class="inputbox" size="1"', 'value', 'text', 0);

	$captions = array( JText::_('MQ_NO'), JText::_('MQ_YES') );
	$values = array( '0', '1' );
	
	$lists['manager'] = mqm_switchcheckbox('radio', 'manager', $captions, $values, 0, 'switch');
	$lists['manager2'] = mqm_switchcheckbox('radio', 'manager2', $captions, $values, $row->manager, 'switch');
	$lists['block'] = mqm_switchcheckbox('radio', 'block', $captions, $values, $row->block, 'switch');
	$lists['approval'] = mqm_switchcheckbox('radio', 'approval', $captions, $values, $row->approval, 'switch');
	$lists['available'] = mqm_switchcheckbox('radio', 'available', $captions, $values, 1, 'switch');
	
	$database->setQuery( "SELECT kf.id, kf.id_field, kf.ordering, kf.required, cf.caption, cf.ftype, cf.value, cf.size, cf.maxlength FROM #__support_contract_fields kf INNER JOIN #__support_custom_fields cf ON cf.id=kf.id_field WHERE cf.cftype='C' ORDER BY kf.ordering" );
	$cfields = $database->loadObjectList();
	
	client_html::edit( $row, $users, $clientdocs, $lists, $contracts, $tickets, $inforecords, $downloads, $cfields );
}

/**
* Saves the client
* @param database A database connector object
* @param string The name of the component
*/
function saveClient( $description, $apply ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$row = new mosSupportClient( $database );

	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$row->checkin();
	
	$database->setQuery( "DELETE FROM #__support_client_wk WHERE id_client='".$row->id."'" );
	$database->query();
	
	$wks = explode(",", $_POST['wks']);
	for($i=0; $i<count($wks); $i++) {
		$database->setQuery( "INSERT INTO #__support_client_wk(id_workgroup, id_client) VALUES('".$wks[$i]."', '".$row->id."')" );
		$database->query();
	}
	
	// Saves the logo
	if( $_FILES['logo']['name'] != '' ) {
		// Check if the folder exists, if not creates it
		if( !is_dir(JPATH_SITE.'/components/com_maqmahelpdesk/images/logos/') ){
			mkdir( JPATH_SITE.'/components/com_maqmahelpdesk/images/logos/' );
		}
		$msg = mqm_do_upload( $row->id, 'CLI', "logo", JPATH_SITE.'/components/com_maqmahelpdesk/images/logos/', '', 0, 0, 'image' );
	}
	
	if( $apply ) {
		$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=client_edit&cid[0]=".$row->id  );
	}else{
		$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=client" );
	}
}

/**
* Deletes one or more categories from the categories table
* @param database A database connector object
* @param string The name of the category section
* @param array An array of unique category id numbers
*/
function removeClient( $cid ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	if (count( $cid ) < 1) {
		echo "<script type='text/javascript'> alert('".JText::_('client_delete')."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_client WHERE id IN (".$cids.")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

		//Delete User associations with this client
		$database->setQuery( "DELETE FROM #__support_client_users WHERE id_client IN (".$cids.")" ); 
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

		//Delete Workgroup Permissions for this client
		$database->setQuery( "DELETE FROM #__support_client_wk WHERE id_client IN (".$cids.")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	
		//Delete Contracts for this client
		$database->setQuery( "DELETE FROM #__support__contract WHERE id_client IN (".$cids.")" ); 
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

		//Delete Announcements for this client
		$database->setQuery( "DELETE FROM #__support__announce WHERE id_client IN (".$cids.")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

		//Delete Documents for this client
		$database->setQuery( "DELETE FROM #__support__client_docs WHERE id_client IN (".$cids.")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

		//Delete Notes for this client
		$database->setQuery( "DELETE FROM #__support__client_info WHERE id_client IN (".$cids.")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

	}

	$mainframe->redirect("index.php?option=com_maqmahelpdesk&task=client" );
}

function saveUser() 
{
	$database = JFactory::getDBO();
	$id_user = JRequest::getInt( 'id_user', 0 );
	
	if( $id_user ) {
		$row = new mosSupportClientUser( $database );

		if (!$row->bind( $_POST )) {
			echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}
		if (!$row->check()) {
			echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}
		if (!$row->store()) {
			echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$row->checkin();
	}
}

/**
* Saves the client user
* @param database A database connector object
* @param string The name of the component
*/
function editUser( $id ) {
	$database = JFactory::getDBO();
	
	$phone = JRequest::getVar( 'phone', '', 'POST', 'string' );
	$mobile = JRequest::getVar( 'mobile', '', 'POST', 'string' );
	$fax = JRequest::getVar( 'fax', '', 'POST', 'string' );
	$manager = JRequest::getVar( 'manager', '', 'POST', 'int' );

	$database->setQuery( "UPDATE #__support_client_users SET phone=".$database->quote($phone).", mobile=".$database->quote($mobile).", fax=".$database->quote($fax).", manager=".$database->quote($manager)." WHERE id='".$id."'" );
	$database->query();
}

/**
* Saves the client user
* @param database A database connector object
* @param string The name of the component
*/
function changeManager( $action, $id_user, $id_client ) {
	$database = JFactory::getDBO();
	
	$database->setQuery( "UPDATE #__support_client_users SET manager='".$action."' WHERE id_client='".$id_client."' AND id_user='".$id_user."'" );
	$database->query();
}

/**
* Delete a client user
* @param database A database connector object
* @param string The name of the component
*/
function deleteUser( $id_user, $id_client ) {
	$database = JFactory::getDBO();
	
	$database->setQuery( "DELETE FROM #__support_client_users WHERE id_user='".$id_user."' AND id_client='".$id_client."'" );
	$database->query();
}

/**
* Saves the client contract
* @param database A database connector object
* @param string The name of the component
*/
function saveContract() {
	global $supportConfig;
	
	$database = JFactory::getDBO();
	$row = new mosSupportClientContract( $database );

	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$row->checkin();
	
	// Gets info from the contract template
	$ctempl = null;
	$database->setQuery( "SELECT unit, val FROM #__support_contract_template WHERE id='".$row->id_contract."'" );
	$ctempl = $database->loadObject();
	
	// Updates the client contract
	$database->setQuery( "UPDATE #__support_contract SET unit='".$ctempl->unit."', value='".$ctempl->val."', creation_date='".dateOffset("Y-m-d")."'".($row->contract_number=='' ? ", contract_number='".$row->id."'" : "")." WHERE id='".$row->id."'" );
	$database->query();
	
	$database->setQuery( "DELETE FROM #__support_contract_comp WHERE id_contract='".$row->id."'" );
	$database->query();

	$wks = explode(",", $_POST['components']);
	for($i=0; $i<count($wks); $i++) {
		$database->setQuery( "INSERT INTO #__support_contract_comp(id_component, id_contract) VALUES('".$wks[$i]."', '".$row->id."')" );
		$database->query();
	}
	
	//////////////////////////////////////
	//	Update Contract Custom Fields	//
	//////////////////////////////////////
	$database->setQuery( "DELETE FROM #__support_contract_fields_values WHERE id_contract='".$row->id."'" );
	$database->query();

	$database->setQuery( "SELECT f.id_field, c.caption FROM #__support_contract_fields AS f INNER JOIN #__support_custom_fields AS c ON c.id=f.id_field ORDER BY f.ordering" );

	$customfields = $database->loadObjectList();
	if( !$database->query() ) {
		putGlobalMessage( JText::_('tkt_dberror').'<br />'.$database->getErrorMsg(), 'e', $database->stderr(1) );
	}

	$x = 0;
	$cfields_array = array();
	for ($x=0; $x < count($customfields); $x++) {
		$contractField = $customfields[$x];
		$custom_val = stripslashes( JRequest::getVar( 'custom'.$contractField->id_field, '', '', 'string' ) );
		$cfields_array_tmp = array( '%cfield'.$contractField->id_field.'_caption%' => $contractField->caption,
								'%cfield'.$contractField->id_field.'_value%' => string2HTML($custom_val));
		$cfields_array = array_merge( $cfields_array, $cfields_array_tmp );
		$database->setQuery( "INSERT INTO #__support_contract_fields_values(id_field, id_contract, value) VALUES('".$contractField->id_field."', '".$row->id."', ".$database->quote($custom_val).")" );
		if( !$database->query() ) {
			putGlobalMessage( JText::_('tkt_dberror').'<br />'.$database->getErrorMsg() , 'e', $database->stderr(1) );
		}
	}
}

/**
* Delete a client contract
* @param database A database connector object
* @param string The name of the component
*/
function deleteContract() {
	$database = JFactory::getDBO();

	$database->setQuery( "DELETE FROM #__support_contract WHERE id='".JRequest::getVar( 'id', 0, '', 'int' )."'" );
	$database->query();
	
	// 08.04.2009
	$database->setQuery( "DELETE FROM #__support_contract_fields_values WHERE id_contract='".JRequest::getVar( 'id', 0, '', 'int' )."'" );
	$database->query();
	
}

/**
* Activates/Deactivates a client contract
* @param database A database connector object
* @param string The name of the component
*/
function publishContract() {
	$database = JFactory::getDBO();
	
	$action = JRequest::getVar('action', '', 'GET', 'string');

	$database->setQuery( "UPDATE #__support_contract SET `status`='".($action=='I' ? 'A' : 'I')."' WHERE id='".JRequest::getVar( 'id', 0, '', 'int' )."'" );
	$database->query();
}

/**
* Saves the client file
* @param database A database connector object
* @param string The name of the component
*/
function saveFile() {
	global $supportConfig;
	
	$database = JFactory::getDBO();
	
	$description = JRequest::getVar( 'description', '', 'POST', 'string' );
	echo mqm_do_upload( JRequest::getVar( 'id_client', 0, 'POST', 'int' ), 'C', "file", $supportConfig->docspath.'docs/', $description );
}

/**
* Delete a client file
* @param database A database connector object
* @param string The name of the component
*/
function deleteClientFile() {
	global $supportConfig;
	$database = JFactory::getDBO();
	unlink($supportConfig->docspath.'docs/'.JRequest::getVar( 'filename', '', '', 'string' ));
	$database->setQuery( "DELETE FROM #__support_client_docs WHERE id='".JRequest::getVar( 'id', 0, '', 'int' )."'" );
	$database->query();
}

/**
* Saves the client information record
* @param database A database connector object
* @param string The name of the component
*/
function saveInfo() {
	$database = JFactory::getDBO();

	$row = new mosSupportClientInfo( $database );

	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$row->checkin();
}

/**
* Delete a client information record
* @param database A database connector object
* @param string The name of the component
*/
function deleteInfo() {
	$database = JFactory::getDBO();

	$database->setQuery( "DELETE FROM #__support_client_info WHERE id='".JRequest::getVar( 'id', 0, '', 'int' )."'" );
	$database->query();
}

/**
* Publish/Unpublish a client information record
* @param database A database connector object
* @param string The name of the component
*/
function publishInfo() {
	$database = JFactory::getDBO();

	$database->setQuery( "UPDATE #__support_client_info SET published='".JRequest::getVar( 'action', 0, '', 'int' )."' WHERE id='".JRequest::getVar( 'id', 0, '', 'int' )."'" );
	$database->query();
}
?>
