<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.contracts.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );

// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );

if (!is_array( $cid )) {
	$cid = array(0);
}

// Activities logger
mqm_activitylog('admin', 'contracts', $task, $cid[0]);

switch ($task) {
	case "new":
		editContract( 0 );
		break;

	case "edit":
		editContract( $cid[0] );
		break;

	case "save":
		saveContract();
		break;

	case "remove":
		removeContract( $cid );
		break;

	// 08.04.2009
	case "fields":								// lista de campos personalizados
		showCustomField();
		break;
	case "fields_new":							//toolbar: contracts_fields_new
		editCustomField( 0 );
		break;
	case "fields_edit":							//toolbar: contracts_fields_edit
		editCustomField( $cid[0] );
		break;
	case "fields_remove":						//toolbar: contracts_fields_remove
		removeCustomField( $cid );
		break;
	case 'saveorder':
		saveOrder();
		break;
	// case 'fields_apply':
	case "fields_save":					// gravar atribuio de campos personalizados
		saveCustomField();
		break;
		
	default:
		showContract();
		break;
}

// 08.04.2009
/**
* @param string The component name
*/
function showCustomField() {
	$database = JFactory::getDBO();
	
	$mainframe = JFactory::getApplication();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );
	echo '<script type="text/javascript" src="../components/com_maqmahelpdesk/js/tablednd.min.js"></script>';

	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__support_contract_fields" );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$database->setQuery( "SELECT c.id, f.caption, f.ftype, c.required "
	. "\nFROM #__support_contract_fields c, #__support_custom_fields f"
	. "\nWHERE c.id_field=f.id"
	. "\nORDER BY c.ordering",
	$pageNav->limitstart, $pageNav->limit
	);

	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	contracts_html::showcustomfields( $rows, $pageNav );
}


// 08.04.2009
function editCustomField( $uid=0 ) {
	$database = JFactory::getDBO();

	$row = new mosSupportContractFields( $database );	// definido em maqmahelpdesk.class.php
	// load the row from the db table
	$row->load( $uid );

	// Build Custom Fields select list
	$sql = "SELECT `id` AS value, `caption` AS text FROM #__support_custom_fields WHERE cftype='C' ORDER BY `caption`";
	$database->setQuery($sql);
	$rows_wk = $database->loadObjectList();
	$rows_wk = array_merge(array(JHTML::_('select.option', '0', JText::_('selectlist'))), $rows_wk);
	$lists['fields'] = JHTML::_('select.genericlist',$rows_wk, 'id_field', 'class="inputbox" size="1"', 'value', 'text', $row->id_field);

	$captions = array( JText::_('MQ_NO'), JText::_('MQ_YES') );
	$values = array( '0', '1' );
	$lists['required'] = mqm_switchcheckbox('radio', 'required', $captions, $values, $row->required, 'switch');

	// build the html select list for ordering
	$order = JHTML::_('list.genericordering', "SELECT s.ordering AS value, f.caption AS text"
		. "\nFROM #__support_contract_fields s, #__support_custom_fields f"
		. "\nWHERE s.id_field=f.id ORDER BY s.ordering"
	);
	$lists['ordering'] = JHTML::_('select.genericlist', $order, 'ordering', 'class="inputbox" size="1"', 'value', 'text', intval( $row->ordering ) );
	contracts_html::editcustomfields( $row, $lists );
}


// 08.04.2009
/**
* Saves the workgroup
* @param database A database connector object
* @param string The name of the component
*/
function saveCustomField() {
	$database = JFactory::getDBO();
	
	$mainframe = JFactory::getApplication();
	$row = new mosSupportContractFields( $database );
	
	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$row->checkin();
	//$row->updateOrder( "id_workgroup='$row->id_workgroup'" );

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=contracts_fields" );
}



// 08.04.2009
function removeCustomField( $cid ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	if (count( $cid ) < 1) {
		// TODO: create language call refering contact (not wk)
		echo "<script type='text/javascript'> alert('".JText::_('wkfield_delete')."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_contract_fields WHERE id IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=contracts_fields" );
}

function saveOrder() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$orders = JRequest::getVar( 'contentTable', array(0), '', 'array' );
	
	for( $i=1; $i<(count($orders)-1); $i++ ) 
	{
		$sql = "UPDATE `#__support_contract_fields`
				SET `ordering`=$i
				WHERE `id`=".$orders[$i];
		$database->setQuery( $sql );
		$database->query();
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=contracts_fields", JText::_('new_ordering_save') );
}


/**
* Compiles a list of workgroups
* @param string The component name
*/
function showContract() {
	$database = JFactory::getDBO();
	
	$mainframe = JFactory::getApplication();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );

	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__support_contract_template" );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

		jimport('joomla.html.pagination');;
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$database->setQuery( "SELECT t.id, t.name, t.description, t.unit, t.val, CONCAT(p.description, ' (', p.timevalue, ' ', p.timeunit, ')') AS priority"
	. "\nFROM #__support_contract_template t, #__support_priority p"
	. "\nWHERE t.id_priority=p.id"
	. "\nORDER BY t.name",
	$pageNav->limitstart, $pageNav->limit 
	);

	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	contracts_html::show( $rows, $pageNav );
}

/**
* Compiles information to add or edit a section
* @param database A database connector object
* @param string The component name
*/
function editContract( $uid=0 ) {
	$database = JFactory::getDBO();
	$row = new mosSupportContractTemplate( $database );
	// load the row from the db table
	$row->load( $uid );
	
	// Build Unit select list
	$units[] = JHTML::_('select.option', '', JText::_('selectlist'));
	$units[] = JHTML::_('select.option', 'Y', JText::_('years'));
	$units[] = JHTML::_('select.option', 'M', JText::_('months'));
	$units[] = JHTML::_('select.option', 'D', JText::_('days'));
	$units[] = JHTML::_('select.option', 'H', JText::_('hours'));
	$units[] = JHTML::_('select.option', 'T', JText::_('tickets'));
	$lists['unit'] = JHTML::_('select.genericlist',$units, 'unit', 'class="inputbox" size="1"', 'value', 'text', $row->unit);
	
	// Build Priority select list
	$sql = "SELECT `id` AS value, CONCAT(description, ' (', timevalue, ' ', timeunit, ')') AS text FROM #__support_priority";
	$database->setQuery($sql);
	$rows_cat = $database->loadObjectList();
	$rows_cat = array_merge(array(JHTML::_('select.option', '0', JText::_('selectlist'))), $rows_cat);
	$lists['priority'] = JHTML::_('select.genericlist',$rows_cat, 'id_priority', 'class="inputbox" size="1"', 'value', 'text', $row->id_priority);

	contracts_html::edit( $row, $lists );
}

/**
* Saves the workgroup
* @param database A database connector object
* @param string The name of the component
*/
function saveContract() {
	$database = JFactory::getDBO();
	
	$mainframe = JFactory::getApplication();
	$row = new mosSupportContractTemplate( $database );

	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$row->checkin();
	//$row->updateOrder( "" );

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=contracts" );
	
}

/**
* Deletes one or more categories from the categories table
* @param database A database connector object
* @param string The name of the category section
* @param array An array of unique category id numbers
*/
function removeContract( $cid ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	if (count( $cid ) < 1) {
		echo "<script> alert('".JText::_('contracttmpl_delete')."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_contract_template WHERE id IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=contracts" );
}
?>
