<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.customer.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );

//$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
$cid = JRequest::getVar( 'cid', array(0), 'REQUEST', 'array' );

if (!is_array( $cid )) {
	$cid = array(0);
}

// Activities logger
mqm_activitylog('admin', 'customer', $task, $cid[0]);

switch ($task) {
	case "new":
		editCustomer( null );
		break;

	case "save":
		saveCustomer();
		break;

	case "edit":
		editCustomer( $cid[0] );
		break;

	case "remove":
		removeCustomer( $cid );
		break;

	case "cancel":
	case "customer":
		viewCustomers();
		break;

}

function viewCustomers()
{
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
    $session = JFactory::getSession();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );
	$filter = JRequest::getVar( 'filter', $session->get('filter_customer', '', 'maqmahelpdesk'), 'POST', 'string' );
    $session->set('filter_customer', $filter, 'maqmahelpdesk');
	
	$sql = "SELECT count(*) 
			FROM #__support_dl_access a 
				 INNER JOIN #__support_dl d ON a.id_download=d.id
				 INNER JOIN #__support_client c ON a.id_user=c.id ".
			( $filter != '' ? "WHERE c.clientname LIKE '%$filter%' OR d.pname LIKE '%$filter%'" : "" );
	$database->setQuery( $sql );
	$total = $database->loadResult();
	echo $database->getErrorMsg();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );
	
	$sql = "SELECT a.id, c.clientname, d.pname AS product, a.isactive, a.serialno, a.servicefrom, a.serviceuntil , ca.cname AS category
			FROM #__support_dl_access a 
				 INNER JOIN #__support_dl d ON a.id_download=d.id
				 INNER JOIN #__support_dl_category ca ON d.id_category=ca.id
				 INNER JOIN #__support_client c ON a.id_user=c.id ".
			( $filter != '' ? "WHERE c.clientname LIKE '%$filter%' OR d.pname LIKE '%$filter%'" : "" )."
			ORDER BY c.clientname, d.pname ";
	$database->setQuery( $sql, $pageNav->limitstart, $pageNav->limit );

	if(!$result = $database->query()) {
		echo $database->stderr();
		return false;
	}

	$rows = $database->loadObjectList();

	HTML_customer::showCustomer( $rows, $pageNav, $filter );
}

function editCustomer( $id_group ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$lists = array();

	$row = new mosDownloadAccess($database);
	$row->load( $id_group );

	// Get client name
	$sql = "SELECT clientname FROM #__support_client WHERE id=".(int)$row->id_user;
	$database->setQuery($sql);
	$row->clientname = $database->loadResult();

	// Build Products select list
	$sql = "SELECT d.`id` as value, CONCAT(c.`cname`, ' - ', d.`pname`) as text 
			FROM `#__support_dl` AS d 
				 INNER JOIN `#__support_dl_category` AS c ON c.`id`=d.`id_category`
			ORDER BY c.`cname`, d.`pname`";
	$database->setQuery($sql);
	if (!$database->query()) {
		echo $database->stderr();
		return false;
	}
	$rows_prod = $database->loadObjectList();
	$rows_prod = array_merge(array(JHTML::_('select.option', '0', JText::_('selectlist'))), $rows_prod);
	$lists['products'] = JHTML::_('select.genericlist', $rows_prod, 'id_download', 'class="inputbox" size="1"','value', 'text', $row->id_download);
	
	$captions = array( JText::_('MQ_NO'), JText::_('MQ_YES') );
	$values = array( '0', '1' );
	
	$lists['isactive'] = mqm_switchcheckbox('radio', 'isactive', $captions, $values, $row->isactive, 'switch');

	HTML_customer::customerForm( $row, $lists );
}

function saveCustomer()
{
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$row = new mosDownloadAccess( $database );

	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$row->checkin();

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=customer" );
}

function removeCustomer( $cid ) {
	$database = JFactory::getDBO();
	
	$mainframe = JFactory::getApplication();
	
	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_dl_access WHERE id IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}
	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=customer" );
}
