<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.customfield.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );

// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
if (!is_array( $cid )) {
	$cid = array(0);
}

$ftype = JRequest::getVar( 'ftype', '', '', 'string' );

// Activities logger
mqm_activitylog('admin', 'customfield', $task, $cid[0]);

switch ($task) {
	case "new":
		editCustomField( 0 );
		break;

	case "edit":
		editCustomField( $cid[0] );
		break;

	case "save":
		saveCustomField();
		break;

	case "remove":
		removeCustomField( $cid );
		break;

	case "publish":
		publishCustomField( $cid, 1 );
		break;

	case "unpublish":
		publishCustomField( $cid, 0 );
		break;

	default:
		showCustomField( $ftype );
		break;
}

/**
* Compiles a list of workgroups
* @param string The component name
*/
function showCustomField( $ftype ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );
	
	$where = '';
	if( $ftype != '' ) {
		$where = " WHERE cftype=".$database->quote($ftype);
	}

	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__support_custom_fields".$where );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$database->setQuery( "SELECT id, caption, ftype, value, cftype"
	. "\nFROM #__support_custom_fields"
	. "\n".$where
	. "\nORDER BY caption",
	$pageNav->limitstart, $pageNav->limit
	);

	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	// Build the field type select list
	$cftypelist[] = JHTML::_('select.option', '', JText::_('all'));
	$cftypelist[] = JHTML::_('select.option', 'W', JText::_('wk_field'));
	$cftypelist[] = JHTML::_('select.option', 'U', JText::_('users_field'));
	$cftypelist[] = JHTML::_('select.option', 'C', JText::_('contract_field'));
	$lists['cftype'] = JHTML::_('select.genericlist',$cftypelist, 'ftype', 'class="inputbox" size="1" onChange="document.adminForm.submit();"', 'value', 'text', $ftype);

	cfield_html::show( $rows, $pageNav, $lists );
}

/**
* Compiles information to add or edit a custom field
* @param database A database connector object
* @param string The component name
*/
function editCustomField( $uid=0 ) {
	global $lists;
	
	$database = JFactory::getDBO();
	
	echo '<script type="text/javascript" src="../components/com_maqmahelpdesk/js/jquery.autogrowtextarea.min.js"></script>';
	
	$row = new mosSupportCField( $database );
	// load the row from the db table
	$row->load( $uid );
	
	$row->value = str_replace('\"', '"', $row->value);
	$row->value = str_replace("\'", "'", $row->value);

	// Build the field type select list
	$cftypelist[] = JHTML::_('select.option', '', JText::_('selectlist'));
	$cftypelist[] = JHTML::_('select.option', 'W', JText::_('wk_field'));
	$cftypelist[] = JHTML::_('select.option', 'U', JText::_('users_field'));
	$cftypelist[] = JHTML::_('select.option', 'C', JText::_('contract_field'));
	$lists['cftype'] = JHTML::_('select.genericlist',$cftypelist, 'cftype', 'class="inputbox" size="1"', 'value', 'text', $row->cftype);

	cfield_html::edit( $row, $lists );
}

/**
* Saves the workgroup
* @param database A database connector object
* @param string The name of the component
*/
function saveCustomField() {
	$database = JFactory::getDBO();
	
	$mainframe = JFactory::getApplication();
	$row = new mosSupportCField( $database );

	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$row->checkin();

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=customfield" );
}

/**
* Deletes one or more categories from the categories table
* @param database A database connector object
* @param string The name of the category section
* @param array An array of unique category id numbers
*/
function removeCustomField( $cid ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	if (count( $cid ) < 1) {
		echo "<script type='text/javascript'> alert('".JText::_('cfield_delete')."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_custom_fields WHERE id IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
		$database->setQuery( "DELETE FROM #__support_wk_fields WHERE id_field IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=customfield" );
}

/**
* Publishes or Unpublishes one or more workgroups
* @param database A database connector object
* @param array An array of unique workgroup id numbers
* @param integer 0 if unpublishing, 1 if publishing
* @param string The name of the component
*/
function publishCustomField( $cid=null, $publish=1 ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	if ( !is_array( $cid ) || count( $cid ) < 1 ) {
		$action = $publish ? 'publish' : 'unpublish';
		echo "<script type='text/javascript'> alert('".JText::_('cfield_action')." $action'); window.history.go(-1);</script>\n";
		exit;
	}

	$database->setQuery( "UPDATE #__support_custom_field SET `show`='$publish' WHERE id IN (".$database->quote($cids).")" );

	if (!$database->query()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=customfield" );
}
?>