<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.dlcategory.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );

$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
if (!is_array( $cid )) {
	$cid = array(0);
}

global $product_id;

// Activities logger
mqm_activitylog('admin', 'dlcategory', $task, $cid[0]);

switch ($task) {
	case "new":
		editCategory( null );
		break;

	case "save":
		saveCategory();
		break;

	case "edit":
		editCategory( $cid[0] );
		break;

	case "remove":
		removeCategory( $cid );
		break;

	case "publish":
		publishCategory( $cid,1 );
		break;

	case "unpublish":
		publishCategory( $cid, 0 );
		break;
	
	case "cancel":
	case "dlcategory":
		viewCategory();
		break;

	case 'saveorder':
		saveOrder();
		break;
}

function viewCategory() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );
	
	echo '<script type="text/javascript" src="../components/com_maqmahelpdesk/js/tablednd.min.js"></script>';
	
	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__support_dl_category" );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

	$query = "SELECT c.id, c.cname AS title, c.description, c.published, c.parent AS parent_id, c.`level` FROM #__support_dl_category c ORDER BY c.parent, c.ordering";
	$database->setQuery( $query );
	$rows2 = $database->loadObjectList();

	// establish the hierarchy of the menu
	$children = array();
	// first pass - collect children
	foreach ($rows2 as $v ) {
		$pt = $v->parent_id;
		$list = @$children[$pt] ? $children[$pt] : array();
		array_push( $list, $v );
		$children[$pt] = $list;
	}
	// second pass - get an indent list of the items
	$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, max( 0, 10 ), 0, 0 );

	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );
	
	// slice out elements based on limits
	$list = array_slice( $list, $pageNav->limitstart, $pageNav->limit );

	HTML_category::showCategory( $list, $pageNav );
}

function editCategory( $Categoryid ) 
{
	$lists = array();
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	$row = new mosDownloadCategory($database);
	$row->load( $Categoryid );
	
	$lists['parent'] = ParentCategory( $row, 0 );
	$lists['published'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $row->published, JText::_('MQ_YES'), JText::_('MQ_NO') );

	HTML_category::categoryForm( $row, $lists );
}

function saveCategory()
{
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$row = new mosDownloadCategory($database);

	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$row->checkin();
	
	// Saves the image - icon in the database
	if( $_FILES['image']['name'] != '' ) {
		// Check if the folder exists, if not creates it
		if( !is_dir(JPATH_SITE.'/components/com_maqmahelpdesk/images/logos/') ){
			mkdir( JPATH_SITE.'/components/com_maqmahelpdesk/images/logos/' );
		}

		$msg = mqm_do_upload( $row->id, 'CA', "image", JPATH_SITE.'/components/com_maqmahelpdesk/images/logos/', '', 1, 1, 'image' );
	}
	
	// Update the category level
	if( $row->parent ) {
		// Get parent level
		$sql = "SELECT `level`
				FROM `#__support_dl_category`
				WHERE `id`=".$row->parent;
		$database->setQuery( $sql );
		$level = $database->loadResult();
		// Increase the level of current category
		$sql = "UPDATE `#__support_dl_category`
				SET `level`=".($level+1)."
				WHERE `id`=".$row->id;
		$database->setQuery( $sql );
		$database->query();
	}
	
	if($database->getErrorMsg()) {
		echo "<p>".$database->getErrorMsg();
	}else{
		$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=dlcategory" );
	}
}

function publishCategory( $cid, $publish=1 )
{
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	if (!is_array( $cid ) || count( $cid ) < 1) {
		$action = $publish ? 'publish' : 'unpublish';
		echo "<script type='text/javascript'> alert('".JText::_('category_action')." $action'); window.history.go(-1);</script>\n";
		exit;
	}

	$cids = implode( ',', $cid );

	$database->setQuery( "UPDATE #__support_dl_category SET published='$publish' WHERE id IN (".$database->quote($cids).")" );
	if (!$database->query()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=dlcategory" );

}

function removeCategory( $cid ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_dl_category WHERE id IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}
	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=dlcategory" );
}

function saveOrder( &$cid ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$orders = JRequest::getVar( 'contentTable', array(0), '', 'array' );
	
	for( $i=1; $i<(count($orders)-1); $i++ ) 
	{
		$sql = "UPDATE `#__support_dl_category`
				SET `ordering`=$i
				WHERE `id`=".$orders[$i];
		$database->setQuery( $sql );
		$database->query();
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=dlcategory", JText::_('new_ordering_save') );
}

function ParentCategory( &$row, $iscat ) {
	$database = JFactory::getDBO();

	// get a list of the menu items
	$query = "SELECT c.id, c.cname AS title, c.published, c.parent AS parent_id FROM #__support_dl_category c WHERE c.published='1' ORDER BY c.parent";
	$database->setQuery( $query );
	$mitems = $database->loadObjectList();

	// establish the hierarchy of the menu
	$children = array();
	// first pass - collect children
	foreach ( $mitems as $v ) {
		$pt = $v->parent_id;
		$list = @$children[$pt] ? $children[$pt] : array();
		array_push( $list, $v );
		$children[$pt] = $list;
	}
	// second pass - get an indent list of the items
	$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 9999, 0, 0 );

	// assemble menu items to the array
	$mitems = array();
	$mitems[] = JHTML::_('select.option',  '0', JText::_('top') );
	
	$this_treename = '';
	foreach ( $list as $item ) {
		if ( $this_treename ) {
			if ( $item->id != $row->id && strpos( $item->treename, $this_treename ) === false) {
				$mitems[] = JHTML::_('select.option',  $item->id, $item->treename );
			}
		} else {
			$mitems[] = JHTML::_('select.option',  $item->id, $item->treename );
		}
	}
	if( !$iscat ) {
		$parent = JHTML::_('select.genericlist', $mitems, 'parent', 'class="inputbox" size="1"', 'value', 'text', $row->parent );
	}else{
		$parent = JHTML::_('select.genericlist', $mitems, 'id_category', 'class="inputbox" size="1"', 'value', 'text', $row->id_category );
	}
	return $parent;
}
