<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.kb.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );

// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
if (!is_array( $cid )) {
	$cid = array(0);
}
$id = JRequest::getVar( 'id', 0, '', 'int' );
$extid = JRequest::getVar( 'extid', 0, '', 'int' );
$categories = JRequest::getVar( 'categories', '', '', 'string' );

// Activities logger
mqm_activitylog('admin', 'kb', $task, $cid[0]);

switch ($task) {
	case "new":
		editKB( 0 );
		break;

	case "edit":
		editKB( $cid[0] );
		break;

	case "save":
		saveKB( $categories, 0 );
		break;

	case "apply":
		saveKB( $categories, 1 );
		break;

	case "remove":
		removeKB( $cid );
		break;

	case "publish":
		publishKB( $cid, 1 );
		break;

	case "unpublish":
		publishKB( $cid, 0 );
		break;

	case "delattach":
		removeAttach( $_REQUEST['id_attach'], $_REQUEST['option'], $_REQUEST['filename'] );
		editKB( $id );
		break;

	case "delcomment":
		removeComment( $_REQUEST['id_comment'] );
		editKB( $id );
		break;
		
	case "ticket":
		convertTicket( $id );
		break;

	case "download":
		downloadFile( $id, $extid, 'K' );
		break;

	case "moderate":
		moderateComments();
		break;

	case "delcomments":
		removeComments( $cid );
		moderateComments();
		break;

	case "publishcomments":
		publishComments( $cid );
		moderateComments();
		break;
	
	case "search":
	default:
		showKB();
		break;
}

function convertTicket( $uid ) {
	$database = JFactory::getDBO();
	
	$database->setQuery( "SELECT 0 as id, ticketmask as kbcode, subject as kbtitle, message as question, 0 as views, now() as date_created, now() as date_updated, 1 as publish, '' as keywords, '' as resolution, 0 as anonymous_access, 0 as faq, id_category FROM #__support_ticket WHERE id='".$uid."'" );
	$row = $database->loadObject();
	print $database->getErrorMsg();

	//Get Resolution Messages
	$query = "SELECT message FROM #__support_ticket_resp WHERE id_ticket='".$uid."' ORDER BY id";
	$database->setQuery( $query );
	$replies = $database->loadObjectList();

	$row->resolution = '';
	for($i=0; $i<count($replies); $i++) {
		$rowReply = $replies[$i];
		$row->resolution .= "-------------------------------------------------------------------\n".$rowReply->message."\n\n";
	}

	//Build Workgroups select list
	$query = "SELECT id FROM #__support_workgroup WHERE `show`='1' ORDER BY wkdesc";
	$database->setQuery( $query );
	$wkrows = $database->loadObjectList();
	
	$database->setQuery( "SELECT id_category FROM #__support_ticket WHERE id='".$uid."'" );
	$categories = $database->loadObjectList();
	
	$prodcat = "";
	for($i=0; $i<count($categories); $i++) {
		$row_cat = $categories[$i];
		$prodcat .= $row_cat->id_category.(count($categories)-$i>1 ? ',' : '');
	}

	$lists['categories'] = BuildCategories( $row->id_category, false, false, false, true );

	// Build Workgroup select list
	$wkrow = &$wkrows[0];
	$sql = "SELECT `id` AS value, `wkdesc` AS text FROM #__support_workgroup WHERE `show`='1' ORDER BY wkdesc";
	$database->setQuery($sql);
	$rows_wk = $database->loadObjectList();
	$rows_wk = array_merge(array(JHTML::_('select.option', '0', JText::_('selectlist'))), $rows_wk);
	$lists['workgroup'] = JHTML::_('select.genericlist',$rows_wk, 'id_workgroup', 'class="inputbox" size="1" onChange="ShowCategory()"', 'value', 'text', 0);
	
	// Get KB Attachments
	$database->setQuery( "SELECT * FROM #__support_file WHERE id='".$row->id."' AND source='K'" );
	$kbAttachs = $database->loadObjectList();
	print $database->getErrorMsg();

	// Get KB Comments
	$database->setQuery( "SELECT c.id, c.id_kb, c.date, c.comment, u.name FROM #__support_kb_comment c LEFT JOIN #__users u ON u.id=c.id_user WHERE c.id_kb='".$row->id."'" );
	$kbComments = $database->loadObjectList();
	print $database->getErrorMsg();

	// Get KB Rate
	$rate = null;
	$database->setQuery( "SELECT SUM(rate) AS ratesum, COUNT(id) AS ratecount FROM #__support_rate WHERE id_table='".$row->id."' AND source='K'" );
	$rate = $database->loadObject();
	print $database->getErrorMsg();

	$captions = array( JText::_('MQ_NO'), JText::_('MQ_YES') );
	$values = array( '0', '1' );
	
	$lists['anonymous'] = mqm_switchcheckbox('radio', 'anonymous_access', $captions, $values, $row->anonymous_access, 'switch');
	$lists['faq'] = mqm_switchcheckbox('radio', 'faq', $captions, $values, $row->faq, 'switch');
	
	kb_html::edit( $row, $lists, $kbAttachs, $rate, $wkrows, $kbComments, $prodcat, $uid );
}

function showKB() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
    $session = JFactory::getSession();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );
    $search = JRequest::getVar( 'search', $session->get('filter_kb', '', 'maqmahelpdesk'), 'POST', 'string' );
    $session->set('filter_kb', $search, 'maqmahelpdesk');

	// get the total number of records
	$database->setQuery( "SELECT COUNT(*) FROM #__support_kb k ".($search=='' ? '' : "WHERE k.keywords like '%".$database->getEscaped($search)."%'") );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$database->setQuery( "SELECT k.id, k.kbtitle, k.publish, k.date_created, k.date_updated, k.kbcode, k.approved FROM #__support_kb k ".($search=='' ? '' : "WHERE k.keywords like '%".$database->getEscaped($search)."%'")." ",$pageNav->limitstart, $pageNav->limit );
	
	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	kb_html::show( $rows, $pageNav, $search );
}

function editKB( $uid=0 ) {
	$database = JFactory::getDBO();
	
	$row = new mosSupportKB( $database );
	$row->load( $uid );

	//Build Workgroups select list
	$query = "SELECT id FROM #__support_workgroup WHERE `show`='1' ORDER BY wkdesc";
	$database->setQuery( $query );
	$wkrows = $database->loadObjectList();
	
	$database->setQuery( "SELECT id_category FROM #__support_kb_category WHERE id_kb='".$row->id."'" );
	$categories = $database->loadObjectList();
	
	$prodcat = "";
	for($i=0; $i<count($categories); $i++) {
		$row_cat = $categories[$i];
		$prodcat .= $row_cat->id_category.(count($categories)-$i>1 ? ',' : '');
	}

	$lists['categories'] = BuildCategories( 0, false, false, true, true );

	// Build Workgroup select list
	$wkrow = &$wkrows[0];
	$sql = "SELECT `id` AS value, `wkdesc` AS text FROM #__support_workgroup WHERE `show`='1' ORDER BY wkdesc";
	$database->setQuery($sql);
	$rows_wk = $database->loadObjectList();
	$rows_wk = array_merge(array(JHTML::_('select.option', '0', JText::_('selectlist'))), $rows_wk);
	$lists['workgroup'] = JHTML::_('select.genericlist',$rows_wk, 'id_workgroup', 'class="inputbox" size="1" onChange="ShowCategory()"', 'value', 'text', 0);
	
	// Get KB Attachments
	$database->setQuery( "SELECT * FROM #__support_file WHERE id='".$row->id."' AND source='K'" );
	$kbAttachs = $database->loadObjectList();
	print $database->getErrorMsg();

	// Get KB Comments
	$database->setQuery( "SELECT c.id, c.id_kb, c.date, c.comment, u.name FROM #__support_kb_comment c LEFT JOIN #__users u ON u.id=c.id_user WHERE c.id_kb='".$row->id."'" );
	$kbComments = $database->loadObjectList();
	print $database->getErrorMsg();

	// Get KB Rate
	$rate = null;
	$database->setQuery( "SELECT SUM(rate) AS ratesum, COUNT(id) AS ratecount FROM #__support_rate WHERE id_table='".$row->id."' AND source='K'" );
	$rate = $database->loadObject();
	
	print $database->getErrorMsg();
	
	$captions = array( JText::_('MQ_NO'), JText::_('MQ_YES') );
	$values = array( '0', '1' );
	
	$lists['anonymous'] = mqm_switchcheckbox('radio', 'anonymous_access', $captions, $values, $row->anonymous_access, 'switch');
	$lists['faq'] = mqm_switchcheckbox('radio', 'faq', $captions, $values, $row->faq, 'switch');
	$lists['approved'] = mqm_switchcheckbox('radio', 'approved', $captions, $values, $row->approved, 'switch');
	
	kb_html::edit( $row, $lists, $kbAttachs, $rate, $wkrows, $kbComments, $prodcat, 0 );
}

function saveKB( $categories, $apply ) {
    global $supportConfig;
	
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$user = JFactory::getUser();
	
    $row = new mosSupportKB( $database );

    if (!$row->bind( $_POST )) {
        echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
        exit();
    }
    if (!$row->check()) {
        echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
        exit();
    }
    if (!$row->store()) {
        echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
        exit();
    }

    $row->checkin();

    // Get Configuration Options
    $database->setQuery( "SELECT * FROM #__support_config WHERE id='1'" );
    $supportConfig = null;
    $supportConfig = $database->loadObject();

    // Get logged user info
    $database->setQuery( "SELECT name, email FROM #__users WHERE id='".$user->id."'" );
    $loggeduser = null;
    $loggeduser = $database->loadObject();

    // Take care of the JomSocial integration if enabled
    if( $supportConfig->post_kb_creation_in_wall ) {
         // Get the workgroup of the first category
        $category = explode(",", $categories);
        $sql = "SELECT `id_workgroup`
                FROM `#__support_category`
                WHERE `id` = '".$category[0]."'";
        $database->setQuery( $sql );
        $id_workgroup = $database->loadResult();
        
        // Get the Itemid
        $sql = "SELECT `id`
                FROM `#__menu`
                WHERE `link` = 'index.php?option=com_maqmahelpdesk'";
        $database->setQuery( $sql );
        $Itemid = $database->loadResult();

        if( JRequest::getVar( 'id', 0, 'POST', 'int' ) ) {
            $comment = sprintf(JText::_("comment_kb_creation_wall_update"), JRoute::_("index.php?option=com_maqmahelpdesk&Itemid=".$Itemid."&task=kb_view&id_workgroup=".$id_workgroup."&id=".$row->id), $row->kbtitle, $row->kbtitle);
        }else{
            $comment = sprintf(JText::_("comment_kb_creation_wall_create"), JRoute::_("index.php?option=com_maqmahelpdesk&Itemid=".$Itemid."&task=kb_view&id_workgroup=".$id_workgroup."&id=".$row->id), $row->kbtitle, $row->kbtitle);
        }
		
		mqm_jomsocial_post($user->id, $comment, strip_tags(substr($row->content,0,100)));
    }

    // Insert categories
    $database->setQuery( "DELETE FROM #__support_kb_category WHERE id_kb='".$row->id."'" );
    $database->query();

    $category = explode(",", $categories);
    for($i=0; $i<count($category); $i++) {
        $database->setQuery( "INSERT INTO #__support_kb_category(id_kb, id_category) values('".$row->id."', '".$category[$i]."')" );
        $database->query();
    }

    // Inserts the attachments
    $msg = '';
    for($xx=0; $xx < $supportConfig->attachs_num; $xx++) {
        if( $_POST['desc'.$xx] != '' ) {
            $msg = mqm_do_upload( $row->id, 'K', "file$xx", $supportConfig->docspath.'/', $_POST['desc'.$xx] );
        }
    }

    if( $row->id > 0 && $_POST['fromticket'] ) {
        $database->setQuery( "UPDATE #__support_ticket SET id_kb='".$row->id."'" );
        $database->query();
    }

    if( $apply == true ) {
        $mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=kb_edit&cid=".$row->id."&msg=".$msg );
    }else{
        $mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=kb&msg=".$msg );
    }
}

function removeKB( $cid ) {
	global $supportConfig;
	
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();

	if (count( $cid ) < 1) {
		echo "<script type='text/javascript'> alert('".JText::_('kb_delete')."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_kb WHERE id IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}else{
			$database->setQuery( "DELETE FROM #__support_kb_comment WHERE id_kb IN (".$database->quote($cids).")" );				$database->query();
			$database->setQuery( "DELETE FROM #__support_kb_category WHERE id_kb IN (".$database->quote($cids).")" );				$database->query();
			$database->setQuery( "DELETE FROM #__support_rate WHERE id_table IN (".$database->quote($cids).") AND source='K'" );	$database->query();
			$database->setQuery( "SELECT filename FROM #__support_file WHERE id_table IN (".$database->quote($cids).") AND source='K'" );
			$files = $database->loadObjectList();
			for($x=0; $x<count($files); $x++) {
				$file = $files[$x];
				unlink($supportConfig->docspath."/".$file->filename);
			}
			$database->setQuery( "DELETE FROM #__support_file WHERE id_table IN (".$database->quote($cids).") AND source='K'" );	$database->query();
		}
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=kb" );
}

function publishKB( $cid=null, $publish=1 ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	$cids = implode( ',', $cid );
	$database->setQuery( "UPDATE #__support_kb SET `publish`='$publish' WHERE id IN (".$database->quote($cids).")" );

	if (!$database->query()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=kb" );
}

function removeAttach( $id, $filename ) {
	global $supportConfig;
	
	$database = JFactory::getDBO();

	$database->setQuery( "DELETE FROM #__support_file WHERE id_file='$id'" );
	if (!$database->query()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
	}else{
		unlink($supportConfig->docspath."/".$filename);
	}
}

function removeComment( $id ) {
	$database = JFactory::getDBO();

	$database->setQuery( "DELETE FROM #__support_kb_comment WHERE id='$id'" );
	$database->query();
}

function removeComments( $cid ) {
	$database = JFactory::getDBO();
	
	$cids = implode( ',', $cid );
	$database->setQuery( "DELETE FROM #__support_kb_comment WHERE id IN (".$database->quote($cids).")" );
	
	if (!$database->query()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
}

function publishComments( $cid=null ) {
    global $supportConfig;
	
	$database = JFactory::getDBO();

    $cids = implode( ',', $cid );
    $database->setQuery( "UPDATE #__support_kb_comment SET `publish`='1' WHERE id IN (".$database->quote($cids).")" );
    
    if (!$database->query()) {
        echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
        exit();
    }
    
    // If JomSocial post comments is enabled must process it here
    if( $supportConfig->post_comments_in_wall ) {
        $sql = "SELECT c.`id_user`, c.`id_kb`, c.`comment`, k.`kbtitle`, c.`id_workgroup`, c.`itemid`
                FROM `#__support_kb_comment` AS c
                     INNER JOIN `#__support_kb` AS k ON k.`id`=c.`id_kb`
                WHERE c.`id` IN (".$database->quote($cids).")";
        $database->setQuery( $sql );
        $rows = $database->loadObjectList();

        for( $i=0; $i<count($rows); $i++ )
        {
            $row = $rows[$i];
            $comment = sprintf(JText::_("comment_post_wall"), "index.php?option=com_maqmahelpdesk&Itemid=".$row->itemid."&task=kb_view&id_workgroup=".$row->id_workgroup."&id=".$row->id_kb, $row->kbtitle, $row->kbtitle);
			mqm_jomsocial_post($row->id_user, $comment, $row->comment);
        }
    }
}

function moderateComments() {
    $database = JFactory::getDBO();
	
	$mainframe = JFactory::getApplication();
    $limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
    $limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );

    // get the total number of records
    $database->setQuery( "SELECT COUNT(*) FROM #__support_kb_comment WHERE publish='0' ORDER BY id" );
    $total = $database->loadResult();
    echo $database->getErrorMsg();

    jimport('joomla.html.pagination');;
    $pageNav = new JPagination( $total, $limitstart, $limit );

    $database->setQuery( "SELECT k.kbtitle, c.id, c.comment, u.name, c.date, k.id as id_kb FROM #__support_kb_comment AS c INNER JOIN #__support_kb AS k ON c.id_kb=k.id LEFT JOIN #__users AS u ON u.id=c.id_user WHERE c.publish='0' ORDER BY c.id ", $pageNav->limitstart, $pageNav->limit );

    $rows = $database->loadObjectList();
    if ($database->getErrorNum()) {
        echo $database->stderr();
        return false;
    }

    kb_html::showComments( $rows, $pageNav );
}
?>