<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.mail.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );

// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
if (!is_array( $cid )) {
	$cid = array(0);
}

// Activities logger
mqm_activitylog('admin', 'mail', $task, $cid[0]);

switch ($task) {
	case "categories":
		getCategories();
		break;
		
	case "new":
		editMail( 0 );
		break;

	case "edit":
		editMail( $cid[0] );
		break;

	case "save":
		saveMail();
		break;

	case "remove":
		removeMail( $cid );
		break;

	case "publish":
		publishMail( $cid, 1 );
		break;

	case "unpublish":
		publishMail( $cid, 0 );
		break;

	default:
		showMail();
		break;
}

function getCategories( $id_workgroup=0, $id_category=0, $echo=true )
{
	$database = JFactory::getDBO();
	
	$id_workgroup = JRequest::getInt('id_workgroup', $id_workgroup);
	$id_category = JRequest::getInt('id_category', $id_category);
	
	// Build Workgroups select list
	$sql = "SELECT `id` AS value, `name` AS text 
			FROM `#__support_category`
			WHERE `id_workgroup`=".(int)$id_workgroup." AND `show`=1 AND `tickets`=1
			ORDER BY `name`";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	$rows = array_merge(array(JHTML::_('select.option', '0', JText::_('selectlist'))), $rows);
	$list = JHTML::_('select.genericlist',$rows, 'id_category', 'class="inputbox" size="1"', 'value', 'text', $id_category);
	
	if( $echo ) {
		echo $list;
	}else{
		return $list;
	}
}

function showMail() 
{
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );

	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__support_mail_fetch" );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

	jimport('joomla.html.pagination');;
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$database->setQuery( "SELECT m.id, w.wkdesc, m.server, m.username, m.email"
	. "\nFROM #__support_mail_fetch m, #__support_workgroup w"
	. "\nWHERE m.id_workgroup=w.id"
	. "\nORDER BY w.wkdesc",
	$pageNav->limitstart, $pageNav->limit
	);

	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	mail_html::show( $rows, $pageNav );
}

function editMail( $uid=0 ) 
{
	$database = JFactory::getDBO();
	$row = new mosSupportMailFetch( $database );
	$row->load( $uid );
	
	$captions = array( JText::_('MQ_NO'), JText::_('MQ_YES') );
	$values = array( '0', '1' );
	$lists['remove'] = mqm_switchcheckbox('radio', 'remove', $captions, $values, $row->remove, 'switch');
	$lists['queue'] = mqm_switchcheckbox('radio', 'queue', $captions, $values, $row->queue, 'switch');
	$lists['notls'] = mqm_switchcheckbox('radio', 'notls', $captions, $values, $row->notls, 'switch');
	$lists['ssl'] = mqm_switchcheckbox('radio', 'ssl', $captions, $values, $row->ssl, 'switch');
	$lists['published'] = mqm_switchcheckbox('radio', 'published', $captions, $values, $row->published, 'switch');
	
	// Build Server Type select list
	$ftypelist[] = JHTML::_('select.option', '0', JText::_('selectlist'));
	$ftypelist[] = JHTML::_('select.option', 'pop', 'POP');
	$ftypelist[] = JHTML::_('select.option', 'imap', 'IMAP');
	$lists['type'] = JHTML::_('select.genericlist',$ftypelist, 'type', 'class="inputbox" size="1"', 'value', 'text', $row->type);
	
	// Build Workgroups select list
	$sql = "SELECT `id` AS value, `wkdesc` AS text FROM #__support_workgroup ORDER BY wkdesc";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	$rows = array_merge(array(JHTML::_('select.option', '0', JText::_('selectlist'))), $rows);
	$lists['workgroup'] = JHTML::_('select.genericlist',$rows, 'id_workgroup', 'class="inputbox" size="1" onchange="GetCategories();"', 'value', 'text', $row->id_workgroup);
	
	// Build Status select list
	$sql = "SELECT `id` AS value, `description` AS text FROM #__support_status WHERE status_group='O' AND `show`=1 ORDER BY description";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	$rows = array_merge(array(JHTML::_('select.option', '0', JText::_('selectlist'))), $rows);
	$lists['status'] = JHTML::_('select.genericlist',$rows, 'id_status', 'class="inputbox" size="1"', 'value', 'text', $row->id_status);
	
	// Build Category select list
	$lists['category'] = getCategories( $row->id_workgroup, $row->id_category, false );
	
	mail_html::edit( $row, $lists );
}

function saveMail() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$row = new mosSupportMailFetch( $database );

	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$row->checkin();

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=mail" );
}

function removeMail( $cid ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	if (count( $cid ) < 1) {
		echo "<script type='text/javascript'> alert('".JText::_('email_delete')."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_mail_fetch WHERE id IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=mail" );
}
