<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.readmail.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/**
* Return User UD
* @param database A database connector object
* @param string The name of the category section
* @param array An array of unique category id numbers
*/
function GetUserID( $email ) 
{
	$database = JFactory::getDBO();
	$database->setQuery( "SELECT id, name, email FROM #__users WHERE email=".$database->quote($email) );
	return $database->loadResult();
}

/**
* Inserts a log into the logs table
* @param database A database connector object
* @param string The name of the category section
* @param array An array of unique category id numbers
*/
function ticketLog2( $ticketId, $log, $log_reserved, $id_user, $id_status=0, $image='' ) 
{
	$database = JFactory::getDBO();
	$sql = "INSERT INTO #__support_log(id_ticket, id_user, date_time, log, `log_reserved`, `id_status`, `time_elapse`, `image` ) 
			VALUES('".$ticketId."', '".$id_user."', '".dateOffset("Y-m-d H:i")."', ".$database->quote($log).", ".$database->quote($log_reserved).", ".$id_status.", 0, '".$image."')";
	$database->setQuery( $sql );
	$database->query();
	print $database->getErrorMsg();
}

/**
* Inserts a new message related to a ticket
* @param database A database connector object
* @param string The name of the category section
* @param array An array of unique category id numbers
*/
function ticketMessage ( $ticketId, $message, $id_user ) 
{
	$database = JFactory::getDBO();
	$sql = "INSERT INTO #__support_ticket_resp(id_ticket, id_user, `date`, `message`) 
			VALUES('$ticketId', '$id_user', '".dateOffset("Y-m-d H:i")."', ".$database->quote($message).")";
	$database->setQuery( $sql );
	$database->query();

	print $database->getErrorMsg();
}

/**
* Inserts a new ticket from an e-mail
* @param int The ticket ID in case the ticket already exists
* @param int The Workgroup ID of the e-mail account it is processing
* @param string The e-mail subject
* @param string The e-mail body
* @param string The name of the sender
* @param string The e-mail address of the sender
*/
function Mail2Ticket ( $id, $id_workgroup, $id_category, $subject, $body, $name, $email, $queue=0, $status=0 ) 
{
	$database = JFactory::getDBO();
	$mailer = JFactory::getMailer();
	$CONFIG = new JConfig();
	$mainframe = JFactory::getApplication('administrator');

	$ticketmask = "";

	if( $id == 0 ) {
		$task = 1;
	}else{
		$task = 0;
	}

	// Get the Itemid
	$database->setQuery( "SELECT id FROM #__menu WHERE link='index.php?option=com_maqmahelpdesk'" );
	$Itemid = $database->loadResult();
	
	// Get Workgroup Options
	$database->setQuery( "SELECT * FROM #__support_workgroup WHERE id='".$id_workgroup."'" );
	$wkoptions = null;
	$wkoptions = $database->loadObject();
	print "<br>Support User Auto-Assign: ".$wkoptions->auto_assign."</p>";

	// Get Configuration Options
	$database->setQuery( "SELECT * FROM #__support_config WHERE id='1'" );
	$supportConfig = null;
	$supportConfig = $database->loadObject();
	
	// Get Assigned User
	$database->setQuery( "SELECT name, email FROM #__users WHERE id='".$wkoptions->auto_assign."'" );
	$assigned = null;
	$assigned = $database->loadObject();

	// Get User
	$database->setQuery( "SELECT id, name, email FROM #__users WHERE email=".$database->quote($email) );
	$loguser = null;
	$loguser = $database->loadObject();
	
	if( !isset($loguser->id) && $supportConfig->readmail_create_user && !$queue ) {
		print "<br /><span style='color:orange'>Create new user: <i>".$email."</i></span>";
		$database->setQuery( "SELECT id, name, email FROM #__users WHERE id=".createUser( $email ) );
		$loguser = null;
		$loguser = $database->loadObject();
	}
	
	// User doesn't exist and shouldn't be created set values
	if( !isset($loguser) ) {
		$loguser->id = 0;
		$loguser->name = $name;
		$loguser->email = $email;
	}

	print "<br />User ID: ".$loguser->id;
	print "<br />User Name: ".$loguser->name;
	print "<br />User E-Mail: ".$loguser->email;
	
	// Get the client id
	$sql = "SELECT `id_client` FROM `#__support_client_users` WHERE `id_user`='".$loguser->id."'";
	$database->setQuery( $sql );
	$id_client = $database->loadResult();
	
	// Get Default Status
	if( !$status ) {
		$database->setQuery( "SELECT id FROM #__support_status WHERE isdefault='1'" );
		$status = $database->loadResult();
	}
	
	// Get Default Priority
	$database->setQuery( "SELECT id FROM #__support_priority WHERE isdefault='1'" );
	$priority = $database->loadResult();
	$duedate = ReturnDueDate( date("Y"), date("m"), date("d"), date("H"), date("i"), $priority );
		
	// Check if user is from support or customer
	$sql = "SELECT COUNT(*) FROM #__support_permission WHERE id_workgroup='".$id_workgroup."' AND id_user='".$loguser->id."'";
	$database->setQuery( $sql );
	$is_support = $database->loadResult();
	
	if( ( !$queue && isset($loguser) && $loguser->id ) || $queue ) {
		// Creates or Updates the ticket
		if( $id == 0 ) {
			$sql = "INSERT INTO #__support_ticket(id, id_workgroup, id_category, id_status, id_user, id_client, date, subject, message, last_update, assign_to, id_priority, source, ticketmask, an_name, an_mail, duedate, queue)
					VALUES(0, '".$id_workgroup."', '".$id_category."', '".$status."', '".$loguser->id."', '".$id_client."', '".dateOffset("Y-m-d H:i")."', ".$database->quote($subject).", ".$database->quote($body).", '".dateOffset("Y-m-d H:i")."', '".$wkoptions->auto_assign."', '".$priority."', 'M', '', ".$database->quote($name).", ".$database->quote($email).", '".$duedate."', ".$queue.")";
			$database->setQuery( $sql );
			$database->query();
			$id = $database->insertid();
		}else{
			echo "<p>ticket message $id | ".$loguser->id;
			ticketMessage ( $id, $body, $loguser->id );
			
			// Check if auto-change status should be used
			$sql = "SELECT `id`
					FROM `#__support_status`
					WHERE `auto_status_".($is_support ? 'agents' : 'users')."`=1";
			$database->setQuery( $sql );
			$status_id_new = (int)$database->loadResult();
			
			if( $status_id_new ) {
				// Get current status of ticket
				$sql = "SELECT `id_status`
						FROM `#__support_ticket`
						WHERE `id`=";
				$database->setQuery( $sql );
				$status_id_old = $database->getResult();
				
				// If different change it
				if( $status_id_old != $status_id_new ) {
					echo "<br />Status auto change: $status_id_new";
					$ticketLogMsg = JText::_('changed_status');
					$ticketLogMsg = str_replace( '%1', getUser( $loguser->id ), $ticketLogMsg );
					$ticketLogMsg = str_replace( '%2', getStatus( $status_id_old ), $ticketLogMsg );
					$ticketLogMsg = str_replace( '%3', getStatus( $status_id_new ), $ticketLogMsg );
					ticketLog( $ticket->id, $ticketLogMsg, JText::_('changed_status_hidden'), $status_id_new, 'status', $status_id_new, 0, 'change.gif' );
				}
			}
		}
		
		echo "<br />ID: $id";

		// Update Ticket Mask
		if( $task == 1) {
			$ticketmask = rand(10,99).$id.rand(1000,9999);
			print "<br />Ticket Mask: ".$ticketmask."<br />";
			$database->setQuery( "UPDATE #__support_ticket SET ticketmask='".$ticketmask."' WHERE id='".$id."'" );
		}else{
			$database->setQuery( "SELECT ticketmask FROM #__support_ticket WHERE id='".$id."'" );
			$debug_ticketmask = $database->loadObject();
			print "<br />Ticket Mask: ".$debug_ticketmask->ticketmask."<br />";
			
			$database->setQuery( "UPDATE #__support_ticket SET last_update='".dateOffset("Y-m-d H:i")."' WHERE id='".$id."'" );
		}
		$database->query();
		print $database->getErrorMsg();

		// Get the ticket record
		$row_ticket = null;
		$database->setQuery( "SELECT * FROM #__support_ticket WHERE id='".$id."'" );
		$row_ticket = $database->loadObject();
		
		// Insert Custom Fields
		$database->setQuery( "SELECT id_field FROM #__support_wk_fields WHERE id_workgroup='".$id_workgroup."' ORDER BY ordering" );
		$customfields = $database->loadObjectList();
		print $database->getErrorMsg();

		if( $task == 1 ) {
			$x = 0;
			for ($x=0; $x < count($customfields); $x++) {
				$rowField = $customfields[$x];
				$database->setQuery( "INSERT INTO #__support_field_value(id_field, id_ticket, newfield) VALUES('".$rowField->id_field."', '".$id."', '')" );
				$database->query();
				print $database->getErrorMsg();
			}
		}

		echo "<p><span style='color:blue'>- notifications -</span>";
		
		// Insert Logs of Creation of Ticket and Auto-Assign
		if( $task == 1 ) {
			ticketLog2( $id, str_replace( '%1', $name, JText::_('ticket_created')), JText::_('ticket_created_hidden'), $loguser->id, 0, 'add_ticket.gif' );
			
			if( $wkoptions->auto_assign > 0 ) {
				ticketLog2( $id, str_replace( '%1', $assigned->name, JText::_('ticket_assigned')), JText::_('assigned_hidden'), $loguser->id, 0, 'add_assign.png' );
			}
		}

		$sendmail1 = "";
		$sendmail2 = "";
		
		// Set Email Notify Template variables
		$ticket_url = JURI::root() . 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$wkoptions->id.'&task=ticket_view&id='.$id;

		$var_set = array( '[number]' => $row_ticket->ticketmask,
						'[title]' => '',
						'[message]' => '',
						'[date]' => dateOffset( getDateShortFrmt() ),
						'[dateshort]' => dateOffset( getDateShortFrmt() ),
						'[datelong]' => dateOffset( getDateLongFrmt() ),
						'[duedate]' => $row_ticket->duedate,
						'[duedate_old]' => '',
						'[assign]' => isset($assigned) ? $assigned->name : '',
						'[assign_email]' => isset($assigned) ? $assigned->email : '',
						'[unassigned]' => '',
						'[unassigned_email]' => '',
						'[subject]' => stripslashes( $subject ),
						'[ticket_message]' => stripslashes( nl2br(strip_tags( $body )) ),
						'[summary]' => '',
						'[reply_message]' => '',
						'[author]' => getUser( $loguser->id ),
						'[user]' => $name,
						'[email]' => $email,
						'[client]' => '',
						'[url]' => $ticket_url,
						'[workgroup]' => $wkoptions->wkdesc,
						'[priority]' => getPriority( $priority ),
						'[priority_old]' => '',
						'[status]' => getStatus( $status ),
						'[status_old]' => '',
						'[category]' => getCategory( $row_ticket->id_category ),
						'[category_old]' => '',
						'[source]' => JText::_('email'),
						'[anonymous]' => sprintf(JText::_('anonymous_ticket_fetch'), $row_ticket->ticketmask, $row_ticket->ticketmask, $email)
						);

		// Notify users - Assigned User and User that requested the support
		if( $task == 1 ) {
			if( !$queue ) {
				if( $wkoptions->auto_assign > 0 ) {
					$msginfo->message = parseTpl( $var_set, 'tkt_notification' );
					$msginfo->subject = parseTpl( $var_set, '', JText::_('ticket_created_mail_subject') );
					$mailer->setSender( ( $wkoptions->wkmail_address != '' ? $wkoptions->wkmail_address : $CONFIG->mailfrom ), $wkoptions->wkmail_address_name );
					$mailer->addRecipient( $assigned->email );
					$mailer->setSubject( $msginfo->subject );
					$mailer->setBody( $msginfo->message );
					$mailer->IsHTML( true );
					$sendmail = $mailer->Send();
					print "<p>".JText::_('mail_to_assigned_user')." - ".$assigned->email.': '.$sendmail.'</p>';
				}

				// Notify Workgroup Administrator
				if( $wkoptions->wkemail && $wkoptions->wkadmin_email ) {
					$msginfo->message = parseTpl( $var_set, 'tkt_notification' );
					$msginfo->subject = parseTpl( $var_set, '', JText::_('ticket_created_mail_subject') );
					$mailer->setSender( $CONFIG->mailfrom, $CONFIG->fromname );
					$mailer->addRecipient( ( $wkoptions->wkadmin_email != '' ? $wkoptions->wkadmin_email : ($wkoptions->wkmail_address != '' ? $wkoptions->wkmail_address : $CONFIG->mailfrom) ) );
					$mailer->setSubject( $msginfo->subject );
					$mailer->setBody( $msginfo->message );
					$mailer->IsHTML( true );
					$sendmail = $mailer->Send();
					print '<p>'.JText::_('notify_workgroup_admin')." - ".( $wkoptions->wkadmin_email != '' ? $wkoptions->wkadmin_email : ($wkoptions->wkmail_address != '' ? $wkoptions->wkmail_address : $CONFIG->mailfrom) ).': '.$sendmail.'</p>';
				}
				
				// Notify System Administrator
				if( $supportConfig->receive_mail ) {
					$body = parseTpl( $var_set, 'tkt_notification' );
					$subject = parseTpl( $var_set, '', JText::_('ticket_created_mail_subject') );
					$mailer->setSender( $CONFIG->mailfrom, $CONFIG->fromname );
					$mailer->addRecipient( $CONFIG->mailfrom );
					$mailer->setSubject( $subject );
					$mailer->setBody( $body );
					$mailer->IsHTML( true );
					$sendmail = $mailer->Send();
					print '<p>'.JText::_('notify_system_admin')." - ".$CONFIG->mailfrom.': '.$sendmail.'</p>';
				}
				
				// Notify customer about ticket creation
				unset($mailer);
				$mailer = JFactory::getMailer();
				if( $loguser->id ) {
					$body = parseTpl( $var_set, 'tkt_notification_fetch' );
				}else{
					$body = parseTpl( $var_set, 'tkt_notification_anonymous' );
				}
				$subject = parseTpl( $var_set, '', JText::_('ticket_created_mail_subject') );
				$mailer->setSender( $CONFIG->mailfrom, $CONFIG->fromname );
				$mailer->addRecipient( $loguser->email );
				$mailer->setSubject( $subject );
				$mailer->setBody( $body );
				$mailer->IsHTML( true );
				$sendmail = $mailer->Send();
				print '<p>'.JText::_('mail_to_user')." - ".$loguser->email.': '.$sendmail.'</p>';
			}
		} else {
			// Notify assigned user if the message is from customer and notify customer that message was saved
			if( !$is_support ) {
				$msginfo->message = parseTpl( $var_set, 'tkt_notification' );
				$msginfo->subject = parseTpl( $var_set, '', JText::_('ticket_reply_mail_subject') );
				$mailer->setSender( $wkoptions->wkmail_address, $wkoptions->wkmail_address_name );
				$mailer->addRecipient( $assigned->email );
				$mailer->setSubject( $msginfo->subject );
				$mailer->setBody( $msginfo->message );
				$mailer->IsHTML( true );
				$sendmail = $mailer->Send();
				print "<p>".JText::_('mail_to_user')." 2 (notify user) : ".intval($sendmail).'</p>';
				
			// Notify customer if the message is from support user
			}else{
				$msginfo->message = parseTpl( $var_set, 'tkt_notification_customer' );
				$msginfo->subject = parseTpl( $var_set, '', JText::_('ticket_reply_mail_subject') );
				$mailer->setSender( $wkoptions->wkmail_address, $wkoptions->wkmail_address_name );
				$mailer->addRecipient( $userinfo->email );
				$mailer->setSubject( $msginfo->subject );
				$mailer->setBody( $msginfo->message );
				$mailer->IsHTML( true );
				$sendmail = $mailer->Send();
				print "<p>".JText::_('mail_to_user')." 3 (message from support user > notify customer) : ".intval($sendmail).'</p>';
			}
		}
	}else{
		print '<p color="#f00000">'.JText::_('user_email_dont_exist').'</p>';
	}

	return $id;
}

/**
* Inserts a log into the logs table for the emails
* @param database A database connector object
* @param string The name of the category section
* @param array An array of unique category id numbers
*/
function mailLog( $id, $mail, $log, $emailid ) 
{
	$database = JFactory::getDBO();
	
	$sql = "INSERT INTO #__support_mail_log(`id_mail_fetch`, `date`, `email`, `log`, `emailid`) 
			VALUES('$id', '".dateOffset("Y-m-d H:i:s")."', '$mail', '$log', '$emailid')";
	$database->setQuery( $sql );
	$database->query();
	print $database->getErrorMsg();
}

function createUser( $email ) 
{
	$database = JFactory::getDBO();

	$CONFIG = new JConfig();
	$mailer = JFactory::getMailer();
	
	list($username,$domain) = explode("@",$email);
	$username1 = $username.rand(100,999).rand(100,999);
	$salt = md5(rand(100,999));
	$password = rand(1000,99999);
	$pass = md5($password.$salt).':'.$salt;
	
	if( jversion15_check() ) {
		$database->setQuery( "INSERT INTO #__users(`name`, username, password, email, usertype, sendEmail, gid, registerDate) VALUES(".$database->quote($username).", ".$database->quote($username1).", '".$pass."', ".$database->quote($email).", 'Registered', '0', '18', '".date("Y-m-d H:i")."')" );
		$database->query();
		$id_user = $database->insertid();
		
		$database->setQuery( "INSERT INTO #__core_acl_aro(section_value, value, order_value, name, hidden) VALUES('users', '".$id_user."', '0', ".$database->quote($email).", '0')" );
		$database->query();
		$id_core = $database->insertid();
		
		$database->setQuery( "INSERT INTO #__core_acl_groups_aro_map(group_id, section_value, aro_id) VALUES('18', '', '".$id_core."')" );
		$database->query();
	}else{
		$sql = sprintf("INSERT INTO `#__users`(`name`, `username`, `email`, `password`, `registerDate`) 
    					VALUES('%s', '%s', '%s', '%s', '".date("Y-m-d H:i:s")."')", 
    						$username, 
    						$username1, 
    						$email, 
    						$pass);
		$database->setQuery( $sql );
		$database->query();
		$id_user = $database->insertid();
		
		$sql = "INSERT INTO `#__user_usergroup_map`(`user_id`, `group_id`)
    			VALUES('".$id_user."', '2')";
    	$database->setQuery( $sql );
		$database->query();
	}
	
	$body_html = "<p>Welcome ".$username.",</p>
	<p>Your account has been activated with the following details:</p>
	<p>Email : ".$email." <br />Username : ".$username1." <br />Password : ".$password." </p>
	<p>Kind Regards, <br />
	".$CONFIG->sitename;
	
	$subject = 'New User Details';

	// check if Global Config `mailfrom` and `fromname` values exist
	if ($CONFIG->mailfrom != '' && $CONFIG->fromname != '') {
		$adminName2 = $CONFIG->fromname;
		$adminEmail2 = $CONFIG->mailfrom;
	} else {
		// use email address and name of first superadmin for use in email sent to user
		$query = "SELECT name, email"
		. "\n FROM #__users"
		. "\n WHERE LOWER( usertype ) = 'superadministrator'"
		. "\n OR LOWER( usertype ) = 'super administrator'"
		;
		$database->setQuery( $query );
		$rows = $database->loadObjectList();
		$row2 = $rows[0];
		
		$adminName2 = $row2->name;
		$adminEmail2 = $row2->email;
	}
	
	// Send email to user
	echo "<p>adminEmail2: $adminEmail2";
	echo "<p>adminName2: $adminName2";
	echo "<p>email: $email";
	echo "<p>subject: $subject";
	echo "<p>message: $body_html";
	
	$mailer->addRecipient( $email );
	$mailer->setSender( $adminEmail2, $adminName2 );
	$mailer->setSubject( $subject );
	$mailer->setBody( $body_html );
	$mailer->IsHTML( true );
	$sendmail = $mailer->Send();
	print "<br />Mail user creation: ".intval($sendmail);

	return $id_user;
}
