<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.staff.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );

// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );

if (!is_array( $cid )) {
	$cid = array(0);
}

$id = intval( JRequest::getVar( 'id', 0, '', 'int' ) );
$uid = intval( JRequest::getVar( 'uid', 0, '', 'int' ) );
$permission = intval( JRequest::getVar( 'permission', 0, '', 'int' ) );
$action = intval( JRequest::getVar( 'action', 0, '', 'int' ) );

// Activities logger
mqm_activitylog('admin', 'staff', $task, $cid[0]);

switch ($task) {
	case "categories":
		getCategories();
		break;
		
	case "new":
		editPermission( 0 );
		break;

	case "edit":
		editPermission( $cid[0] );
		break;

	case "save":
		savePermission();
		break;

	case "remove":
		removePermission( $cid );
		break;

	case "edit2":
		editStaff2( $cid[0] );
		break;

	case "permission":
		changePermission( $id, $permission, $uid );
		break;

	default:
		showStaff();
		break;
}

function getCategories( $id_workgroup=0, $id_user=0, $echo=true )
{
	$database = JFactory::getDBO();
	$id_workgroup = JRequest::getInt('id_workgroup', $id_workgroup);
	$id_user = JRequest::getInt('id_user', $id_user);
	
	// Build Workgroups select list
	$sql = "SELECT c.`id`, c.`name`, p.`id` AS cid
			FROM `#__support_category` AS c
				 LEFT JOIN `#__support_permission_category` AS p ON p.`id_category`=c.`id` AND p.`id_workgroup`=".(int)$id_workgroup." AND p.`id_user`=".(int)$id_user."
			WHERE c.`id_workgroup`=".(int)$id_workgroup." AND c.`show`=1 AND c.`tickets`=1
			ORDER BY c.`name`";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	
	$list = '<select id="id_category" name="id_category[]" class="medium" size="7" multiple="multiple">';
	foreach( $rows as $row )
	{
		$list.= '<option value="'.$row->id.'" '.($row->cid ? 'selected' : '').'>'.$row->name.'</option>';
	}
	$list.= '<select>';
	
	if( $echo ) {
		echo $list;
	}else{
		return $list;
	}
}

function changePermission( $id, $permission, $uid ) 
{
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();

	$database->setQuery( "UPDATE #__support_permission SET manager='".$permission."' WHERE id='".$id."'" );
	$database->query();

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=staff_edit2&cid[0]=".$uid );
}

function showStaff() 
{
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = JRequest::getInt( 'limitstart', 0 );
	$id_workgroup = JRequest::getInt( 'id_workgroup', 0 );
	
	// get the total number of records
	$database->setQuery( "SELECT count(distinct(id_user)) FROM #__support_permission" );
	$total = $database->loadResult();
	echo $database->getErrorMsg();
	
	jimport('joomla.html.pagination');;
	$pageNav = new JPagination( $total, $limitstart, $limit );
	
	$sql = "SELECT distinct(p.id_user), u.id, u.name, u.username, p.level 
			FROM #__support_permission p, #__users u, #__support_workgroup w 
			WHERE u.id=p.id_user AND p.id_workgroup=w.id ".($id_workgroup ? "AND p.id_workgroup=$id_workgroup" : "")."
			ORDER BY u.name";
	$database->setQuery( $sql, $pageNav->limitstart, $pageNav->limit );
	
	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}
	
	// Build Workgroup select list
	$sql = "SELECT `id` AS value, `wkdesc` AS text FROM #__support_workgroup";
	$database->setQuery($sql);
	$rows_wk = $database->loadObjectList();
	$rows_wk = array_merge(array(JHTML::_('select.option', '0', JText::_('all'))), $rows_wk);
	$lists['workgroup'] = JHTML::_('select.genericlist', $rows_wk, 'id_workgroup', 'class="inputbox" size="1" onchange="document.filterForm.submit();"', 'value', 'text', $id_workgroup);
	
	staff_html::show( $rows, $lists, $pageNav );
}

function editStaff2( $uid=0 ) {
	$database = JFactory::getDBO();

	// Get User Info
	$database->setQuery( "SELECT * FROM #__users WHERE id='".$uid."'" );
	$userInfo = null;
	$userInfo = $database->loadObject();
	
	// Get number of tickets
	$database->setQuery( "SELECT COUNT(*) FROM #__support_ticket WHERE assign_to='".$uid."'" );
	$lists['ticket_total'] = $database->loadResult();

	// Get number of kb articles
	$database->setQuery( "SELECT COUNT(*) FROM #__support_kb WHERE id_user='".$uid."'" );
	$lists['kb_total'] = $database->loadResult();

	// Get number of ticket responses
	$database->setQuery( "SELECT COUNT(*) FROM #__support_ticket_resp WHERE id_user='".$uid."'" );
	$lists['resp_total'] = $database->loadResult();

	// Get user permissions
	$database->setQuery( "SELECT p.id, p.manager, w.wkdesc FROM #__support_permission p, #__support_workgroup w WHERE p.id_workgroup=w.id AND p.id_user='".$uid."' ORDER BY w.wkdesc" );
	$permissions = $database->loadObjectList();
	
	staff_html::edit2( $userInfo, $lists, $permissions );
}

function editPermission( $uid=0 ) {
	$database = JFactory::getDBO();

	$row = new mosSupportPermission( $database );
	// load the row from the db table
	$row->load( $uid );
	
	// get the name of the user
	$sql = "SELECT `name` FROM `#__users` WHERE `id`='".$row->id_user."'";
	$database->setQuery( $sql );
	$row->name = $database->loadResult();

	// Build Workgroup select list
	$sql = "SELECT `id` AS value, `wkdesc` AS text FROM #__support_workgroup";
	$database->setQuery($sql);
	$rows_wk = $database->loadObjectList();
	$rows_wk = array_merge(array(JHTML::_('select.option', '0', JText::_('select3'))), $rows_wk);
	$lists['workgroup'] = JHTML::_('select.genericlist',$rows_wk, 'id_workgroup', 'class="inputbox" size="1" onchange="GetCategories();"', 'value', 'text', $row->id_workgroup);
	
	// Build Category select list
	$lists['category'] = getCategories( $row->id_workgroup, $row->id_user, false );
	
	// Usertype
	$sup_usertype[] = JHTML::_('select.option', '7', JText::_('manager') );
	$sup_usertype[] = JHTML::_('select.option', '6', JText::_('team_leader') );
	$sup_usertype[] = JHTML::_('select.option', '5', JText::_('support_user') );
	$lists['sup_usertype'] = JHTML::_('select.genericlist', $sup_usertype, 'manager', 'class="inputbox" size="1"', 'value', 'text', $row->manager);
	
	// Support level
	$level[] = JHTML::_('select.option', '0', JText::_('NOT_APPLICABLE') );
	for( $i=1; $i<11; $i++ ) {
		$level[] = JHTML::_('select.option', $i, sprintf(JText::_('SUPPORT_LEVEL_LABEL'), $i) );
	}
	$lists['level'] = JHTML::_('select.genericlist', $level, 'level', 'class="inputbox" size="1"', 'value', 'text', $row->level);
	
	$captions = array( JText::_('MQ_NO'), JText::_('MQ_YES') );
	$values = array( '0', '1' );
	
	$assign_aditional = ($row->assign_report_users == '')? 0 : 1;
	$lists['assign_report'] = mqm_switchcheckbox('radio', 'assign_report', $captions, $values, $assign_aditional, 'switch', 'showhidediv();');
	$lists['can_delete'] = mqm_switchcheckbox('radio', 'can_delete', $captions, $values, $row->can_delete, 'switch');
	
	// Build Users checkboxs list
	$sql = "SELECT DISTINCT u.`id` AS value, u.`name` AS text 
			FROM `#__users` AS u INNER JOIN `#__support_permission` AS p ON p.`id_user`=u.`id`
			WHERE `id_user`!=".(int)$row->id_user."
			ORDER BY u.`name`";
	$database->setQuery($sql);
	$rows_user = $database->loadObjectList();
	ob_start(); ?>
	<div id="div_support_users"><?php
	if (count($rows_user) > 0 ) {
		$users_report_aditional = "";
		if ($row->assign_report_users != '') {
			$users_report_aditional = explode('#',$row->assign_report_users);
		}
		foreach ($rows_user as $row_user) {
			$checked = is_array($users_report_aditional)? (in_array($row_user->value,$users_report_aditional)? " checked " : ""): ""; ?>
			<p style="margin:0;line-height:10px;padding:0;"><label><input name="assign_report_users[<?php echo $row_user->value; ?>]" value="1" type="checkbox" <?php echo $checked; ?> /> <?php echo $row_user->text; ?></label></p><?php
		}
	} ?>
	</div><?php
	$aditional_assign_user = ob_get_contents();
	ob_end_clean();	
	$lists['assign_report_users'] = $aditional_assign_user;
	
	// Get user schedules
	$database->setQuery( "SELECT id, profile FROM #__support_schedule ORDER BY id, profile ");
	$schedules_list = $database->loadObjectList();
	$numb_schedules = sizeof($schedules_list);

	if ($numb_schedules > 0) {
		$arr = array();
		for ($i = 0; $i < $numb_schedules; $i++) {
			$arr[] = get_object_vars($schedules_list[$i]);		
		}	
		$schedules[] = JHTML::_('select.option',  '0', JText::_('schedule_select') );
		for ($i=0; $i < $numb_schedules; $i++) {
			$schedules[] = JHTML::_('select.option', $arr[$i]['id'], $arr[$i]['profile']);
		}
		$lists['schedules'] = JHTML::_('select.genericlist',$schedules, 'id_schedule', 'class="inputbox" size="1"', 'value', 'text', $row->id_schedule);
	} else {
		ob_start();
		echo "<input type='hidden' name='id_schedule' value='0' />";
		echo "<span style='color:red;' >".JText::_('no_schedule_list_alert')."</span>";
		$sc = ob_get_contents();
		ob_end_clean();	
		$lists['schedules'] = $sc;
	}
	
	$lists['vacances'] = $row->vacances;
	
	staff_html::edit( $row, $lists );
}

function savePermission() 
{
	global $supportConfig;
	 
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();

	$id 				 = intval( JRequest::getVar( 'id', '', '', 'int' ) );
	$id_workgroup 		 = intval( JRequest::getVar( 'id_workgroup', '', '', 'int' ) );
	$id_user 			 = intval( JRequest::getVar( 'id_user', '', '', 'int' ) );
	$manager 			 = intval( JRequest::getVar( 'manager', '', '', 'int' ) );
	$id_schedule 		 = intval( JRequest::getVar( 'id_schedule', '', '', 'int' ) );
	$can_delete 		 = intval( JRequest::getVar( 'can_delete', '', '', 'int' ) );
	$level 		 		 = intval( JRequest::getVar( 'level', '', '', 'int' ) );
	$vacances 			 = JRequest::getVar( 'vacances', '', '', 'string' );
	$assign_report 		 = intval( JRequest::getVar( 'assign_report', '0', '', 'int' ) );
	$report_users_colect = JRequest::getVar( 'assign_report_users', '', '', 'array' );
	$categories			 = JRequest::getVar( 'id_category', '', '', 'array' );
	
	if ($assign_report==1) {
		$assign_report_users = "";
		foreach ($report_users_colect as $chave=>$valor) {
			$assign_report_users .= $chave."#";
			echo ($chave.":".$valor."<br />");
		}
		$assign_report_users = substr_replace($assign_report_users,"",-1);
	} else {
		$assign_report_users = '';
	}
	
	// Check for ticket manager views
	$sql = "SELECT COUNT(*)
			FROM `#__support_permission`
			WHERE `id_user`=".$id_user;
	$database->setQuery( $sql );
	$permissions = (int)$database->loadResult();
	
	if( $id ){
		$sql = "UPDATE `#__support_permission` 
				SET `id_user` = ".$id_user.", `id_workgroup` = ".$id_workgroup.", `manager` = ".$manager.", `id_schedule` = ".$id_schedule.", `vacances` = ".$database->quote($vacances).", `can_delete` = ".$database->quote($can_delete).", `assign_report_users` = ".$database->quote($assign_report_users).", `level` = ".$database->quote($level)."
				WHERE `id` = ".$id." ";
		$database->setQuery( $sql );
		$database->query();
	}else{
		$sql = "INSERT INTO `#__support_permission` (`id`,`id_user`,`id_workgroup`,`manager`,`id_schedule`,`vacances`,`assign_report_users`,`can_delete`, `level`) 
				VALUES (".$id.",".$id_user.",".$id_workgroup.",".$manager.",".$id_schedule.",".$database->quote($vacances).",".$database->quote($assign_report_users).",".$can_delete.",".$level.") ";
		$database->setQuery( $sql );
		$database->query();
		$id = $database->insertid();
	}
	
	// Set categories
	$sql = "DELETE FROM `#__support_permission_category`
			WHERE `id_workgroup`=".$id_workgroup." AND `id_user`=".$id_user;
	$database->setQuery( $sql );
	$database->query();
	for( $i=0; $i<count($categories); $i++ )
	{
		$sql = "INSERT INTO `#__support_permission_category`(`id_workgroup`, `id_category`, `id_user`)
				VALUES(".$id_workgroup.", ".$categories[$i].",".$id_user.")";
		$database->setQuery( $sql );
		$database->query();
	}
	
	// Create default views for ticket manager
	//echo "<p>-".$id;
	//echo "<p>-".$supportConfig->common_ticket_views;
	//echo "<p>-".$permissions;
	if( !$id && !$supportConfig->common_ticket_views && !$permissions ) {
		$id = $database->insertid();
		$operator = 'AND'.($manager>5 ? '|OR' : '');
		$field = 't.assign_to'.($manager>5 ? '|t.assign_to' : '');
		$arithmetic = '='.($manager>5 ? '|=' : '');
		$value = $id_user.''.($manager>5 ? '|0' : '');
		$sql = "INSERT INTO `#__support_views`(`id_user`, `name`, `viewtype`, `ordering`, `operator`, `field`, `arithmetic`, `value`, `default`)
				VALUES($id_user, '".JText::_('lbl_assigned_to_me').($manager>5 ? ' '.JText::_('lbl_not_assigned') : '')."', 'table', 't.duedate', '$operator', '$field', '$arithmetic', '$value', 1)";
		$database->setQuery( $sql );
		$database->query();
	}
	
	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=staff" );
}

function removePermission( $cid ) 
{
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	if (count( $cid ) < 1) {
		echo "<script type='text/javascript'> alert('".JText::_('staff_delete')."'); window.history.go(-1);</script>\n";
		exit;
	}
	
	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_permission WHERE id IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}else{
			for( $i=0; $i<count($cid); $i++ )
			{
				$id_user = (int)$cid[$i];
				
				$sql = "SELECT COUNT(*)
						FROM `#__support_permission`
						WHERE `id_user`=".$id_user;
				$database->setQuery( $query );
				$permissions = (int)$database->loadResult();
				
				if( !$permissions ) {
					$sql = "DELETE FROM #__support_views 
							WHERE id_user=".$id_user;
					$database->setQuery( $sql );
					$database->query();
				}
			}
		}
	}
	
	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=staff" );
}
