<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.status.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );

// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
if (!is_array( $cid )) {
	$cid = array(0);
}

// Activities logger
mqm_activitylog('admin', 'status', $task, $cid[0]);

switch ($task) {
	case "new":
		editStatus( 0 );
		break;

	case "edit":
		editStatus( $cid[0] );
		break;

	case "save":
		saveStatus();
		break;

	case "remove":
		removeStatus( $cid );
		break;

	case "publish":
		publishStatus( $cid, 1 );
		break;

	case "unpublish":
		publishStatus( $cid, 0 );
		break;

	default:
		showStatus();
		break;
}

/**
* Compiles a list of priorities
* @param string The component name
*/
function showStatus() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );

	//$user_access[] = JHTML::_('select.option',  0, JText::_('select_log') );	
	
	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__support_status ORDER BY description" );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

	jimport('joomla.html.pagination');;
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$database->setQuery( "SELECT s.id, s.description, s.show, s.status_group, s.isdefault_manager, s.isdefault, s.user_access"
	. "\nFROM #__support_status s"
	. "\nORDER BY s.status_group, s.description",
	$pageNav->limitstart, $pageNav->limit
	);

	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	status_html::show( $rows, $pageNav );
}

/**
* Compiles information to add or edit a priority
* @param database A database connector object
* @param string The component name
*/
function editStatus( $uid=0 ) {
	$database = JFactory::getDBO();

	$row = new mosSupportStatus( $database );
	$row->load( $uid );

	$status_groups[] = JHTML::_('select.option', '0', JText::_('selectlist'));
	$status_groups[] = JHTML::_('select.option', 'O', JText::_('open'));
	$status_groups[] = JHTML::_('select.option', 'C', JText::_('closed'));
	$lists['group'] = JHTML::_('select.genericlist',$status_groups, 'status_group', 'class="inputbox" size="1"', 'value', 'text', $row->status_group);

	$status_side[] = JHTML::_('select.option', '0', JText::_('status_side_not_used'));
	$status_side[] = JHTML::_('select.option', '1', JText::_('support_user'));
	$status_side[] = JHTML::_('select.option', '2', JText::_('user'));
	$lists['status_side'] = JHTML::_('select.genericlist',$status_side, 'ticket_side', 'class="inputbox" size="1"', 'value', 'text', $row->ticket_side);
	
	$captions = array( JText::_('MQ_NO'), JText::_('MQ_YES') );
	$values = array( '0', '1' );
	
	$lists['default'] = mqm_switchcheckbox('radio', 'isdefault', $captions, $values, $row->isdefault, 'switch');
	$lists['default_manager'] = mqm_switchcheckbox('radio', 'isdefault_manager', $captions, $values, $row->isdefault_manager, 'switch');
	$lists['show'] = mqm_switchcheckbox('radio', 'show', $captions, $values, $row->show, 'switch');
	$lists['user_access'] = mqm_switchcheckbox('radio', 'user_access', $captions, $values, $row->user_access, 'switch');
	$lists['allow_old_status_back'] = mqm_switchcheckbox('radio', 'allow_old_status_back', $captions, $values, $row->allow_old_status_back, 'switch');
	$lists['auto_status_agents'] = mqm_switchcheckbox('radio', 'auto_status_agents', $captions, $values, $row->auto_status_agents, 'switch');
	$lists['auto_status_users'] = mqm_switchcheckbox('radio', 'auto_status_users', $captions, $values, $row->auto_status_users, 'switch');
	
	$database->setQuery( "SELECT id, description FROM #__support_status " ); 
	$status_list = $database->loadObjectList();

	$status_checked = explode ("#",$row->status_workflow);
	$checkbox_status_workflow ="";
	if( count($status_list) > 0 ) {
		$checkbox_status_workflow ="";
		for($i=0, $n =count($status_list); $i < $n; $i++) {
			$status = &$status_list[$i];
			if ($row->id == $status->id) {
				$value = 0;
				$readonly = "disabled";
				$checked = "";
			} else {
				$value = 1;
				$readonly = "";
				$checked = in_array($status->id, $status_checked)? "checked": "";
			}
			$checkbox_status_workflow .= "<input type='checkbox' name='status_id[".$status->id."]' value='".$value."' ".$checked." ".$readonly." /> ".$status->description." <br />";
		}
		$lists['status_workflow'] = '<div class="controlset-pad">'.$checkbox_status_workflow.'</div>';
	} else {
		$lists['status_workflow'] = "";
	}
	
	status_html::edit( $row, $lists, count($status_list) );
}

/**
* Saves the workgroup
* @param database A database connector object
* @param string The name of the component
*/
function saveStatus() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$row = new mosSupportStatus( $database );

	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$id 					= intval( JRequest::getVar( 'id', '', '', 'int' ) );
	$description 			= JRequest::getVar( 'description', '', '', 'string' );
	$status_group 			= JRequest::getVar( 'status_group', '', '', 'string' );
	$isdefault 				= intval( JRequest::getVar( 'isdefault', '', '', 'int' ) );
	$show  					= intval( JRequest::getVar( 'show', '', '', 'int' ) );
	$user_access  			= intval( JRequest::getVar( 'user_access', '', '', 'int' ) );
	$allow_old_status_back 	= intval( JRequest::getVar( 'allow_old_status_back', '', '', 'int' ) );
	$status_id 				= JRequest::getVar( 'status_id', '', '', 'array' );	
	
	$status_workflow = "";
	foreach ($status_id as $chave=>$valor) {
		$status_workflow .= $chave."#";
	}
	$status_workflow = substr($status_workflow, 0, -1);
	
	$query = "UPDATE #__support_status SET `description` = ".$database->quote($description).", `show` = ".$show.", `status_group` = ".$database->quote($status_group).", `isdefault` = ".$isdefault.", `user_access` = ".$user_access.", `allow_old_status_back` = ".$allow_old_status_back.", `status_workflow` = ".$database->quote($status_workflow)." WHERE `id` = ".$id." ";
	$database->setQuery( $query );
	if (!$database->query()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	//$row->checkin();
	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=status" );
}

/**
* Deletes one or more categories from the categories table
* @param database A database connector object
* @param string The name of the priority section
* @param array An array of unique priority id numbers
*/
function removeStatus( $cid ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();

	if (count( $cid ) < 1) {
		echo "<script type='text/javascript'> alert('".JText::_('status_delete')."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_status WHERE id IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=status" );
}

/**
* Publishes or Unpublishes one or more workgroups
* @param database A database connector object
* @param array An array of unique workgroup id numbers
* @param integer 0 if unpublishing, 1 if publishing
* @param string The name of the component
*/
function publishStatus( $cid=null, $publish=1 ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();

	if ( !is_array( $cid ) || count( $cid ) < 1 ) {
		$action = $publish ? 'publish' : 'unpublish';
		echo "<script type='text/javascript'> alert('".JText::_('status_action')." ".$action."'); window.history.go(-1);</script>\n";
		exit;
	}

	$cids = implode( ',', $cid );
	$count = count( $cid );

	$database->setQuery( "UPDATE #__support_status SET `show`='$publish' WHERE id IN (".$database->quote($cids).")" );

	if (!$database->query()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=status" );
}
?>