<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.wkfields.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );

// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );

if (!is_array( $cid )) {
	$cid = array(0);
}

// Activities logger
mqm_activitylog('admin', 'wkfields', $task, $cid[0]);

switch ($task) {
	case "sections":
		getSections();
		break;
		
	case "new":
		editCustomField( 0 );
		break;

	case "edit":
		editCustomField( $cid[0] );
		break;

	case "save":
		saveCustomField();
		break;

	case "remove":
		removeCustomField( $cid );
		break;

	case 'saveorder':
		saveOrder();
		break;

	default:
		showCustomField();
		break;
}

function getSections( $id_workgroup=0, $value='', $echo=true )
{
	$database = JFactory::getDBO();
	$id_workgroup = JRequest::getInt('id_workgroup', $id_workgroup);
	
	$sql = "SELECT DISTINCT(`section`) AS value, `section` AS text 
			FROM #__support_wk_fields 
			WHERE `id_workgroup`=".(int)$id_workgroup." AND `section`!=''
			ORDER BY `section`";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	
	$list = '<select id="section" name="section" class="medium" size="1">';
	$list.= '<option value="">'.JText::_('selectlist').'</option>';
	foreach( $rows as $row )
	{
		$list.= '<option value="'.$row->value.'" '.($row->value == $value ? 'selected' : '').'>'.$row->text.'</option>';
	}
	$list.= '<select>';
	
	if( $echo ) {
		echo $list;
	}else{
		return $list;
	}
}

function showCustomField() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );
	echo '<script type="text/javascript" src="../components/com_maqmahelpdesk/js/tablednd.min.js"></script>';

	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__support_wk_fields" );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

	jimport('joomla.html.pagination');;
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$database->setQuery( "SELECT s.id, f.caption, f.ftype, w.wkdesc, s.required, s.support_only, s.new_only, s.section"
	. "\nFROM #__support_wk_fields s, #__support_custom_fields f, #__support_workgroup w"
	. "\nWHERE s.id_workgroup=w.id AND s.id_field=f.id"
	. "\nORDER BY w.wkdesc, s.section, s.ordering",
	$pageNav->limitstart, $pageNav->limit
	);

	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	cfield_html::show( $rows, $pageNav );
}

function editCustomField( $uid=0 ) {
	$database = JFactory::getDBO();

	$row = new mosSupportWKFields( $database );
	// load the row from the db table
	$row->load( $uid );
	
	// Build Workgroup select list
	$sql = "SELECT `id` AS value, `wkdesc` AS text 
			FROM #__support_workgroup
			ORDER BY `wkdesc`";
	$database->setQuery($sql);
	$rows_wk = $database->loadObjectList();
	$rows_wk = array_merge(array(JHTML::_('select.option', '0', JText::_('selectlist'))), $rows_wk);
	$lists['workgroup'] = JHTML::_('select.genericlist',$rows_wk, 'id_workgroup', 'class="inputbox" size="1" onchange="GetSections();"', 'value', 'text', $row->id_workgroup);
	
	// Build Section select list
	$lists['section'] = getSections( $row->id_workgroup, $row->section, false );

	// Build Custom Fields select list
	$sql = "SELECT `id` AS value, CONCAT(SUBSTRING(`caption`,1,100),'...') AS text 
			FROM #__support_custom_fields WHERE cftype='W' 
			ORDER BY `caption`";
	$database->setQuery($sql);
	$rows_wk = $database->loadObjectList();
	$rows_wk = array_merge(array(JHTML::_('select.option', '0', JText::_('selectlist'))), $rows_wk);
	$lists['fields'] = JHTML::_('select.genericlist',$rows_wk, 'id_field', 'class="inputbox" size="1"', 'value', 'text', $row->id_field);

	$captions = array( JText::_('MQ_NO'), JText::_('MQ_YES') );
	$values = array( '0', '1' );
	
	$lists['required'] = mqm_switchcheckbox('radio', 'required', $captions, $values, $row->required, 'switch');
	$lists['new_only'] = mqm_switchcheckbox('radio', 'new_only', $captions, $values, $row->new_only, 'switch');
	
	$support_only =  array ( JHTML::_('select.option', '0', JText::_('normal')),
							 JHTML::_('select.option', '1', JText::_('readonly')),
							 JHTML::_('select.option', '2', JText::_('hidden')));
	$lists['support_only'] = JHTML::_('select.genericlist',$support_only, 'support_only', 'id="support_only" class="inputbox" size="1" ', 'value', 'text', $row->support_only);
	
	// build the html select list for ordering
	$order = JHTML::_('list.genericordering', "SELECT s.ordering AS value, f.caption AS text"
		. "\nFROM #__support_wk_fields s, #__support_custom_fields f"
		. "\nWHERE s.id_workgroup='$row->id_workgroup' AND s.id_field=f.id ORDER BY s.ordering"
	);
	$lists['ordering'] = JHTML::_('select.genericlist', $order, 'ordering', 'class="inputbox" size="1"', 'value', 'text', intval( $row->ordering ) );

	cfield_html::edit( $row, $lists );
}

/**
* Saves the workgroup
* @param database A database connector object
* @param string The name of the component
*/
function saveCustomField() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$section_new = JRequest::getVar( 'section_new', '', '', 'string' );
	$row = new mosSupportWKFields( $database );
	
	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$row->checkin();
	
	// Check if section is to create a new one or a selected
	if( $section_new != '' ) {
		$sql = "UPDATE `#__support_wk_fields`
				SET `section`='$section_new'
				WHERE `id`=".$row->id;
		$database->setQuery( $sql );
		$database->query();
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=wkfields" );
}

/**
* Deletes one or more categories from the categories table
* @param database A database connector object
* @param string The name of the category section
* @param array An array of unique category id numbers
*/
function removeCustomField( $cid ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	if (count( $cid ) < 1) {
		echo "<script type='text/javascript'> alert('".JText::_('wkfield_delete')."'); window.history.go(-1);</script>\n";
		exit;
	}
	
	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_wk_fields WHERE id IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=wkfields" );
}

function saveOrder() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$orders = JRequest::getVar( 'contentTable', array(0), '', 'array' );
	
	for( $i=1; $i<(count($orders)-1); $i++ ) 
	{
		$sql = "UPDATE `#__support_wk_fields`
				SET `ordering`=$i
				WHERE `id`=".$orders[$i];
		$database->setQuery( $sql );
		$database->query();
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=wkfields", JText::_('new_ordering_save') );
}