<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.announce.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class announce_html {
	static function show( &$rows, &$pageNav ) {
		$database = JFactory::getDBO(); ?>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=announce"><?php echo JText::_('announcements'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		<div class="contentarea">
			<div id="contentbox">
			<?php if ( count( $rows ) == 0 ) : ?>
				<div class="detailmsg">
					<h1><img src="../components/com_maqmahelpdesk/images/alert.png" align="left" /> <?php echo JText::_('register_not_found'); ?></h1>
					<p><?php echo JText::_('to_add_new_record_desc'); ?></p>
				</div>
				<script type="text/javascript"> MaQmaJS.AddHelpHand('toolbar-new'); </script>
			<?php else: ?>
				<table class="contenttable" cellspacing="0">
				<thead>
				<tr>
					<td width="20" align="right">#</td>
					<td width="20"><input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" /></td>
					<td class="title"><?php echo JText::_('title'); ?></td>
					<td class="title"><?php echo JText::_('date'); ?></td>
					<td class="title"><?php echo JText::_('workgroup'); ?></td>
					<td class="title"><?php echo JText::_('client'); ?></td>
					<td width="70" align="center"><?php echo JText::_('frontpage'); ?></td>
					<td width="70" align="center"><?php echo JText::_('urgent'); ?></td>
					<td width="70" align="center"><?php echo JText::_('sent'); ?></td>
				</tr>
				</thead>
				<tfoot>
					<tr>
					<td colspan="9"><?php echo $pageNav->getListFooter(); ?></td>
				</tr>
				</tfoot>
				<tbody><?php
				$k = 0;
				$j = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) 
				{
					$row = &$rows[$i];
					$img1 = $row->frontpage ? 'tick' : 'no';
					$img2 = $row->urgent ? 'tick' : 'no';
					$img3 = $row->sent ? 'tick' : 'no';
					$task = $row->sent ? 'announce_publish' : 'announce_unpublish';
					$alt = $row->sent ? JText::_('send_again') : JText::_('dont_send'); ?>
					<tr class="<?php echo "row$k"; ?>">
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td>
							<a href="#announce_edit" onClick="return listItemTask('cb<?php echo $i;?>','announce_edit')">
								<?php echo $row->introtext; ?>
							</a>
						</td>
						<td><?php echo $row->date; ?></td>
						<td><?php
							if( $row->id_workgroup == 0 ) {
								echo JText::_('all');
							}else{
								$database->setQuery( "SELECT wkdesc FROM #__support_workgroup WHERE id='".$row->id_workgroup."'" );
								echo $database->loadResult();
							} ?>
						</td>
						<td><?php
						if( $row->id_client == 0 ) {
								echo JText::_('all');
							}else{
								$database->setQuery( "SELECT clientname FROM #__support_client WHERE id='".$row->id_client."'" );
								echo $database->loadResult();
							} ?>
						</td>
						<td width="70" align="center">
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img1;?>.png" border="0" />
						</td>
						<td width="70" align="center">
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img2;?>.png" border="0" />
						</td>
						<td width="70" align="center">
							<a href="javascript: void(0);" onClick="return listItemTask('cb<?php echo $i;?>','<?php echo $task;?>')">
								<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img3;?>.png" border="0" alt="<?php echo $alt; ?>" />
							</a>
						</td>
					</tr>
					<?php	
				} // for ?>
				</tbody>
				</table>
			<?php endif; ?>
			</div>
			<div id="infobox">
				<span id="infoarrow"></span>
				<dl class="first">
					<dd class="title"><?php echo JText::_('info_announcements_title');?></dd>
					<dd class="last">
						<?php echo JText::_('info_announcements_desc');?>
						<p align="center"><a href="http://www.imaqma.com/" target="_blank" class="mqmbutton gray"><img src="../components/com_maqmahelpdesk/images/16px/help.png" align="absmiddle" border="0" alt="" /> <?php echo JText::_('more_information');?></a></p>
					</dd>
				</dl>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="announce" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php
	}

	static function edit( &$row, $lists ) {
		global $supportConfig; 
		$editor = JFactory::getEditor(); 
		$GLOBALS['title_edit_announce'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('announcement'); ?>
		
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'announce') {
				submitform( pressbutton );
				return;
			}

			if (form.id_workgroup.value == ""){
				alert("<?php echo JText::_('workgroup_required'); ?>");
			} else {
				<?php echo $editor->save( 'bodytext' ); ?>
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'announce') {
				submitform( pressbutton );
				return;
			}

			if (form.id_workgroup.value == ""){
				alert("<?php echo JText::_('workgroup_required'); ?>");
			} else {
				<?php echo $editor->save( 'bodytext' ); ?>
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=announce"><?php echo JText::_('announcements'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('workgroup').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('workgroup'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['workgroup']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('client').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('client'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['client']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('frontpage').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('frontpage'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['frontpage']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('urgent').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('urgent'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['urgent']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('title').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('title'); ?>
				</span> 
				<input class="large" type="text" id="introtext" name="introtext" value="<?php echo $row->introtext; ?>" maxlength="100" />
			</div>
			<div class="field w100" style="height:580px;">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('body').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('body'); ?>
				</span> 
				<div style="margin-left:170px;"><?php echo $editor->display( 'bodytext', $row->bodytext, '98%', '500', '75', '20' );?></div>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="date" value="<?php echo ($row->id>0 ? $row->date : dateOffset("Y-m-d")); ?>" />
		</form>
		
		<script type='text/javascript'>
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		</script><?php 
	}

	/**
	* Writes the edit form for new and existing workgroups
	*
	* A new record is defined when <var>$row</var> is passed witht the <var>id</var>
	* property set to 0.
	* @param string Record fields
	* @param string The component name
	* @param string The select lists
	*/
	static function prepareSend( $announces, $n_users ) { ?>
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			submitform(pressbutton);
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			submitform( pressbutton );
			return;
		}
		<?php } ?>
		</script>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="" />
		
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=announce"><?php echo JText::_('announcements'); ?></a>
			<span><?php echo JText::_('send'); ?></span>
		</div>
		<div class="contentarea">
			<br />
			
			<p><span><?php echo JText::_('first_announce');?></span>: <?php echo $announces->mindate; ?></p>
			<p><span><?php echo JText::_('last_announce');?></span>: <?php echo $announces->maxdate; ?></p>
			<p><span><?php echo JText::_('n_announces');?></span>: <?php echo $announces->total; ?></p>
			<p><span><?php echo JText::_('n_subscribers');?></span>: <?php echo $n_users; ?></p>
		</div>
		</form>
		
		<script type="text/javascript"> MaQmaJS.AddHelpHand('toolbar-move'); </script><?php 
	}
}
