<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.client.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

JHTML::_('behavior.tooltip');

class client_html 
{
	static function show( &$rows, &$pageNav, $filter ) 
	{
		$database = JFactory::getDBO();?>
		
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=client"><?php echo JText::_('clients_manager'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		
		<form action="index.php" method="post" name="filterForm">
		<div id="filtersarea">
			<?php echo strtoupper(JText::_('filters'));?> <img src="components/com_maqmahelpdesk/images/separator2.png" style="padding:5px;" align="absmiddle" /> 
			<input type="text" id="filter" name="filter" value="<?php echo $filter;?>" /> 
			<div class="mqmbutton-group" style="float: right;padding-top: 5px;">
				<a href="javascript:;" class="mqmbutton icon trash red" onclick="document.filterForm.getElementById('filter').value='';document.filterForm.submit();"><?php echo JText::_('reset');?></a> 
				<a href="javascript:;" class="mqmbutton icon search success" onclick="document.filterForm.submit();"><?php echo JText::_('filter');?></a>
			</div>
		</div>
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="client" />
		</form>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="contentarea">
			<div id="contentbox">
			<?php if ( count( $rows ) == 0 ) : ?>
				<div class="detailmsg">
					<h1><img src="../components/com_maqmahelpdesk/images/alert.png" align="left" /> <?php echo JText::_('register_not_found'); ?></h1>
					<p><?php echo JText::_('to_add_new_record_desc'); ?></p>
				</div>
				<script type="text/javascript"> MaQmaJS.AddHelpHand('toolbar-new'); </script>
			<?php else: ?>
				<table class="contenttable" cellspacing="0">
				<thead>
					<tr>
					<th width="20" align="right">#</th>
					<td width="20"><input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" /></td>
					<td class="title"><?php echo JText::_('name'); ?></td>
					<td class="title"><?php echo JText::_('users'); ?></td>
					<td width="70" align="center"><?php echo JText::_('blocked'); ?></td>
					<td width="70" align="center"><?php echo JText::_('tickets'); ?></td>
					</tr>
				</thead>
				<tfoot>
					<tr>
					<td colspan="9"><?php echo $pageNav->getListFooter(); ?></td>
				</tr>
				</tfoot>
				<tbody><?php
				$k = 0;
				$j = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) 
				{
					$row = &$rows[$i];
					$img_blocked = $row->block ? 'tick' : 'no'; ?>
					<tr class="<?php echo ($i==0 ? 'first' : ''); ?>">
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td>
							<a href="#client_edit" onClick="return listItemTask('cb<?php echo $i;?>','client_edit')">
								<?php echo $row->clientname; ?>
							</a>
						</td>
						<td><?php
							$sql = "SELECT u.name 
									FROM #__support_client_users AS c 
										 INNER JOIN #__users AS u ON c.id_user=u.id 
									WHERE c.id_client=".$row->id;
							$database->setQuery( $sql );
							$users = $database->loadObjectList();
							for( $x=0; $x<count($users); $x++ ) { 
								echo $users[$x]->name.', ';
							} ?>
						</td>
						<td width="70" align="center">
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img_blocked;?>.png" border="0" />
						</td>
						<td width="70" align="center"><?php
							$sql = "SELECT COUNT(*) 
									FROM #__support_ticket
									WHERE id_client=".$row->id; 
							$database->setQuery( $sql );
							echo $database->loadResult(); ?>
						</td>
					</tr><?php	
				} // for ?>
				</tbody>
				</table>
			<?php endif; ?>
			</div>
			<div id="infobox">
				<span id="infoarrow"></span>
				<dl class="first">
					<dd class="title"><?php echo JText::_('INFO_CLIENT_TITLE');?></dd>
					<dd class="last">
						<?php echo JText::_('INFO_CLIENT_DESC');?>
						<p align="center"><a href="http://www.imaqma.com/" target="_blank" class="mqmbutton gray"><img src="../components/com_maqmahelpdesk/images/16px/help.png" align="absmiddle" border="0" alt="" /> <?php echo JText::_('more_information');?></a></p>
					</dd>
				</dl>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="client" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input[type='text'], input[type='checkbox'], input[type='radio'], textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
			
			$jMaQma("#filter").css("width", $jMaQma("#filtersarea").width() - $jMaQma("#filter").offset().left - $jMaQma(".mqmbutton-group").width());
			$jMaQma(window).resize(function(){
				$jMaQma("#filter").css("width", $jMaQma("#filtersarea").width() - $jMaQma("#filter").offset().left - $jMaQma(".mqmbutton-group").width());
			});
		});
		</script><?php
	}

	static function edit( &$row, $users, $clientdocs, $lists, $contracts, $tickets, $inforecords, $downloads, $cfields  ) 
	{
		global $supportConfig, $print;
		
		$database = JFactory::getDBO();
		$session = JFactory::getSession();
		$GLOBALS['titulo_client_edit'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('client');
		$imgpath = JURI::root().'/components/com_maqmahelpdesk/images'; 
		
		$sel3 = '';
		for($i=0; $i <=8; $i++) {
			$sel3 .= '<option value="'.($i).'.00"'.($row->travel_time == $i.".00" ? ' selected' : '').'>'.($i).':00</option>';
			$sel3 .= '<option value="'.($i).'.15"'.($row->travel_time == $i.".15" ? ' selected' : '').'>'.($i).':15</option>';
			$sel3 .= '<option value="'.($i).'.30"'.($row->travel_time == $i.".30" ? ' selected' : '').'>'.($i).':30</option>';
			$sel3 .= '<option value="'.($i).'.45"'.($row->travel_time == $i.".45" ? ' selected' : '').'>'.($i).':45</option>';
		}

		$editCustomParam = "";
		if( count($cfields) > 0 ) {
			for( $x=0; $x<count($cfields); $x++ ) { 
				$cfield = $cfields[$x];
				$editCustomParam .= ", custom".$cfield->id_field;
			}
		} ?>
		
		<script language="javascript" type="text/javascript" src="<?php echo JURI::root();?>components/com_maqmahelpdesk/js/jquery.autocomplete-min.js"></script>

		<div id="Layer1" style="position: absolute; margin-left: auto; margin-right: auto; width: 200px; height: 125px; z-index: 1; display: none; background-color: #efefef; layer-background-color: #FF0000; border: 1px solid #99989D;">
			<table width="100%">
			<tr>
				<td bgcolor="#330099" height="25">
					&nbsp;<span style="color:#FFFFFF"><?php echo JText::_('save');?></span>
				</td>
			</tr>
			<tr>
				<td align="center" valign="middle">
					<p><?php echo JText::_('save_progress');?></p>
					<p><img src="../components/com_maqmahelpdesk/images/loading.gif"></p>
					<p><?php echo JText::_('be_pacient');?></p>
				</td>
			</tr>
			</table>
		</div>
		
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=client"><?php echo JText::_('clients_manager'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		
		<div class="contentarea withleft">
			<div class="sidebar">
				<div class="content" style="display: block;">
					<ul class="leftmenu">
						<li class="current"><a href="#" onclick="MaQmaJS.SelectTab(this,1);"><img src="../components/com_maqmahelpdesk/images/menu/clients.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('client');?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,2);"><img src="../components/com_maqmahelpdesk/images/menu/users.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('users').' <span class="mqmnumber">'.count($users).'</span>';?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,3);"><img src="../components/com_maqmahelpdesk/images/menu/contracts.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('contracts').' <span class="mqmnumber">'.count($contracts).'</span>';?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,4);"><img src="../components/com_maqmahelpdesk/images/menu/files.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('downloads').' <span class="mqmnumber">'.count($downloads).'</span>';?></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,5);"><img src="../components/com_maqmahelpdesk/images/menu/table.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('attachments').' <span class="mqmnumber">'.count($clientdocs).'</span>';?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,6);"><img src="../components/com_maqmahelpdesk/images/menu/logs.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('info_title').' <span class="mqmnumber">'.count($inforecords).'</span>';?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,7);"><img src="../components/com_maqmahelpdesk/images/menu/tickets.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('tickets').' <span class="mqmnumber">'.count($tickets).'</span>';?></a></li>
					</ul>
				</div>
			</div>
			<div class="contentbar withleft">
				<div id="tab1" class="contenttab" style="display:block;">
					<form action="index.php" method="post" id="adminForm" name="adminForm" enctype="multipart/form-data" class="label-inline">
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('block_client').'::'.JText::_('block_client_tooltip')); ?>">
							<?php echo JText::_('block_client'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['block']; ?>
						</div>
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('name').'::'.JText::_('block_client_tooltip')); ?>">
							<?php echo JText::_('name'); ?>
						</span> 
						<input class="large" type="text" id="clientname" name="clientname" value="<?php echo $row->clientname; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('clientid').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('clientid'); ?>
						</span> 
						<input class="medium" type="text" id="clientid" name="clientid" value="<?php echo $row->clientid; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('taxnumber').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('taxnumber'); ?>
						</span> 
						<input class="medium" type="text" id="taxnumber" name="taxnumber" value="<?php echo $row->taxnumber; ?>" maxlength="100" />
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('logo').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('logo'); ?>
						</span> 
						<input class="medium" type="file" id="logo" name="logo" value="" />
					</div>
					<div class="field w100" style="height:110px;">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('description'); ?>
						</span> 
						<textarea id="description" name="description" style="height:100px;" class="large"><?php echo $row->description; ?></textarea>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('address').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('address'); ?>
						</span> 
						<input class="medium" type="text" id="address" name="address" value="<?php echo $row->address; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('zipcode').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('zipcode'); ?>
						</span> 
						<input class="medium" type="text" id="zipcode" name="zipcode" value="<?php echo $row->zipcode; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('city').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('city'); ?>
						</span> 
						<input class="medium" type="text" id="city" name="city" value="<?php echo $row->city; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('state').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('state'); ?>
						</span> 
						<input class="medium" type="text" id="state" name="state" value="<?php echo $row->state; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('country').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('country'); ?>
						</span> 
						<input class="medium" type="text" id="country" name="country" value="<?php echo $row->country; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('phone').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('phone'); ?>
						</span> 
						<input class="medium" type="text" id="phone" name="phone" value="<?php echo $row->phone; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('fax').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('fax'); ?>
						</span> 
						<input class="medium" type="text" id="fax" name="fax" value="<?php echo $row->fax; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('mobile').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('mobile'); ?>
						</span> 
						<input class="medium" type="text" id="mobile" name="mobile" value="<?php echo $row->mobile; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('email').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('email'); ?>
						</span> 
						<input class="medium" type="text" id="email" name="email" value="<?php echo $row->email; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('contact').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('contact'); ?>
						</span> 
						<input class="medium" type="text" id="contactname" name="contactname" value="<?php echo $row->contactname; ?>" maxlength="100" />
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('website').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('website'); ?>
						</span> 
						<input class="large" type="text" id="website" name="website" value="<?php echo $row->website; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('notify_manager').'::'.JText::_('notify_manager_tooltip')); ?>">
							<?php echo JText::_('notify_manager'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['manager2']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('client_approval').'::'.JText::_('client_approval_tooltip')); ?>">
							<?php echo JText::_('client_approval'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['approval']; ?>
						</div>
					</div>
					<div class="field w100" style="height:60px;">
						<label for="client_mail_notify">
							<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('client_mail_notify').'::'.JText::_('client_mail_notify_tooltip')); ?>"><?php echo JText::_('client_mail_notify'); ?></span> 
						</label> 
						<textarea id="client_mail_notify" name="client_mail_notify" style="height:50px;" class="large"><?php echo $row->client_mail_notify; ?></textarea>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('travel_time').'::'.JText::_('travel_time_tooltip')); ?>">
							<?php echo JText::_('travel_time'); ?>
						</span> 
						<div class="controlset-pad">
							<select id="travel_time" name="travel_time"><?php echo $sel3; ?></select>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('billing_rate').'::'.JText::_('billing_tooltip')); ?>">
							<?php echo JText::_('billing_rate'); ?>
						</span> 
						<input class="medium" type="text" id="rate" name="rate" value="<?php echo $row->rate; ?>" maxlength="10" />
					</div>
					<div class="field w100" style="height:110px;">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('workgroups').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('workgroups'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['workgroup']; ?>
						</div>
					</div>
					<input type="hidden" name="wks" value="<?php echo $lists['wks']; ?>" />
					<input type="hidden" name="option" value="com_maqmahelpdesk" />
					<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
					<input type="hidden" name="date_created" value="<?php echo ( $row->id > 0 ? $row->date_created : date("Y-m-d") ); ?>" />
					<input type="hidden" name="task" value="" />
					</form>
					<br class="clr" />
				</div>
				<div id="tab2" class="contenttab">
					<form id="addUser" name="addUser" action="index.php" method="post" class="label-inline">
					<?php if( $row->id ):?>
						<h3 style="border-bottom:1px solid #eee;"><?php echo JText::_('add_user');?></h3>
						<div class="field w50">
							<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('user').'::'.JText::_('add_user_tooltip')); ?>">
								<?php echo JText::_('user'); ?>
							</span> 
							<input class="medium" type="text" id="ac_me" name="ac_me" value="" maxlength="100" />
							<input type="hidden" id="id_user" name="id_user" value="" />
						</div>
						<div class="field w50">
							<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('manager').'::'.JText::_('manager_tooltip')); ?>">
								<?php echo JText::_('manager'); ?>
							</span> 
							<div class="controlset-pad">
								<?php echo $lists['manager']; ?>
							</div>
						</div>
						<div class="field w100" style="text-align:right;">
							<input type="submit" name="submit" value="<?php echo JText::_('save');?>" class="mqmbutton gray" />
						</div>
						
						<table class="contenttable" cellspacing="0">
					    <thead>
							<tr>
								<td class="title"><?php echo JText::_('name'); ?></td>
								<td class="title"><?php echo JText::_('email'); ?></td>
								<td class="title"><?php echo JText::_('phone'); ?></td>
								<td class="title"><?php echo JText::_('fax'); ?></td>
								<td class="title"><?php echo JText::_('mobile'); ?></td>
								<td width="50" align="center"><?php echo JText::_('manager'); ?></td>
								<td width="50" align="center"><?php echo JText::_('edit'); ?></td>
								<td width="50" align="center"><?php echo JText::_('delete'); ?></td>
							</tr>
						</thead>
						<tbody><?php
						$k = 0;
						$j = 0;
						for ($i=0, $n=count( $users ); $i < $n; $i++) 
						{
							$row_user = &$users[$i]; ?>
							<tr class="<?php echo ($i==0 ? 'first' : ''); ?>">
								<td><?php echo $row_user->name.' ('.$row_user->username.')'; ?></td>
								<td><?php echo ( $row_user->email!='' ? '<a href="mailto:'.$row_user->email.'">'.$row_user->email.'</a>' : '' ); ?></td>
								<td><?php echo $row_user->phone; ?></td>
								<td><?php echo $row_user->fax; ?></td>
								<td><?php echo $row_user->mobile; ?></td>
								<td>
									<div align="center">
										<a href="index.php?option=com_maqmahelpdesk&task=client_manager&id_client=<?php echo $row->id; ?>&id_user=<?php echo $row_user->id; ?>&action=<?php echo ($row_user->manager ? 0 : 1); ?>"><img src="../components/com_maqmahelpdesk/images/16px/<?php echo ($row_user->manager ? 'tick' : 'no'); ?>.png" border="0" /></a>
									</div>
								</td>
								<td>
									<div align="center">
										<a href="index.php?option=com_maqmahelpdesk&task=users_edit&cid[0]=<?php echo $row_user->id; ?>&id_client=<?php echo $row_user->id_client; ?>"><img src="../components/com_maqmahelpdesk/images/16px/edit.png" border="0" alt="<?php echo JText::_('edit'); ?>" /></a>
									</div>
								</td>
								<td>
									<div align="center">
										<a href="index.php?option=com_maqmahelpdesk&task=client_deluser&id=<?php echo $row_user->id; ?>&id_client=<?php echo $row_user->id_client; ?>"><img src="../components/com_maqmahelpdesk/images/16px/delete.png" border="0" alt="<?php echo JText::_('delete'); ?>" /></a>
									</div>
								</td>
							</tr><?php	
						} ?>
						<?php if( !count($users) ):?>
						<tr class="first">
							<td align="center" colspan="8" height="20"><img src="../components/com_maqmahelpdesk/images/info.png" align="absmiddle" />&nbsp;<b><?php echo JText::_('no_users'); ?></b></td>
						</tr>
						<br />
						<?php endif;?>
						</tbody>
						</table>
					<?php else:?>
					<div align="center">
						<img src="../components/com_maqmahelpdesk/images/info.png" align="absmiddle" />&nbsp;<b><?php echo JText::_('client_create_users');?></b>
					</div>
					<br />
					<?php endif;?>
					<input type="hidden" name="id_client" value="<?php echo $row->id; ?>" />
					<input type="hidden" name="task" value="client_saveuser" />
					<input type="hidden" name="id" value="0" />
					<input type="hidden" name="option" value="com_maqmahelpdesk" />
					</form>
					<br class="clr" />
				</div>
				<div id="tab3" class="contenttab">
					<form name="addContract" action="index.php" method="post" onsubmit="return ValidateForm();" class="label-inline">
					<?php if( $row->id ):?>
						<h3 style="border-bottom:1px solid #eee;"><?php echo JText::_('add_contract');?></h3>
						<div class="field w50">
							<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('contract').'::'.JText::_('todo')); ?>">
								<?php echo JText::_('contract'); ?>
							</span> 
							<div class="controlset-pad">
								<?php echo $lists['contract']; ?>
							</div>
						</div>
						<div class="field w50">
							<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('maintainer').'::'.JText::_('todo')); ?>">
								<?php echo JText::_('maintainer'); ?>
							</span> 
							<div class="controlset-pad">
								<?php echo $lists['staff']; ?>
							</div>
						</div>
						<div class="field w50">
							<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('start').'::'.JText::_('todo')); ?>">
								<?php echo JText::_('start'); ?>
							</span> 
							<?php echo JHTML::Calendar('', 'date_start' , 'date_start', '%Y-%m-%d', array('class'=>'', 'size'=>'12',  'maxlength'=>'12')); ?>
						</div>
						<div class="field w100">
							<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('end').'::'.JText::_('todo')); ?>">
								<?php echo JText::_('end'); ?>
							</span> 
							<?php echo JHTML::Calendar('', 'date_end' , 'date_end', '%Y-%m-%d', array('class'=>'', 'size'=>'12',  'maxlength'=>'12')); ?>
						</div>
						<div class="field w50">
							<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('number').'::'.JText::_('todo')); ?>">
								<?php echo JText::_('number'); ?>
							</span> 
							<input class="medium" type="text" id="contract_number" name="contract_number" maxlength="200" />
						</div><?php
						if( count($cfields) > 0 ) {
							for( $x=0; $x<count($cfields); $x++ ) { 
								$cfield = $cfields[$x]; ?>
								<div class="field w50">
									<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars($cfield->caption.'::'.JText::_('todo')); ?>">
										<?php echo $cfield->caption; ?>
									</span><?php 
									echo WriteField( 0, $cfield->id_field, $cfield->ftype, $cfield->value, $cfield->size, $cfield->maxlength ); 
									echo $cfield->required ? ' <img src="../components/com_maqmahelpdesk/images/16px/link.png" border="0" alt="'.JText::_('required').'" align="absmiddle" />' : ''; ?>
								</div><?php
							} 
						} ?>
						<div class="field w50" style="height:110px;">
							<label for="components">
								<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('components').'::'.JText::_('todo')); ?>">
									<?php echo JText::_('components'); ?>
								</span> 
							</label> 
							<div class="controlset-pad">
								<?php echo $lists['components']; ?>
							</div>
						</div>
						<div class="field w50" style="height:110px;">
							<label for="remarks">
								<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('remarks').'::'.JText::_('todo')); ?>">
									<?php echo JText::_('remarks'); ?>
								</span> 
							</label> 
							<textarea id="remarks" name="remarks" style="height:100px;" class="medium"></textarea>
						</div>
						<div class="field w100" style="text-align:right;">
							<input type="submit" name="submit" value="<?php echo JText::_('save');?>" class="mqmbutton gray" />
						</div>
						<div id="contractform" name="contractform"></div>
						
						<table class="contenttable" cellspacing="0">
					    <thead>
							<tr>
								<td class="title"><?php echo JText::_('number'); ?></td>
								<td class="title"><?php echo JText::_('type'); ?></td>
								<td class="title"><?php echo JText::_('maintainer'); ?></td>
								<td class="title"><?php echo JText::_('creation'); ?></td>
								<td class="title"><?php echo JText::_('start'); ?></td>
								<td class="title"><?php echo JText::_('end'); ?></td>
								<td class="title"><?php echo JText::_('unit'); ?></td>
								<td class="title"><?php echo JText::_('value'); ?></td>
								<td class="title"><?php echo JText::_('current'); ?></td>
								<td class="title"><?php echo JText::_('status'); ?></td><?php
								if( count($cfields) > 0 ) {
								for( $x=0; $x<count($cfields); $x++ ) { 
										$cfield = $cfields[$x]; ?>
										<td class="title"><?php echo htmlspecialchars($cfield->caption); ?></td><?php
									} 
								} ?>
								<td width="50" align="center"><?php echo JText::_('components'); ?></td>
								<td width="50" align="center"><?php echo JText::_('edit'); ?></td>
								<td width="50" align="center"><?php echo JText::_('delete'); ?></td>
							</tr>
						</thead>
						<tbody><?php
						$k = 0;
						$j = 0;
						for ($i=0, $n=count($contracts); $i < $n; $i++) 
						{
							$row_user = $contracts[$i]; 
							
							$contract_components = '';
							$sql = "SELECT co.id, co.name, co.description 
									FROM #__support_contract_comp c, #__support_components co 
									WHERE c.id_component=co.id AND c.id_contract=".$row_user->id;
							$database->setQuery( $sql );
							$components = $database->loadObjectList();
							
							$components_desc = '';
							for($ii=0; $ii<count($components); $ii++) {
								$row_comp = $components[$ii];
								$components_desc .= ( $components_desc != '' ? '<br />' : '' );
								$components_desc .= '- '.$row_comp->name;
								$contract_components = $contract_components.$row_comp->id.'|';
							}
							
							$contract_components = substr($contract_components, 0, strlen($contract_components)-1);
							$link = 'index.php?option=com_maqmahelpdesk&task=client_publishcontract&id='.$row_user->id.'&id_client='.$row_user->id_client.'&action='.$row_user->status; ?>
							
							<tr class="<?php echo ($i==0 ? 'first' : ''); ?>">
								<td><?php echo $row_user->contract_number; ?></td>
								<td><?php echo $row_user->contracttmpl; ?></td>
								<td><?php echo $row_user->name; ?><br /><?php echo $row_user->username; ?></td>
								<td><?php echo $row_user->creation_date; ?></td>
								<td><?php echo $row_user->date_start; ?></td>
								<td><?php echo $row_user->date_end; ?></td>
								<td><?php echo $row_user->unit; ?></td>
								<td><?php echo $row_user->value; ?></td>
								<td><?php echo ( $row_user->unit == 'T' ? intval($row_user->actual_value) : convDECtoHHMM($row_user->actual_value) ); ?></td>
								<td>
									<div align="center">	
										<a href="<?php echo $link; ?>"><?php echo ( $row_user->status=='I' ? JText::_('inactive') : JText::_('active') ); ?></a>
									</div>
								</td><?php
								$editcustom = "";
								if( count($cfields) > 0 ) {
									for( $x=0; $x<count($cfields); $x++ ) { 
										$cfield = $cfields[$x];
										$sql = "SELECT cf.value 
												FROM #__support_contract_fields_values cf 
												WHERE cf.id_contract='".$row_user->id."' AND cf.id_field='".$cfield->id_field."' 
												LIMIT 1";
										$database->setQuery( $sql );
										$contract_custom_field = $database->loadResult();
										$custom_value = ( $contract_custom_field == '' ? '-' : $contract_custom_field );
										if ( ($cfield->ftype == 'radio') || ($cfield->ftype == 'checkbox') ) {
											$editcustom .= ",'".preg_replace('/[^A-Za-z0-9_]/', '_', $custom_value)."'";
										} else {
											$editcustom .= ",'".$custom_value."'";
										} ?>
										<td><?php echo $custom_value ; ?></td><?php
									} 
								} ?>
								<td width="50">
									<div align="center">
										<?php echo ( $components_desc != '' ? '<span class="editlinktip hasTip" title="'.htmlspecialchars(JText::_('components').'::'.$components_desc).'"><img src="../components/com_maqmahelpdesk/images/info.png" align="absmiddle" border="0" hspace="5" style="cursor:help; cursor:hand;" /></span>' : '-' ); ?>
									</div>
								</td>
		   						<td width="50">
		   							<div align="center">
		   								<a href="javascript:;" onclick="EditContract('<?php echo $row_user->id; ?>', '<?php echo $row_user->contract_number; ?>', '<?php echo $row_user->creation_date; ?>', '<?php echo $row_user->date_start; ?>', '<?php echo $row_user->date_end; ?>', '<?php echo $row_user->unit; ?>', '<?php echo $row_user->id_contract; ?>', '<?php echo $row_user->value; ?>', '<?php echo $row_user->actual_value; ?>', '<?php echo $row_user->status; ?>', '<?php echo $row_user->remarks; ?>', '<?php echo $row_user->id_user; ?>', '<?php echo $contract_components; ?>'<?php echo $editcustom; ?>);"><img src="../components/com_maqmahelpdesk/images/16px/edit.png" border="0" alt="<?php echo JText::_('edit'); ?>" /></a>
		   							</div>
		   						</td>
		   						<td width="50">
		   							<div align="center">
		   								<a href="index.php?option=com_maqmahelpdesk&task=client_delcontract&id=<?php echo $row_user->id; ?>&id_client=<?php echo $row_user->id_client; ?>"><img src="../components/com_maqmahelpdesk/images/16px/delete.png" border="0" alt="<?php echo JText::_('delete'); ?>" /></a>
		   							</div>
		   						</td>
							</tr><?php	
						} ?>
						<?php if( !count($contracts) ):?>
						<tr class="first">
							<td align="center" colspan="<?php echo (count($cfields)+13);?>" height="20"><img src="../components/com_maqmahelpdesk/images/info.png" align="absmiddle" />&nbsp;<b><?php echo JText::_('no_contracts'); ?></b></td>
						</tr>
						<br />
						<?php endif;?>
						</tbody>
						</table>
					<?php else:?>
					<div align="center">
						<img src="../components/com_maqmahelpdesk/images/info.png" align="absmiddle" />&nbsp;<b><?php echo JText::_('create_client_contract');?></b>
					</div>
					<br />
					<?php endif;?>
					<input type="hidden" name="id_client" value="<?php echo $row->id; ?>" />
					<input type="hidden" name="task" value="client_savecontract" />
					<input type="hidden" name="components" value="" />
					<input type="hidden" name="actual_value" value="" />
					<input type="hidden" name="unit" value="" />
					<input type="hidden" name="value" value="" />
					<input type="hidden" name="creation_date" value="" />
					<input type="hidden" name="status" value="I" />
					<input type="hidden" name="contract_components" value="" />
					<input type="hidden" name="id" value="0" />
					<input type="hidden" name="option" value="com_maqmahelpdesk" />
					</form>
					<br class="clr" />
				</div>
				<div id="tab4" class="contenttab">
					<table class="contenttable" cellspacing="0">
				    <thead>
						<tr>
							<td class="title"><?php echo JText::_('download'); ?></td>
							<td class="title"><?php echo JText::_('serial_number'); ?></td>
							<td class="title"><?php echo JText::_('start'); ?></td>
							<td class="title"><?php echo JText::_('end'); ?></td>
							<td width="50" align="center"><?php echo JText::_('status'); ?></td>
							<td width="50" align="center"><?php echo JText::_('edit'); ?></td>
						</tr>
					</thead>
					<tbody><?php
					$k = 0;
					$j = 0;
					for ($i=0, $n=count($downloads); $i < $n; $i++) 
					{
						$row_download = &$downloads[$i]; 
						$link = 'index.php?option=com_maqmahelpdesk&task=customer&cid='.$row_download->id; ?>
						<tr class="<?php echo ($i==0 ? 'first' : ''); ?>">
							<td><?php echo $row_download->cname.' - '.$row_download->pname; ?></td>
							<td><?php echo $row_download->serialno; ?></td>
							<td><?php echo $row_download->servicefrom; ?></td>
							<td><?php echo $row_download->serviceuntil; ?></td>
							<td>
								<div align="center">
									<?php echo ( $row_download->isactive ? JText::_('active') : JText::_('inactive') );?>
								</div>
							</td>
							<td>
								<div align="center">
									<a href="<?php echo $link; ?>"><img src="../components/com_maqmahelpdesk/images/16px/edit.png" border="0" alt="<?php echo JText::_('edit'); ?>" /></a>
								</div>
							</td>
						</tr><?php	
					} ?>
					<?php if( !count($downloads) ):?>
					<tr class="first">
						<td align="center" colspan="6" height="20"><img src="../components/com_maqmahelpdesk/images/info.png" align="absmiddle" />&nbsp;<b><?php echo JText::_('no_downloads'); ?></b></td>
					</tr>
					<br />
					<?php endif;?>
					</tbody>
					</table>
					<br class="clr" />
				</div>
				<div id="tab5" class="contenttab">
					<form id="addFiles" name="addFiles" action="index.php" method="post" enctype="multipart/form-data" onsubmit="ShowProgress();" class="label-inline">
					<?php if( $row->id ):?>
					<h3 style="border-bottom:1px solid #eee;"><?php echo JText::_('add_file');?></h3>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('file').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('file'); ?>
						</span> 
						<input class="medium" type="file" id="file" name="file" value="" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('available').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('available'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['available']; ?>
						</div>
					</div>
					<div class="field w100" style="height:110px;">
						<label for="description">
							<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('todo')); ?>">
								<?php echo JText::_('description'); ?>
							</span> 
						</label> 
						<textarea id="description" name="description" style="height:100px;" class="medium"></textarea>
					</div>
					<div class="field w100" style="text-align:right;">
						<input type="submit" name="submit" value="<?php echo JText::_('save');?>" class="mqmbutton gray" />
					</div>
					<?php endif;?>
					
					<table class="contenttable" cellspacing="0">
				    <thead>
						<tr>
							<td class="title"><?php echo JText::_('date_created'); ?></td>
							<td class="title"><?php echo JText::_('description'); ?></td>
							<td class="title"><?php echo JText::_('file'); ?></td>
							<td class="title"><?php echo JText::_('available'); ?></td>
							<td width="50" align="center"><?php echo JText::_('delete'); ?></td>
						</tr>
					</thead>
					<tbody><?php
					$k = 0;
					$j = 0;
					for ($i=0, $n=count($clientdocs); $i < $n; $i++) 
					{
						$row_user = &$clientdocs[$i]; 
						$link = 'index.php?option=com_maqmahelpdesk&task=client_download&id='.$row_user->id; ?>
						<tr class="<?php echo ($i==0 ? 'first' : ''); ?>">
							<td><?php echo $row_user->date_created; ?></td>
							<td><?php echo $row_user->description; ?></td>
							<td><a href="<?php echo $link;?>" target="_blank"><?php echo $row_user->filename; ?></a></td>
							<td align="center"><img src="../components/com_maqmahelpdesk/images/16px/<?php echo ($row_user->available ? 'tick' : 'no');?>.png" border="0" /></td>
							<td>
								<div align="center">
									<a href="index.php?option=com_maqmahelpdesk&task=client_delfile&id=<?php echo $row_user->id;?>&id_client=<?php echo $row_user->id_client;?>&filename=<?php echo $row_user->filename;?>"><img src="../components/com_maqmahelpdesk/images/16px/delete.png" border="0" alt="<?php echo JText::_('delete'); ?>" /></a>
								</div>
							</td>
						</tr><?php	
					} ?>
					<?php if( !count($clientdocs) ):?>
					<tr class="first">
						<td align="center" colspan="5" height="20"><img src="../components/com_maqmahelpdesk/images/info.png" align="absmiddle" />&nbsp;<b><?php echo JText::_('no_files'); ?></b></td>
					</tr>
					<br />
					<?php endif;?>
					</tbody>
					</table>
					<input type="hidden" name="id_client" value="<?php echo $row->id;?>" />
					<input type="hidden" name="task" value="client_savefile" />
					<input type="hidden" name="option" value="com_maqmahelpdesk" />
					</form>
					<br class="clr" />
				</div>
				<div id="tab6" class="contenttab">
					<form name="addInformation" action="index.php" method="post" class="label-inline">
					<?php if( $row->id ):?>
					<h3 style="border-bottom:1px solid #eee;"><?php echo JText::_('add_info');?></h3>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('subject').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('subject'); ?>
						</span> 
						<input class="medium" type="text" id="subject" name="subject" value="" />
					</div>
					<div class="field w50" style="height:110px;">
						<label for="description">
							<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('todo')); ?>">
								<?php echo JText::_('description'); ?>
							</span> 
						</label> 
						<textarea id="message" name="message" style="height:100px;" class="medium"></textarea>
					</div>
					<div class="field w100" style="text-align:right;">
						<input type="submit" name="submit" value="<?php echo JText::_('save');?>" class="mqmbutton gray" />
					</div>
					<?php endif;?>
					
					<table class="contenttable" cellspacing="0">
				    <thead>
						<tr>
							<td class="title"><?php echo JText::_('date'); ?></td>
							<td class="title"><?php echo JText::_('subject'); ?></td>
							<td class="title"><?php echo JText::_('message'); ?></td>
							<td width="50" align="center"><?php echo JText::_('published'); ?></td>
							<td width="50" align="center"><?php echo JText::_('delete'); ?></td>
						</tr>
					</thead>
					<tbody><?php
					$k = 0;
					$j = 0;
					for ($i=0, $n=count($inforecords); $i < $n; $i++) 
					{
						$row_info = &$inforecords[$i]; ?>
						<tr class="<?php echo ($i==0 ? 'first' : ''); ?>">
							<td><?php echo $row_info->date; ?></td>
							<td><?php echo $row_info->subject; ?></td>
							<td><?php echo $row_info->message; ?></td>
							<td>
								<div align="center">
									<a href="index.php?option=com_maqmahelpdesk&task=client_publishinfo&id=<?php echo $row_info->id;?>&id_client=<?php echo $row_info->id_client;?>&action=<?php echo ($row_info->published==1 ? '0' : '1');?>" /><img src="../components/com_maqmahelpdesk/images/16px/<?php echo ($row_info->published == 1 ? 'tick' : 'no');?>.png" border="0" /></a>
								</div>
							</td>
							<td>
								<div align="center">
									<a href="index.php?option=com_maqmahelpdesk&task=client_delinfo&id=<?php echo $row_info->id;?>&id_client=<?php echo $row_info->id_client;?>"><img src="../components/com_maqmahelpdesk/images/16px/delete.png" border="0" alt="<?php echo JText::_('delete'); ?>" /></a>
								</div>
							</td>
						</tr><?php	
					} ?>
					<?php if( $row->id == 0 ):?>
					<tr class="first">
						<td align="center" colspan="5" height="20"><img src="../components/com_maqmahelpdesk/images/info.png" align="absmiddle" />&nbsp;<b><?php echo JText::_('create_client_info'); ?></b></td>
					</tr>
					<br />
					<?php endif;?>
					</tbody>
					</table>
					<input type="hidden" name="id_client" value="<?php echo $row->id;?>" />
					<input type="hidden" name="date" value="<?php echo dateOffset("Y-m-d");?>" />
					<input type="hidden" name="task" value="client_saveinfo" />
					<input type="hidden" name="option" value="com_maqmahelpdesk" />
					</form>
					<br class="clr" />
				</div>
				<div id="tab7" class="contenttab">
					<table class="contenttable" cellspacing="0">
				    <thead>
						<tr>
							<td class="title" width="20">&nbsp;</td>
							<td class="title"><?php echo JText::_('id'); ?></td>
							<td class="title"><?php echo JText::_('subject'); ?></td>
							<td class="title"><?php echo JText::_('workgroup'); ?></td>
							<td class="title"><?php echo JText::_('user'); ?></td>
							<td class="title"><?php echo JText::_('date'); ?></td>
							<td class="title"><?php echo JText::_('status'); ?></td>
							<td width="50" align="center"><?php echo JText::_('more'); ?></td>
						</tr>
					</thead>
					<tbody><?php
					$k = 0;
					$j = 0;
					for ($i=0, $n=count($tickets); $i < $n; $i++) 
					{
						$row_user = &$tickets[$i];
						$link = '../index.php?option=com_maqmahelpdesk&id_workgroup='.$row_user->id_workgroup.'&task=ticket_view&id='.$row_user->id;
						
						// Get the source
						$source_desc = '';
						if($row_user->source=="M") {
							$source_desc = JText::_('email');
						}elseif($row_user->source=="F") {
							$source_desc = JText::_('fax');
						}elseif($row_user->source=="O") {
							$source_desc = JText::_('other');
						}elseif($row_user->source=="W") {
							$source_desc = JText::_('website');
						}elseif($row_user->source=="P") {
							$source_desc = JText::_('phone');
						} 
						
						//Get the number of messages
						$database->setQuery( "SELECT COUNT(*) FROM #__support_ticket_resp WHERE id_ticket=".$row_user->id ); 
						$num_msgs = 0;
						$num_msgs = $database->loadResult();
						
						// Get number of attachments
						$database->setQuery( "SELECT COUNT(*) FROM #__support_file WHERE source='T' AND id='".$row_user->id."'" );
						$attachs = $database->loadResult(); ?>
						<tr class="<?php echo ($i==0 ? 'first' : ''); ?>">
							<td><?php echo ( $attachs ? '<img src="../components/com_maqmahelpdesk/images/16px/attach.png" alt="'.JText::_('attachments').': '.$attachs.'">' : '' ); ?></td>
							<td><a href="<?php echo $link;?>" target="_blank"><?php echo $row_user->ticketmask; ?></a></td>
							<td><?php echo $row_user->subject; ?></td>
							<td><?php echo $row_user->wkdesc; ?></td>
							<td><?php echo $row_user->an_name; ?></td>
							<td><?php echo $row_user->date; ?></td>
							<td><?php echo $row_user->status; ?></td>
							<td width="50">
								<div align="center">
									<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('more').'::'.JText::_('id').': <b>'.$row_user->ticketmask.'</b><br />'.JText::_('date_updated').': <b>'.$row_user->last_update.'</b><br />'.JText::_('source').': <b>'.$source_desc.'</b><br />'.JText::_('messages').': <b>'.($num_msgs+1).'</b>');?>"><img src="../components/com_maqmahelpdesk/images/info.png" align="absmiddle" border="0" hspace="5" style="cursor:help; cursor:hand;" /></span>
								</div>
							</td>
						</tr><?php	
					} ?>
					<?php if( !count($tickets) ):?>
					<tr class="first">
						<td align="center" colspan="8" height="20"><img src="../components/com_maqmahelpdesk/images/info.png" align="absmiddle" />&nbsp;<b><?php echo JText::_('no_tickets'); ?></b></td>
					</tr>
					<?php endif;?>
					</tbody>
					</table>
					<br class="clr" />
				</div>
			</div>
		</div>
		
		<script type='text/javascript'>
		function ShowProgress() {
			middle_width = screen.width / 2;
			middle_height = screen.height / 2;
			
			$jMaQma("#Layer1").css('left',middle_width - 100);
			$jMaQma("#Layer1").css('top',middle_height - 250);
			$jMaQma("#Layer1").show('fade');
		}
		
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'client') {
				submitform( pressbutton );
				return;
			}

			WKSObj = document.adminForm.id_workgroup ;
			var j = 0 ;
			h = 0 ;
			for(j=0; j<WKSObj.length; j++) {
				if(WKSObj[j].selected) {
					h = h + 1 ;
				}
			}

			PrepareWks() ;
			
			if (form.clientname.value == ""){
				alert("<?php echo JText::_('name_required');?>");
			} else {
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'client') {
				submitform( pressbutton );
				return;
			}

			WKSObj = document.adminForm.id_workgroup ;
			var j = 0 ;
			h = 0 ;
			for(j=0; j<WKSObj.length; j++) {
				if(WKSObj[j].selected) {
					h = h + 1 ;
				}
			}

			PrepareWks() ;
			
			if (form.clientname.value == ""){
				alert("<?php echo JText::_('name_required');?>");
			} else {
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>

		function FillWks() {
			GRPS1 = document.adminForm.wks.value ;
			GRPS = GRPS1.split(/\s*,\s*/) ;
			
			for(i=0; i<document.adminForm.id_workgroup.length; i++) {
				for(z=0; z<GRPS.length; z++) {
					if(document.adminForm.id_workgroup[i].value == GRPS[z]) {
						document.adminForm.id_workgroup[i].selected = true ;
					}
				}
			}
		}

		function PrepareWks() {
			WKSObj = document.adminForm.id_workgroup ;
			document.adminForm.wks.value = '' ;
			WKSVal = '' ;

			var j = 0 ;
			for(j=0; j<WKSObj.length; j++) {
				if(WKSObj[j].selected) {
					WKSVal = WKSVal + WKSObj[j].value + "," ;
				}
			}
			
			document.adminForm.wks.value = WKSVal.substring(0, WKSVal.length-1) ;
		}

		function PrepareComponents() {
			CompsObj = document.addContract.id_component ;
			document.addContract.components.value = '' ;
			CompsVal = '' ;

			var j = 0 ;
			for(j=0; j<CompsObj.length; j++) {
				if(CompsObj[j].selected) {
					CompsVal = CompsVal + CompsObj[j].value + "," ;
				}
			}
			
			document.addContract.components.value = CompsVal.substring(0, CompsVal.length-1) ;
		}

		function EditContract(id, contract_number, creation_date, date_start, date_end, unit, id_contract, value, actual_value, status, remarks, id_user, contract_components <?php echo $editCustomParam; ?>) {
			document.addContract.contract_number.value = contract_number ;
			document.addContract.creation_date.value = creation_date ;
			document.addContract.date_start.value = date_start ;
			document.addContract.date_end.value = date_end ;
			document.addContract.unit.value = unit ;
			document.addContract.id_contract.value = id_contract ;
			document.addContract.value.value = value ;
			document.addContract.actual_value.value = actual_value ;
			document.addContract.status.value = status ;
			document.addContract.remarks.value = remarks ;
			document.addContract.id_user.value = id_user ;
			document.addContract.id.value = id ;
			document.addContract.contract_components.value = contract_components ;
			
			FillComponents();
			<?php
				if( count($cfields) > 0 ) {
					for( $x=0; $x<count($cfields); $x++ ) { 
						$cfield = $cfields[$x];
						if ( ($cfield->ftype == 'radio') || ($cfield->ftype == 'checkbox') ) {
							echo "document.getElementById('custom".$cfield->id_field."_' + custom".$cfield->id_field.").checked = true;"."\n";
						} else {
							echo "document.addContract.custom".$cfield->id_field.".value = custom".$cfield->id_field.";"."\n";
						}
					}
				}
			?>
		}

		function FillComponents() {
			GRPS1 = document.addContract.contract_components.value ;
			GRPS = GRPS1.split("|") ;
			
			for(i=0; i<document.addContract.id_component.length; i++) {
				document.addContract.id_component[i].selected = false ;

				for(z=0; z<GRPS.length; z++) {
					if(document.addContract.id_component[i].value == GRPS[z]) {
						document.addContract.id_component[i].selected = true ;
					}
				}
			}
		}

		function SetContractTitle( TITLE ) {
			document.getElementById("contract_title").innerHTML = TITLE ;
		}

		function ValidateForm() {
			var form = document.addContract;
			if(form.id_contract.value == "0") {
				alert( "Error: Select Contract Type" );
				form.id_contract.focus();
				return false;
			} else if (form.id_user.value == "0"){
				alert( "Error: Select Contract Maintainner" );
				form.id_user.focus();
				return false;
			} else if (form.date_start.value == ""){
				alert( "Error: Select Contract date start" );
				form.date_start.focus();
				return false;
			} else if (form.date_end.value == ""){
				alert( "Error: Select Contract date end" );
				form.date_end.focus();
				return false;
				<?php
				for( $x=0; $x<count($cfields); $x++ )
				{ 
					$cfield = $cfields[$x];
					if( $cfield->required ) {
						echo '} else if (form.custom'.$cfield->id_field.'.value == "" ) {'."\n";
						echo 'alert( "'.JText::_('cfield_required').' '.$cfield->caption.'." );'."\n";
						echo 'return false;';
					}
				} ?>
			}

			return true;
		}
		
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();

			$jMaQma("#ac_me").autocomplete("index.php?option=com_maqmahelpdesk&task=ajax_getuser&format=raw&session=<?php echo $session->getId();?>", {
				selectFirst: false,
				scroll: true,
				scrollHeight: 300,
				formatItem: function(data, i, n, value) {
					return '<img src="'+data[5]+'" width="32" height="32" align="left">'+data[1]+(data[3]!='' ? '<br><i>'+data[3]+'</i>' : '');
				},
				selectExecute: function(data) {
					$jMaQma("#id_user").val( data[0] );
					$jMaQma("#ac_me").val( data[1] );
				}
			});
			
			<?php if( $row->id > 0 ) echo "FillWks();"; ?>
		});
		</script><?php 
	}
}
