<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.components.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class comp_html {
	/**
	* Writes a list of the priorities
	* @param array An array of status objects
	* @param string The name of the status section
	*/
	static function show( &$rows, &$pageNav ) { ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=contracts"><?php echo JText::_('contracts'); ?></a>
			<span><?php echo JText::_('contract_components'); ?></span>
		</div>
		<div class="contentarea">
			<table class="contenttable" cellspacing="0">
			<thead>
			<tr>
				<td width="20" align="right">#</td>
				<td width="20">
					<input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
				</td>
				<td class="title"><?php echo JText::_('name'); ?></td>
				<td class="title"><?php echo JText::_('description'); ?></td>
			</tr>
			</thead>
			<tbody>
			<?php
			if (count( $rows )==0) {
				?><tr><td colspan="4"><?php echo JText::_('register_not_found'); ?></td></tr><?php
			} else {
				$k = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) {
					$row = &$rows[$i]; ?>
					<tr class="<?php echo ($i==0 ? 'first' : ''); ?>">
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td>
							<a href="#components_edit" onClick="return listItemTask('cb<?php echo $i;?>','components_edit')">
								<?php echo $row->name; ?>
							</a>
						</td>
						<td><?php echo $row->description; ?></td><?php		
						$k = 1 - $k; ?>
					</tr>
					<?php	
				} // for loop
			} // if ?>
			<tbody>
			<tfoot>
			<tr>
				<td colspan="4">
					<?php echo $pageNav->getListFooter(); ?>
				</td>
			</tr>
			</tfoot>
			</table>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="components" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php
	}

	/**
	* Writes the edit form for new and existing status
	*
	* A new record is defined when <var>$row</var> is passed witht the <var>id</var>
	* property set to 0.
	* @param string Record fields
	* @param string The component name
	* @param string The select lists
	*/
	static function edit( &$row ) {
		$editor = JFactory::getEditor(); ?>

		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'components') {
				submitform( pressbutton );
				return;
			}

			if (form.name.value == ""){
				alert("<?php echo JText::_('name_required'); ?>");
			} else {
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'components') {
				submitform( pressbutton );
				return;
			}

			if (form.name.value == ""){
				alert("<?php echo JText::_('name_required'); ?>");
			} else {
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>
		
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		</script>
		
		<?php $GLOBALS['titulo_components_edit'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('component'); ?>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=contracts"><?php echo JText::_('contracts'); ?></a>
			<span><?php echo JText::_('contract_components'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('name').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('name'); ?>
				</span> 
				<input class="large" type="text" id="name" name="name" value="<?php echo $row->name; ?>" maxlength="100" />
			</div>
			<div class="field w100">
				<label for="description">
					<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('allowed_types_tooltip')); ?>">
						<?php echo JText::_('description'); ?>
					</span> 
				</label> 
				<textarea name="description" style="height:50px;" class="large"><?php echo $row->description; ?></textarea>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form><?php 
	}
}
