<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.contracts.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class contracts_html 
{
	static function showcustomfields( &$rows, &$pageNav ) 
	{ ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=customfield"><?php echo JText::_('cfields'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=contracts"><?php echo JText::_('contracts'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		<div class="contentarea">
			<table class="contenttable" cellspacing="0">
			<thead>
			<tr>
				<td width="20" nowrap="nowrap"></td>
				<td width="20" align="right">#</td>
				<td width="20">
					<input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
				</td>
				<td class="title"><?php echo JText::_('field_name'); ?></td>
				<td class="title"><?php echo JText::_('field_type'); ?></td>
				<td width="70" align="center"><?php echo JText::_('required'); ?></td>
			</tr>
			</thead>
			<tbody>
			<?php
			if (count( $rows )==0) {
				?><tr><td colspan="6"><?php echo JText::_('register_not_found'); ?></td></tr><?php
			} else {
				$k = 0;
				$j = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) {
					$row = &$rows[$i];
					$img = $row->required ? 'tick' : 'no';
					$alt = $row->required ? JText::_('required_tooltip') : JText::_('not_required_tooltip');
					?>
					<tr class="<?php echo ($i==0 ? 'first' : ''); ?>">
						<td align="left" width="20" align="right" class="dragHandle"></td>
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td>
							<a href="#contracts_fields_edit" onClick="return listItemTask('cb<?php echo $i;?>','contracts_fields_edit')">
								<?php echo $row->caption; ?>
							</a>
						</td>
						<td><?php echo JText::_('formfield_'.$row->ftype); ?></td>
						<td align="center">
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="<?php echo $alt;?>" />
						</td><?php		
						$k = 1 - $k;
						$j++; ?>
					</tr><?php	
				} // for loop
			} // if ?>
			</tbody>
			<tfoot>
				<tr>
					<td colspan="7">
						<?php echo $pageNav->getListFooter(); ?>
					</td>
				</tr>
			</tfoot>
			</table>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="contracts" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
			
			$jMaQma('#contentTable').tableDnD({
				onDrop: function(table, row) {
					window.location = 'index.php?option=com_maqmahelpdesk&task=contracts_saveorder&'+$jMaQma('#contentTable').tableDnDSerialize();
				},
				dragHandle: "dragHandle"
			});
			
			$jMaQma("#contentTable tr").hover(function() {
				  $jMaQma(this.cells[0]).addClass('showDragHandle');
			}, function() {
				  $jMaQma(this.cells[0]).removeClass('showDragHandle');
			});
		});
		</script><?php
	}

	static function editcustomfields( &$row, $lists ) {
		$GLOBALS['titulo_contracts_fields_edit'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('cfield'); ?>
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'contract_fields_save') {
				submitform( pressbutton );
				return;
			}

			submitform(pressbutton);
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'contract_fields_save') {
				submitform( pressbutton );
				return;
			}

			Joomla.submitform(pressbutton, document.getElementById('adminForm'));
		}
		<?php } ?>
		
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=customfield"><?php echo JText::_('cfields'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=contracts"><?php echo JText::_('contracts'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=contracts_fields"><?php echo JText::_('users_cfield_menu'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('field').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('field'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['fields']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('required').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('required'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['required']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('ordering').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('ordering'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['ordering']; ?>
				</div>
			</div>
			<br class="clr" />
		</div>
			
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form><?php 
	}
	
	static function show( &$rows, &$pageNav ) 
	{ ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=contracts"><?php echo JText::_('contract_types'); ?></a>
			<span><?php echo JText::_('manager'); ?></span>
		</div>
		<div class="contentarea">
			<table class="contenttable" cellspacing="0">
			<thead>
			<tr>
				<td width="20" align="right">#</td>
				<td width="20">
					<input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
				</td>
				<td class="title"><?php echo JText::_('name'); ?></td>
				<td class="title"><?php echo JText::_('description'); ?></td>
				<td class="title"><?php echo JText::_('priority'); ?></td>
				<td align="center"><?php echo JText::_('unit'); ?></td>
				<td align="center"><?php echo JText::_('value'); ?></td>
			</tr>
			</thead>
			<tbody><?php
			if (count( $rows )==0) {
				?><tr><td colspan="7"><?php echo JText::_('register_not_found'); ?></td></tr><?php
			} else {
				$k = 0;
				$j = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) {
					$row = &$rows[$i];
					$unit_desc = '';
					switch($row->unit) 
					{
						case 'Y':
							$unit_desc = JText::_('years');
							break;

						case 'M':
							$unit_desc = JText::_('months');
							break;

						case 'D':
							$unit_desc = JText::_('days');
							break;

						case 'H':
							$unit_desc = JText::_('hours');
							break;

						case 'T':
							$unit_desc = JText::_('tickets');
							break;
					} ?>
					<tr class="<?php echo "row$k"; ?>">
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td>
							<a href="#contracts_edit" onClick="return listItemTask('cb<?php echo $i;?>','contracts_edit')">
								<?php echo $row->name; ?>
							</a>
						</td>
						<td><?php echo strip_tags($row->description); ?></td>
						<td><?php echo $row->priority; ?></td>
						<td align="center"><?php echo $unit_desc; ?></td>
						<td align="center"><?php echo $row->val; ?></td><?php		
						$k = 1 - $k; 
						$j++; ?>
					</tr><?php	
				} // for loop
			} // if ?>
			</tbody>
			<tfoot>
			<tr>
				<td colspan="7">
					<?php echo $pageNav->getListFooter(); ?>
				</td>
			</tr>
			</tfoot>
			</table>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="contracts" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php
	}

	static function edit( &$row, $lists ) 
	{
		$editor = JFactory::getEditor();
		$GLOBALS['titulo_contracts_edit'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('contract_type'); ?>

		<script language="javascript" type="text/javascript">
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'contracts') {
				submitform( pressbutton );
				return;
			}

			if (form.name.value == ""){
				alert("<?php echo JText::_('name_required'); ?>.");
			} else if (form.id_priority.value == "0"){
				alert("<?php echo JText::_('priority_required'); ?>.");
			} else if (form.unit.value == ""){
				alert("<?php echo JText::_('unit_required'); ?>.");
			} else if (form.val.value == ""){
				alert("<?php echo JText::_('value_required'); ?>.");
			} else {
				<?php echo $editor->save( 'description' ); ?>
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=contracts"><?php echo JText::_('contract_types'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('name').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('name'); ?>
				</span> 
				<input class="large" type="text" id="name" name="name" value="<?php echo $row->name; ?>" maxlength="100" />
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('priority').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('priority'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['priority']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('unit').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('unit'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['unit']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('value').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('value'); ?>
				</span> 
				<input type="text" id="val" name="val" value="<?php echo $row->val; ?>" maxlength="10" size="12" />
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('description'); ?>
				</span> 
				<div style="margin-left:170px;"><?php echo $editor->display( 'description', $row->description, '100%', '300', '75', '20' );?></div>
			</div>
			<br class="clr" />
		</div>

		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form><?php 
	}
}
