<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.customer.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class HTML_customer {
	static function showCustomer( &$rows, &$pageNav, $filter ) 
	{ ?>
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=product"><?php echo JText::_('downloads'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=customer"><?php echo JText::_('clients_access'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		
		<form action="index.php" method="POST" id="adminForm" name="adminForm">
		<div id="filtersarea">
			<?php echo strtoupper(JText::_('filters'));?> <img src="components/com_maqmahelpdesk/images/separator2.png" style="padding:5px;" align="absmiddle" /> 
			<input type="text" id="filter" name="filter" value="<?php echo $filter;?>" /> 
			<div class="mqmbutton-group" style="float: right;padding-top: 5px;">
				<a href="javascript:;" class="mqmbutton icon trash red" onclick="document.adminForm.getElementById('filter').value='';document.adminForm.submit();"><?php echo JText::_('reset');?></a> 
				<a href="javascript:;" class="mqmbutton icon search success" onclick="document.adminForm.submit();"><?php echo JText::_('filter');?></a>
			</div>
		</div>		
		
		<div class="contentarea">
			<?php if ( count( $rows ) == 0 ) : ?>
				<div class="detailmsg">
					<h1><img src="../components/com_maqmahelpdesk/images/alert.png" align="left" /> <?php echo JText::_('register_not_found'); ?></h1>
					<p><?php echo JText::_('to_add_new_record_desc'); ?></p>
				</div>
				<script type="text/javascript"> MaQmaJS.AddHelpHand('toolbar-new'); </script>
			<?php else: ?>
				<table class="contenttable" cellspacing="0">
				<thead>
					<tr>
						<th width="20" align="right">#</th>
						<th class="title" width="20"><input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows ); ?>);" /></th>
						<th class="title" nowrap><?php echo JText::_('client'); ?></th>
						<th class="title" nowrap><?php echo JText::_('dl_category'); ?></th>
						<th class="title" nowrap><?php echo JText::_('dl_product'); ?></th>
						<th class="center" width="50"><?php echo JText::_('active'); ?></th>
						<th class="center" width="70"><?php echo JText::_('start'); ?></th>
						<th class="center" width="70"><?php echo JText::_('end'); ?></th>
					</tr>
				</thead>
				<tbody><?php
				$k = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) {
					$row = &$rows[$i]; ?>
					<tr id="contentTable-row-<?php echo ($row->id);?>" class="<?php echo "row$k"; ?>">
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20">
							<input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onClick="isChecked(this.checked);" />
						</td>
						<td align="left"><a href="#edit" onclick="return listItemTask('cb<?php echo $i; ?>','customer_edit')"><?php echo $row->clientname; ?></a></td>
						<td align="left"><?php echo $row->category;?></td>
						<td align="left"><?php echo $row->product;?></td>
						<td width="50" align="center"><?php
							$img = $row->isactive ? 'tick' : 'no'; ?>
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="" />
						</td>
						<td align="center" width="70"><?php echo $row->servicefrom;?></td>
						<td align="center" width="70"><?php echo $row->serviceuntil;?></td>
					</tr><?php	
				} ?>
				</tbody>
				<tfoot>
					<tr>
						<td colspan="9">
							<?php echo $pageNav->getListFooter(); ?>
						</td>
					</tr>
				</tfoot>
				</table>
			<?php endif; ?>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="customer" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input[type='text'], input[type='checkbox'], input[type='radio'], textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
			
			$jMaQma("#filter").css("width", $jMaQma("#filtersarea").width() - $jMaQma("#filter").offset().left - $jMaQma(".mqmbutton-group").width());
			$jMaQma(window).resize(function(){
				$jMaQma("#filter").css("width", $jMaQma("#filtersarea").width() - $jMaQma("#filter").offset().left - $jMaQma(".mqmbutton-group").width());
			});
		});
		</script><?php
	}

	static function customerForm( &$_row, $lists ) { 
		$GLOBALS['title_customer_form'] = ( $_row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('client_access'); ?>
		<script type="text/javascript" src="<?php echo JURI::root();?>components/com_maqmahelpdesk/js/jquery.autocomplete-min.js"></script>
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'customer_cancel') {
				submitform( pressbutton );
				return;
			}
			
			submitform(pressbutton);
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'customer_cancel') {
				submitform( pressbutton );
				return;
			}
			
			Joomla.submitform(pressbutton, document.getElementById('adminForm'));
		}
		<?php } ?>
		</script>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=product"><?php echo JText::_('downloads'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=customer"><?php echo JText::_('clients_access'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('client').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('client'); ?>
				</span> 
				<input type="text" id="searchclient" name="searchclient" value="<?php echo $_row->clientname; ?>" class="large" /> 
				<input type="hidden" id="id_user" name="id_user" value="<?php echo $_row->id_user; ?>" />
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('dl_product').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('dl_product'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['products']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('active').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('active'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['isactive']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('serial_number').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('serial_number'); ?>
				</span> 
				<input class="medium" type="text" id="serialno" name="serialno" value="<?php echo $_row->serialno; ?>" maxlength="250" />
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('start').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('start'); ?>
				</span> 
				<?php echo JHTML::Calendar($_row->servicefrom, 'servicefrom' , 'servicefrom', '%Y-%m-%d', array('class'=>'text_area', 'size'=>'12',  'maxlength'=>'12')); ?>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('end').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('end'); ?>
				</span> 
				<?php echo JHTML::Calendar($_row->serviceuntil, 'serviceuntil' , 'serviceuntil', '%Y-%m-%d', array('class'=>'text_area', 'size'=>'12',  'maxlength'=>'12')); ?>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $_row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input[type='text'], input[type='checkbox'], input[type='radio'], textarea, select").uniform();
			$jMaQma("#searchclient").autocomplete("index.php?option=com_maqmahelpdesk&task=ajax_getclient&format=raw", {
				selectFirst: false,
				scroll: true,
				scrollHeight: 300,
				formatItem: function(data, i, n, value) {
					return '<img src="'+data[2]+'" width="32" height="32" align="left">'+data[1];
				},
				selectExecute: function(data) {
					$jMaQma("#id_user").val( data[0] );
					$jMaQma("#searchclient").val( data[1] );
				}
			});
		});
		</script><?php
	}
}
