<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.kb.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );
include_once( JPATH_SITE. '/components/com_maqmahelpdesk/includes/common.php' );

class kb_html 
{
	static function show( &$rows, &$pageNav, $search ) {
		$database = JFactory::getDBO();?>
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=kb"><?php echo JText::_('kb'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div id="filtersarea">
			<?php echo strtoupper(JText::_('filters'));?> <img src="components/com_maqmahelpdesk/images/separator2.png" style="padding:5px;" align="absmiddle" /> 
			<input type="text" id="search" name="search" value="<?php echo urldecode(htmlspecialchars($search));?>" /> 
			<div class="mqmbutton-group" style="float: right;padding-top: 5px;">
				<a href="javascript:;" class="mqmbutton icon trash red" onclick="document.getElementById('search').value='';document.adminForm.submit();"><?php echo JText::_('reset');?></a> 
				<a href="javascript:;" class="mqmbutton icon search success" onclick="document.adminForm.submit();"><?php echo JText::_('filter');?></a>
			</div>
		</div>
		
		<div class="contentarea">
			<div id="contentbox" class="mqmclear">
                <?php if ( count( $rows ) == 0 ) : ?>
                    <div class="detailmsg">
                        <h1><img src="../components/com_maqmahelpdesk/images/alert.png" align="left" /> <?php echo JText::_('register_not_found'); ?></h1>
                        <p><?php echo JText::_('to_add_new_record_desc'); ?></p>
                    </div>
                    <script type="text/javascript"> MaQmaJS.AddHelpHand('toolbar-new'); </script>
                <?php else: ?>
                    <table class="contenttable" cellspacing="0">
                    <thead>
                        <tr>
                        <th width="20" align="right">#</th>
                        <td width="20"><input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" /></td>
                        <td class="title"><?php echo JText::_('code'); ?></td>
                        <td class="title"><?php echo JText::_('title'); ?></td>
                        <td class="title"><?php echo JText::_('categories'); ?></td>
                        <td class="title"><?php echo JText::_('date_updated'); ?></td>
                        <td width="70" align="center"><?php echo JText::_('approved'); ?></td>
                        <td width="70" align="center"><?php echo JText::_('published'); ?></td>
                        </tr>
                    </thead>
                    <tfoot>
                        <tr>
                        <td colspan="9"><?php echo $pageNav->getListFooter(); ?></td>
                    </tr>
                    </tfoot>
                    <tbody><?php
                    $k = 0;
                    $j = 0;
                    for ($i=0, $n=count( $rows ); $i < $n; $i++)
                    {
                        $row = &$rows[$i];
                        $img = $row->publish ? 'tick' : 'no';
                        $img_approve = $row->approved ? 'tick' : 'no';
                        $task = $row->publish ? 'kb_unpublish' : 'kb_publish';
                        $alt = $row->publish ? JText::_('published') : JText::_('unpublished'); ?>

                        <tr class="<?php echo ($i==0 ? 'first' : ''); ?>">
                            <td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
                            <td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
                            <td>
                                <a href="#kb_edit" onClick="return listItemTask('cb<?php echo $i;?>','kb_edit')">
                                    <?php echo $row->kbcode; ?>
                                </a>
                            </td>
                            <td>
                                <a href="#kb_edit" onClick="return listItemTask('cb<?php echo $i;?>','kb_edit')">
                                    <?php echo str_replace("\'", "'", $row->kbtitle); ?>
                                </a>
                            </td>
                            <td><?php
                                $database->setQuery( "SELECT c.name FROM #__support_category c, #__support_kb k, #__support_kb_category kc WHERE c.id=kc.id_category AND k.id=kc.id_kb AND k.id=".$row->id );
                                $catrows = $database->loadObjectList();
                                $z=0;
                                for($z=0;$z<count($catrows);$z++) {
                                    $catrow = &$catrows[$z];
                                    print $catrow->name;
                                    if((count($catrows)-$z)>1) {
                                        print ", ";
                                    }
                                } ?>
                            </td>
                            <td><?php echo $row->date_updated; ?></td>
                            <td width="70" align="center">
                                <img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img_approve;?>.png" border="0" alt="" />
                            </td>
                            <td width="70" align="center">
                                <a href="javascript:;" onClick="return listItemTask('cb<?php echo $i;?>','<?php echo $task;?>')">
                                    <img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="<?php echo $alt;?>" />
                                </a>
                            </td>
                        </tr>
                        <?php
                    } // for ?>
                    </tbody>
                    </table>
                <?php endif; ?>
			</div>
			<div id="infobox">
				<span id="infoarrow"></span>
				<dl class="first">
					<dd class="title"><?php echo JText::_('INFO_KB_TITLE');?></dd>
					<dd class="last">
						<?php echo JText::_('INFO_KB_DESC');?>
						<p align="center"><a href="http://www.imaqma.com/support/documentation/16-helpdesk-component/99-knowledge-base.html" target="_blank" class="mqmbutton gray"><img src="../components/com_maqmahelpdesk/images/16px/help.png" align="absmiddle" border="0" alt="" /> <?php echo JText::_('more_information');?></a></p>
					</dd>
				</dl>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="kb" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input[type='text'], input[type='checkbox'], input[type='radio'], textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
			
			$jMaQma("#search").css("width", $jMaQma("#filtersarea").width() - $jMaQma("#search").offset().left - $jMaQma(".mqmbutton-group").width());
			$jMaQma(window).resize(function(){
				$jMaQma("#search").css("width", $jMaQma("#filtersarea").width() - $jMaQma("#search").offset().left - $jMaQma(".mqmbutton-group").width());
			});
		});
		</script><?php
	}

	static function edit( &$row, $lists, $kbAttachs, $rate, $wkrows, $kbComments, $prodcat, $fromticket ) 
	{
		global $supportConfig; 
		
		$editor = JFactory::getEditor();
		$database = JFactory::getDBO();
		$user	= JFactory::getUser(); ?>
		
		<style type="text/css">
		.wklist {
			background: #cecece;
		}
		</style>

		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'kb') {
				submitform( pressbutton );
				return;
			}
			
			if (form.kbtitle.value == ""){
				alert( "<?php echo JText::_('title_required'); ?>" );
			} else {
				<?php echo $editor->save( 'content' ); ?>
				ArrangeFields();
				submitform( pressbutton );
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'kb') {
				submitform( pressbutton );
				return;
			}
			
			if (form.kbtitle.value == ""){
				alert( "<?php echo JText::_('title_required'); ?>" );
			} else {
				<?php echo $editor->save( 'content' ); ?>
				ArrangeFields();
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>

		function ShowComment(arg, img) {
			$jMaQma("#"+arg).slideToggle();
		}
		
		function ShowCategory() {
			var obj;
			var arg;
			var totwks;		
			var WKObj=document.adminForm.id_workgroup;

			for(i=1;i<WKObj.length;i++){
				if(WKObj[i].selected){
					arg = 'cat' + WKObj[i].value;
					obj=MM_findObj(arg)
					obj=obj.style; 
					obj.display = 'block';
				}else{
					arg = 'cat' + WKObj[i].value;
					obj=MM_findObj(arg)
					obj=obj.style; 
					obj.display = 'none';
				}
			}
		}

		function ArrangeFields() {
			NEMPS = '';
			
			var CATObj = document.adminForm.id_category;
			for(i=0; i<CATObj.length; i++) {
				if(CATObj[i].selected == true && CATObj[i].value != 'WK') {
					NEMPS = NEMPS + CATObj[i].value + ",";
				}
			}
			
			document.adminForm.categories.value = NEMPS.substr(0, NEMPS.length-1);
		}

		function FillValues() {
			EMPS1 = "<?php echo $prodcat;?>";
			EMPS = EMPS1.split(",");
			
			var CATObj = document.adminForm.id_category;
			for(i=0; i<CATObj.length; i++) {
				for(z=0; z<EMPS.length; z++) {
					if(CATObj[i].value == EMPS[z]) {
						CATObj[i].selected = true;
					}
				}
			}
		}
		</script>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm" enctype="multipart/form-data" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=kb"><?php echo JText::_('kb'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea withleft">
			<div class="sidebar">
				<div class="content" style="display: block;">
					<ul class="leftmenu">
						<li class="current"><a href="#" onclick="MaQmaJS.SelectTab(this,1);"><img src="../components/com_maqmahelpdesk/images/menu/kb.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('article_header');?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,2);"><img src="../components/com_maqmahelpdesk/images/menu/table.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('content');?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,3);"><img src="../components/com_maqmahelpdesk/images/16px/attach.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('attachments');?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,4);"><img src="../components/com_maqmahelpdesk/images/menu/comments.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('comment');?></a></li>
					</ul>
				</div>
			</div>
			<div class="contentbar withleft">
				<div id="tab1" class="contenttab" style="display:block;">
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('title').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('title'); ?>
						</span> 
						<input class="large" type="text" id="kbtitle" name="kbtitle" value="<?php echo $row->kbtitle; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('keywords').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('keywords'); ?>
						</span> 
						<input class="medium" type="text" id="keywords" name="keywords" value="<?php echo $row->keywords; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('code').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('code'); ?>
						</span> 
						<input class="medium" type="text" id="kbcode" name="kbcode" value="<?php echo $row->kbcode; ?>" maxlength="100" />
					</div>
					<div class="field w100" style="height:180px;">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('categories').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('categories'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['categories']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('anonymous_access').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('anonymous_access'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['anonymous']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('approved').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('approved'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['approved']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('show_faq').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('show_faq'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $supportConfig->faq_kb_manual ? $lists['faq'] : '<i>'.JText::_('disabled_config').'</i>'; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('date_created').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('date_created'); ?>
						</span> 
						<?php echo ($row->date_created=='' ? dateOffset("Y-m-d") : $row->date_created); ?>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('date_updated').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('date_updated'); ?>
						</span> 
						<?php echo ($row->date_updated=='' ? dateOffset("Y-m-d") : $row->date_updated); ?>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('views').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('views'); ?>
						</span> 
						<?php echo $row->views; ?>
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('rating').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('rating'); ?>
						</span> 
						<img src="../components/com_maqmahelpdesk/images/rating/<?php echo ( $rate->ratecount > 0 ? number_format($rate->ratesum/$rate->ratecount,0) : 0);?>star.png" />
					</div>
					<br class="clr" />
				</div>
				<div id="tab2" class="contenttab">
					<div class="field w100" style="height:550px;">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('content').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('content'); ?>
						</span> 
						<div style="margin-left:170px;"><?php echo $editor->display( 'content', str_replace('\"','"',$row->content), '100%', '500', '75', '20' );?></div>
					</div>
					<br class="clr" />
				</div>
				<div id="tab3" class="contenttab">
					<table class="contenttable" cellspacing="0">
					<thead>
					<tr>
						<td class="title"><?php echo JText::_('filename'); ?></td>
						<td class="title"><?php echo JText::_('description'); ?></td>
						<td width="70" align="center"><?php echo JText::_('delete'); ?></td>
					</tr>
					</thead>
					<tbody><?php
					$k = 0;
					$j = 0;
					for ($i=0, $n=count( $kbAttachs ); $i < $n; $i++) 
					{
						$row_attach = $kbAttachs[$i];
						$link = JRoute::_('index.php?option=com_maqmahelpdesk&task=kb_download&id='.$row_attach->id_file.'&extid='.$row_attach->id); ?>
						<tr class="<?php echo ($i==0 ? 'first' : ''); ?>">
							<td>
								<a href="<?php echo $link;?>">
									<?php echo $row_attach->filename; ?>
								</a>
							</td>
							<td><?php echo $row_attach->description;?></td>
							<td width="70" align="center">
								<a href="index.php?option=com_maqmahelpdesk&task=kb_delattach&id_attach=<?php echo $row_attach->id_file;?>&filename=<?php echo $row_attach->filename;?>&id=<?php echo $row->id;?>"><img src="../components/com_maqmahelpdesk/images/16px/delete.png" border="0" alt="<?php echo JText::_('delete');?>" /></a>
							</td>
						</tr>
						<?php	
					} // for 
					if( count($kbAttachs) == 0 ) { ?>
						<tr><td class="first" colspan="3"><?php echo JText::_('no_attachments');?>.</td></tr><?php
					} ?>
					</tbody>
					</table>
					
					<p>&nbsp;</p><?php
					if (count($supportConfig->attachs_num) > 0 ) { 
						for($i=0; $i<count($supportConfig->attachs_num); $i++) { ?>
							<div class="field w100">
								<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('attachments').'::'.JText::_('todo')); ?>">
									<?php echo JText::_('attachments').' ('.($i+1).')'; ?>
								</span> 
								<input class="large" type="file" id="file<?php echo $i; ?>" name="file<?php echo $i; ?>" value="" />
							</div>
							<div class="field w100" style="height:110px;">
								<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('attachs_details').'::'.JText::_('todo')); ?>">
									<?php echo JText::_('attachs_details'); ?>
								</span> 
								<textarea id="desc<?php echo $i; ?>" name="desc<?php echo $i; ?>" style="height:100px;" class="large"></textarea>
							</div><?php
						}
					} ?>
					<br class="clr" />
				</div>
				<div id="tab4" class="contenttab">
					<table class="contenttable" cellspacing="0">
					<thead>
					<tr>
						<td class="title"><?php echo JText::_('comment'); ?></td>
						<td width="70" align="center"><?php echo JText::_('delete'); ?></td>
					</tr>
					</thead>
					<tbody><?php
					$k = 0;
					$j = 0;
					for ($i=0, $n=count( $kbComments ); $i < $n; $i++) 
					{
						$row_comment = $kbComments[$i]; ?>
						<tr class="<?php echo ($i==0 ? 'first' : ''); ?>">
							<td>
								<div onclick="ShowComment('comment<?php echo $i;?>','imgmsg<?php echo $i;?>');" style="cursor:pointer;float:left;"><?php echo $row_comment->name.' @ '.$row_comment->date;?></div>
								<div style="display:none; border-left:10px solid #ececec;" id="comment<?php echo $i;?>" name="comment<?php echo $i;?>"><?php echo nl2br($row_comment->comment);?></div>
							</td>
							<td>
								<a href="index.php?option=com_maqmahelpdesk&task=kb_delcomment&id_comment=<?php echo $row_comment->id;?>&id=<?php echo $row->id;?>"><img src="../components/com_maqmahelpdesk/images/16px/delete.png" border="0" alt="<?php echo JText::_('delete');?>" align="absmiddle" /></a>
							</td>
						</tr>
						<?php	
					} // for 
					if( count($kbComments) == 0 ) { ?>
						<tr><td class="first"><?php echo JText::_('no_user_comments');?>.</td></tr><?php
					} ?>
					</tbody>
					</table>
					<br class="clr" />
				</div>
			</div>
		</div>
		
		<?php if( $row->id > 0 || $fromticket > 0 ): ?>
			<input type="hidden" name="id_workgroup" value="" />
			<script type="text/javascript"> ShowCategory(); FillValues(); </script>
		<?php endif;?>
		
		<input type="hidden" name="categories" value="">
		<input type="hidden" name="fromticket" value="<?php echo $fromticket;?>" />
		<input type="hidden" name="views" value="<?php echo $row->views;?>" />
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="id_user" value="<?php echo ($row->id > 0 ? $row->id_user : $user->id); ?>" />
		<input type="hidden" name="date_created" value="<?php echo ($row->id > 0 ? $row->date_created : dateOffset("Y-m-d H:i:s")); ?>" />
		<input type="hidden" name="date_updated" value="<?php echo dateOffset("Y-m-d H:i:s"); ?>" />
		<input type="hidden" name="task" value="" />
		</form>
		
		<script type='text/javascript'>
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		</script><?php
	}

	static function showComments( &$rows, &$pageNav ) 
	{
		$database = JFactory::getDBO();?>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=kb"><?php echo JText::_('kb'); ?></a>
			<span><?php echo JText::_('moderate_comments'); ?></span>
		</div>
		<div class="contentarea">
			<div id="contentbox">
			<?php if ( count( $rows ) == 0 ) : ?>
				<div class="detailmsg">
					<h1><img src="../components/com_maqmahelpdesk/images/alert.png" align="left" /> <?php echo JText::_('register_not_found'); ?></h1>
				</div>
			<?php else: ?>
				<table class="contenttable" cellspacing="0">
				<thead>
				<tr>
					<th width="20" align="right">#</th>
					<td width="20"><input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" /></td>
					<td class="title"><?php echo JText::_('title'); ?></td>
					<td class="title"><?php echo JText::_('user'); ?></td>
					<td class="title"><?php echo JText::_('date'); ?></td>
					<td class="title"><?php echo JText::_('comment'); ?></td>
				</tr>
				</thead>
				<tfoot>
				<tr>
					<td colspan="9"><?php echo $pageNav->getListFooter(); ?></td>
				</tr>
				</tfoot>
				<tbody><?php
				$k = 0;
				$j = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) 
				{
					$row = &$rows[$i];
					$img = $row->show ? 'tick' : 'no';
					$task = $row->show ? 'forms_unpublish' : 'forms_publish';
					$alt = $row->show ? JText::_('published') : JText::_('unpublished'); ?>
					<tr class="<?php echo ($i==0 ? 'first' : ''); ?>">
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td valign="top">
							<a href="index.php?option=com_maqmahelpdesk&task=kb_edit&cid[0]=<?php echo $row->id_kb; ?>">
								<?php echo $row->kbtitle; ?>
							</a>
						</td>
						<td valign="top" align="left">
							<a href="index.php?option=com_maqmahelpdesk&task=kb_edit&cid[0]=<?php echo $row->id_kb; ?>">
								<?php echo $row->name; ?>
							</a>
						</td>
						<td valign="top"><?php echo $row->date; ?></td>
						<td valign="top"><?php echo $row->comment; ?></td>
					</tr>
					<?php	
				} // for ?>
				</tbody>
				</table>
			<?php endif; ?>
			</div>
			<div id="infobox">
				<span id="infoarrow"></span>
				<header>
					<h3><?php echo JText::_('info_title');?></h3>
				</header>
				<dl class="first">
					<dd class="title"><?php echo JText::_('INFO_KBMODERATE_TITLE');?></dd>
					<dd class="last">
						<?php echo JText::_('INFO_KBMODERATE_DESC');?>
						<p align="center"><a href="http://www.imaqma.com" target="_blank" class="mqmbutton gray"><img src="../components/com_maqmahelpdesk/images/16px/help.png" align="absmiddle" border="0" alt="" /> <?php echo JText::_('more_information');?></a></p>
					</dd>
				</dl>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="kb_moderate" />
		<input type="hidden" name="boxchecked" value="0" />
		</form><?php
	}
}
