<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.licenses.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class license_html 
{
	static function show( &$rows, &$pageNav ) { ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=product"><?php echo JText::_('downloads'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=licenses"><?php echo JText::_('licenses'); ?></a>
			<span><?php echo JText::_('manager'); ?></span>
		</div>
		<div class="contentarea">
			<div id="contentbox">
			<?php if ( count( $rows ) == 0 ) : ?>
				<div class="detailmsg">
					<h1><img src="../components/com_maqmahelpdesk/images/alert.png" align="left" /> <?php echo JText::_('register_not_found'); ?></h1>
					<p><?php echo JText::_('to_add_new_record_desc'); ?></p>
				</div>
				<script type="text/javascript"> MaQmaJS.AddHelpHand('toolbar-new'); </script>
			<?php else: ?>
				<table class="contenttable" cellspacing="0">
				<thead>
					<tr>
						<td width="10">#</td>
						<td width="10">
							<input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
						</td>
						<td class="title"><?php echo JText::_('name'); ?></td>
					</tr>
				</thead>
				<tbody><?php
				$k = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) {
					$row = &$rows[$i]; ?>
					<tr class="<?php echo "row$k"; ?>">
						<td width="10" align="right"><?php echo $pageNav->getRowOffset( $i ); ?></td>
						<td width="10"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td>
							<a href="#licenses_edit" onClick="return listItemTask('cb<?php echo $i;?>','licenses_edit')">
								<?php echo $row->title; ?>
							</a>
						</td><?php		
						$k = 1 - $k; ?>
					</tr><?php	
				} // for loop ?>
				</tbody>
				<tfoot>
					<tr>
						<td colspan="3"><?php echo $pageNav->getListFooter(); ?></td>
					</tr>
				</tfoot>
				</table>
			<?php endif; ?>
			</div>
			<div id="infobox">
				<span id="infoarrow"></span>
				<dl class="first">
					<dd class="title"><?php echo JText::_('INFO_LICENSES_TITLE');?></dd>
					<dd class="last">
						<?php echo JText::_('INFO_LICENSES_DESC');?>
						<p align="center"><a href="http://www.imaqma.com/" target="_blank" class="mqmbutton gray"><img src="../components/com_maqmahelpdesk/images/16px/help.png" align="absmiddle" border="0" alt="" /> <?php echo JText::_('more_information');?></a></p>
						<p align="center"><a href="http://www.imaqma.com/" target="_blank" class="mqmbutton success"><img src="../components/com_maqmahelpdesk/images/16px/down.png" align="absmiddle" border="0" alt="" /> Download</a></p>
					</dd>
				</dl>
			</div>
			<br class="clr" />
		</div>

		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="licenses" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
			
			if( $jMaQma("#contentbox").height() > 400 ) {
				$jMaQma("#infobox").css("height", $jMaQma("#contentbox").height());
			}
		});
		</script><?php
	}

	static function edit( &$row ) {
		$editor = JFactory::getEditor();
		$GLOBALS['title_edit_licenses'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('license'); ?>

		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'licenses') {
				submitform( pressbutton );
				return;
			}

			if (form.title.value == ""){
				alert("<?php echo JText::_('title_required'); ?>");
			} else {
				<?php echo $editor->save( 'description' ); ?>
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'licenses') {
				submitform( pressbutton );
				return;
			}

			if (form.title.value == ""){
				alert("<?php echo JText::_('title_required'); ?>");
			} else {
				<?php echo $editor->save( 'description' ); ?>
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=product"><?php echo JText::_('downloads'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=licenses"><?php echo JText::_('licenses'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('title').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('title'); ?>
				</span> 
				<input class="large" type="text" id="title" name="title" value="<?php echo $row->title; ?>" maxlength="100" />
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('description'); ?>
				</span> 
				<div style="margin-left:170px;"><?php echo $editor->display( 'description', $row->description, '100%', '500', '75', '20' );?></div>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form>
		
		<script type='text/javascript'>
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		</script><?php 
	}
}
