<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.schedule.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

/**
* @package iMaQma Helpdesk
*/
class schedule_html {
	/**
	* Writes a list of the categories for a section
	* @param array An array of category objects
	* @param string The name of the category section
	*/
	static function show( &$rows, &$pageNav ) { ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="javascript:;"><?php echo JText::_('settings'); ?></a>
			<a href="javascript:;"><?php echo JText::_('common'); ?></a>
			<a href="javascript:;"><?php echo JText::_('expedient'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=schedule"><?php echo JText::_('schedules'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		<div class="contentarea">
			<table class="contenttable" cellspacing="0">
			<thead>
			<tr>
				<th width="10px">#</th>
				<th width="10px">
					<input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
				</th>
				<th class="title" width="170px"><div align="center"><?php echo JText::_('profile'); ?></div></th>
				<th class="title"><?php echo JText::_('dl_description'); ?></th>
				<th class="title" align="center"><?php echo JText::_('work_on_holidays'); ?></th>
			</tr>
			</thead>
			<tbody><?php
			if (count( $rows )==0) {
				?><tr><td colspan="5"><?php echo JText::_('register_not_found'); ?></td></tr><?php
			} else {
				$k = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) {
					$row = &$rows[$i]; ?>
					<tr class="<?php echo "row$k"; ?>">
						<td width="10px" align="right"><?php echo $pageNav->getRowOffset( $i ); ?></td>
						<td width="10px"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td width="170px">
							<a href="#schedule_edit" onClick="return listItemTask('cb<?php echo $i;?>','schedule_edit')" >
								<?php echo $row->profile; ?>
							</a>
						</td>
						<td>
							<a href="#schedule_edit" onClick="return listItemTask('cb<?php echo $i;?>','schedule_edit')" >
								<?php echo strip_tags($row->description); ?>
							</a>
						</td>
						<td align="center"><?php
							$img = $row->work_on_holidays ? 'tick' : 'no';
							$alt = $row->work_on_holidays ? JText::_('MQ_YES') : JText::_('MQ_NO'); ?>
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="<?php echo $alt;?>" />
						</td><?php		
						$k = 1 - $k; ?>
					</tr><?php	
				} // for loop
			} // if ?>
			</tbody>
			<tfoot>
				<tr>
					<td colspan="5"><?php echo $pageNav->getListFooter(); ?></td>
				</tr>
			</tfoot>
			</table>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="schedule" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php
	}

	static function edit( &$scheduleInfo, $lists ) {	
		global $supportConfig;
		$editor = JFactory::getEditor(); ?>

		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'schedule') {
				submitform( pressbutton );
				return;
			}

			if (form.profile.value == ""){
				alert("<?php echo JText::_('profile_required'); ?>");
			} else {
				submitform(pressbutton);
			}
			
			var re = /(00|01|02|03|04|05|06|07|08|09|10|11|12|13|14|15|16|17|18|19|20|21|22|23)[:](0|1|2|3|4|5)\d{1}/;
			for(i=0; i< form.elements.length; i++){
				if(form.elements[i].name == "schedule_work_start[]" || form.elements[i].name == "schedule_work_end[]" || form.elements[i].name == "schedule_break_start[]" || form.elements[i].name == "schedule_break_start[]") {
					var v = form.elements[i].value;
					var n = form.elements[i].name;
					if (!re.test(v)) {
						form.elements[i].value = '00:00';
					}
				}
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'schedule') {
				submitform( pressbutton );
				return;
			}

			if (form.profile.value == ""){
				alert("<?php echo JText::_('profile_required'); ?>");
			} else {
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
			
			var re = /(00|01|02|03|04|05|06|07|08|09|10|11|12|13|14|15|16|17|18|19|20|21|22|23)[:](0|1|2|3|4|5)\d{1}/;
			for(i=0; i< form.elements.length; i++){
				if(form.elements[i].name == "schedule_work_start[]" || form.elements[i].name == "schedule_work_end[]" || form.elements[i].name == "schedule_break_start[]" || form.elements[i].name == "schedule_break_start[]") {
					var v = form.elements[i].value;
					var n = form.elements[i].name;
					if (!re.test(v)) {
						form.elements[i].value = '00:00';
					}
				}
			}
		}
		<?php } ?>
		</script>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="javascript:;"><?php echo JText::_('settings'); ?></a>
			<a href="javascript:;"><?php echo JText::_('common'); ?></a>
			<a href="javascript:;"><?php echo JText::_('expedient'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=schedule"><?php echo JText::_('schedules'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('profile').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('profile'); ?>
				</span> 
				<input class="large" type="text" id="profile" name="profile" value="<?php echo (isset($scheduleInfo->profile)) ? $scheduleInfo->profile : ''; ?>" maxlength="30" />
			</div>
			<div class="field w100" style="height:550px;">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('description'); ?>
				</span> 
				<div style="margin-left:170px;"><?php echo $editor->display( 'description', $scheduleInfo->description, '100%', '200', '75', '20' );?></div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('work_on_holidays').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('work_on_holidays'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['work_on_holidays']; ?>
				</div>
			</div>
			<br class="clr" />
			
			<hr />
			
			<table>
			<thead>
			<tr>
				<td nowrap valign="top" class="key"><?php echo JText::_('weekday'); ?></td>
				<td nowrap valign="top" class="key"><?php echo JText::_('schedule_work_start'); ?></td>
				<td nowrap valign="top" class="key"><?php echo JText::_('schedule_work_end'); ?></td>
				<td nowrap valign="top" class="key"><?php echo JText::_('schedule_break_start'); ?></td>
				<td nowrap valign="top" class="key"><?php echo JText::_('schedule_break_end'); ?></td>
			</tr>
			</thead>
			<tbody><?php 
			for ($w=1; $w < 8; $w++) 
			{ 
				$id = (isset($lists['schedule_weekdayInfo'][$w]['id']))? $lists['schedule_weekdayInfo'][$w]['id']: '0';
				$weekday = (isset($lists['schedule_weekdayInfo'][$w]['weekday']))? $lists['schedule_weekdayInfo'][$w]['weekday']: '0';
				$work_start = (isset($lists['schedule_weekdayInfo'][$w]['work_start'])) ? buildHoursMinutes( 0, substr($lists['schedule_weekdayInfo'][$w]['work_start'],0,5) ) : buildHoursMinutes( 0, '00:00' );
				$work_end = (isset($lists['schedule_weekdayInfo'][$w]['work_end'])) ? buildHoursMinutes( 0, substr($lists['schedule_weekdayInfo'][$w]['work_end'],0,5) ) : buildHoursMinutes( 0, '00:00' );
				$break_start = (isset($lists['schedule_weekdayInfo'][$w]['break_start'])) ? buildHoursMinutes( 0, substr($lists['schedule_weekdayInfo'][$w]['break_start'],0,5) ) : buildHoursMinutes( 0, '00:00' );
				$break_end = (isset($lists['schedule_weekdayInfo'][$w]['break_end'])) ? buildHoursMinutes( 0, substr($lists['schedule_weekdayInfo'][$w]['break_end'],0,5) ) : buildHoursMinutes( 0, '00:00' ); ?>
				<input type="hidden" name="schedule_id[]" value="<?php echo $id; ?>" />
				<input type="hidden" name="schedule_weekday[]" value="<?php echo $weekday; ?>" />
				<tr>
					<td nowrap valign="top" class="key"><?php echo $lists['listweekday'][$w]; ?></td>
					<td>
						<select name="schedule_work_start[]"><?php echo $work_start; ?></select>
					</td>
					<td>
						<select name="schedule_work_end[]"><?php echo $work_end; ?></select></select>
					</td>
					<td>
						<select name="schedule_break_start[]"><?php echo $break_start; ?></select>
					</td>
					<td>
						<select name="schedule_break_end[]"><?php echo $break_end; ?></select>
					</td>
				</tr><?php 
			} ?>
			</tbody>
			</table>
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="" />
   		<input type="hidden" name="id" value="<?php echo (isset($scheduleInfo->id)) ? $scheduleInfo->id:'0'; ?>" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		</script><?php 
	}
}
