<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.staff.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

/**
* @package iMaQma Helpdesk
*/
class staff_html 
{
	static function show( &$rows, $lists, &$pageNav ) 
	{
		$database = JFactory::getDBO(); ?>
		<script type="text/javascript" src="<?php echo JURI::root();?>components/com_maqmahelpdesk/js/jquery.equalHeights.min.js"></script>
		
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=workgroup"><?php echo JText::_('workgroups'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=category"><?php echo JText::_('categories'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		
		<form action="index.php" method="post" id="filterForm" name="filterForm">
			<div id="filtersarea">
				<?php echo strtoupper(JText::_('filters'));?> <img src="components/com_maqmahelpdesk/images/separator2.png" style="padding:5px;" align="absmiddle" /> <?php echo JText::_('workgroup').': '.$lists['workgroup'];?>
			</div>
			<input type="hidden" name="option" value="com_maqmahelpdesk" />
			<input type="hidden" name="task" value="staff" />
		</form>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		
		<?php
		if (count( $rows )==0) { ?>
			<div class="detailmsg">
				<h1><img src="../components/com_maqmahelpdesk/images/alert.png" align="left" /> <?php echo JText::_('register_not_found'); ?></h1>
				<p><?php echo JText::_('to_add_new_record_desc'); ?></p>
			</div>
			<script type="text/javascript"> MaQmaJS.AddHelpHand('toolbar-new'); </script><?php
		} else {
			for ($i=0, $n=count( $rows ); $i < $n; $i++) {
				$row = &$rows[$i]; ?>
				<div class="ucard">
					<div class="uname">
						<a href="index.php?option=com_maqmahelpdesk&task=staff_edit2&cid=<?php echo $row->id ?>"><?php echo $row->name ?></a> 
						<?php echo ( $row->level ? '<em>('.sprintf(JText::_('SUPPORT_LEVEL_LABEL'), $row->level).')</em>' : "" ); ?>
					</div>
					<div class="uavatar"><img src="<?php echo mqm_getavatar($row->id_user);?>" /></div>
					<div class="udesc"><?php
						$database->setQuery( "SELECT COUNT(*) FROM #__support_kb WHERE id_user='".$row->id."'" ); 
						echo '<p>'.JText::_('kb_articles').': <span class="mqmnumber">'.$database->loadResult().'</span></p>';
						$database->setQuery( "SELECT COUNT(*) FROM #__support_ticket WHERE assign_to='".$row->id."'" ); 
						echo '<p>'.JText::_('tickets').': <span class="mqmnumber">'.$database->loadResult().'</span></p>'; ?>
					</div>
				</div><?php
			}
		} ?>
		
		<div style="clear:both;"></div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="staff" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function() {
			$jMaQma(".ucard").equalHeights();
			
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php
	}

	static function edit2( $userInfo, $lists, $permissions ) 
	{
		global $supportConfig; ?>

		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'staff') {
				submitform( pressbutton );
				return;
			}

			submitform(pressbutton);
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'staff') {
				submitform( pressbutton );
				return;
			}

			Joomla.submitform(pressbutton, document.getElementById('adminForm'));
		}
		<?php } ?>
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=staff"><?php echo JText::_('support_staff'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		<div class="contentarea withleft">
			<div class="sidebar">
				<div class="content" style="display: block;">
					<div class="dashboard">
						<p align="center">
							<img src="<?php echo mqm_getavatar($userInfo->id);?>" width="48" height="48" /><br />
							<?php echo $userInfo->name; ?><br />
							<?php echo $userInfo->email; ?>
						</p>
						<p>&nbsp;</p>
						<p><?php echo JText::_('assigned_tickets');?>: <span class="mqmnumber"><?php echo $lists['ticket_total']; ?></span></p>
						<p><?php echo JText::_('messages');?>: <span class="mqmnumber"><?php echo $lists['resp_total']; ?></span></p>
						<p><?php echo JText::_('average');?>: <span class="mqmnumber"><?php echo ($lists['ticket_total'] > 0 ? number_format( $lists['resp_total'] / $lists['ticket_total'], 2 ) : 0 ); ?></span></p>
						<p><?php echo JText::_('kb_articles');?>: <span class="mqmnumber"><?php echo $lists['kb_total']; ?></span></p>
					</div>
				</div>
			</div>
			<div class="contentbar withleft">
				<table class="contenttable" cellspacing="0">
				<thead>
					<tr>
						<td width="10">
							<input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $permissions );?>);" />
						</td>
						<td class="title"><?php echo JText::_('workgroup'); ?></td>
						<td class="title" align="center"><?php echo JText::_('manager'); ?></td>
						<td class="title" align="center"><?php echo JText::_('team_leader'); ?></td>
						<td class="title" align="center"><?php echo JText::_('support_user'); ?></td>
					</tr>
				</thead>
				<tbody><?php
				$k = 0;
				for ($i=0, $n=count( $permissions ); $i < $n; $i++) {
					$row = &$permissions[$i]; ?>
					<tr class="<?php echo "row$k"; ?>">
						<td width="10"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td><a href="#staff_edit" onClick="return listItemTask('cb<?php echo $i;?>','staff_edit')"><?php echo $row->wkdesc; ?></a>
						</td>
						<td align="center">
							<a href="index.php?option=com_maqmahelpdesk&task=staff_permission&uid=<?php echo $userInfo->id;?>&id=<?php echo $row->id;?>&permission=7"><img src="../components/com_maqmahelpdesk/images/16px/<?php echo ($row->manager == 7 ? 'tick' : 'no');?>.png" border="0"></a>
						</td>
						<td align="center">
							<a href="index.php?option=com_maqmahelpdesk&task=staff_permission&uid=<?php echo $userInfo->id;?>&id=<?php echo $row->id;?>&permission=6"><img src="../components/com_maqmahelpdesk/images/16px/<?php echo ($row->manager == 6 ? 'tick' : 'no');?>.png" border="0"></a>
						</td>
						<td align="center">
							<a href="index.php?option=com_maqmahelpdesk&task=staff_permission&uid=<?php echo $userInfo->id;?>&id=<?php echo $row->id;?>&permission=5"><img src="../components/com_maqmahelpdesk/images/16px/<?php echo ($row->manager == 5 ? 'tick' : 'no');?>.png" border="0"></a>
						</td><?php		
						$k = 1 - $k; ?>
					</tr><?php	
				} // for loop ?>
				</tbody>
				</table>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id_user" value="<?php echo $userInfo->id; ?>" />
		<input type="hidden" name="task" value="staff" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php 
	}

	static function edit( &$row, $lists ) {
		global $supportConfig;
		
		$session = JFactory::getSession(); ?>
		
		<script language="javascript" type="text/javascript" src="<?php echo JURI::root();?>components/com_maqmahelpdesk/js/jquery.autocomplete-min.js"></script>
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'staff') {
				submitform( pressbutton );
				return;
			}
			if( $jMaQma("#id_workgroup").val() == '0' ) {
				alert('<?php echo JText::_('select_workgroup');?>');
				return false;
			}
			if( $jMaQma("#id_user").val() == '' || $jMaQma("#id_user").val() == '0' ) {
				alert('<?php echo JText::_('select_user');?>');
				return false;
			}
			submitform(pressbutton);
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'staff') {
				submitform( pressbutton );
				return;
			}
			if( $jMaQma("#id_workgroup").val() == '0' ) {
				alert('<?php echo JText::_('select_workgroup');?>');
				return false;
			}
			if( $jMaQma("#id_user").val() == '' || $jMaQma("#id_user").val() == '0' ) {
				alert('<?php echo JText::_('select_user');?>');
				return false;
			}
			Joomla.submitform(pressbutton, document.getElementById('adminForm'));
		}
		<?php } ?>
		</script>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		
		<div class="field w50">
			<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('workgroup').'::'.JText::_('staff_wk_tooltip')); ?>">
				<?php echo JText::_('workgroup'); ?>
			</span> 
			<div class="controlset-pad">
				<?php echo $lists['workgroup']; ?>
			</div>
		</div>
		<div class="field w50">
			<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('can_delete').'::'.JText::_('can_delete_tooltip')); ?>">
				<?php echo JText::_('can_delete'); ?>
			</span> 
			<div class="controlset-pad">
				<?php echo $lists['can_delete']; ?>
			</div>
		</div>
		<div class="field w100">
			<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('user').'::'.JText::_('staff_users_tooltip')); ?>">
				<?php echo JText::_('user'); ?>
			</span> 
			<input class="large" type="text" id="ac_me" name="ac_me" value="<?php echo $row->name; ?>" maxlength="100" />
			<input type="hidden" id="id_user" name="id_user" value="<?php echo $row->id_user; ?>" />
		</div>
		<div class="field w50">
			<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('support_staff_type').'::'.JText::_('staff_type_tooltip')); ?>">
				<?php echo JText::_('support_staff_type'); ?>
			</span> 
			<div class="controlset-pad">
				<?php echo $lists['sup_usertype']; ?>
			</div>
		</div>
		<div class="field w50">
			<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('schedule').'::'.JText::_('schedule_tooltip')); ?>">
				<?php echo JText::_('schedule'); ?>
			</span> 
			<div class="controlset-pad">
				<?php echo $lists['schedules']; ?>
			</div>
		</div>
		<div class="field w100">
			<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('support_level').'::'.JText::_('support_level_tooltip')); ?>">
				<?php echo JText::_('support_level'); ?>
			</span> 
			<div class="controlset-pad">
				<?php echo $lists['level']; ?>
			</div>
		</div>
		<div class="field w50" style="height:110px;">
			<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('vacances').'::'.JText::_('vacances_tooltip')); ?>">
				<?php echo JText::_('vacances'); ?>
			</span> 
			<textarea id="vacances" name="vacances" style="height:100px;" class="medium"><?php echo $lists['vacances']; ?></textarea>
		</div>
		<div class="field w50" style="height:120px;">
			<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('category').'::'.JText::_('assign_category_tooltip')); ?>">
				<?php echo JText::_('category'); ?>
			</span> 
			<div id="categoryField" class="controlset-pad">
				<?php echo $lists['category']; ?>
			</div>
		</div>
		<div class="field w100" style="height:120px;">
			<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('assign_notification').'::'.JText::_('assign_notification_tooltip')); ?>">
				<?php echo JText::_('assign_notification'); ?>
			</span> 
			<div class="controlset-pad">
				<?php echo $lists['assign_report']; ?>
				<br /><?php echo $lists['assign_report_users']; ?>
			</div>
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form>
		
		<script type='text/javascript'>
		function showhidediv() {
			if( $jMaQma('#assign_report1').is(':checked') ) {
				$jMaQma("#div_support_users").show();
			}else{
				$jMaQma("#div_support_users").hide();
			}
		}
		
		$jMaQma(document).ready(function() {
			$jMaQma("#ac_me").autocomplete("index.php?option=com_maqmahelpdesk&task=ajax_getuser&format=raw&session=<?php echo $session->getId();?>", {
				selectFirst: false,
				scroll: true,
				scrollHeight: 300,
				formatItem: function(data, i, n, value) {
					return '<img src="'+data[5]+'" width="32" height="32" align="left">'+data[1]+' ('+data[4]+')'+(data[3]!='' ? '<br><i>'+data[3]+'</i>' : '');
				},
				selectExecute: function(data) {
					$jMaQma("#id_user").val( data[0] );
					$jMaQma("#ac_me").val( data[1] );
				}
			});
			$jMaQma("input, textarea, select").uniform();
			$jMaQma("#assign_report1").click(function(){ 
				showhidediv();
			});
			$jMaQma("#assign_report0").click(function(){ 
				showhidediv();
			});
			
			showhidediv();
		});
		
		function GetCategories()
		{
			$jMaQma.ajax({
				url: "index.php?option=com_maqmahelpdesk&task=staff_categories&id_user="+$jMaQma("#id_user").val()+"&id_workgroup="+$jMaQma("#id_workgroup").val()+"&format=raw",
				success: function(data){
					$jMaQma("#categoryField").html(data);
					$jMaQma("#id_category").uniform();
				}
			});
		}
		</script><?php 
	}
}
