<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.status.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class status_html 
{
	static function show( &$rows, &$pageNav ) { ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=status"><?php echo JText::_('status'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div id="contentbox">
			<?php if ( count( $rows ) == 0 ) : ?>
				<div class="detailmsg">
					<h1><img src="../components/com_maqmahelpdesk/images/alert.png" align="left" /> <?php echo JText::_('register_not_found'); ?></h1>
					<p><?php echo JText::_('to_add_new_record_desc'); ?></p>
				</div>
				<script type="text/javascript"> MaQmaJS.AddHelpHand('toolbar-new'); </script>
			<?php else: ?>
				<table class="contenttable" cellspacing="0">
				<thead>
				<tr>
					<th width="20" align="right">#</th>
					<td width="20">
						<input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
					</td>
					<td class="title"><?php echo JText::_('group'); ?></td>
					<td class="title"><?php echo JText::_('description'); ?></td>
					<td class="title" width="50"><?php echo JText::_('user_access'); ?></td>
					<td class="title" width="50"><?php echo JText::_('default'); ?></td>
					<td class="title" width="50"><?php echo JText::_('default_for_manager'); ?></td>
					<td width="70"><?php echo JText::_('published'); ?></td>
				</tr>
				</thead>
				<tbody><?php
				$k = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) {
					$row = &$rows[$i];
					$img = $row->show ? 'tick' : 'no';
					$task = $row->show ? 'status_unpublish' : 'status_publish';
					$alt = $row->show ? JText::_('published') : JText::_('unpublished');
					$default = $row->isdefault ? 'tick' : 'no';
					$default_manager = $row->isdefault_manager ? 'tick' : 'no';
					$u_access = $row->user_access ? 'tick' : 'no';
					?>
					<tr class="<?php echo "row$k"; ?>">
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td><?php echo ($row->status_group=="O" ? JText::_('open')  : JText::_('closed') );?></td>
						<td>
							<a href="#status_edit" onClick="return listItemTask('cb<?php echo $i;?>','status_edit')">
								<?php echo $row->description; ?>
							</a>
						</td>
						<td width="50" align="center"><img src="../components/com_maqmahelpdesk/images/16px/<?php echo $u_access;?>.png" border="0" /></td>
						<td width="50" align="center"><img src="../components/com_maqmahelpdesk/images/16px/<?php echo $default;?>.png" border="0" /></td>
						<td width="50" align="center"><img src="../components/com_maqmahelpdesk/images/16px/<?php echo $default_manager;?>.png" border="0" /></td>
						<td width="70" align="center">
							<a href="javascript: void(0);" onClick="return listItemTask('cb<?php echo $i;?>','<?php echo $task;?>')">
								<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="<?php echo $alt;?>" />
							</a>
						</td><?php
						$k = 1 - $k; ?>
					</tr><?php	
				} // for loop ?>
				</tbody>
				<tfoot>
					<tr>
						<td colspan="8"><?php echo $pageNav->getListFooter(); ?></td>
					</tr>
				</tfoot>
				</table>
			<?php endif; ?>
			</div>
			<div id="infobox">
				<span id="infoarrow"></span>
				<dl class="first">
					<dd class="title"><?php echo JText::_('INFO_STATUS_TITLE');?></dd>
					<dd class="last">
						<?php echo JText::_('INFO_STATUS_DESC');?>
						<p align="center"><a href="http://www.imaqma.com/support/documentation/16-helpdesk-component/88-statuses.html" target="_blank" class="mqmbutton gray"><img src="../components/com_maqmahelpdesk/images/16px/help.png" align="absmiddle" border="0" alt="" /> <?php echo JText::_('more_information');?></a></p>
					</dd>
				</dl>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="status" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php
	}

	static function edit( &$row, $lists, $status_list ) { 
		$GLOBALS['titulo_status_edit'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('status'); ?>
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'status') {
				submitform( pressbutton );
				return;
			}

			if (form.description.value == ""){
				alert("<?php echo JText::_('description_required'); ?>");
			} else if( $jMaQma("#auto_status_agents").is(":checked") && $jMaQma("#auto_status_users").is(":checked") ) {
				alert('<?php echo JText::_('auto_status_error');?>');
			} else {
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'status') {
				submitform( pressbutton );
				return;
			}

			if (form.description.value == ""){
				alert("<?php echo JText::_('description_required'); ?>");
			} else if( $jMaQma("#auto_status_agents").is(":checked") && $jMaQma("#auto_status_users").is(":checked") ) {
				alert('<?php echo JText::_('auto_status_error');?>');
			} else {
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>
		</script>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=status"><?php echo JText::_('status'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('description'); ?>
				</span> 
				<input class="medium" type="text" id="description" name="description" value="<?php echo $row->description; ?>" maxlength="100" />
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('status_group').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('status_group'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['group']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('user_access_status').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('user_access_status'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['user_access']; ?>
				</div>
			</div>
			<div class="field w100" style="height:<?php echo ($status_list*18);?>px;">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('status_workflow').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('status_workflow'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['status_workflow']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('allow_old_status_back').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('allow_old_status_back'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['allow_old_status_back']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('status_side_title').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('status_side_title'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['status_side']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('is_default').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('is_default'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['default']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('default_for_manager').'::'.JText::_('default_for_manager_tooltip')); ?>">
					<?php echo JText::_('default_for_manager'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['default_manager']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('auto_status_agents').'::'.JText::_('auto_status_agents_tooltip')); ?>">
					<?php echo JText::_('auto_status_agents'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['auto_status_agents']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('auto_status_users').'::'.JText::_('auto_status_users_tooltip')); ?>">
					<?php echo JText::_('auto_status_users'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['auto_status_users']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('published').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('published'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['show']; ?>
				</div>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form>
		
		<script type='text/javascript'>
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		</script><?php 
	}
}
