<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.troubleshooter.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

function showTroubleshooter( &$rows ) 
{
	$database = JFactory::getDBO(); ?>
	
	<script type='text/javascript'>
	function SubmitForm() {
		document.adminForm.submit()
	}
	</script>
	
	<link rel="StyleSheet" href="<?php echo JURI::root()."administrator/components/com_maqmahelpdesk/js/dtree.css"; ?>" type="text/css" />
	<script language="JavaScript" src="<?php echo JURI::root()."administrator/components/com_maqmahelpdesk/js/dtree.js"; ?>"></script>
	
	<form action="index.php" method="POST" id="adminForm" name="adminForm">
	
	<div id="contentbox"><?php
		$troubleHeader = null;
		$database->setQuery( "SELECT * FROM #__support_troubleshooter ORDER BY id" );
		$troubles = $database->loadObjectList(); 
		
		if(count($troubles) > 0) { ?>
			<div class="dtree">
			<p><a href="javascript: d.openAll();"><?php echo JText::_('open'); ?></a> | <a href="javascript: d.closeAll();"><?php echo JText::_('close'); ?></a></p>
			
			<script type="text/javascript">
				<!--
				d = new dTree('d');<?php
				for($i=0; $i<count($troubles); $i++) { 
					$rowLvl = &$troubles[$i];
					$link = "index.php?option=com_maqmahelpdesk&task=troubleshooter_edit&id=".$rowLvl->id."&parent=".$rowLvl->parent;
					print "d.add(".$rowLvl->id.",".($rowLvl->parent==0 ? -1 : $rowLvl->parent).",'".addslashes($rowLvl->title)."','".$link."','','','".JURI::root()."/administrator/components/com_maqmahelpdesk/js/folder.gif');\n";
				} ?>

				document.write(d);
				//-->
			</script>
			</div><?php
		}else{ ?>
			<b><a href="index.php?option=com_maqmahelpdesk&task=troubleshooter_new"><?php echo JText::_('add'); ?></a><br><?php echo JText::_('nothing_trouble'); ?></b><?php
		} ?>
	</div>
	<div id="infobox">
		<span id="infoarrow"></span>
		<dl class="first">
			<dd class="title"><?php echo JText::_('INFO_TROUBLESHOOTER_TITLE');?></dd>
			<dd class="last">
				<?php echo JText::_('INFO_TROUBLESHOOTER_DESC');?>
				<p align="center"><a href="http://www.imaqma.com/support/documentation/16-helpdesk-component/103-troubleshooter.html" target="_blank" class="mqmbutton gray"><img src="../components/com_maqmahelpdesk/images/16px/help.png" align="absmiddle" border="0" alt="" /> <?php echo JText::_('more_information');?></a></p>
			</dd>
		</dl>
	</div>

	<input type="hidden" name="option" value="com_maqmahelpdesk" />
	<input type="hidden" name="task" value="troubleshooter" />
	</form><?php
}

function troubleForm( $row, $parent, $id ) 
{
	$editor = JFactory::getEditor();
	$GLOBALS['title_edit_trouble'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('troubleshooter'); ?>

	<script language="javascript">
	<?php if( jversion15_check() ) { ?>
	function submitbutton(pressbutton) {
		var form = document.adminForm;
		if (pressbutton == 'troubleshooter') {
			submitform( pressbutton );
			return;
		}
		
		if (form.title.value == "") {
			alert( "<?php echo JText::_('title_required'); ?>" );
		} else {
			<?php echo $editor->save( 'description' ); ?>
			submitform( pressbutton );
		}
	}
	<?php } else { ?>
	Joomla.submitbutton = function(pressbutton) {
		var form = document.adminForm;
		if (pressbutton == 'troubleshooter') {
			submitform( pressbutton );
			return;
		}
		
		if (form.title.value == "") {
			alert( "<?php echo JText::_('title_required'); ?>" );
		} else {
			<?php echo $editor->save( 'description' ); ?>
			Joomla.submitform(pressbutton, document.getElementById('adminForm'));
		}
	}
	<?php } ?>
	</script>

	<form action="index.php" method="POST" id="adminForm" name="adminForm" class="label-inline">
	
	<?php if($row->id): ?>
		<div style="text-align:right;background:#e5e5e5;padding:5px;margin-bottom:10px;">
			<div class="mqmbutton-group">
				<a href="index.php?option=com_maqmahelpdesk&task=troubleshooter_new&parent=<?php echo $id; ?>" class="mqmbutton success icon add primary"><?php echo JText::_('add');?></a>
				<a href="index.php?option=com_maqmahelpdesk&task=troubleshooter_delete&id=<?php echo $id; ?>" class="mqmbutton red icon remove"><?php echo JText::_('delete');?></a>
			</div>
		</div>
	<?php endif; ?>
	<div class="field w100">
		<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('title').'::'.JText::_('todo')); ?>">
			<?php echo JText::_('title'); ?>
		</span> 
		<input class="large" type="text" id="title" name="title" value="<?php echo $row->title; ?>" maxlength="100" />
	</div>
	<div class="field w100" style="height:550px;">
		<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('todo')); ?>">
			<?php echo JText::_('description'); ?>
		</span> 
		<div style="margin-left:170px;"><?php echo $editor->display( 'description', $row->description, '100%', '500', '75', '20' );?></div>
	</div>

	<input type="hidden" name="option" value="com_maqmahelpdesk" />
	<input type="hidden" name="id" value="<?php echo JRequest::getVar( 'id', 0, '', 'int' ); ?>" />
	<input type="hidden" name="parent" value="<?php echo JRequest::getVar( 'parent', 0, '', 'int' ); ?>" />
	<input type="hidden" name="task" value="<?php echo JRequest::getVar( 'task', 0, '', 'int' ); ?>" />
	</form><?php
}
