<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.wkfields.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class cfield_html 
{
	static function show( &$rows, &$pageNav ) { ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=workgroup"><?php echo JText::_('workgroups'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=wkfields"><?php echo JText::_('cfield_assign_menu'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		<div class="contentarea">
			<table id="contentTable" class="contenttable" cellspacing="0">
			<thead>
			<tr>
				<td width="20" nowrap="nowrap"></td>
				<td width="20" align="right">#</td>
				<td width="20">
					<input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
				</td>
				<td class="title"><?php echo JText::_('workgroup'); ?></td>
				<td class="title"><?php echo JText::_('section'); ?></td>
				<td class="title"><?php echo JText::_('field_name'); ?></td>
				<td class="title"><?php echo JText::_('field_type'); ?></td>
				<td width="70" align="center"><?php echo JText::_('support_only_short'); ?></td>
				<td width="70" align="center"><?php echo JText::_('new_only_short'); ?></td>
				<td width="70" align="center"><?php echo JText::_('required'); ?></td>
			</tr>
			</thead>
			<tbody>
			<?php
			if (count( $rows )==0) {
				?><tr><td colspan="10"><?php echo JText::_('register_not_found'); ?></td></tr><?php
			} else {
				$k = 0;
				$j = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) {
					$row = &$rows[$i];
					$img = $row->required ? 'tick' : 'no';
					$alt = $row->required ? JText::_('required_tooltip') : JText::_('not_required_tooltip');
					?>
					<tr id="contentTable-row-<?php echo ($row->id);?>" class="<?php echo "row$k"; ?>">
						<td align="left" width="20" align="right" class="dragHandle"></td>
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td><?php echo $row->wkdesc; ?></td>
						<td><?php echo $row->section; ?></td>
						<td>
							<a href="#wkfields_edit" onClick="return listItemTask('cb<?php echo $i;?>','wkfields_edit')">
								<?php echo $row->caption; ?>
							</a>
						</td>
						<td><?php echo JText::_('formfield_'.$row->ftype); ?></td>
						<td align="center">
						<?php
							$img_support_only = $row->support_only ? 'tick' : 'no';
							$alt_support_only = $row->support_only ? JText::_('support_only_tooltip1') : JText::_('support_only_tooltip0');
						?>
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img_support_only;?>.png" border="0" alt="<?php echo $alt_support_only;?>" />
						</td>
						<td align="center">
						<?php
							$img_new_only = $row->new_only ? 'tick' : 'no';
							$alt_new_only = $row->new_only ? JText::_('new_only_tooltip1') : JText::_('new_only_tooltip0');
						?>
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img_new_only;?>.png" border="0" alt="<?php echo $alt_new_only;?>" />
						</td>
						<td align="center">
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="<?php echo $alt;?>" />
						</td><?php		
						$k = 1 - $k;
						$j++;
						?>
					</tr>
					<?php	
				} // for loop
			} // if ?>
			</tbody>
			<tfoot>
				<tr>
					<td colspan="10">
						<?php echo $pageNav->getListFooter(); ?>
					</td>
				</tr>
			</tfoot>
			</table>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="wkfields" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
			
			$jMaQma('#contentTable').tableDnD({
				onDrop: function(table, row) {
					window.location = 'index.php?option=com_maqmahelpdesk&task=wkfields_saveorder&'+$jMaQma('#contentTable').tableDnDSerialize();
				},
				dragHandle: "dragHandle"
			});
			
			$jMaQma("#contentTable tr").hover(function() {
				  $jMaQma(this.cells[0]).addClass('showDragHandle');
			}, function() {
				  $jMaQma(this.cells[0]).removeClass('showDragHandle');
			});
		});
		</script><?php
	}

	static function edit( &$row, $lists ) { 
		$GLOBALS['titulo_wkfields_edit'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('wk_custom_field'); ?>
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'wkfields') {
				submitform( pressbutton );
				return;
			}

			submitform(pressbutton);
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'wkfields') {
				submitform( pressbutton );
				return;
			}

			Joomla.submitform(pressbutton, document.getElementById('adminForm'));
		}
		<?php } ?>
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=workgroup"><?php echo JText::_('workgroups'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=wkfields"><?php echo JText::_('cfield_assign_menu'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('workgroup').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('workgroup'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['workgroup']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('section').'::'.JText::_('section_tooltip')); ?>">
					<?php echo JText::_('section'); ?>
				</span> 
				<div id="sectionField" class="controlset-pad">
					<?php echo $lists['section']; ?>
				</div>
				<i><?php echo JText::_('section_new');?></i> <input type="text" id="section_new" name="section_new" value="" style="width:100px;" maxlength="50" />
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('field').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('field'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['fields']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('permissions').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('permissions'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['support_only']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('required').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('required'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['required']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('new_only').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('new_only'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['new_only']; ?>
				</div>
			</div>
			<br class="clr" />
		</div>
			
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="ordering" value="<?php echo $row->ordering; ?>" />
		<input type="hidden" name="task" value="" />
		</form>
		
		<script type='text/javascript'>
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		
		function GetSections()
		{
			$jMaQma.ajax({
				url: "index.php?option=com_maqmahelpdesk&task=wkfields_sections&id_workgroup="+$jMaQma("#id_workgroup").val()+"&format=raw",
				success: function(data){
					$jMaQma("#sectionField").html(data);
					$jMaQma("#section").uniform();
				}
			});
		}
		</script><?php 
	}
}
