<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.workgroup.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class wk_html 
{
	static function show( &$rows, &$pageNav ) { ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=workgroup"><?php echo JText::_('workgroups'); ?></a>
			<span><?php echo JText::_('manager'); ?></span>
		</div>
		<div class="contentarea">
			<div id="contentbox">
			<?php if ( count( $rows ) == 0 ) : ?>
			<div class="detailmsg">
				<h1><img src="../components/com_maqmahelpdesk/images/alert.png" align="left" /> <?php echo JText::_('register_not_found'); ?></h1>
				<p><?php echo JText::_('to_add_new_record_desc'); ?></p>
			</div>
			<script type="text/javascript"> MaQmaJS.AddHelpHand('toolbar-new'); </script>
			<?php else: ?>
				<table id="contentTable" class="contenttable" cellspacing="0">
				<thead>
				<tr>
					<td width="20" nowrap="nowrap"></td>
					<th width="20" align="right">#</th>
					<td width="20"><input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" /></td>
					<td class="title"><?php echo JText::_('name'); ?></td>
					<td class="title"><?php echo JText::_('email_from_name'); ?></td>
					<td class="title"><?php echo JText::_('email_from_address'); ?></td>
					<td align="center"><?php echo JText::_('contract_only'); ?></td>
					<td align="center"><?php echo JText::_('published'); ?></td>
				</tr>
				</thead>
				<tbody><?php
					$k = 0;
					for ($i=0, $n=count( $rows ); $i < $n; $i++) {
						$row = &$rows[$i];
						$img = $row->show ? 'tick' : 'no';
						$img_contract = $row->contract ? 'tick' : 'no';
						$task = $row->show ? 'workgroup_unpublish' : 'workgroup_publish';
						$alt = $row->show ? JText::_('published') : JText::_('unpublished'); ?>
						<tr id="contentTable-row-<?php echo ($row->id);?>" class="<?php echo "row$k"; ?>">
							<td align="left" width="20" align="right" class="dragHandle"></td>
							<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
							<td align="left" width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
							<td>
								<a href="#workgroup_edit" onClick="return listItemTask('cb<?php echo $i;?>','workgroup_edit')"><?php echo $row->wkdesc; ?></a>
							</td>
							<td><?php echo $row->wkmail_address_name; ?></td>
							<td><?php echo $row->wkmail_address; ?></td>
							<td align="center"><img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img_contract;?>.png" border="0" /></td>
							<td align="center">
								<a href="javascript: void(0);" onClick="return listItemTask('cb<?php echo $i;?>','<?php echo $task;?>')">
									<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="<?php echo $alt;?>" />
								</a>
							</td><?php
							$k = 1 - $k; ?>
						</tr><?php	
					} // for loop ?>
				<tbody>
				<tfoot>
					<tr>
						<td colspan="8">
							<?php echo $pageNav->getListFooter(); ?>
						</td>
					</tr>
				</tfoot>
				</table>
			<?php endif; ?>
			</div>
			<div id="infobox">
				<span id="infoarrow"></span>
				<dl class="first">
					<dd class="title"><?php echo JText::_('INFO_DEPARTMENT_TITLE');?></dd>
					<dd class="last">
						<?php echo JText::_('INFO_DEPARTMENT_DESC');?>
						<p align="center"><a href="http://www.imaqma.com/support/documentation/16-helpdesk-component/86-workgroups.html" target="_blank" class="mqmbutton gray"><img src="../components/com_maqmahelpdesk/images/16px/help.png" align="absmiddle" border="0" alt="" /> <?php echo JText::_('more_information');?></a></p>
					</dd>
				</dl>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="workgroup" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
			
			$jMaQma('#contentTable').tableDnD({
				onDrop: function(table, row) {
					window.location = 'index.php?option=com_maqmahelpdesk&task=workgroup_saveorder&'+$jMaQma('#contentTable').tableDnDSerialize();
				},
				dragHandle: "dragHandle"
			});
			
			$jMaQma("#contentTable tr").hover(function() {
				  $jMaQma(this.cells[0]).addClass('showDragHandle');
			}, function() {
				  $jMaQma(this.cells[0]).removeClass('showDragHandle');
			});
		});
		</script><?php
	}

	static function edit( &$row, $lists ) {
		global $supportConfig, $wkoptions; 
		
		$editor = JFactory::getEditor();
		$user = JFactory::getUser();

		if ( $row->id ) {
			$GLOBALS['workgroup_title'] = JText::_('edit_workgroup')." (".$row->wkdesc .")";
		} else {
			$GLOBALS['workgroup_title'] = JText::_('add_workgroup');
		} ?>

		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'workgroup') {
				submitform( pressbutton );
				return;
			}

			if (form.wkdesc.value == ""){
				alert("<?php echo JText::_('name_required'); ?>");
			} else {
				<?php echo $editor->save( 'wkabout' ); ?>
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'workgroup') {
				submitform( pressbutton );
				return;
			}

			if (form.wkdesc.value == ""){
				alert("<?php echo JText::_('name_required'); ?>");
			} else {
				<?php echo $editor->save( 'wkabout' ); ?>
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm" enctype="multipart/form-data" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=workgroup"><?php echo JText::_('workgroups'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea withleft">
			<div class="sidebar">
				<div class="content" style="display: block;">
					<ul class="leftmenu">
						<li class="current"><a href="#" onclick="MaQmaJS.SelectTab(this,1);"><img src="../components/com_maqmahelpdesk/images/menu/workgroups.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('general');?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,2);"><img src="../components/com_maqmahelpdesk/images/menu/send.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('wk_notifications');?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,3);"><img src="../components/com_maqmahelpdesk/images/menu/support_staff.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('assignments');?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,4);"><img src="../components/com_maqmahelpdesk/images/menu/table.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('links');?></a></li>
					</ul>
				</div>
			</div>
			<div class="contentbar withleft">
				<div id="tab1" class="contenttab" style="display:block;">
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_publish').'::'.JText::_('wk_publish_tooltip')); ?>">
							<?php echo JText::_('wk_publish'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['show']; ?>
						</div>
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_name').'::'.JText::_('wk_name_tooltip')); ?>">
							<?php echo JText::_('wk_name'); ?>
						</span> 
						<input class="large" type="text" id="wkdesc" name="wkdesc" value="<?php echo str_replace("\'","'",$row->wkdesc); ?>" maxlength="100" />
					</div>
					<div class="field w100" style="height:375px;">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_desc').'::'.JText::_('wk_desc_tooltip')); ?>">
							<?php echo JText::_('wk_desc'); ?>
						</span> 
						<div style="margin-left:170px;"><?php echo $editor->display( 'wkabout', $row->wkabout, '100%', '300', '75', '20' );?></div>
					</div>
					<div class="field w100">
						<label for="shortdesc">
							<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('short_desc').'::'.JText::_('short_desc_tooltip')); ?>"><?php echo JText::_('short_desc'); ?></span> 
						</label> 
						<textarea id="shortdesc" name="shortdesc" style="height:50px;" class="large"><?php echo $row->shortdesc; ?></textarea>
					</div>
					<br class="clr" />
					<?php if( !$row->logo ): ?>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_logo').'::'.JText::_('wk_logo_tooltip')); ?>">
							<?php echo JText::_('wk_logo'); ?>
						</span> 
						<input class="large" type="file" id="logo" name="logo" maxlength="100" />
					</div>
					<?php else:?>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_remove_logo').'::'.JText::_('wk_logo_tooltip')); ?>">
							<?php echo JText::_('wk_remove_logo'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['logo_remove']; ?>
						</div>
					</div>
					<?php $tiptext = JText::_('filename').': '.$row->logo.'<br />'.JText::_('wk_location').': <small><i>'.JURI::root().'components/com_maqmahelpdesk/images/logos/'.$row->logo.'</i></small>'; ?>
					<div class="field w100" style="height:50px;">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_logo_details').'::'.$tiptext); ?>">
							<?php echo JText::_('wk_logo_preview'); ?>
						</span> 
						<img hspace="10" vspace="10" width="48" height="48" src="<?php echo JURI::root();?>components/com_maqmahelpdesk/images/logos/<?php echo $row->logo; ?>" />
					</div>
					<?php endif;?>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_theme').'::'.JText::_('wk_theme_tooltip')); ?>">
							<?php echo JText::_('wk_theme'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['themes']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('priority').'::'.JText::_('wk_default_priority')); ?>">
							<?php echo JText::_('priority'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['priority']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_contract').'::'.JText::_('wk_contract_tooltip')); ?>">
							<?php echo JText::_('wk_contract'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['contract']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('contract_total_disable').'::'.JText::_('contract_total_disable_tooltip')); ?>">
							<?php echo JText::_('contract_total_disable'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['contract_total_disable']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_assign').'::'.JText::_('wk_assign_tooltip')); ?>">
							<?php echo JText::_('wk_assign'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['auto_assign']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_hyperlinks').'::'.JText::_('wk_hyperlinks_tooltip')); ?>">
							<?php echo JText::_('wk_hyperlinks'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['hyper_links']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_activities').'::'.JText::_('wk_activities_tooltip')); ?>">
							<?php echo JText::_('wk_activities'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['use_activity']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_tickets2').'::'.JText::_('wk_tickets_tooltip')); ?>">
							<?php echo JText::_('wk_tickets2'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['wkticket']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_kb2').'::'.JText::_('wk_kb_tooltip')); ?>">
							<?php echo JText::_('wk_kb2'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['wkkb']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_downloads_use').'::'.JText::_('wk_downloads_tooltip')); ?>">
							<?php echo JText::_('wk_downloads_use'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['wkdownloads']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_faq2').'::'.JText::_('wk_faq_tooltip')); ?>">
							<?php echo JText::_('wk_faq2'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['wkfaq']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_trouble').'::'.JText::_('wk_trouble_tooltip')); ?>">
							<?php echo JText::_('wk_trouble'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['trouble']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_use_glossary').'::'.JText::_('wk_glossary_tooltip')); ?>">
							<?php echo JText::_('wk_use_glossary'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['wkglossary']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_use_announces').'::'.JText::_('wk_announces_tooltip')); ?>">
							<?php echo JText::_('wk_use_announces'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['wkannounces']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('enable_discussions').'::'.JText::_('enable_discussions_desc')); ?>">
							<?php echo JText::_('enable_discussions'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['enable_discussions']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('use_bookmarks').'::'.JText::_('use_bookmarks_tooltip')); ?>">
							<?php echo JText::_('use_bookmarks'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['use_bookmarks']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('use_account').'::'.JText::_('use_account_tooltip')); ?>">
							<?php echo JText::_('use_account'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['use_account']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('digistore_wk').'::'.JText::_('digistore_wk_desc')); ?>">
							<?php echo JText::_('digistore_wk'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['digistore']; ?>
						</div>
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_hide_activities').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('wk_hide_activities'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['lim_actmsgs']; ?>
						</div>
					</div><div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_chars').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('wk_chars'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['lim_actmsgs_chars']; ?>
						</div>
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_lines').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('wk_lines'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['lim_actmsgs_lines']; ?>
						</div>
					</div>
					<br class="clr" />
				</div>
				<div id="tab2" class="contenttab">
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_from_name').'::'.JText::_('wk_from_name_tooltip')); ?>">
							<?php echo JText::_('wk_from_name'); ?>
						</span> 
						<input class="medium" type="text" id="wkmail_address_name" name="wkmail_address_name" value="<?php echo $row->wkmail_address_name; ?>" maxlength="100" />
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_from_mail').'::'.JText::_('wk_from_mail_tooltip')); ?>">
							<?php echo JText::_('wk_from_mail'); ?>
						</span> 
						<input class="medium" type="text" id="wkmail_address" name="wkmail_address" value="<?php echo $row->wkmail_address; ?>" maxlength="100" />
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wk_admin_mail').'::'.JText::_('wk_admin_mail_tooltip')); ?>">
							<?php echo JText::_('wk_admin_mail'); ?>
						</span> 
						<input class="medium" type="text" id="wkadmin_email" name="wkadmin_email" value="<?php echo $row->wkadmin_email; ?>" maxlength="100" />
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('add_mail_tag').'::'.JText::_('add_mail_tag_tooltip')); ?>">
							<?php echo JText::_('add_mail_tag'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['add_mail_tag']; ?>
						</div>
					</div>
					<h4 style="padding-top:100px;"><?php echo JText::_('wk_assign_notifications'); ?></h4>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('tkt_asgn_new_asgn').'::'.JText::_('tkt_asgn_new_asgn_tooltip')); ?>">
							<?php echo JText::_('tkt_asgn_new_asgn'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['tkt_asgn_new_asgn']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('tkt_asgn_old_asgn').'::'.JText::_('tkt_asgn_old_asgn_tooltip')); ?>">
							<?php echo JText::_('tkt_asgn_old_asgn'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['tkt_asgn_old_asgn']; ?>
						</div>
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('tkt_asgn_nfy_usr_one').'::'.JText::_('tkt_asgn_nfy_usr_one_tooltip')); ?>">
							<?php echo JText::_('tkt_asgn_nfy_usr_one'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['tkt_asgn_nfy_usr_one']; ?>
						</div>
					</div>
					<h4 style="padding-top:100px;"><?php echo JText::_('wk_create_notifications'); ?></h4>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('tkt_crt_nfy_mgr').'::'.JText::_('tkt_crt_nfy_mgr_tooltip')); ?>">
							<?php echo JText::_('tkt_crt_nfy_mgr'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['tkt_crt_nfy_mgr']; ?>
						</div>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('wkemail').'::'.JText::_('wkemail_tooltip')); ?>">
							<?php echo JText::_('wkemail'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['wkemail']; ?>
						</div>
					</div>
					<br class="clr" />
				</div>
				<div id="tab3" class="contenttab">
					<div id="assigns" name="assigns" align="left"></div>
					<br class="clr" />
				</div>
				<div id="tab4" class="contenttab">
					<div id="links" name="links" align="left">
					<br class="clr" />
				</div>
		</div>

		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="old_logo" value="<?php echo $row->logo; ?>" />
		<input type="hidden" name="task" value="" />
		</form>

		<script type='text/javascript'>
		/* Assignments JS */
		function getAssigns() {
			$jMaQma("div#loading").show();
			$jMaQma("div#assigns").load("index.php?option=com_maqmahelpdesk&task=workgroup_ajax&page=assignments&tmpl=component&format=raw", 
				{
					action: 'list',
					id_wk: '<?php echo $row->id; ?>'
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		function showAssign( WK, CAT, CIT, USER ) {
			if( CAT == 0 ) {
				ACTION = 'new';
			}else{
				ACTION = 'edit';
			}
			
			$jMaQma("div#loading").show();
			$jMaQma("div#assigns").load("index.php?option=com_maqmahelpdesk&task=workgroup_ajax&page=assignments&tmpl=component&format=raw", 
				{
					action: ACTION,
					id_wk: '<?php echo $row->id; ?>',
					id_cat: CAT,
					city: CIT,
					id_user: USER
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		function cancelAssign() {
			getAssigns();
		}

		function saveAssign() {
			$jMaQma("div#loading").show();
			$jMaQma("div#assigns").load("index.php?option=com_maqmahelpdesk&task=workgroup_ajax&page=assignments&tmpl=component&format=raw", 
				{
					action: 'save',
					id_wk: '<?php echo $row->id; ?>',
					id_cat: $jMaQma("#assign_cat").val(),
					city: $jMaQma("#city").val(),
					id_user: $jMaQma("#assign_user").val()
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		function deleteAssign( WK, CAT, CIT, USER ) {
			$jMaQma("div#loading").show();
			$jMaQma("div#assigns").load("index.php?option=com_maqmahelpdesk&task=workgroup_ajax&page=assignments&tmpl=component&format=raw", 
				{
					action: 'delete',
					id_wk: WK,
					id_cat: CAT,
					city: CIT,
					id_user: USER
				},
				function() { $jMaQma("div#loading").hide(); } );
		}
		
		/* Links JS */
		function getLinks() {
			$jMaQma("div#loading").show();
			$jMaQma("div#links").load("index.php?option=com_maqmahelpdesk&task=workgroup_ajax&page=links&tmpl=component&format=raw", 
				{
					action: 'list',
					section: 'F'
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		function showLink( ID ) {
			if( ID == 0 ) {
				ACTION = 'new';
			}else{
				ACTION = 'edit';
			}
			
			$jMaQma("div#loading").show();
			$jMaQma("div#links").load("index.php?option=com_maqmahelpdesk&task=workgroup_ajax&page=links&tmpl=component&format=raw", 
				{
					action: ACTION,
					id_wk: '<?php echo $row->id; ?>',
					section: 'F',
					id: ID
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		function cancelLink() {
			getLinks();
		}

		function saveLink() {
			if( document.adminForm.link_published0.checked ) {
				PUBLISHED = 0;
			}else{
				PUBLISHED = 1;
			}
			
			if( document.adminForm.public0.checked ) {
				PUBLIC = 0;
			}else{
				PUBLIC = 1;
			}
			
			$jMaQma("div#loading").show();
			$jMaQma("div#links").load("index.php?option=com_maqmahelpdesk&task=workgroup_ajax&page=links&tmpl=component&format=raw", 
				{
					action: 'save',
					id_wk: '<?php echo $row->id; ?>',
					id: document.adminForm.link_id.value,
					name: document.adminForm.link_name.value,
					description: document.adminForm.link_description.value,
					link: document.adminForm.link_url.value,
					ordering: document.adminForm.link_ordering.value,
					image: document.adminForm.link_image.value,
					section: 'F',
					published: PUBLISHED,
					public: PUBLIC
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		function deleteLink( ID ) {
			$jMaQma("div#loading").show();
			$jMaQma("div#links").load("index.php?option=com_maqmahelpdesk&task=workgroup_ajax&page=links&tmpl=component&format=raw", 
				{
					action: 'delete',
					id_wk: '<?php echo $row->id; ?>',
					section: 'F',
					id: ID
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		function saveLinkOrder() {
			$jMaQma("div#loading").show();
			
			ORDERS = '';
			for( i=0; i<document.adminForm.nr_links.value; i++ )
			{
				ORDERS = ORDERS + document.getElementById('link'+i).value + '|' + document.getElementById('order'+i).value + ';';
			}

			$jMaQma("div#links").load("index.php?option=com_maqmahelpdesk&task=workgroup_ajax&page=links&tmpl=component&format=raw", 
				{
					action: 'saveorder',
					section: 'F',
					orders: ORDERS
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

        $jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			$jMaQma("ul.sidebar-tabs").tabs("div.panes > div");
			getLinks();
			getAssigns();
			if( $jMaQma.browser.msie && parseInt($jMaQma.browser.version, 10) == 7 ) {
				$jMaQma("div.current dd table.admintable").css("margin-left","-45px");
			}
		});
        </script><?php 
	}
}
?>
