<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		payplans@readybytes.in
*/
if(defined('_JEXEC')===false) die();


class PayplansadminViewTransaction extends XiView
{
	protected function _adminGridToolbar()
	{
		XiHelperToolbar::addNew('newTransaction');
		XiHelperToolbar::editList();
		XiHelperToolbar::divider();
		XiHelperToolbar::searchpayplans();
	}
	
	protected function _adminEditToolbar()
	{   
		$itemId = $this->getModel()->getState('id');
		
		if(!$itemId){
        	XiHelperToolbar::apply();
			XiHelperToolbar::save();
		}
		
		XiHelperToolbar::cancel();
	}
	
	function edit($tpl=null, $itemId=null)
	{	
		$itemId = ($itemId === null)? $this->getModel()->getState('id') : $itemId;
		
		$transaction = PayplansTransaction::getInstance($itemId);
		$user		 = PayplansUser::getInstance($transaction->getBuyer());
		
		if(!$itemId){
			$invoiceId = JRequest::getVar('invoice_id', 0);

			$invoice   = PayplansInvoice::getInstance($invoiceId);
			$payment   = $invoice->getPayment();
			$paymentId = 0;
			if($payment){
				$paymentId = $payment->getId();
			}
			$user	   = $invoice->getBuyer(PAYPLANS_INSTANCE_REQUIRE);

			$transaction->set('user_id',    $user->getId())
						->set('payment_id', $paymentId)
						->set('invoice_id', $invoiceId)
						->set('amount', 	$invoice->getTotal());
			$this->setTpl('new');
		}
		
		$logRecords	 = XiFactory::getInstance('log', 'model')
								->loadRecords(array('object_id'=>$itemId, 'class'=>'PayplansTransaction'));
		
		$paymentId    = $transaction->getPayment();
		$payment      = $transaction->getPayment(PAYPLANS_INSTANCE_REQUIRE);
		$txnRecord    = '';
		
		if(!empty($paymentId)  && ($payment instanceof PayplansPayment)){
			$paymentApp = $payment->getApp(PAYPLANS_INSTANCE_REQUIRE);
			$txnRecord 	= $paymentApp->onPayplansTransactionRecord($transaction);
		}
		
		$this->assign('transaction_html', $txnRecord);
		$this->assign('transaction', 	  $transaction);
		$this->assign('user', 		 	  $user);
		$this->assign('log_records', 	  $logRecords);
		return true;
	}
	
	public function _getDynamicJavaScript()
	{
		$url		 =	"index.php?option=com_{$this->_component}&view={$this->getName()}";

		ob_start(); ?>

		payplansAdmin.transaction_newTransaction = function()
		{
			payplans.url.modal("<?php echo "$url&task=newTransaction";?>");
			return false;
		}

		<?php
		$js = ob_get_contents();
		ob_end_clean();
		return $js;
	}

	public function newTransaction()
	{
		$this->_setAjaxWinTitle(XiText::_('COM_PAYPLANS_TRANSACTION_NEW_TEXT_POPUP_TITLE'));

		$onClick = "xi.submitAjaxForm('payplans-transaction-new-next');";
		$this->_addAjaxWinAction(XiText::_('COM_PAYPLANS_AJAX_CANCEL_BUTTON'),'xi.ui.dialog.close();');
		$this->_setAjaxWinAction();
		$this->_setAjaxWinHeight('150');
		return true;
	}
	
	function _displayGrid($records)
	{
		$uesrids = array();
		foreach($records as $record){
			$userids[] = $record->user_id;
		}
		
		$users = PayplansHelperUser::get($userids);
		$this->assign('users', $users);
		
		return parent::_displayGrid($records);
	}
}

