<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: readmail.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// Ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

include_once ( JPATH_SITE . '/components/com_maqmahelpdesk/classes/mail.class.php' );

$CONFIG = new JConfig();
$database = JFactory::getDBO();
$content = '';

if( php_sapi_name() != 'cli' ) {
	$cmd = true;
} else {
	$cmd = false;
}

if( extension_loaded('imap') ) {
	$content.= '<p style="color:#04B404;"><b>imap extension is loaded!</b></p>';

	if (!get_cfg_var('safe_mode')) {      
		$time_limit = ini_get('max_execution_time'); 
		set_time_limit(0);
	}

	require_once( JPATH_SITE."/administrator/components/com_maqmahelpdesk/functions/admin.readmail.php" );

	// Get Configuration Options
	$database->setQuery( "SELECT * FROM #__support_config WHERE id='1'" );
	$supportConfig = null;
	$supportConfig = $database->loadObject();
	
	$database->setQuery( "SELECT publish FROM #__support_addon WHERE sname='readmail'" );
	$published = $database->loadResult();
	
	if( $published ) {
		$database->setQuery( "SELECT * FROM #__support_mail_fetch WHERE `published`=1" );
		$cat_res = $database->loadObjectList();
		
		if (count($cat_res) == 0) {
			$content.= '<p style="#f00000"><b>No mail accounts defined!</b></p>';
		} else {
			for($i=0; $i<count($cat_res); $i++) {
				$cat_row = $cat_res[$i];
				
				$sql = "SELECT `add_mail_tag` 
						FROM `#__support_workgroup` 
						WHERE `id`=".$cat_row->id_workgroup;
				$database->setQuery( $sql );
				$workgroupSettings = $database->loadObject();
				
				/*	WRITES INFO ON THE SCREEN */
				$content.= '<h3 style="border:1px solid #d5d5d5;background:#e5e5e5;padding:5px;">E-Mail Fetch Account #'.$i.'</h3>';
				$content.= '<table cellpadding="5">';
				$content.= '<tr><td>E-Mail: </td><td>'.$cat_row->email.'</td></tr>';
				$content.= '<tr><td>Server: </td><td>'.$cat_row->server.'</td></tr>';
				$content.= '<tr><td>Type: </td><td>'.$cat_row->type.'</td></tr>';
				$content.= '<tr><td>Port: </td><td>'.$cat_row->port.'</td></tr>';
				$content.= '<tr><td>ID Workgroup: </td><td>'.$cat_row->id_workgroup.'</td></tr>';
				$content.= '<tr><td>ID Category: </td><td>'.$cat_row->id_category.'</td></tr>';
				$content.= '<tr><td>Delete email: </td><td>'.$cat_row->remove.'</td></tr>';
				$content.= '<tr><td>Extra Info: </td><td>'.$cat_row->extra_info.'</td></tr>';
				$content.= '<tr><td>Place in Queue: </td><td>'.$cat_row->queue.'</td></tr>';
				$content.= '<tr><td>Status: </td><td>'.$cat_row->id_status.'</td></tr>';
				$content.= '<tr><td>Folder: </td><td>'.$cat_row->label.'</td></tr>';
				$content.= '<tr><td>SSL: </td><td>'.$cat_row->ssl.'</td></tr>';
				$content.= '<tr><td>TLS: </td><td>'.$cat_row->notls.'</td></tr>';
				$content.= '<tr><td>Date to start: </td><td>'.date('m-d-Y', strtotime('- 1 day')).'</td></tr>';
				$content.= '<tr><td>Use email tag: </td><td>'.$workgroupSettings->add_mail_tag.' - <b>'.JText::_('mail_tag').'</b></td></tr>';
				$content.= '</table>';
				
				/*	
					CONFIGURE MAILBOX LOGIN  
				*/
				$Mail_ServerName_conf			= $cat_row->server;		// NAME ON THE MAIL SERVER
				$Mail_ServerAccessProtocol_conf = $cat_row->type;		// CAN BE imap or pop
				$Mail_ServerAccessPort_conf		= $cat_row->port;		// CAN WHAT YOU'VE SET MAILSERVER TO (default is pop=110 or imap=143
				$Mail_Mail_conf					= $cat_row->email;		// EMAIL FOR THE ACCOUNT TO RECEIVE FROM
				$Mail_UserName_conf				= $cat_row->username;	// USERNAME ON THE MAILSERVER FOR THE ACCOUNT TO RECEIVE FROM
				$Mail_PassWord_conf				= $cat_row->password;	// PASSWORD ON THE MAILSERVER FOR THE ACCOUNT TO RECEIVE FROM
				$Mail_Delete_conf				= $cat_row->remove;		// SET IF IT SHOULD REMOVE EMAILS FROM THE SERVER OR NOT
				$Mail_ExtraInfo_conf			= $cat_row->extra_info;	// EXTRA DETAILS TO APPLY TO THE CONNECTION EX. /ssl
				
				/*
					OPENING MAILBOX
				*/
				//$obj = new MailParser("{imap.gmail.com:993/imap/ssl}INBOX", 'EMAIL', 'PASSWORD');
				$obj = new MailParser("{".$Mail_ServerName_conf.":".$Mail_ServerAccessPort_conf."/".$Mail_ServerAccessProtocol_conf.($cat_row->ssl?'/ssl':'').($cat_row->notls?'':'/notls').$Mail_ExtraInfo_conf."}".$cat_row->label, $Mail_UserName_conf, $Mail_PassWord_conf);
				$obj->delete = $Mail_Delete_conf;
				$obj->parseMessagesByRecDate(date("j F Y", strtotime('- 1 day')));
				$result = $obj->getResult();
				$i = 0;
				$content.= '<h2 style="border:1px solid #d5d5d5;background:#e5e5e5;padding:5px;">MESSAGES IN THE SERVER: '.count($result).'</h2>';
				
				// Retrieving the message information from $result
				foreach($result as $msg) 
				{
					$i++;
					$plainText	 = $msg['plainBody'];
					$html		 = $msg['htmlBody'];
					$header		 = $msg['headers'];
					$attachments = $msg['attachments'];
					$subject     = imap_utf8($header->subject);
					$to	       	 = $header->toaddress;
					$from        = $header->from[0]->mailbox.'@'.$header->from[0]->host;
					$from_name   = isset($header->from[0]->personal) ? $header->from[0]->personal : $header->from[0]->mailbox;
					$from_name   = imap_utf8($from_name);
					$body 		 = $plainText;
					$message_id  = ( $header->message_id != '' ? $header->message_id : md5($header->MailDate.$header->subject) );
					
					// Email tag
					$pos = strpos($body, JText::_('mail_tag'));
					if( $pos !== false ) {
						$body = substr($body, 0, $pos);
					}
					
					// Body re-worked
					$body = nl2br(imap_utf8($body));
					$body = str_replace("\r\n","",$body);
					$body = str_replace("<br /><br />","<br />",$body);
					$body = str_replace("\'","'",$body);
					$body = strip_tags($body,'<p><br><u><b><i><a>');
					echo "encoding: ".mb_check_encoding($body)."<br>";
					if( mb_check_encoding($body) ) {
						$body = mb_convert_encoding($body, "utf-8", "auto");
					}else{
						$body = htmlentities($body);
						$body = html_entity_decode($body, ENT_NOQUOTES, 'UTF-8');
					}
					
					$content.= '<h3 style="border:1px solid #d5d5d5;background:#e5e5e5;padding:5px;">MESSAGE #'.$i.'</h3>';
					$content.= '<table cellpadding="5">';
					$content.= '<tr><td bgcolor="#f5f5f5">message id</td><td>'.$message_id.'</td></tr>';
					$content.= '<tr><td bgcolor="#f5f5f5">message from</td><td>'.$from.'</td></tr>';
					$content.= '<tr><td bgcolor="#f5f5f5">message from name</td><td>'.$from_name.'</td></tr>';
					$content.= '<tr><td bgcolor="#f5f5f5">subject</td><td>'.$subject.'</td></tr>';
					$content.= '</table>';
					
					/*print '<pre>';
					print_r($header);
					print '</pre>';
					print '<hr>';*/
					
					// body of the message in html
					/*print '<pre>';
					print_r($html);
					print '</pre>';
					print '<hr>';*/
					
					// body of the message in text format
					/*print '<pre>';
					print_r($plainText);
					print '</pre>';
					print '<hr>';*/
					
					// array com anexos
					/*print '<pre>';
					print_r($attachments);
					print '</pre>';
					print '<hr>';*/
					
					// Verifies if StopForumSpam is to be used
					$spamcheck = true;
					if( $supportConfig->stopspam ) {
						$spamcheck = mqm_check_stopspam( $from );
					}
					$content.= "<p>Spamcheck: $spamcheck</p>";
					
					// If passed spam check and wasn't processed yet continues
					if( $spamcheck && !mqm_check_emailid( $message_id ) ) {
						/* CREATES A NEW TICKET OR CREATE A NEW TICKET REPLY */
						if ( !preg_match("/[[][#][0-9]{7,20}[]]/", $subject) ) {
							$content.= "<p><span style='color:blue'>- create new ticket -</span></p>";
							$ticket_id = Mail2Ticket ( 0, $cat_row->id_workgroup, $cat_row->id_category, ($subject), ($body), ($from_name), $from, $cat_row->queue, $cat_row->id_status );
						} else { 
							$TicketID2 = strstr($subject, "[#");
							$TicketID2 = substr( $TicketID2, 2, strlen($TicketID2)-(strlen($TicketID2)-strpos($TicketID2, "]"))-2 );
							$mask_len = strlen($TicketID2);
							$TicketID2 = substr($TicketID2, 2, ($mask_len-6));
							$content.= "<p><span style='color:blue'>- create new ticket response $TicketID2 -</span></p>";
							$ticket_id = Mail2Ticket ( $TicketID2, $cat_row->id_workgroup, $cat_row->id_category, ($subject), ($body), ($from_name), $from, $cat_row->queue, $cat_row->id_status );
						}
						$content.= "<p>Ticket ID: $ticket_id</p>";
						
						if($attachments && $ticket_id) 
						{
							foreach($attachments as $fileName => $data) 
							{
								$fileName = $ticket_id.'_'.rand(0,999).'_'.$fileName;
								$fh = fopen($supportConfig->docspath.$fileName, 'wb');
								fwrite($fh, $data);
								fclose($fh);
								$database->setQuery( "INSERT INTO #__support_file(id, source, filename, public, `date`) VALUES('".$ticket_id."', 'T', '".$fileName."', '1', '".dateOffset("Y-m-d H:i:s")."')" );
								$database->query();
								ticketLog2( $ticket_id, "The file <b>".$fileName."</b> has been attached by <b>".($from_name)."</b> as an attached from the e-mail.", '', GetUserID($from), 0, 'add_attach.gif' );
							}
						}
						
						$content.= "<p><span style='color:blue'>- status -</span></p>";
						if ( $ticket_id ) {
							$content.= "<p><span style='color:green;'>Email imported and ticket created!</span></p>";
							mailLog( $cat_row->id, $from_name, 'The e-mail was accepted and a ticket has been created with the ID <b>'.$ticket_id.'</b>.', $message_id );
						} else {
							$content.= "<p><span style='color:red;'>Email not imported!</span></p>";
							mailLog( $cat_row->id, $from_name, 'The e-mail was rejected and no ticket was created.', $message_id );
						}
					}else{
						if( !$spamcheck ) {
							$content.= "<p><span style='color:red;'>Email not imported - Spam check failed!</span></p>";
							mailLog( $cat_row->id, $from_name, 'The e-mail was rejected and no ticket was created because failed spam check.', $message_id );
						}else{
							$content.= "<p><span style='color:red;'>Email not imported - Email processed previously!</span></p>";
							//mailLog( $cat_row->id, $from_name, 'The e-mail was rejected and no ticket was created because email was processed previously.', $message_id );
						}
					}
				}
			}
		}
	}

	if (!get_cfg_var('safe_mode')) {      
		set_time_limit($time_limit);
	}	
	
}else{
	$content.= '<p><span style="color:#f00000;">imap extension is not loaded</span></p>';
}

if( $cmd ) {
	echo $content;
}