<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: tickets.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// Ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

$CONFIG = new JConfig();
$database = JFactory::getDBO();

$SecretWord = JRequest::getCmd( 'SecretWord', '', '', 'string' );

if( $CONFIG->secret != $SecretWord ) {
	return false;
}

// Get config
$supportConfig = GetConfig();

$database->setQuery( "SELECT publish FROM #__support_addon WHERE sname='tickets'" );
$published = $database->loadResult();

if( $published ) {
	//get the total number of records
	$database->setQuery( "SELECT t.id as dbid, t.ticketmask as ticketid, t.subject, s.description as status, t.duedate,
						  t.date as date_created, t.last_update, w.wkabout as workgroup, u.email, u.name, t.id_user
						  FROM #__support_ticket as t 
						       INNER JOIN #__support_status as s ON t.id_status=s.id
							   INNER JOIN #__users as u ON u.id=t.assign_to
							   INNER JOIN #__support_workgroup as w ON w.id=t.id_workgroup
						  WHERE s.status_group = 'O'
						  GROUP BY t.id_user ORDER BY t.duedate DESC" );
	$rows = $database->loadObjectList();
	echo $database->getErrorMsg();
	
	$prev_user = 0;
	$prev_name = '';
	$prev_mail = '';
	$tickets = 0;
	$feed_summary = '';
	
	if( count($rows) > 0 ) {
		for($i=0; $i<count($rows); $i++) {
			$row = &$rows[$i];
			if( $prev_user == '' ) {
				$prev_user = $row->id_user;
				$prev_name = $row->name;
				$prev_mail = $row->email;
			}
			$tickets = $tickets + 1;
			
			$feed_summary .= '
				<tr>
				<td bgcolor="#FFFFFF" valign="top" align="left" class="bodytext">'. $row->date_created .'</td>
				<td bgcolor="#FFFFFF" valign="top" align="left" class="bodytext">'. $row->duedate .'</td>
				<td bgcolor="#FFFFFF" valign="top" align="left" class="bodytext">'. $row->ticketid .'</td>
				<td bgcolor="#FFFFFF" valign="top" align="left" class="bodytext">'. $row->subject .'</td>
				<td bgcolor="#FFFFFF" valign="top" align="left" class="bodytext">'. $row->workgroup .'</td>
				</tr>		
				';

			if( $prev_user != $row->id_user || (count($rows)-$i) == 1 ) {
				/** EMAIL variables */
				$admin_email = $prev_mail;
				$email_subject = JText::_('tickets_addon_title');
				//$email_body = str_replace( '<tag:tickets />', $feed_summary, $tmpl_code );
				//$email_body = str_replace( '<tag:tickets_total />', $tickets, $email_body );

				ob_start();
				$tmplfile = JPATH_SITE.'/components/com_maqmahelpdesk/templates/default/mail/tickets_addon.php';
				include_once($tmplfile);
				$email_body = ob_get_contents();
				ob_end_clean();

				$mailer = JFactory::getMailer();
				$mailer->setSender( $CONFIG->mailfrom, JText::_('tickets_mail_from') );
				$mailer->addRecipient( $admin_email );
				$mailer->setSubject( $email_subject );
				$mailer->setBody( $email_body );
				$mailer->IsHTML( true );
				print "<p>mail (".$admin_email."): ".$mailer->Send();
				
				// Re-start counter and change previous user info
				$prev_user = $row->id_user;
				$prev_name = $row->name;
				$prev_mail = $row->email;
				$tickets = 0;
				$feed_summary = '';
			}
		}
	}
}

