<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: calendar.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

$id = JRequest::getVar( 'id', 0, '', 'int' );
$month = JRequest::getVar( 'month', dateOffset("m"), '', 'int' );
$year = JRequest::getVar( 'year', dateOffset("Y"), '', 'int' );
$date = JRequest::getVar( 'date', dateOffset("Y-m-d"), '', 'string' );

// Activities logger
mqm_activitylog('site', 'calendar', $task, $id);

switch( $task )
{
	case "view":
		showCalendar( 'M', $month, $year, '' );
		break;

	case "add":
		showEdit( 0 );
		break;

	case "edit":
		$user->id > 0 && isMineCal($id) ? showEdit( $id ) : JError::raiseError	( 403, JText::_("ALERTNOTAUTH"));
		break;

	case "save":
		showSave();
		break;

	case "delete":
		$user->id > 0 && isMineCal($id) ? showDelete( $id ) : JError::raiseError( 403, JText::_("ALERTNOTAUTH"));
		break;

	case "week":
		showCalendar( 'W', $month, $year, $date );
		break;

	case "day":
		showCalendar( 'D', $month, $year, $date );
		break;

	case "list":
		showCalendar( 'L', $month, $year, '' );
		break;
}

function isMineCal( $id ) {
	$database = JFactory::getDBO();
	$user	= JFactory::getUser();
	
	$database->setQuery( "SELECT COUNT(*) FROM #__support_task WHERE id_user='".$user->id."' AND id='".$id."'" );
	if( $database->loadResult() > 0 ) {
		return true;
	}else{
		return false;
	}
}

function showCalendar( $report, $month, $year, $date ) 
{
	global $supportConfig, $is_support, $is_client, $workgroupSettings, $supportOptions, $supportConfig, $print;

	$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	$database = JFactory::getDBO();

	// Parameters
	JLoader::register('JTableMenu', JPATH_LIBRARIES.DS.'joomla'.DS.'database'.DS.'table'.DS.'menu.php');
	$menu = new JTableMenu( $database );
	$menu->load( $Itemid );
	$params = new Jparameter( $menu->params );

	// Sets the title
	PageTitle('showCalendar');

	$imgpath = JURI::root().'components/com_maqmahelpdesk/images';
	$legend = '';
	$legend .= '<img src='.$imgpath.'/menu/status.png align=absmiddle border=0 hspace=2 vspace=2 /> '.JText::_('task_ticket').'<br /><img src='.$imgpath.'/16px/flag-yellow.png align=absmiddle border=0 hspace=2 vspace=2 /> '.JText::_('task_isopen').'<br /><img src='.$imgpath.'/16px/flag-green.png align=absmiddle border=0 hspace=2 vspace=2 /> '.JText::_('task_isclosed').'<br /><img src='.$imgpath.'/16px/flag-red.png align=absmiddle border=0 hspace=2 vspace=2 /> '.JText::_('task_isdue');

	ob_start();
	JHTML::_('behavior.tooltip');
	echo '<span class="editlinktip hasTip" title="'.htmlspecialchars(JText::_('legend').'::'.$legend).'"><img src="'.$imgpath.'/16px/info.png" align="absmiddle" border="0" hspace="5" style="cursor:help; cursor:hand;" /></span>';
	$tooltip = ob_get_contents();
	ob_end_clean();
	
	// Year and Month filters
	if( $month == '' ) {
		$month = dateOffset("m");
	}

	if( $year == '' ) {
		$year = dateOffset("Y");
	}

	if( $month == dateOffset("m") && $year == dateOffset("Y") ) {
		$day = dateOffset("d");
	}else{
		$day = 0;
	}

	if( $date == '' ) {
		$date = dateOffset("Y-m-d");
	}else{
		$part_date = explode( '-', $date );
		$day = $part_date[2];
		$month = $part_date[1];
		$year = $part_date[0];
	}

	ob_start(); ?>
	<select name="year" class="inputbox" onChange="javascript:document.adminForm.submit();"><?php	
	$i = 0;
	$start = 2004;
	$end = dateOffset("Y") + 1;
	for($i=$start; $i<=$end; $i++) {
		print '<option value="'.$i.'"'.($year==$i ? ' selected' : '').'>'.$i.'</option>';
	} ?>
	</select><?php
	$years = ob_get_contents();
	ob_end_clean();

	ob_start(); ?>
	<select name="month" class="inputbox" onChange="javascript:document.adminForm.submit();">
		<option value="01" <?php echo ($month=='01' ? 'selected' : ''); ?>><?php echo JText::_('month01'); ?></option>
		<option value="02" <?php echo ($month=='02' ? 'selected' : ''); ?>><?php echo JText::_('month02'); ?></option>
		<option value="03" <?php echo ($month=='03' ? 'selected' : ''); ?>><?php echo JText::_('month03'); ?></option>
		<option value="04" <?php echo ($month=='04' ? 'selected' : ''); ?>><?php echo JText::_('month04'); ?></option>
		<option value="05" <?php echo ($month=='05' ? 'selected' : ''); ?>><?php echo JText::_('month05'); ?></option>
		<option value="06" <?php echo ($month=='06' ? 'selected' : ''); ?>><?php echo JText::_('month06'); ?></option>
		<option value="07" <?php echo ($month=='07' ? 'selected' : ''); ?>><?php echo JText::_('month07'); ?></option>
		<option value="08" <?php echo ($month=='08' ? 'selected' : ''); ?>><?php echo JText::_('month08'); ?></option>
		<option value="09" <?php echo ($month=='09' ? 'selected' : ''); ?>><?php echo JText::_('month09'); ?></option>
		<option value="10" <?php echo ($month=='10' ? 'selected' : ''); ?>><?php echo JText::_('month10'); ?></option>
		<option value="11" <?php echo ($month=='11' ? 'selected' : ''); ?>><?php echo JText::_('month11'); ?></option>
		<option value="12" <?php echo ($month=='12' ? 'selected' : ''); ?>><?php echo JText::_('month12'); ?></option>
	</select><?php
	$months = ob_get_contents();
	ob_end_clean();
	
	$link = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=';
	
	$task = JRequest::getVar( 'task', 'view', '', 'string' );
	$taskcheck = explode ('_', $task);
	switch( $taskcheck[1] ) 
	{
		case 'view': $tmplfile = 'month'; break;
		case 'list': $tmplfile = 'list';  break;
		case 'day':  $tmplfile = 'day';   break;
		case 'week': $tmplfile = 'week';  break;
	}
	
	include( JPATH_SITE.'/components/com_maqmahelpdesk/templates/'.$workgroupSettings->theme.'/tasks/tasks_'.$tmplfile.'_view.php' );
}

function showEdit( $id ) 
{
	global $supportConfig, $is_support, $is_client, $workgroupSettings, $supportOptions, $is_manager;

	$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	$database = JFactory::getDBO();
	$editor = JFactory::getEditor();
	$user	= JFactory::getUser();

	// Parameters
	JLoader::register('JTableMenu', JPATH_LIBRARIES.DS.'joomla'.DS.'database'.DS.'table'.DS.'menu.php');
	$menu = new JTableMenu( $database );
	$menu->load( $Itemid );
	$params = new Jparameter( $menu->params );

	// Sets the title
	PageTitle( 'editCalendar', ( $id ? JText::_('pathway_edit') : JText::_('pathway_new') ) );

	$row = new mosSupportTask( $database );
	$row->load( $id );
	
	// Build Date without time
	$date_task = '';
	$date_task = substr($row->date_time, 0, 10);

	// Build Hours without time
	$hour_task = '';
	$hour_task = substr($row->date_time, 11, -6);

	// Build Mins without time
	$mins_task = '';
	$mins_task = substr($row->date_time, 14, -3);

	// Get Activity Rate Default
	$database->setQuery( "SELECT id FROM #__support_activity_rate WHERE isdefault='1'" );
	$default_rate = $database->loadResult();

	// Build Activity Rate select list
	$sql = "SELECT `id` AS value, `description` AS text FROM #__support_activity_rate WHERE published='1' ORDER BY description";
	$database->setQuery($sql);
	$rows_actrate = $database->loadObjectList();
	$lists['task_rate'] = JHTML::_('select.genericlist',$rows_actrate, 'activity_rate', 'class="inputbox" size="1"', 'value', 'text', $default_rate);

	// Get Activity Type Default
	$database->setQuery( "SELECT id FROM #__support_activity_type WHERE isdefault='1'" );
	$default_type = $database->loadResult();

	// Build Activity Type select list
	$sql = "SELECT `id` AS value, `description` AS text FROM #__support_activity_type WHERE published='1' ORDER BY description";
	$database->setQuery($sql);
	$rows_acttype = $database->loadObjectList();
	$lists['task_type'] = JHTML::_('select.genericlist',$rows_acttype, 'activity_type', 'class="inputbox" size="1"', 'value', 'text', $default_type);

	// Build the Travel yes/no list
	$lists['task_travel'] = JHTML::_('select.booleanlist', 'tasktravel', 'class="inputbox" onClick="SetTravelTime();"', 1, JText::_('MQ_YES'), JText::_('MQ_NO') );
	$lists['taskstatus'] = JHTML::_('select.booleanlist', 'status', 'class="inputbox"', ($row->status=='O' ? 1 : 0), JText::_('MQ_YES'), JText::_('MQ_NO') );
	$clienttravel = 0;

	// Build Support Staff select list
	$sql = "SELECT DISTINCT(u.`id`) AS value, u.`name` AS text FROM #__support_permission as p, #__users as u WHERE p.id_user=u.id AND p.id_workgroup='".$id_workgroup."' ORDER BY u.name";
	$database->setQuery($sql);
	$rows_staff = $database->loadObjectList();
	$rows_staff = array_merge(array(JHTML::_('select.option', '0', JText::_('select3'))), $rows_staff);
	$lists['id_user'] = JHTML::_('select.genericlist',$rows_staff, 'id_user', 'class="inputbox" size="1"', 'value', 'text', $user->id);

	ob_start();
	echo getJScript('GetLabourTimeTasks');
	$javascript = ob_get_contents();
	ob_end_clean();
	
	$hours = '';
	for( $xxx=0; $xxx<24; $xxx++ ) {
		$hours .= '<option value="'.($xxx<10?'0'.$xxx:$xxx).'" '.($hour_task==($xxx<10?'0'.$xxx:$xxx) ? 'selected' : '').'>'.($xxx<10?'0'.$xxx:$xxx).'</option>';
	}
	
	$minutes = buildHoursMinutes( 1, $mins_task );

	if ($row->id_ticket > 0) {
		// Ticket Number
		$database->setQuery( "SELECT ticketmask FROM #__support_ticket WHERE id='".$row->id_ticket."'" );
		$ticket_mask = $database->loadResult();
		$ticket_link = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=ticket_view&id='.$row->id_ticket);
	}

	ob_start();
	echo JHTML::Calendar($date_task, 'date' , 'date', '%Y-%m-%d', array('class'=>'inputbox', 'size'=>'12',  'maxlength'=>'10')); 
	$content_date = ob_get_contents();
	ob_end_clean();
	
	ob_start();
	echo $editor->display( 'taskfield', $row->task, $supportConfig->field_width, '400', '75', '20' ) ;
	$task = ob_get_contents();
	ob_end_clean();
	
	include( JPATH_SITE.'/components/com_maqmahelpdesk/templates/'.$workgroupSettings->theme.'/tasks/tasks_add_form.php' );
}

function showDelete( $id ) 
{
	$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	$mainframe = JFactory::getApplication();
	$database = JFactory::getDBO();
	
	$sql = "delete from #__support_task where id='".$id."'";
	$database->setQuery( $sql );
	$database->query();
	
	$mainframe->redirect( JRoute::_("index.php?option=com_maqmahelpdesk&id_workgroup=".$id_workgroup."&Itemid=".$Itemid."&task=calendar_view&msg=".JText::_('task_deleted')) );
}

function showSave() 
{
	global $supportConfig, $is_support, $is_client, $workgroupSettings, $supportOptions, $is_manager;

	$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	$mainframe = JFactory::getApplication();
	$database = JFactory::getDBO();
	$user	= JFactory::getUser();

	$CONFIG = new JConfig();
	$id = JRequest::getVar( 'id', '', 'POST', 'int' );
	$id_user = JRequest::getVar( 'id_user', '', 'POST', 'int' );
	$date = JRequest::getVar( 'date', '', 'POST', 'string' );
	$taskfield = JRequest::getVar( 'taskfield', '', 'POST', 'string', 4 );
	$status = JRequest::getVar( 'status', '', 'POST', 'string' );
	$taskhour = JRequest::getVar( 'taskhour', '', 'POST', 'string' );
	$taskmin = JRequest::getVar( 'taskmin', '', 'POST', 'string' );
	$date = $date . " " . $taskhour . ":" . $taskmin . ":00";
	
	if( $_POST['id'] == 0 ) {
		$database->setQuery( "INSERT INTO #__support_task(id_ticket, id_user, date_time, task, status) VALUES('".$id."', '".$id_user."', ".$database->quote($date).", ".$database->quote($taskfield).", ".$database->quote($status).")" );
		$msg = JText::_('task_created');
	}else{
		$database->setQuery( "UPDATE #__support_task SET id_user='".$id_user."', date_time=".$database->quote($date).", task=".$database->quote($taskfield).", status=".$database->quote($status)." WHERE id='".$id."'" );
		$msg = JText::_('task_updated');
	}
	$database->query();

	// Informs the user about the task in case it's not the logged user
	if( $user->id != $_POST['id_user'] ) {
		// Get Assigned User
		$database->setQuery( "SELECT name, email FROM #__users WHERE id=".$database->quote($_POST['id_user']) );
		$taskuser = null;
		$taskuser = $database->loadObject();

		// Get Workgroup Options
		$database->setQuery( "SELECT * FROM #__support_workgroup WHERE id=".$database->quote($_POST['id_workgroup']) );
		$wkoptions = null;
		$wkoptions = $database->loadObject();

		// ==================================================================================================================
		// Get the template for the page
		$tmpl_code->htmlcode = getSCTemplate( $id_workgroup, 'mail/tsk_notify_new' );
		// ==================================================================================================================

		// Replaces message body variables for the values
		$msginfo->message = str_replace( "%ticket", '-', $tmpl_code->htmlcode );			// Replaces the %ticket
		$msginfo->message = str_replace( "%staff", $taskuser->name, $msginfo->message );					// Replaces the %staff
		$msginfo->message = str_replace( "%task", JRequest::getVar( 'taskfield', '', 'POST', 'string' ), $msginfo->message );		// Replaces the %message
		$msginfo->message = str_replace( "%calendar", JURI::root(), $msginfo->message );			// Replaces the %email
		$msginfo->message = str_replace( "%url", JURI::root(), $msginfo->message );					// Replaces the %url
		
		$sendmail1 = JUtility::sendMail( ($wkoptions->wkadmin_email!='' ? $wkoptions->wkadmin_email : $CONFIG->mailfrom), ($wkoptions->wkmail_address_name!='' ? $wkoptions->wkmail_address_name : $CONFIG->sitename)." <".($wkoptions->wkadmin_email!='' ? $wkoptions->wkadmin_email : $CONFIG->fromname).">", $taskuser->email, JText::_('tsk_notify_new_subj'), $msginfo->message, 1 );
		
		if($sendmail1!=true) {
			$msg .= "MAIL: An error ocurred while sending the mail to assigned user!";
		}
	}

	$mainframe->redirect( JRoute::_("index.php?option=com_maqmahelpdesk&id_workgroup=".$id_workgroup."&Itemid=".$Itemid."&task=calendar_view&msg=".$msg) );
}
