<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: timesheet.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

include_once ( JPATH_SITE . '/components/com_maqmahelpdesk/includes/common.php' );
include_once ( JPATH_SITE . '/components/com_maqmahelpdesk/includes/reports.php' );

$year    = JRequest::getVar( 'year', date("Y"), '', 'int' );
$month    = JRequest::getVar( 'month', date("m"), '', 'int' );
$id_client    = JRequest::getVar( 'id_client', 0, '', 'int' );
$type    = JRequest::getVar( 'type', 'D', '', 'string' );
$task    = JRequest::getVar( 'task', 'timesheet', '', 'string' );

// Activities logger
mqm_activitylog('site', 'timesheet', $task);

switch ($task) {
	default:
		isValidPermissions($task, 'TM') ? showTimesheet( $year, $month, $id_client, $type ) : noAccessQuit();
		break;
}

function showTimesheet( $year, $month, $id_client, $type ) 
{
	global $workgroupSettings;
	
	$mainframe = JFactory::getApplication();
	$database = JFactory::getDBO();
	$document = JFactory::getDocument();
	$user	= JFactory::getUser();
	$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	
	// Sets the title
	PageTitle( 'showTimesheet' );
	$document->title = JText::_('timesheet');

	$years[] = JHTML::_('select.option', '00', JText::_('select3')	);
	for($i=2004; $i<=dateOffset("Y"); $i++) {
		$years[] = JHTML::_('select.option', $i, $i);
	}
	$lists['year'] = JHTML::_('select.genericlist',$years, 'year', 'class="inputbox" size="1" onChange="document.adminForm.submit();"', 'value', 'text', $year);
	
	$months[] = JHTML::_('select.option', '00', JText::_('selectlist'));
	$months[] = JHTML::_('select.option', '01', JText::_('month01'));
	$months[] = JHTML::_('select.option', '02', JText::_('month02'));
	$months[] = JHTML::_('select.option', '03', JText::_('month03'));
	$months[] = JHTML::_('select.option', '04', JText::_('month04'));
	$months[] = JHTML::_('select.option', '05', JText::_('month05'));
	$months[] = JHTML::_('select.option', '06', JText::_('month06'));
	$months[] = JHTML::_('select.option', '07', JText::_('month07'));
	$months[] = JHTML::_('select.option', '08', JText::_('month08'));
	$months[] = JHTML::_('select.option', '09', JText::_('month09'));
	$months[] = JHTML::_('select.option', '10', JText::_('month10'));
	$months[] = JHTML::_('select.option', '11', JText::_('month11'));
	$months[] = JHTML::_('select.option', '12', JText::_('month12'));
	$lists['month'] = JHTML::_('select.genericlist',$months, 'month', 'class="inputbox" size="1" onChange="document.adminForm.submit();"', 'value', 'text', $month);

	$reporting = new SupportReports();
	
	include( JPATH_SITE.'/components/com_maqmahelpdesk/templates/'.$workgroupSettings->theme.'/general/timesheet.php' );
}
