<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: workgroup.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// no direct access
defined('_JEXEC') or die( 'Restricted access' );

$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );

// Activities logger
mqm_activitylog('site', 'workgroup', $task, $id_workgroup);

switch( $task ) 
{
	case "view":
		$workgroupSettings ? showWorkgroup() : noAccessQuit();
		break;
	
	default:
		showList();
		break;
}

function showWorkgroup() 
{
	global $supportConfig, $is_support, $is_client, $workgroupSettings, $supportOptions, $clientOptions; 
	
	$Itemid	= JRequest::getInt( 'Itemid', 0 );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	$session = JFactory::getSession();
	$database = JFactory::getDBO();
	$user	= JFactory::getUser();
	
	// Validate if profile must be complete
	mqm_profile_required();

	// Sets the title
	PageTitle( 'showWorkgroup' );
	
	// Get announcements
	$sql = "SELECT id, `date`, introtext as intro, bodytext as body, frontpage, urgent, sent, id_workgroup, DAY(`date`) AS date_day, MONTH(`date`) AS date_month, YEAR(`date`) AS date_year, CONCAT('index.php?option=com_maqmahelpdesk&Itemid=".$Itemid."&id_workgroup=".$id_workgroup."&task=announce_view&id=',`id`) AS link, SUBSTRING(`bodytext`,1,50) AS body_resume 
			FROM #__support_announce 
			WHERE frontpage='1' ".($is_support ? "" : "AND (id_client='0' OR id_client='".$is_client."') ").($id_workgroup==0 ? "AND id_workgroup='0'" : "AND (id_workgroup='0' OR id_workgroup='".$id_workgroup."')")." 
			ORDER BY date DESC";
	$database->setQuery( $sql );
	$announcements = $database->loadObjectList();

	/*
	$date_day_desc            = substr( $row->date, 8, 2 ).ordinalNumber( substr( $row->date, 8, 2 ) );
	$date_month_desc_complete = returnMonthDesc( substr( $row->date, 5, 2 ) );
	$date_month_desc_small    = substr( returnMonthDesc( substr( $row->date, 5, 2 ) ), 0, 3 );
	*/

	// Build Options Array
	$i = 0;
	$io = 0;
	$wk_options = array();
	$other_options = array();
	
	if( $is_client > 0 && $clientOptions->manager ) {
		$other_options[$io]['title'] = JText::_('wk_client_profile');
		$other_options[$io]['icon']  = 'clients.png';
		$other_options[$io]['link']  = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=client_view&id='.$is_client);
		$other_options[$io]['description'] = JText::_('wk_client_profile_desc');
		$io++;
	}

	if( $is_support ) {
		$other_options[$io]['title'] = JText::_('wk_clients');
		$other_options[$io]['icon']  = 'clients.png';
		$other_options[$io]['link']  = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=client_list');
		$other_options[$io]['description']  = JText::_('wk_clients_desc');
		$io++;
	}
	
	if( $workgroupSettings->wkticket && ( ( $supportConfig->unregister && !$user->id && $supportConfig->anonymous_tickets && !$workgroupSettings->contract ) || $user->id ) ) {
		$wk_options[$i]['title'] = JText::_('wk_addticket');
		$wk_options[$i]['icon']  = 'tickets_add.png';
		$wk_options[$i]['link']  = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=ticket_new');
		$wk_options[$i]['description']  = JText::_('wk_addticket_desc');
		$i++;

		$wk_options[$i]['title'] = JText::_('wk_tickets');
		$wk_options[$i]['icon']  = 'tickets.png';
		$wk_options[$i]['link']  = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=ticket_my');
		$wk_options[$i]['description']  = JText::_('wk_tickets_desc');
		$i++;
		
		global $is_manager, $usertype;
		if ( ($is_support && $usertype > 5) || ( $is_client && $is_manager ) ) {
			#	support = 1
			#		usertype
			#			7: Support manager
			#			6: Support team leader
			#			5: Basic support user
			#	client = 1
			#		manager = 1
			/*$other_options[$io]['title'] = JText::_('open_tickets_report');
			$other_options[$io]['icon']  = 'tickets_report.png';
			$other_options[$io]['link']  = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=ticket_opentickets');
			$other_options[$io]['description']  = JText::_('open_tickets_report_desc');
			$io++;*/
			
			$other_options[$io]['title'] = JText::_('report_tickets');
			$other_options[$io]['icon']  = 'tickets_report.png';
			$other_options[$io]['link']  = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=ticket_report');
			$other_options[$io]['description']  = JText::_('report_tickets_description');
			$io++;
		}

		if ( $is_support ) {
			$other_options[$io]['title'] = JText::_('tickets_analysis');
			$other_options[$io]['icon']  = 'search.png';
			$other_options[$io]['link']  = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=ticket_analysis');
			$other_options[$io]['description']  = JText::_('tickets_analysis_desc');
			$io++;
		}
	}
	
	if( $workgroupSettings->enable_discussions ) {
		$wk_options[$i]['title'] = JText::_('discussions');
		$wk_options[$i]['icon']  = 'discussions.png';
		$wk_options[$i]['link']  = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=discussions');
		$wk_options[$i]['description']  = JText::_('discussions_desc');
		$i++;
	}

	if( $workgroupSettings->wkkb ) {
		if( $is_support ) {
			$other_options[$io]['title'] = JText::_('wk_addarticle');
			$other_options[$io]['icon']  = 'kb_add.png';
			$other_options[$io]['link']  = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=kb_new');
			$other_options[$io]['description']  = JText::_('wk_addarticle_desc');
			$io++;

			$other_options[$io]['title'] = JText::_('wk_myarticles');
			$other_options[$io]['icon']  = 'kb.png';
			$other_options[$io]['link']  = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=my_kb');
			$other_options[$io]['description']  = JText::_('wk_myarticles_desc');
			$io++;
		}
		
		// If there's only one category link goes direct
		$sql = "SELECT c.`id`
				FROM `#__support_category` AS c
					 INNER JOIN `#__support_kb_category` AS kc ON kc.`id_category` = c.`id`
				WHERE c.`id_workgroup`=".$id_workgroup;
		$database->setQuery( $sql );
		$categories = $database->loadObjectList();
		$link = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=kb_list'.( !$categories || count($categories) > 1 ? '' : '&parent='.$categories[0]->id ));
		$wk_options[$i]['title'] = JText::_('wk_kb');
		$wk_options[$i]['icon']  = 'kb.png';
		$wk_options[$i]['link']  = $link;
		$wk_options[$i]['description']  = JText::_('wk_kb_desc');
		$i++;

		/*$wk_options[$i]['title'] = JText::_('wk_searchkb');
		$wk_options[$i]['icon']  = 'kb_search.png';
		$wk_options[$i]['link']  = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=kb_search');
		$wk_options[$i]['description']  = JText::_('wk_searchkb_desc');
		$i++;*/
	}

	if( $workgroupSettings->wkfaq ) {
		$wk_options[$i]['title'] = JText::_('wk_faq');
		$wk_options[$i]['icon']  = 'replies.png';
		$wk_options[$i]['link']  = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=kb_faq');
		$wk_options[$i]['description']  = JText::_('wk_faq_desc');
		$i++;
	}
	
	if( $is_support && $workgroupSettings->wkglossary ) {
		$other_options[$io]['title'] = JText::_('wk_addglossary');
		$other_options[$io]['icon']  = 'glossary_add.png';
		$other_options[$io]['link']  = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=kb_addglossary';
		$other_options[$io]['description']  = JText::_('wk_addglossary_desc');
		$io++;
	}
	
	if( $workgroupSettings->wkglossary ) {
		$wk_options[$i]['title'] = JText::_('wk_glossary');
		$wk_options[$i]['icon']  = 'glossary.png';
		$wk_options[$i]['link']  = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=kb_glossary';
		$wk_options[$i]['description']  = JText::_('wk_glossary_desc');
		$i++;
	}

	if( $is_support ) {
		$other_options[$io]['title'] = JText::_('wk_tasks');
		$other_options[$io]['icon']  = 'calendar.png';
		$other_options[$io]['link']  = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=calendar_view';
		$other_options[$io]['description']  = JText::_('wk_tasks_desc');
		$io++;
	}

	if( $workgroupSettings->trouble ) {
		$wk_options[$i]['title'] = JText::_('wk_troubleshooter');
		$wk_options[$i]['icon']  = 'troubleshooter.png';
		$wk_options[$i]['link']  = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=troubleshooter';
		$wk_options[$i]['description']  = JText::_('wk_troubleshooter_desc');
		$i++;
	}

	if( $user->id > 0 && $workgroupSettings->use_bookmarks ) {
		$other_options[$io]['title'] = JText::_('wk_bookmarks');
		$other_options[$io]['icon']  = 'bookmarks.png';
		$other_options[$io]['link']  = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=my_bookmark';
		$other_options[$io]['description']  = JText::_('wk_bookmarks_desc');
		$io++;
	}
	
	if( $workgroupSettings->wkannounces ) {
		$wk_options[$i]['title'] = JText::_('wk_announces');
		$wk_options[$i]['icon']  = 'announcements.png';
		$wk_options[$i]['link']  = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=announce_list';
		$wk_options[$i]['description']  = JText::_('wk_announces_desc');
		$i++;
	}
	
	if( $workgroupSettings->wkdownloads ) {
		$wk_options[$i]['title'] = JText::_('wk_downloads');
		$wk_options[$i]['icon']  = 'files.png';
		$wk_options[$i]['link']  = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=downloads';
		$wk_options[$i]['description']  = JText::_('wk_downloads_desc');
		$i++;
	}
	
	if( $is_support && $workgroupSettings->use_activity ) {
		$other_options[$io]['title'] = JText::_('timesheet');
		$other_options[$io]['icon']  = 'reports.png';
		$other_options[$io]['link']  = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=timesheet';
		$other_options[$io]['description']  = JText::_('timesheet_desc');
		$io++;
	}
	
	if( $user->id && $workgroupSettings->use_account ) {
		$other_options[$io]['title'] = JText::_('wk_profile');
		$other_options[$io]['icon']  = 'profile.png';
		$other_options[$io]['link']  = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=users_profile';
		$other_options[$io]['description']  = JText::_('wk_profile_desc');
		$io++;
	}
	
	// Get Links - TODO NOT IN USE!!!
	$sql = "SELECT `id`, `name` as `title`, `description`, `link`, `image` as `icon` 
			FROM #__support_links 
			WHERE id_workgroup='".$id_workgroup."' AND `section`='F' AND `published`='1'".(!$is_support ? " AND `public`='1'" : '')." 
			ORDER BY `ordering` DESC";
	$database->setQuery( $sql );
	$links = $database->loadObjectList();

	// Dashboard - Pending tickets
	$sql = "SELECT COUNT(*) AS TOTAL 
			FROM #__support_ticket AS t 
				 INNER JOIN #__support_status AS s ON s.id=t.id_status 
			WHERE s.status_group='O' 
			  AND t.id_workgroup='".$id_workgroup."'".
			  (!$is_support ? ($is_client ? "AND t.id_client=".$is_client : "AND t.id_user=".$user->id) : "");
	$database->setQuery( $sql );
	$tickets_pending = 0;
	$tickets_pending = $database->loadResult();
	
	// Dashboard - Overdued tickets
	$sql = "SELECT COUNT(*) AS TOTAL 
			FROM #__support_ticket AS t 
				 INNER JOIN #__support_status AS s ON s.id=t.id_status 
			WHERE s.status_group='O' AND t.duedate<'".date("Y-m-d")."' 
			  AND t.id_workgroup='".$id_workgroup."'".
			  (!$is_support ? ($is_client ? "AND t.id_client=".$is_client : "AND t.id_user=".$user->id) : "");
	$database->setQuery( $sql );
	$tickets_overdue = 0;
	$tickets_overdue = $database->loadResult();

	// Dashboard - Tickets today
	$sql = "SELECT COUNT(*) AS TOTAL 
			FROM #__support_ticket AS t 
			WHERE SUBSTRING(t.date,1,10)='".date("Y-m-d")."' 
			  AND t.id_workgroup='".$id_workgroup."'".
			  (!$is_support ? ($is_client ? "AND t.id_client=".$is_client : "AND t.id_user=".$user->id) : "");
	$database->setQuery( $sql );
	$tickets_today = 0;
	$tickets_today = $database->loadResult();
	
	// Output
	include( JPATH_SITE.'/components/com_maqmahelpdesk/templates/'.$workgroupSettings->theme.'/general/workgroup_options_'.( $user->id == 0 ? 'anonymous' : ( $is_support ? 'support' : 'customer' )).($is_support && $session->get("helpdesk_mobile") ? '_mobile' : '').'.php' );
}

function showList() 
{
	global $supportConfig, $is_support, $is_client;
	
	$session = JFactory::getSession();
	$mainframe = JFactory::getApplication();
	$database = JFactory::getDBO();
	$user = JFactory::getUser();
	$Itemid	= JRequest::getInt( 'Itemid', 0 );

	// Sets the title
	PageTitle( 'showWorkgroups' );

	// Get workgroups
	$database->setQuery( "SELECT id, wkdesc, wkabout, logo, shortdesc FROM #__support_workgroup WHERE `show`='1' ORDER BY ordering, wkdesc" );
	$rows = $database->loadObjectList();
	
	// Verify permissions to the workgroups
	$wkids = '';
	if( $is_support ) {
		for( $i=0; $i<count($rows); $i++ ) {
			$row = $rows[$i];
			$sql = "SELECT COUNT(*) FROM #__support_permission WHERE id_workgroup='".$row->id."' AND id_user='".$user->id."'";
			$database->setQuery( $sql );
			if( $database->loadResult() > 0 ) {
				$wkids .= $row->id.',';
			}
		}
		$wkids = substr( $wkids, 0, strlen($wkids)-1 );
		
		if ($supportConfig->support_workgroup_only=="1") {
			$database->setQuery( "SELECT id, wkdesc, wkabout, logo, shortdesc FROM #__support_workgroup WHERE id IN (".$wkids.") AND `show`='1' ORDER BY ordering, wkdesc" );
			$rows = $database->loadObjectList();
		} else {
			// Get workgroups where the user is as support staff
			$database->setQuery( "SELECT id, wkdesc, wkabout, logo, shortdesc FROM #__support_workgroup WHERE id IN (".$wkids.") AND `show`='1' ORDER BY ordering, wkdesc" );
			$rows1 = $database->loadObjectList();
			
			// Get workgroups where the user is not as support staff (if any)
			$database->setQuery( "SELECT id, wkdesc, wkabout, logo, shortdesc FROM #__support_workgroup WHERE id NOT IN (".$wkids.") AND `show`='1' ORDER BY ordering, wkdesc" );
			$rows2 = $database->loadObjectList();

			// Merge both arrays
			$rows = array_merge($rows1, $rows2);
		}
		
	} elseif ( $is_client > 0 ) {
		for( $i=0; $i<count($rows); $i++ ) {
			$row = $rows[$i];
			$database->setQuery( "SELECT COUNT(*) FROM #__support_client_wk WHERE (id_workgroup='".$row->id."' OR id_workgroup='0') AND id_client='".$is_client."'" );
			if( $database->loadResult() > 0 ) {
				$wkids .= $row->id.',';
			}
		}
		$wkids = substr( $wkids, 0, strlen($wkids)-1 );
		
		// Get workgroups
		$database->setQuery( "SELECT id, wkdesc, wkabout, logo, shortdesc FROM #__support_workgroup WHERE id IN (".$wkids.") AND `show`='1' ORDER BY ordering, wkdesc" );
		$rows = $database->loadObjectList();
	}
	$_SESSION['wkids'] = $wkids;
	
	if( count($rows) > 0 ) {
		$i = 1;
		foreach( $rows as $key2 => $value2 )
		{
			if( is_object($value2) ) {
				foreach( $value2 as $key3 => $value3 )
				{
					$workgroups[$i][$key3] = $value3;
					
					if( $key3 == 'id' ) {
						$workgroups[$i]['link'] = JRoute::_("index.php?option=com_maqmahelpdesk&Itemid=".$Itemid."&id_workgroup=".$value3."&task=workgroup_view");
					}

					if( $key3 == 'logo' ) {
						$workgroups[$i]['image'] = 'components/com_maqmahelpdesk/images/'.( $value3 != '' ? 'logos/'.$value3 : 'title/workgroup.png' );
					}

					if( $key3 == 'wkdesc' ) {
						$workgroups[$i]['title'] = str_replace("\'","'",$value3);
					}

					if( $key3 == 'wkabout' ) {
						$workgroups[$i]['description'] = str_replace("\'","'",$value3);
					}
				}
			}

			$i++;
		}
	}

	// Get featured KB articles from the possible workgroups - $wkids
	$sql = "SELECT k.id, k.kbcode AS code, k.kbtitle AS title, k.content AS question, (SUM(r.rate)/COUNT(r.id)) AS rating 
			FROM #__support_kb AS k 
				 LEFT JOIN #__support_rate AS r ON r.id_table=k.id AND r.source='K' 
			WHERE k.publish='1'
			  AND k.id IN (SELECT kc.id_kb FROM #__support_kb_category AS kc)".
			 (!$user->id ? " AND k.anonymous_access='1'" : "")." 
			GROUP BY k.id, k.kbcode, k.kbtitle, k.content 
			ORDER BY k.views 
			LIMIT 0, 5";
	$database->setQuery( $sql );
	$featured_kb = $database->loadAssocList();
	
	for( $i=0; $i<count($featured_kb); $i++ )
	{
		// Get the article categories
		$sql = "SELECT c.id_workgroup FROM #__support_category AS c INNER JOIN #__support_kb_category AS kc ON kc.id_category=c.id WHERE kc.id_kb='".$featured_kb[$i]["id"]."' LIMIT 0, 1";
		$database->setQuery( $sql );
		$featured_kb[$i]["link"] = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$database->loadResult().'&task=kb_view&id='.$featured_kb[$i]["id"] );
		$featured_kb[$i]["rating"] = number_format($featured_kb[$i]["rating"],0);
		$featured_kb[$i]["title"] = ( strlen($featured_kb[$i]['title'])>30 ? substr($featured_kb[$i]["title"],0,30).'...' : $featured_kb[$i]["title"] );
	}

	// Get viewed KB articles from the possible workgroups - $wkids
	$sql = "SELECT k.id, k.kbcode AS code, k.kbtitle AS title, k.content AS question, k.views 
			FROM #__support_kb AS k 
			WHERE k.publish='1'
			  AND k.id IN (SELECT kc.id_kb FROM #__support_kb_category AS kc)".
			(!$user->id ? " AND k.anonymous_access='1'" : "")." 
			GROUP BY k.id, k.kbcode, k.kbtitle, k.content 
			ORDER BY k.views 
			LIMIT 0, 5";
	$database->setQuery( $sql );
	$viewed_kb = $database->loadAssocList();

	for( $i=0; $i<count($viewed_kb); $i++ )
	{
		// Get the article categories
		$sql = "SELECT c.id_workgroup FROM #__support_category AS c INNER JOIN #__support_kb_category AS kc ON kc.id_category=c.id WHERE kc.id_kb='".$viewed_kb[$i]["id"]."' LIMIT 0, 1";
		$database->setQuery( $sql );
		$viewed_kb[$i]["link"] = JRoute::_( 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$database->loadResult().'&task=kb_view&id='.$viewed_kb[$i]["id"] );
		$viewed_kb[$i]["title"] = ( strlen($viewed_kb[$i]['title'])>30 ? substr($viewed_kb[$i]["title"],0,30).'...' : $viewed_kb[$i]["title"] );
	}
	
	if( count($rows) == 0 ) {
		$task     = 'noaccess';
		$function = 'warning';
		showTplMessage( JText::_('client_as_no_workgroup'), 0 );
	}elseif( count($rows) == 1 ) { 
		$row = $rows[0];
		$link = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$row->id.'&task=workgroup_view'.($is_support && $session->get("helpdesk_mobile") ? '&format=raw' : ''));
		$mainframe->redirect( $link );
	}else{
		if( $is_support ) {
			// Dashboard - Pending tickets
			$sql = "SELECT COUNT(*) AS TOTAL 
					FROM #__support_ticket AS t 
						 INNER JOIN #__support_status AS s ON s.id=t.id_status 
					WHERE s.status_group='O' 
					  AND t.id_workgroup IN (".$wkids.") ".
					  (!$is_support ? ($is_client ? "AND t.id_client=".$is_client : "AND t.id_user=".$user->id) : "");
			$database->setQuery( $sql );
			$tickets_pending = 0;
			$tickets_pending = $database->loadResult();
			
			// Dashboard - Overdued tickets
			$sql = "SELECT COUNT(*) AS TOTAL 
					FROM #__support_ticket AS t 
						 INNER JOIN #__support_status AS s ON s.id=t.id_status 
					WHERE s.status_group='O' 
					  AND t.id_workgroup IN (".$wkids.") 
					  AND t.duedate<'".date("Y-m-d")."' ".
					  (!$is_support ? ($is_client ? "AND t.id_client=".$is_client : "AND t.id_user=".$user->id) : "");
			$database->setQuery( $sql );
			$tickets_overdue = 0;
			$tickets_overdue = $database->loadResult();

			// Dashboard - Tickets today
			$sql = "SELECT COUNT(*) AS TOTAL 
					FROM #__support_ticket AS t 
					WHERE t.id_workgroup IN (".$wkids.") 
					  AND SUBSTRING(t.date,1,10)='".date("Y-m-d")."' ".
					  (!$is_support ? ($is_client ? "AND t.id_client=".$is_client : "AND t.id_user=".$user->id) : "");
			$database->setQuery( $sql );
			$tickets_today = 0;
			$tickets_today = $database->loadResult();
		}
		
		// Output
		include( JPATH_SITE.'/components/com_maqmahelpdesk/templates/workgroups_list'.($is_support && $session->get("helpdesk_mobile") ? '_mobile' : '').'.php' );
	}
}
