<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: common.php 342 2012-01-23 15:13:41Z pdaniel $
 * $LastChangedDate: 2012-01-23 15:13:41 +0000 (seg, 23 Jan 2012) $
 *
 */

// Ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

jimport( 'joomla.html.parameter' );

if (!function_exists('sc_commontmp')) {
	function sc_commontmp() {
	}
	
	function jversion15_check()
	{
		$jversion = new JVersion();
		$current_version = $jversion->getShortVersion(); 
		return (version_compare('1.6.0', $current_version) > 0);
	}
	
	function FormatFileSize($size) 
	{
		$units = array(' B', ' KB', ' MB', ' GB', ' TB');
		for ($i = 0; $size >= 1024 && $i < 4; $i++) $size /= 1024;
		return round($size, 2).$units[$i];
	}
	
	/**
	* Inserts a ticket log message
	* @param database A database connector object
	* @param string The log message
	*/
	function ticketLog( $id, $msg, $msg_reserved, $id_status='', $field='', $value='0', $time_elapse='0', $image='' ) {
		$user	= JFactory::getUser();
		$database = JFactory::getDBO();

		// permite que o time elapse se refira a altera��es do mesmo tipo
		if (($field == 'status') || ($field == 'assign') || ($field == 'attachfile') || ($field == 'category') || ($field == 'priority') || ($field == 'rate')) {
			$sql = "SELECT id, UNIX_TIMESTAMP(date_time) AS last_time FROM #__support_log WHERE `id_ticket` = '".$id."' AND `field` = '".$field."' AND `time_elapse` = 0 ORDER BY `date_time` DESC LIMIT 1";
			$database->setQuery( $sql );
			$last_field_changed = $database->loadObject();
			!$database->query() ? showSCMessage( $database->getErrorMsg(), 'e' ) : '';
			if (count($last_field_changed)) {
				$nowtime = mktime(date("H") , date("i") , date("s") , date("n") , date("j") , date("Y") );
				$time_dif = $nowtime - $last_field_changed->last_time;
				$sql = "UPDATE #__support_log SET `time_elapse` =  '".$time_dif."' WHERE id='".$last_field_changed->id."' ";
				$database->setQuery($sql);
				!$database->query() ? showSCMessage( $database->getErrorMsg(), 'e' ) : '';
			}
		}
		
		$sql = "INSERT INTO #__support_log(`id_ticket`, `id_user`, `date_time`, `log`, `log_reserved`, `id_status`, `field`, `value`, `time_elapse`, `image`) 
				VALUES('".$id."', '".$user->id."', '".dateOffset("Y-m-d H:i:s")."', ".$database->quote($msg).", ".$database->quote($msg_reserved).", '".$id_status."', '".$field."', '".$value."', 0, '".$image."')";
		$database->setQuery( $sql );
		!$database->query() ? showSCMessage( $database->getErrorMsg(), 'e' ) : '';
	}

	/**
	* Formats current or given date to take into account mosConfig Timezone offset
	* @param
	* @param
	*/
	function dateOffset( $format="Y-m-d H:i:s" , $timestamp = '' ) 
	{
		global $supportConfig;
	
		!$timestamp ? $timestamp = time() : '';
		return date( $format, $timestamp + ( $supportConfig->offset * 3600 ) );
	}

	/**
	* Formats current or given Unixtimestamp to take into account mosConfig Timezone offset
	* @param
	*/
	function timestampOffset( $timestamp = '' ) 
	{
		global $supportConfig;

		if( !$timestamp ) {
			$timestamp = time() + ( $supportConfig->offset * 3600 );
		} else {
			$timestamp = $timestamp + ( $supportConfig->offset * 3600 );
		}
		return $timestamp;
	}

	/**
	* Checks if the file has an attachment
	* @param
	* @param
	*/
	function ticketAttachs( $id ) {
		global $supportConfig;
		
		$database = JFactory::getDBO();

		//Security measure against SQL Injection
		$id = mysql_escape_string($id);
		$sql = "SELECT COUNT(*) FROM #__support_file WHERE source='T' AND id='".$id."'";
		$database->setQuery( $sql );
		$database->loadResult() > 0 ? $ticket_attachs = 1 : $ticket_attachs = 0;

		return $ticket_attachs;
	}

	/**
	* Allows the client to download a file from the web server
	* @param
	* @param
	*/
	function downloadFile( $id, $extid, $filetype ) {
		global $supportConfig, $is_client;

		$database = JFactory::getDBO();

		//Security measure against SQL Injection
		$id = mysql_escape_string($id);

		//Get the filename either from Support or Clients table
		$fileObj = null;
		switch ($filetype) {
			case 'D':
				$sql = "SELECT filename, filename_original FROM #__support_dl_version WHERE id='".$id."'";
				$attach_subdir = '/';
				break;
			case 'C':
				$sql = "SELECT filename FROM #__support_client_docs WHERE id='".$id."'";
				$attach_subdir = 'docs/';
				break;
			case 'T':
				$sql = "SELECT filename FROM #__support_file WHERE id_file='".$id."' AND id='".$extid."' AND source='T'";
				$attach_subdir = '/';
				break;
			case 'K':
				$sql = "SELECT filename FROM #__support_file WHERE id_file='".$id."' AND id='".$extid."' AND source='K'";
				$attach_subdir = '/';
				break;
		}

		$database->setQuery( $sql );
		$fileObj = $database->loadObject();
		$file = $supportConfig->docspath.$attach_subdir.$fileObj->filename;

		if (file_exists($file)) {
			header('HTTP/1.1 200 OK');
			header('Status: 200 OK');
			header("Cache-Control: private"); // Workarounds for IE weirdness
			/*
			if(isset($_SERVER['HTTP_USER_AGENT']) && strpos($_SERVER['HTTP_USER_AGENT'],'MSIE')) {
				header("Cache-Control: private");
			} else {
				header("Cache-Control: public");
			}
			*/
			header('Pragma: public');

			if( function_exists('mime_content_type') && mime_content_type($file) ) {
				header('Content-Type: '. mime_content_type($file));
			} else {
				if(isset($_SERVER['HTTP_USER_AGENT']) && strpos($_SERVER['HTTP_USER_AGENT'],'MSIE')) {
						header('Content-Type: application/force-download');
				} else {
						header('Content-Type: application/octet-stream');
				}
			}

			header("Content-Transfer-Encoding: binary");
			header('Cache-Control: cache, must-revalidate');
			header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
			header('Content-Disposition: attachment; filename="'.($filetype=='D' ? $fileObj->filename_original : $fileObj->filename).'"');
			header('Content-Length: '.filesize($file));
			
			$handle = fopen($file,'rb');
			fseek($handle,0);
			$contents = "";
			while( !feof($handle) )
			{
				set_time_limit(0);
				print(fread($handle, 8192));
				flush();
				ob_flush();
			}
			fclose($handle); 
			exit;
		}else {
			putGlobalMessage( JText::_('download_notfound'), 'e' );
			echo "<script type='text/javascript'> window.history.go(-1); </script>\n";
		}
	}

	/**
	* Allows the users to delete attachments
	* @param
	* @param
	*/
	function deleteFile( $id, $extid, $filetype ) {
		global $supportConfig, $is_client, $is_support;

		$database = JFactory::getDBO();
		$user	= JFactory::getUser();

		// Security measure against SQL Injection
		$id = mysql_escape_string($id);

		// Get the user name
		$database->setQuery( "SELECT `name` FROM #__users WHERE id='".$user->id."'" );
		$username = $database->loadResult();

		// Get the attachment info
		$sql = "SELECT * FROM #__support_file WHERE id_file='".$id."' AND id='".$extid."' AND source='".$filetype."'";
		$file_info = null;
		$database->setQuery( $sql );
		$file_info = $database->loadObject();

		$file = $supportConfig->docspath.'/'.$file_info->filename;

		if ( $is_support || ( $user->id == $file_info->id_user ) ) {
			if( $filetype == 'T' ) {
				$ticketLogMsg = str_replace( '%1', $username, JText::_('attached_deleted') );
				$ticketLogMsg = str_replace( '%2', $file_info->filename, $ticketLogMsg );
				ticketLog( $extid,  $ticketLogMsg, JText::_('attached_deleted_hidden'), '' );

				$database->setQuery( "DELETE FROM #__support_file WHERE id_file='".$id."'" );
				$database->query();
				( file_exists($file) ) ? unlink( $file ) : putGlobalMessage( JText::_('download_notfound'), 'w' );
				putGlobalMessage( JText::_('download_filedeled'), 'i' );
			}
		}else {
			putGlobalMessage( JText::_('access_denied_title'), 'w' );
		}
	}

// Gets clients or users contract type
	function getContract( $id, $type = 'u' ) {
		global $is_client;

		$database = JFactory::getDBO();

		$valid_contract = 0;	// False by default
		switch ($type) {
			case 'u' :
				$check_sql = "AND u.id_user='".$id."'";
				$id_client = $is_client;
				break;
			case 'c' :
				$check_sql = "AND c.id_client='".$id."'";
				$id_client = $id;
				break;
		}
		// Get client active contract
		$sql = "SELECT c.id, c.id_contract, c.id_client, c.status, c.date_start, c.date_end, c.unit AS unit, c.value, c.actual_value FROM #__support_client_users as u, #__support_contract as c WHERE u.id_client=c.id_client ". $check_sql." AND c.status='A'";
		$database->setQuery($sql);
		$contracts = $database->loadObjectList();

		// Process first contract found for the client
		if( count($contracts) == 0 ) {
			// Do not have an active contract so try to activate one
			if( makeContractActive( $id_client, 0 ) ) {
				$contract = getContract( $id, $type );
				$valid_contract = is_object($contract) ? 1 : 0;
			}else{
				$valid_contract = 0;
			}
		}else{
			$contract = $contracts[0];
			$valid_contract = 1;
		}
		if (!$valid_contract) {
			return false;
		} else {
			return $contract;
		}
	}

// Contract validation for a user or client id
	function isValidContract( $id, $type = 'u' ) {
		global $is_client;

		$database = JFactory::getDBO();

		$valid_contract = 0;	// False by default
		switch ($type) {
			case 'u' :
				$check_sql = "AND u.id_user='".$id."'";
				break;
			case 'c' :
				$check_sql = "AND c.id_client='".$id."'";
				break;
		}
		// Get client active contract
		$database->setQuery( "SELECT c.id, c.id_contract, c.id_client, c.status, c.date_start, c.date_end, c.unit, c.value, c.actual_value FROM #__support_client_users as u, #__support_contract as c WHERE u.id_client=c.id_client ". $check_sql." AND c.status='A'" );
		$contracts = $database->loadObjectList();

		// Process each contract found for the client until an active is found
		if( count($contracts) == 0 ) {
			$valid_contract = 0;	// Do not have an active contract
		}else{
			foreach( $contracts as $contract ) {
				if( !$valid_contract ) {
					$valid_contract = 0;
					switch( $contract->unit ) {
						case 'T' :	// Contract based on the number of tickets
							( $contract->value <= $contract->actual_value ) ? $valid_contract = 0 : $valid_contract = 1;
							break;
						case 'H' : // Contract based on the number of labour hours
							( $contract->value <= $contract->actual_value ) ? $valid_contract = 0 : $valid_contract = 1;
							break;
						default	: // Contract based on dates
							$today_timestamp = parseDate( dateOffset("Y-m-d"), '%Y-%m-%d' );
							$start_timestamp = parseDate( $contract->date_start, '%Y-%m-%d' );
							$end_timestamp = parseDate( $contract->date_end, '%Y-%m-%d' );
							($today_timestamp >= $start_timestamp && $end_timestamp > $today_timestamp) ? $valid_contract = 1 : $valid_contract = 0;
							break;
					}
				}
			}
		}
		
		if ( !$valid_contract ) {
			return false;
		}else{
			return true;
		}
	}

	/**
	* Checks if the action is authorised to be carried out, 0 = no valid permissions, 1 = access allowed
	* @param
	* @param
	*
	* Previously known as checkPermissions() function
	*
	*/
	function isValidPermissions($task, $check_type = 'T') {
		global $supportConfig, $is_support, $is_client, $Itemid, $workgroupSettings, $supportOptions, $usertype, $id_workgroup, $id, $extid, $client_id;
		
		$database = JFactory::getDBO();
		$user = JFactory::getUser();

		$valid_access = 0;
		$permissioncheck_query = 0;
		$id = JRequest::getVar( 'id', 0, '', 'int' );

		// Check applies to ticket tasks (default)
		if  ( $check_type == 'T' ) {
			if ( $task == 'replyapply' || $task == 'reply' || $task == 'view' || $task == 'print' || $task == 'bookmark' || $task == 'rate' || $task == 'download' || $task == 'delattach' || $task == 'quickreply' || $task == 'setstatus' ) {

				// Fix for different variables names in files table
				if( $task == 'download' || $task == 'delattach' ) {
					$tmp_id = $id;
					$id = $extid;
				}

				switch ($usertype) {
					case 1: // Client user, Check if the ticket belongs to current user
						$permissioncheck_query = "SELECT COUNT(*) FROM #__support_ticket WHERE id='".$id."' AND id_user='".$user->id."'";
						break;

					case 2: // Client Manager, Check if the ticket belongs to current users client company
						$permissioncheck_query = "SELECT COUNT(*) FROM #__support_client_users c, #__support_ticket t WHERE t.id='".$id."' AND c.id_user=t.id_user AND c.id_client= '".$client_id."'";
						break;

					case 5: // Support user, Check if the ticket is assigned to the current user and he has access to the tickets workgroup
						$permissioncheck_query = "SELECT COUNT(*) FROM #__support_ticket t, #__support_permission p WHERE t.id='".$id."' AND t.assign_to='".$user->id."' AND t.id_workgroup=p.id_workgroup AND p.id_user='".$user->id."'";
						break;

					case 6: // Support team leader, Check if the ticket is assigned to the current user or unassigned and he has access to the tickets workgroup
						$permissioncheck_query = "SELECT COUNT(*) FROM #__support_ticket t, #__support_permission p WHERE t.id='".$id."' AND (t.assign_to='0' OR t.assign_to='".$user->id."') AND t.id_workgroup=p.id_workgroup AND p.id_user='".$user->id."'";
						break;

					case 7: // Support manager, Check if the current Support Manager has access to tickets workgroup
						$permissioncheck_query = "SELECT COUNT(*) FROM  #__support_ticket t, #__support_permission p WHERE t.id_workgroup=p.id_workgroup AND p.id_user='".$user->id."' AND t.id='".$id."'";
						break;

					default:
						$permissioncheck_query = '';
						break;
				}

				// Fix for quickreply
				if( $task == 'quickreply' ) { 
					$id = JRequest::getVar( 'ticket_reply_id', 0, '', 'int' ); 
					$permissioncheck_query = '';
					$valid_access = 1;
				}

				// Fix for setstatus
				if( $task == 'setstatus' ) { 
					$id = JRequest::getVar( 'ticket', 0, '', 'int' ); 
					$permissioncheck_query = '';
					$valid_access = 1;
				}
				
				// Fix for different variables names in files table
				if( $task == 'download' || $task == 'delattach' ) {
					$id = $tmp_id;
				}

			} elseif ( $task == 'apply' || $task == 'save' || $task == 'new' ) {
				// Client user & Client manager: Check if the user has rights to the workgroup
				if ($is_client && ( $usertype == 1 || $usertype == 2 )) {
					$permissioncheck_query = "SELECT COUNT(*) AS total FROM #__support_client_wk WHERE (id_workgroup='".JRequest::getVar( 'id_workgroup', 0, '', 'int' )."' OR id_workgroup='0') AND id_client='$client_id'";
					
					// Check if Workgroup is only for clients with contracts
					$database->setQuery( "SELECT contract FROM #__support_workgroup WHERE id='".JRequest::getVar( 'id_workgroup', 0, '', 'int' )."'" );
					$wk_contractonly = $database->loadResult();
					
					if( $wk_contractonly && isValidContract($user->id) == false ) {
						$permissioncheck_query = '';
						$msg = JText::_('wkcontractonly');
						$valid_access = 0;
					}
				} elseif ( $usertype == 5 || $usertype == 6 || $usertype == 7) {
					// Support user, Team Leader, Manager: Check if the user has rights to the workgroup
					$permissioncheck_query = "SELECT COUNT(*) FROM #__support_permission p WHERE p.id_workgroup='".JRequest::getVar( 'id_workgroup', 0, '', 'int' )."' AND p.id_user='".$user->id."'";
				} elseif ( !$is_client && $usertype == 1 ) { // Non client user so no need to check for workgroup permissions
					// Check if Workgroup is only for clients with contracts
					$database->setQuery( "SELECT contract FROM #__support_workgroup WHERE id='".JRequest::getVar( 'id_workgroup', 0, '', 'int' )."'" );
					$wk_contractonly = $database->loadResult();
					if( $wk_contractonly && isValidContract($user->id) == false ) {
						$msg = JText::_('wkcontractonly');
						$valid_access = 0;
					}else{
						$permissioncheck_query = '';
						$valid_access = 1;
					}
				}

			}elseif( $task == 'changewk' || $task == 'analysis' || $task == 'opentickets' || $task == 'sticky' || $task == 'parent' ) {
				if( $is_support ) {
					$valid_access = 1;
				}

			}elseif( $task == 'my' || $task == 'cancel' ) {
				if( !$is_support && $user->id > 0 ) {
					// Check if Workgroup is only for clients with contracts
					$database->setQuery( "SELECT contract FROM #__support_workgroup WHERE id='".JRequest::getVar( 'id_workgroup', 0, '', 'int' )."'" );
					$wk_contractonly = $database->loadResult();
					//if( $wk_contractonly && isValidContract($user->id) == false ) {
					//	$msg = JText::_('wkcontractonly');
					//	$valid_access = 0;
					//}else{
						$valid_access = 1;
					//}
				} elseif ( $usertype == 5 || $usertype == 6 || $usertype == 7) {
					// Support user, Team Leader, Manager: Check if the user has rights to the workgroup
					$permissioncheck_query = "SELECT COUNT(*) FROM #__support_permission p WHERE '".JRequest::getVar( 'id_workgroup', 0, '', 'int' )."'=p.id_workgroup AND p.id_user='".$user->id."'";
				}
			}
			if ( $permissioncheck_query != '' ) {
				$database->setQuery( $permissioncheck_query );
				( $database->loadResult() > 0 ) ? $valid_access = 1 : $valid_access = 0;
			}
			if( !$workgroupSettings->wkticket ) {
				$valid_access = 0;
			}
			
			// Anonymous access check
			$filter_email = JRequest::getVar( 'filter_email', null, 'REQUEST', 'string' );
			$filter_ticketid = JRequest::getVar( 'filter_ticketid', null, 'REQUEST', 'int' );
			$database->setQuery( "select count(*) from #__support_ticket where `ticketmask`='".$filter_ticketid."' AND an_mail=".$database->quote($filter_email) );
			$ticketcheck = $database->loadResult();
			if( !$user->id && $supportConfig->unregister && ( $task == 'new' || $task == 'my' || $task == 'save' ) ) {
				$valid_access = 1;
			}
			if( !$user->id && $supportConfig->unregister && ( $task == 'view' || $task == 'print' || $task == 'reply' ) && $ticketcheck ) {
				$valid_access = 1;
			}

		// Check applies to kb tasks
		}elseif( $check_type == 'K' ) {
			$valid_access = $workgroupSettings->wkkb;
			if( ( $task == 'new' || $task == 'edit' || $task == 'save' ) && !$is_support ) {
				$valid_access = 0;
			}

		// Check applies to faq tasks
		}elseif( $check_type == 'FAQ' ) {
			$valid_access = $workgroupSettings->wkfaq;

		// Check applies to troubleshooter tasks
		}elseif( $check_type == 'TR' ) {
			$valid_access = $workgroupSettings->trouble;

		// Check applies to discussions tasks
		}elseif( $check_type == 'DI' ) {
			$valid_access = $workgroupSettings->enable_discussions;
			if( !$user->id && ( $task == 'vote' || $task == 'new' || $task == 'save' ) ) {
				$valid_access = 0;
			}
			if( !$is_support && ( $task == 'publish' || $task == 'delete' ) ) {
				$valid_access = 0;
			}

		// Check applies to client tasks
		}elseif( $check_type == 'C' ) {
			if( $task == 'download' ) {
				// Get the client related with the document
				$database->setQuery( "SELECT id_client FROM #__support_client_docs WHERE id='".JRequest::getVar( 'id', 0, '', 'int' )."'" );
				$doc_client = $database->loadResult();

				switch ($usertype) {
					case 2: // Client Manager, Check if the ticket belongs to current users client company
						if( $doc_client == $is_client ) {
							$valid_access = 1;
						}else{
							$valid_access = 0;
						}
						break;
					case 5: // Support user, Check if the ticket is assigned to the current user and he has access to the tickets workgroup
						$valid_access = 1;
						break;
					case 6: // Support team leader, Check if the ticket is assigned to the current user or unassigned and he has access to the tickets workgroup
						$valid_access = 1;
						break;
					case 7: // Support manager, Check if the current Support Manager has access to tickets workgroup
						$valid_access = 1;
						break;
					default:
						$valid_access = 0;
						break;
				}
			}
		
		// User is trying to register / edit profile
		}elseif( $check_type == 'U' && ( $task == 'profile' || $task == 'saveuseredit' ) ) { // $task=='new' $task=='saveregistration' $task=='activate' 
			$valid_access = 1;

		// Downloads
		}elseif( $check_type == 'D' ) {
			$valid_access = $workgroupSettings->wkdownloads;
		
		// Glossary
		}elseif( $check_type == 'G' ) {
			$valid_access = $workgroupSettings->wkglossary;
			if( ( $task == 'addglossary' || $task == 'editglossary' || $task == 'saveglossary' ) && !$is_support ) {
				$valid_access = 0;
			}
			
		// Announcements
		}elseif( $check_type == 'A' ) {
			$valid_access = $workgroupSettings->wkannounces;

		}elseif( $check_type == 'TM' ) {
			switch ($usertype) {
				case 5: // Support user, Check if the ticket is assigned to the current user and he has access to the tickets workgroup
				case 6: // Support team leader, Check if the ticket is assigned to the current user or unassigned and he has access to the tickets workgroup
				case 7: // Support manager, Check if the current Support Manager has access to tickets workgroup
					$valid_access = 1;
					break;
				
				case 2: // Client Manager, Check if the ticket belongs to current users client company
					$valid_access = 0;
					break;
			}
		}
		
		!$valid_access ? $task = 'noaccess' : '';
		return $valid_access;
	}

	function noAccessQuit()
	{
		global $Itemid, $task, $id_workgroup;

		$database = JFactory::getDBO();

		// Initialize Template Engine
		if ($task == 'nocontract') {
			$tmplfile = 'no_contract_active';
		} else {
			$tmplfile = 'access_denied';
		}
		
		$tmpl_code->htmlcode = getSCTemplate( '', $id_workgroup, 'general/'.$tmplfile );
		
		$title = JText::_('access_denied');

		echo $tmpl_code->htmlcode;
	}

	/**
	* Offloads jscripts from other files
	* to retreive just call as so:   echo getJScript('GetLabourTime');
	*
	*/
	function getJScript ( $jscript, $param1='', $param2='', $param3='' ){
		switch ($jscript)
		{

			case 'Cancel':
				return 'function Cancel() { if (confirm("'.JText::_('tmpl_ticket_cancelquestion').'")) { javascript:history.go(-1); } }'."\n";
				break;

			case 'GetLabourTime':
				return '<script type="text/javascript" defer="defer" >'."\n"
				.'function GetLabourTime() {'."\n"
					.'starttime = document.adminForm.start_time.value;'."\n"
					.'endtime = document.adminForm.end_time.value;'."\n"
					.'breaktime = document.adminForm.break_time.value;'."\n"

					.'var hours_starttime = starttime.substring(0, 2);'."\n"
					.'var mins_starttime = starttime.substring(3, 5);'."\n"
					.'var hours_endtime = endtime.substring(0, 2);'."\n"
					.'var mins_endtime = endtime.substring(3, 5);'."\n"
					.'var hours_breaktime = breaktime.substring(0, 2);'."\n"
					.'var mins_breaktime = breaktime.substring(3, 5);'."\n"

					.'var starttime_decim = (hours_starttime*1) + (mins_starttime / 60);'."\n"
					.'var endtime_decim = (hours_endtime*1) + (mins_endtime / 60);'."\n"
					.'var breaks_decim = (hours_breaktime*1) + (mins_breaktime / 60);'."\n"
					.'var replytime_decim = (endtime_decim - starttime_decim) - (breaks_decim);'."\n"

					.'if( (replytime_decim < 0) && starttime!=endtime && breaks_decim==0 ) {'."\n"
						.'document.adminForm.end_time.value = document.adminForm.start_time.value;'."\n"
						.'starttime = document.adminForm.start_time.value;'."\n"
						.'endtime = document.adminForm.end_time.value;'."\n"
						.'breaktime = document.adminForm.break_time.value;'."\n"

						.'var hours_starttime = starttime.substring(0, 2);'."\n"
						.'var mins_starttime = starttime.substring(3, 5);'."\n"
						.'var hours_endtime = endtime.substring(0, 2);'."\n"
						.'var mins_endtime = endtime.substring(3, 5);'."\n"
						.'var hours_breaktime = breaktime.substring(0, 2);'."\n"
						.'var mins_breaktime = breaktime.substring(3, 5);'."\n"

						.'var starttime_decim = (hours_starttime*1) + (mins_starttime / 60);'."\n"
						.'var endtime_decim = (hours_endtime*1) + (mins_endtime / 60);'."\n"
						.'var breaks_decim = (hours_breaktime*1) + (mins_breaktime / 60);'."\n"
						.'var replytime_decim = (endtime_decim - starttime_decim) - (breaks_decim);'."\n"
					.'}'."\n"

					.'if( replytime_decim > 0 ) {'."\n"
						.'var replytime_hours = Math.floor(replytime_decim);'."\n"
						.'var replytime_mins = (replytime_decim - replytime_hours) * 60;'."\n"
					.'} else {'."\n"
						.'var replytime_hours = Math.ceil(replytime_decim);'."\n"
						.'var replytime_mins = ( (replytime_decim*(-1)) - (replytime_hours*(-1)) ) * 60;'."\n"
					.'}'."\n"

					.'if( replytime_decim < 0 && replytime_hours == 0 ) {'."\n"
						.'var neg_hhmm = "-";'."\n"
					.'} else {'."\n"
						.'var neg_hhmm = "";'."\n"
					.'}'."\n"

					.'replytime_mins = Math.round(replytime_mins);'."\n"
					
					.'if( replytime_mins < 10 ) {'."\n"
						.'replytime_mins = "0" + replytime_mins;'."\n"
					.'}'."\n"

					.'var replytime_hhmm = neg_hhmm + replytime_hours + \':\' +  replytime_mins;'."\n"

					.'document.adminForm.replytime.value =replytime_hhmm;'."\n"

					.'if( replytime_decim < 0 ) {'."\n"
						.'alert("'. JText::_('labour_negative') .'");'."\n"
						.'document.adminForm.break_time.value = "00:00";'."\n"
						.'GetLabourTime();'."\n"
					.'}'."\n"

				.'}'."\n"
				.'$jMaQma(document).ready(function() {'."\n"
				.'GetLabourTime();'."\n"
				.'});'."\n"
				.'</script>';
			break;

			case 'GetLabourTimeTasks':
				return '<script type="text/javascript">'."\n"
				.'function GetLabourTimeTasks() {'."\n"
					.'starttime = $jMaQma("div#facebox .popup .content p").find("#taskstart").val();'."\n"
					.'endtime = $jMaQma("div#facebox .popup .content p").find("#taskend").val();'."\n"
					.'breaktime = $jMaQma("div#facebox .popup .content p").find("#taskbreak").val();'."\n"

					.'var hours_starttime = starttime.substring(0, 2);'."\n"
					.'var mins_starttime = starttime.substring(3, 5);'."\n"
					.'var hours_endtime = endtime.substring(0, 2);'."\n"
					.'var mins_endtime = endtime.substring(3, 5);'."\n"
					.'var hours_breaktime = breaktime.substring(0, 2);'."\n"
					.'var mins_breaktime = breaktime.substring(3, 5);'."\n"

					.'var starttime_decim = (hours_starttime*1) + (mins_starttime / 60);'."\n"
					.'var endtime_decim = (hours_endtime*1) + (mins_endtime / 60);'."\n"
					.'var breaks_decim = (hours_breaktime*1) + (mins_breaktime / 60);'."\n"
					.'var replytime_decim = (endtime_decim - starttime_decim) - (breaks_decim);'."\n"

					.'if( (replytime_decim < 0) && starttime!=endtime && breaks_decim==0 ) {'."\n"
						.'$jMaQma("div#facebox .popup .content p").find("#taskend").val( $jMaQma("div#facebox .popup .content p").find("#taskstart").val() );'."\n"
					.'}'."\n"

					.'if( replytime_decim > 0 ) {'."\n"
						.'var replytime_hours = Math.floor(replytime_decim);'."\n"
						.'var replytime_mins = (replytime_decim - replytime_hours) * 60;'."\n"
					.'} else {'."\n"
						.'var replytime_hours = Math.ceil(replytime_decim);'."\n"
						.'var replytime_mins = ( (replytime_decim*(-1)) - (replytime_hours*(-1)) ) * 60;'."\n"
					.'}'."\n"

					.'if( replytime_decim < 0 && replytime_hours == 0 ) {'."\n"
						.'var neg_hhmm = "-";'."\n"
					.'} else {'."\n"
						.'var neg_hhmm = "";'."\n"
					.'}'."\n"

					.'replytime_mins = Math.round(replytime_mins*Math.pow(10,0))/Math.pow(10,0);'."\n"

					.'if( replytime_mins == "0" ) {'."\n"
						.'replytime_mins = "00";'."\n"
					.'} else if( replytime_mins < 10 ){'."\n"
						.'replytime_mins = "0"+replytime_mins;'."\n"
					.'}'."\n"
					
					.'var replytime_hhmm = neg_hhmm + replytime_hours + \':\' + replytime_mins;'."\n"

					.'$jMaQma("div#facebox .popup .content p").find("#tasktime").val(replytime_hhmm);'."\n"

					.'if( replytime_decim < 0 ) {'."\n"
						.'alert("'. JText::_('labour_negative') .'");'."\n"
						.'$jMaQma("div#facebox .popup .content p").find("#taskbreak").val("00:00");'."\n"
						.'GetLabourTime();'."\n"
					.'}'."\n"

				.'}'."\n"
				.'</script>';
			break;

			case 'JSValidDueDate':
				return 'function JSValidDueDate() {'."\n"
					  .'	valor = document.adminForm.duedate_date.value;'."\n"
					  .'	valor = valor.split("-");'."\n"
					  .'	var DAY = valor[2]'."\n"
					  .'	var MONTH = valor[1];'."\n"
					  .'	var YEAR = valor[0];'."\n"
					  .'	'."\n"
					  .'	if( MONTH < 1 || MONTH > 12 ) {'."\n"
					  .'		alert( "'.JText::_('invalid_month').'" );'."\n"
					  .'		return false;'."\n"
					  .'	}'."\n"
					  .'	'."\n"
					  .'	if( YEAR < 2000 || YEAR > '.(dateOffset("Y")+1).' ) {'."\n"
					  .'		alert( "'.JText::_('invalid_year').'" );'."\n"
					  .'		return false;'."\n"
					  .'	}'."\n"
					  .'	month_days = IsLeap( YEAR, MONTH );'."\n"
					  .'	if( DAY < 1 || DAY > month_days ) {'."\n"
					  .'		alert( "'.JText::_('invalid_day').'" );'."\n"
					  .'		return false;'."\n"
					  .'	}'."\n"
					  .'	valor = document.adminForm.duedate_hours.value;'."\n"
					  .'	var MINUTES = valor.substring(3, 5);'."\n"
					  .'	var HOURS = valor.substring(0, 2);'."\n"
					  .'	if( MINUTES < 0 || MINUTES > 59 ) {'."\n"
					  .'		alert( "'.JText::_('invalid_minutes').'" );'."\n"
					  .'		return false;'."\n"
					  .'	}'."\n"
					  .'	'."\n"
					  .'	if( HOURS < 0 || HOURS > 23 ) {'."\n"
					  .'		alert( "'.JText::_('invalid_hours').'" );'."\n"
					  .'		return false;'."\n"
					  .'	}'."\n"
					  .'	return true;'."\n"
					  .'}'."\n"
					. '	function IsLeap( ano, mes ) {'."\n"
					. '		var IsLeap = parseInt( ano );'."\n"
					. '		IsLeap = !( IsLeap % 4 ) && ( ( IsLeap % 100 ) || !( IsLeap % 400 ) );'."\n"
					. '		IsLeap = [31,(IsLeap?29:28),31,30,31,30,31,31,30,31,30,31][mes-1];'."\n"
					. '		return IsLeap;'."\n"
					. '	}'."\n"
					. ''."\n";
					  
				break;

			case 'JSSetDueDate':
				return ' var year2 = Math.round('.dateOffset("Y").')'."\n"
					. '	var month2 = Math.round(trimNumber('.dateOffset("m").'))'."\n"
					. '	var day2 = Math.round(trimNumber('.dateOffset("d").'))'."\n"
					. '	var hours2 = Math.round(trimNumber('.dateOffset("H").'))'."\n"
					. '	var mins2 = Math.round(trimNumber('.dateOffset("i").'))'."\n"
					. ''."\n\n"
					. '	function JSSetDueDate() {'."\n"
					. '		var HOURSObj = document.adminForm.duedate_hours ;'."\n"
					. '		var form = document.adminForm;'."\n"
					. '		var DUEDATE = "";'."\n"
					. '		var PRIORITYObj = form.id_priority ;'."\n"
					. '		var year = year2;'."\n"
					. '		var month = month2;'."\n"
					. '		var day = day2;'."\n"
					. '		var hours = hours2; '."\n"
					. '		var mins = mins2;'."\n"
					. '		'."\n"
					. '		var j = 0 ;'."\n"
					. '		for(var i=0; i<PRIORITYObj.length; i++) {'."\n"
					. '			if(PRIORITYObj[j].selected == true) {'."\n"
					. '				 DUEDATE = PRIORITYObj[i].text;'."\n"
					. '			}'."\n"
					. '			'."\n"
					. '			j++ ;'."\n"
					. '		}'."\n"
					. '		'."\n"
					. '		var j = 0 ;'."\n"
					. '		var iPos = 0;'."\n"
					. '		var ePos = 0;'."\n"
					. '		'."\n"
					. '		for(var i=0; i<DUEDATE.length; i++) {'."\n"
					. '			if( DUEDATE.substring(i, i+1) == "(" ) {'."\n"
					. '				var iPos = i;'."\n"
					. '			}else if( DUEDATE.substring(i, i+1) == ")" ) {'."\n"
					. '				var ePos = i;'."\n"
					. '			}'."\n"
					. '		}'."\n"
					. ''."\n"
					. '		TIME_VALUE = DUEDATE.substring(iPos+1, ePos-2) ;'."\n"
					. '		TIME_UNIT  = DUEDATE.substring(ePos-1, DUEDATE.length-1) ;'."\n"
					. ''."\n"
					. '		if( TIME_UNIT == "D" ) {'."\n"
					. '			day = Math.round(day) + Math.round(TIME_VALUE);'."\n"
					. '		}else if( TIME_UNIT == "H" ) {'."\n"
					. '			hours = Math.round(hours) + Math.round(TIME_VALUE) ;'."\n"
					. '		}'."\n"
					. ''."\n"
					. '		month_days = IsLeap( year, month );'."\n"
					. '		if( day > month_days ) {'."\n"
					. '			day = day - month_days;'."\n"
					. '			month = month + 1;'."\n"
					. '		}'."\n"
					. '		'."\n"
					. '		if( hours >= 24 ) {'."\n"
					. '			hours = hours - 24;'."\n"
					. '			day = day + 1;'."\n"
					. '		}'."\n"
					. '		'."\n"
					. '		if( mins >= 0 && mins <=15 ) {'."\n"
					. '			mins = "15";'."\n"
					. '		}else if( mins >= 16 && mins <=30 ) {'."\n"
					. '			mins = "30";'."\n"
					. '		}else if( mins >= 31 && mins <=45 ) {'."\n"
					. '			hours = hours + 1;'."\n"
					. '			mins = "45";'."\n"
					. '		}else if( mins >= 45 && mins <=59 ) {'."\n"
					. '			hours = hours + 1;'."\n"
					. '			mins = "00";'."\n"
					. '		}'."\n"
					. ''."\n"
					. '		if( hours < 10 ) {'."\n"
					. '			hours = "0" + hours;'."\n"
					. '		}'."\n"
					. ''."\n"
					. '		if( month > 12 ) {'."\n"
					. '			month = (month - 12);'."\n"
					. '			year = (year + 1);'."\n"
					. '		}'."\n"
					. ''."\n"
					. '		if( month < 10 ) {'."\n"
					. '			month = "0" + month;'."\n"
					. '		}'."\n"
					. ''."\n"
					. '		if( day < 10 ) {'."\n"
					. '			day = "0" + day;'."\n"
					. '		}'."\n"
					. ''."\n"
					. '		document.adminForm.duedate_date.value = year + "-" + month + "-" + day ;'."\n"
					. ''."\n"
					. '		var HOURSObj = document.adminForm.duedate_hours ;'."\n"
					. '		'."\n"
					. '		var j = 0 ;'."\n"
					. '		for(var i=0; i<HOURSObj.length; i++) {'."\n"
					. '			if(HOURSObj[j].value == hours + ":" + mins) {'."\n"
					. '				 HOURSObj[j].selected = true;'."\n"
					. '			}'."\n"
					. '			'."\n"
					. '			j++ ;'."\n"
					. '		}'."\n"
					. '	}'."\n"
					. ''."\n"
					. '	function IsLeap( ano, mes ) {'."\n"
					. '		var IsLeap = parseInt( ano );'."\n"
					. '		IsLeap = !( IsLeap % 4 ) && ( ( IsLeap % 100 ) || !( IsLeap % 400 ) );'."\n"
					. '		IsLeap = [31,(IsLeap?29:28),31,30,31,30,31,31,30,31,30,31][mes-1];'."\n"
					. '		return IsLeap;'."\n"
					. '	}'."\n"
					. ''."\n";
				break;
		}
	}

	/**
	* Inserts a ticket reply
	* @param database A database connector object
	* @param string The reply message
	* @param integer Indicates if the reply is billable time or not
	* @param integer Indicates the time used
	*/
	function ticketReply( $id, $reply_summary, $reply_msg, $replytime=0, $travel_time=0, $tickettravel=0, $clientrate=0, $activity_rate=0, $activity_type=0, $start_time=0, $end_time=0, $break_time=0, $reply_date='', $reply_hours='' ) {
		global $wkoptions;

		$database = JFactory::getDBO();
		$user = JFactory::getUser();

		/*if( $replytime != "0" && $replytime != getTotalTime($start_time, $end_time, $break_time) ) {
			$debugmsg = '$replytime:'. $replytime .'<br />'.getTotalTime($start_time, $end_time, $break_time).'<br /><br />.$start_time:'. $start_time .'<br />$end_time:'. $end_time .'<br />$break_time:'. $break_time;
			putGlobalMessage( JText::_('err_timecals'), 'e',$debugmsg  );
			return false;
		}pdg*/

		if( $reply_date != '' ) {
			$reply_date = $reply_date.' '.$reply_hours;
		} else {
			$reply_date = dateOffset("Y-m-d H:i:s");
		}

			// For new tickets the system doesnt send the clientrate variable
			// First, get the user of the ticket
			$database->setQuery( "SELECT id_user FROM #__support_ticket WHERE id='".$id."'" );
			$client_user = $database->loadResult();
			// Second, get the rate of the client
			$database->setQuery( "SELECT c.rate FROM #__support_client c INNER JOIN #__support_client_users cu ON c.id=cu.id_client WHERE cu.id_user='".$client_user."'" );
			$clientrate = $database->loadResult();
			// Third, get the multiplier of the activity rate
			$database->setQuery( "SELECT multiplier FROM #__support_activity_rate WHERE id='".$activity_rate."'" );
			$multiplier = $database->loadResult();

			$sql = "INSERT INTO #__support_ticket_resp(id_ticket, id_user, `date`, message, timeused, travel_time, tickettravel, id_activity_rate, id_activity_type, user_rate, start_time, end_time, break_time, reply_summary) 
					VALUES('".$id."', '".$user->id."', '".$reply_date."', ".$database->quote( $reply_msg ).", ".$database->quote(str_replace(':', '.', $replytime)).", ".$database->quote($travel_time).", ".$database->quote(str_replace(':','.',$tickettravel)).", '".$activity_rate."', '".$activity_type."', '".$clientrate."', ".$database->quote($start_time).", ".$database->quote($end_time).", ".$database->quote($break_time).", ".$database->quote( $reply_summary ).")";
			$database->setQuery( $sql );
			$database->query();

			if( $database->getErrorMsg() == '' ) {
				// Update Contracts
				$contract = getContract( $client_user );
				if( isset($contract) ) {
					if( $contract != false ) {
						switch( $contract->unit ) {
							case 'T' : 
								$database->setQuery( "UPDATE #__support_contract SET actual_value=(actual_value+1) WHERE id='".$contract->id."'" );
								if( !$database->query() ) {
									putGlobalMessage( JText::_('tkt_dberror').'<br />'.$database->getErrorMsg(), 'e', $database->stderr(1) );
									echo "<script type='text/javascript'> window.history.go(-1); </script>\n";
									exit();
								}
							case 'H' : 
								$database->setQuery( "UPDATE #__support_contract SET actual_value=(actual_value+".convHHMMtoDEC($replytime).") WHERE id='".$contract->id."'" );
								if( !$database->query() ) {
									putGlobalMessage( JText::_('tkt_dberror').'<br />'.$database->getErrorMsg(), 'e', $database->stderr(1) );
									echo "<script type='text/javascript'> window.history.go(-1); </script>\n";
									exit();
								}
						}

						makeContractInactive( $contract->id );
					}
				}
				// Calls the add-on's engine
				executeAddOns( 2, 0, $id, $database->insertid() );
				return true;
			} else {
				putGlobalMessage( 'Ticket reply not saved.<br />'.$database->getErrorMsg(), 'e', $database->stderr(1) );
				return false;
			}
	}

	function getAccess( $id_workgroup, $id_client ) {
		global $supportConfig;

		$database = JFactory::getDBO();

		$database->setQuery( "SELECT COUNT(*) FROM #__support_client_wk WHERE (id_workgroup='".$id_workgroup."' OR id_workgroup='0') AND id_client='".$id_client."'" );

		if( $database->loadResult() > 0 ) {
			$image = '<img src="components/com_maqmahelpdesk/images/16px/tick.png" border="0" align="absmiddle" />';
		}else{
			$image = '<img src="components/com_maqmahelpdesk/images/16px/no.png" border="0" align="absmiddle" />';
		}

		return $image;
	}

	// Displays required message based on user conf'd tempalte
	function showTplMessage( $msg, $id_workgroup=0 ) {
		$database = JFactory::getDBO();
		
		$msg = str_replace("%20", " ", $msg);
		$msg = str_replace("\'", "'", $msg);
		$tmpl_code->htmlcode = getSCTemplate( $msg, $id_workgroup, 'general/information_message' );
		//$tmpl_code->htmlcode = preg_replace('/<lang:(.*?) \/>/ies', 'fetchLanguage(\'\\1\')', $tmpl_code->htmlcode);
		//$tmpl_code->htmlcode = str_replace("<tag:message />", $msg, $tmpl_code->htmlcode);
		
		echo $tmpl_code->htmlcode;
	}

	// Displays fixed layout message, info, warn or error types
	function showSCMessage( $msg, $msgtype='i', $title=null ) 
	{
		$supportConfig = GetConfig();
		
		switch ($msgtype)
		{
			case 'i' :  // Information based messages
				$type = "info";
				break;
			case 'w':	// Warning based messages
				$type = "warning";
				break;
			case 'e':	// Error based messages
				$type = "error";
				break;
			case 's':	// Success based messages
				$type = "success";
				break;
		} 
		
		if( !$supportConfig->growl_notifications ) { ?>
			<div class="maqmamsg <?php echo $type;?>"> 
				<h3><?php echo $title;?></h3> 
				<p><?php echo $msg;?></p> 
			</div><?php
		}else{ ?>
			<script type="text/javascript">
			$jMaQma(document).ready(function() { 
				$jMaQma.gritter.add({
					title: '<?php echo ( $title==null ? ucfirst($type) : $title );?>',
					text: "<?php echo urldecode($msg);?>",
					image: '<?php echo JURI::root();?>components/com_maqmahelpdesk/images/growl/<?php echo $type;?>.png',
					sticky: true, 
					time: '',
					class_name: 'my-sticky-class' 
				});
			});
			</script><?php
		}
	}

	function getRate( $id, $table, $image ) {
		global $supportConfig;
		
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT (SUM(rate)/COUNT(id)) AS rating FROM #__support_rate WHERE id_table='".$id."' AND source=".$database->quote($table) );

		// Image
		if( $image == 1 ) {
			$rate = '<img src="'.JURI::root().'components/com_maqmahelpdesk/images/rating/'.number_format($database->loadResult(),0).'star.png" border="0" align="absmiddle" />';

		// PDF Image
		}elseif( $image == 2 ) {
			$rate = number_format($database->loadResult(),0);

		// Text
		}else{
			$rate = number_format($database->loadResult(),0);
		}

		return $rate;
	}

	function getVotes( $id, $table ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT COUNT(*) FROM #__support_rate WHERE id_table='".$id."' AND source=".$database->quote($table) );
		return $database->loadResult();
	}

	function getMessages( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT COUNT(*) FROM #__support_ticket_resp WHERE id_ticket='".$id."'" );
		return $database->loadResult();
	}

	function getActivityRate( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT description FROM #__support_activity_rate WHERE id='$id'" );
		return $database->loadResult();
	}

	function getActivityType( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT description FROM #__support_activity_type WHERE id='$id'" );
		return $database->loadResult();
	}

	function getAssign( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT name FROM #__users WHERE id='$id'" );
		return ( $database->loadResult() != '' ? $database->loadResult() : JText::_('ticket_unassigned_status') );
	}

	function getUser( $id ) {
		$database = JFactory::getDBO();
		
		$database->setQuery( "SELECT `name` FROM `#__users` WHERE `id`=".(int)$id );
		return $database->loadResult();
	}

	function getClient( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT c.clientname FROM #__support_client c, #__support_client_users u WHERE c.id=u.id_client AND u.id_user='$id'" );
		return ( $database->loadResult() != '' ? $database->loadResult() : JText::_('no_customer') );
	}

	function getClientID( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT c.id FROM #__support_client c, #__support_client_users u WHERE u.id_user='$id'" );
		return $database->loadResult();
	}

	function getArticleTitle( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT kbtitle FROM #__support_kb WHERE id='$id'" );
		return $database->loadResult();
	}

	function getTicketMask( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT ticketmask FROM #__support_ticket WHERE id='$id'" );
		return $database->loadResult();
	}

	/**
	* Returns the Workgroup Name
	* @param database A database connector object
	* @param string The name of the category section
	* @param array An array of unique category id numbers
	*/
	function getWorkgroup( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT wkdesc FROM #__support_workgroup WHERE id='$id'" );
		return $database->loadResult();
	}

	/**
	* Returns the Priority Name
	* @param database A database connector object
	* @param string The name of the category section
	* @param array An array of unique category id numbers
	*/
	function getPriority( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT description FROM #__support_priority WHERE id='$id'" );
		return $database->loadResult();
	}

	function getDefaultPriority() {
		global $workgroupSettings;
		
		if( $workgroupSettings->id_priority ) {
			$dfpriority = $workgroupSettings->id_priority;
		}else{
			$database = JFactory::getDBO();
			$database->setQuery( "SELECT id FROM #__support_priority WHERE isdefault='1'" );
			$dfpriority = $database->loadResult();
		}
		
		return $dfpriority;
	}

	/**
	* Returns the Status Name
	* @param database A database connector object
	* @param string The name of the category section
	* @param array An array of unique category id numbers
	*/
	function getStatus( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT description FROM #__support_status WHERE id='$id'" );
		return $database->loadResult();
	}

	function getDefaultStatus() {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT id FROM #__support_status WHERE isdefault='1'" );
		return $database->loadResult();
	}

	/**
	* Function that returns the due date
	* @param database A database connector object
	* @param string The name of the category section
	* @param array An array of unique category id numbers
	*/
	function ReturnDueDate( $year, $month, $day, $hour, $minute, $priority ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT * FROM #__support_priority WHERE id='$priority'" );
		$hours = null;
		$hours = $database->loadObject();

		$due_date = mktime( $hour+($hours->timeunit=='H' ? $hours->timevalue : 0), $minute, 0, $month, $day+($hours->timeunit=='D' ? $hours->timevalue : 0), $year );

		return date("Y-m-d H:i", $due_date);
	}

	/**
	* Returns the Status Name
	* @param database A database connector object
	* @param string The name of the category section
	* @param array An array of unique category id numbers
	*/
	function getStatusGroup( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT status_group FROM #__support_status WHERE id='$id'" );
		return $database->loadResult();
	}

	function isDueDateValid( $duedate, $priority, $status, $replies, $assign, $style ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT status_group FROM #__support_status WHERE id='$status'" );
		$status = $database->loadResult();

		$due_date = mktime( substr($duedate, 11, 2), substr($duedate, 14, 2), 0, substr($duedate, 5, 2), substr($duedate, 8, 2), substr($duedate, 0, 4) );
		$cur_date = mktime( dateOffset("H"), dateOffset("i"), 0, dateOffset("m"), dateOffset("d"), dateOffset("Y") );

		if( $status == 'C' ) {
			$img = '16px/tick.png';
			$alt = JText::_('icon_closed');
		}elseif( $assign > 0 && $due_date <= $cur_date ) {
			$img = '16px/clock.png';
			$alt = JText::_('icon_overdue');
		}elseif( $assign > 0 && $due_date >= $cur_date ) {
			$img = '16px/hour.png';
			$alt = JText::_('icon_progress');
		}elseif( $assign == 0 ) {
			$img = '16px/alert.png';
			$alt = JText::_('icon_onhold');
		}

		switch ($style)
		{
			case '0': return ' <img src="'.JURI::root().'components/com_maqmahelpdesk/images/'.$img.'" border="0" align="absmiddle" alt="'.$alt.'" /> ';
			case '1': return $alt;
			case '2': return $img;
		}
	}

	function isDueDateValidBoolean( $duedate ) {
		$due_date = mktime( substr($duedate, 11, 2), substr($duedate, 14, 2), 0, substr($duedate, 5, 2), substr($duedate, 8, 2), substr($duedate, 0, 4) );
		$cur_date = mktime( dateOffset("H"), dateOffset("i"), 0, dateOffset("m"), dateOffset("d"), dateOffset("Y") );

		if( $due_date <= $cur_date ) {
			return false;
		}else{
			return true;
		}
	}

	function GetConfig() {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT * FROM #__support_config WHERE id='1'" );
		$supportConfig = $database->loadObject();

		return $supportConfig;
	}

	// DUE DATE    - year, month, day, hour, minute
	// TICKET DATE - year, month, day, hour, minute
	function elapsedTime( $year, $month, $day, $hour, $minute, $year2, $month2, $day2, $hour2, $minute2 ) {
		$dif_month = 0;
		$dif_days  = 0;
		$dif_hours = 0;
		$dif_mins  = 0;

		$now = mktime( $hour2, $minute2, 0, $month2, $day2, $year2 ); // 2005-03-06 19:35
		$due = mktime( $hour, $minute, 0, $month, $day, $year ); // 2005-03-30 15:12

		$dif = $due - $now;

		if( $dif < 0 ) {
			$dif = $now - $due;
			$prefix = '';
		}

		$dif_month = date("m", $dif) - 1;
		$dif_month = ($dif_month > 0 ? "$dif_month<small>".JText::_('times_months')."</small>" : '');

		$dif_days = date("d", $dif) - 1;
		$dif_days = ($dif_days > 0 ? "$dif_days<small>".JText::_('times_days')."</small>" : '');

		$dif_hours = date("H", $dif);
		$dif_hours = ($dif_hours > 0 ? "$dif_hours<small>".JText::_('times_hours')."</small>" : '');

		$dif_mins = date("i", $dif);
		$dif_mins = ($dif_mins > 0 ? "$dif_mins<small>".JText::_('times_mins')."</small>" : '');
		
		return $dif_month . ($dif_days > 0 ? ($dif_month > 0 ? ' ' : '') . $dif_days : '') . ($dif_hours > 0 ? ($dif_days > 0 ? ' ' : '') . $dif_hours : '') . ($dif_mins != 0 ? ($dif_hours > 0 ? ' ' : '') . $dif_mins : '');
	}
	
	function mqm_time_difference($date)
	{
		$periods = array(JText::_('seconds'), JText::_('minutes'), JText::_('hours'), JText::_('times_days'), JText::_('weeks'), JText::_('months'), JText::_('years'), "decade");
		$lengths = array("60","60","24","7","4.35","12","10");
	 
		$now = timestampOffset();
		$unix_date = strtotime($date);
	 
		// is it future date or past date
		if($now > $unix_date) {
			$difference = $now - $unix_date;
			$tense = JText::_("ago");
		} else {
			$difference = $unix_date - $now;
			$tense = JText::_("from_now");
		}
	 
		for($j = 0; $difference >= $lengths[$j] && $j < count($lengths)-1; $j++) {
			$difference /= $lengths[$j];
		}
	 
		$difference = round($difference);
	 
		/*if($difference != 1) {
			$periods[$j].= "s";
		}*/
	 
		return $difference.' <small>'.strtolower($periods[$j])." {$tense}</small>";
	}

	/**
	* Returns the ID of the new active contract
	* @param database A database connector object
	* @param string The name of the category section
	* @param array An array of unique category id numbers
	*/
	function makeContractActive( $id, $time ) 
	{
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT * FROM #__support_contract WHERE id_client='".$id."' AND status='I'" );
		$contracts = $database->loadObjectList();

		if( count($contracts) == 0 ) {
			return 0;
		}else{
			for($i=0; $i<count($contracts); $i++) {
				$contract = $contracts[$i];
				$today_date = mktime(0, 0, 0, dateOffset("m"), dateOffset("d"), dateOffset("Y"));
				$end_date   = mktime(0, 0, 0, substr($contract->date_end, 5, 2), substr($contract->date_end, 8, 2), substr($contract->date_end, 0, 4));
				$start_date = mktime(0, 0, 0, substr($contract->date_start, 5, 2), substr($contract->date_start, 8, 2), substr($contract->date_start, 0, 4));

				//print "<p>id: $contract->id<br>end_date: $end_date<br>today_date: $today_date<br>start_date: $start_date<br>contract->end_date: $contract->date_end<br>contract->unit: $contract->unit";

				if( $end_date >= $today_date && $start_date <= $today_date && $contract->date_end != '0000-00-00' && ( $contract->unit == 'Y' || $contract->unit == 'M' || $contract->unit == 'D' ) ) {
					$database->setQuery( "UPDATE #__support_contract SET status='A' WHERE id='".$contract->id."'" );
					$database->query();
					//return $contract->id;
					return true;

				}elseif( $end_date >= $today_date && $start_date <= $today_date && $contract->value > $contract->actual_value && ( $contract->unit == 'T' || $contract->unit == 'H' ) ) {
					$database->setQuery( "UPDATE #__support_contract SET status='A', actual_value=(actual_value+".($contract->unit=='T' ? 0 : $time).") WHERE id='".$contract->id."'" );
					$database->query();
					return true;

				}
			}
		}

		return false;
	}

	/**
	* Checks if contract must be inactive
	* @param database A database connector object
	* @param string The name of the category section
	* @param array An array of unique category id numbers
	*/
	function makeContractInactive( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT * FROM #__support_contract WHERE id='".$id."'" );
		$contract = null;
//		$database->loadObject( $contract );
		$contract = $database->loadObject();
		
		// Contract is turned Inactive
		if( $contract->value <= $contract->actual_value ) {
			$database->setQuery( "UPDATE #__support_contract SET status='I' WHERE id='".$id."'" );
			$database->query();
			return true;
		
		// Contract maintains Active
		}else{
			return false;
		}
	}

	function getNumberOfDays( $year, $month ) {
		switch( $month )
		{
			case "01":
			case 1:
				return 31;
				break;

			case "02":
			case 2:
				return days_in_feb( $year );
				break;

			case "03":
			case 3:
				return 31;
				break;

			case "04":
			case 4:
				return 30;
				break;

			case "05":
			case 5:
				return 31;
				break;

			case "06":
			case 6:
				return 30;
				break;

			case "07":
			case 7:
				return 31;
				break;

			case "08":
			case 8:
				return 31;
				break;

			case "09":
			case 9:
				return 30;
				break;

			case "10":
				return 31;
				break;

			case "11":
				return 30;
				break;

			case "12":
				return 31;
				break;
		}
	}

	function days_in_feb( $year ){
		//$year must be YYYY
		//[gregorian] leap year math :

		if ($year < 0) $year++;
		$year += 4800;

		if ( ($year % 4) == 0) {
		   if (($year % 100) == 0) {
			   if (($year % 400) == 0) {
				   return(29);
			   } else {
				   return(28);
			   }
		   } else {
			   return(29);
		   }
		} else {
		   return(28);
		}
	}

	/**
	* Writes a list of the categories
	* @param array An array of category objects
	* @param string The name of the category section
	*/
	function WriteField( $ticketId, $fid, $ftype, $fvalue, $fsize, $fmax, $user=0, $form=0, $exclude=0, $contract=0, $showonly=0, $ftooltip='' ) {
		global $is_support, $id_workgroup, $sysmsgs_user_location, $is_client;

		$database = JFactory::getDBO();
		$logged = JFactory::getUser();
		$supportConfig = GetConfig();
		$editor = JFactory::getEditor();

		$field = '';
		$fieldSel = '';
		
		$filter = $user ? $user : ($form ? $form : ($contract ? $contract : $ticketId));
		
		if( $user ) {
			$database->setQuery( "SELECT `value` FROM #__support_user_values WHERE id_field='".$fid."' AND id_user='".$filter."'" );
		}elseif( $form ) {
			$database->setQuery( "SELECT `value` FROM #__support_form_field WHERE id='".$fid."' AND id_form='".$form."'" );
		}elseif( $contract ) {
			$database->setQuery( "SELECT `value` FROM #__support_contract_fields_values WHERE id_field='".$fid."' AND id_contract='".$contract."'" );
		}else{
			$database->setQuery( "SELECT newfield FROM #__support_field_value WHERE id_field='".$fid."' AND id_ticket='".$filter."'" );
		}
		$record_value = $database->loadResult();

		if( $showonly ) {
			return $record_value;
		}
		
		if( !$exclude || $sysmsgs_user_location == 'a' || $is_support || $form > 0 ) {
			// Textbox
			if($ftype=="text") {
				$field .= '<input type="text" id="custom'.$fid.'" name="custom'.$fid.'" value="'.($filter > 0 ? $record_value : $fvalue).'" style="width:'.$supportConfig->field_width.'px;" maxlength="'.$fmax.'" class="inputbox" />';

			// Readonly
			}elseif($ftype=="readonly") {
				$field .= '<input type="hidden" id="custom'.$fid.'" name="custom'.$fid.'" value="'.($filter > 0 ? $record_value : $fvalue).'" style="width:'.$supportConfig->field_width.'px;" maxlength="'.$fmax.'" class="inputbox" readonly />'.($filter > 0 ? $record_value : $fvalue);

			// Hidden
			}elseif($ftype=="hidden") {
				$field .= '<input type="hidden" id="custom'.$fid.'" name="custom'.$fid.'" value="'.($filter > 0 ? $record_value : $fvalue).'" />';
				
			// Radio Button
			}elseif($ftype=="radio") {
				$selectOptions = array();
				$selectOptions = explode(",", $fvalue);
				for($z=0; $z<count($selectOptions); $z++) {
					$field .= "<input type='radio' name='custom".$fid."' id='custom".$fid."_".preg_replace('/[^A-Za-z0-9_]/', '_', trim($selectOptions[$z]))."' value='".$selectOptions[$z]."'".($record_value==$selectOptions[$z] ? " checked" : "")." /> ".$selectOptions[$z];
					$field .= "&nbsp;&nbsp;&nbsp;";
				}

			// Checkbox
			}elseif($ftype=="checkbox") {
				$selectOptions = array();
				$selectOptions = explode(",", $fvalue);
				array_walk($selectOptions,'trim');
				$record_value2 = explode (",",$record_value);
				
				for($z=0; $z<count($selectOptions); $z++) {
					$field .= "<input type='checkbox' id='custom".$fid."_".preg_replace('/[^A-Za-z0-9_]/', '_', trim($selectOptions[$z]))."'  name='custom".$fid."[]' value='".$selectOptions[$z]."'".(in_array($selectOptions[$z],$record_value2) ? " checked" : "")." /> ".$selectOptions[$z];
					$field .= "&nbsp;&nbsp;&nbsp;";
				}

			// Dropdown
			}elseif($ftype=="select") {
				$field .= '<select id="custom'.$fid.'" name="custom'.$fid.'" class="inputbox">';
				$selectOptions = array();
				$selectOptions = explode(",", $fvalue);
				for($z=0; $z<count($selectOptions); $z++) {
					$selectOptions[$z] = trim($selectOptions[$z]);
					if( $selectOptions[$z] == $record_value ) {
						$fieldSel = ' selected';
					}else{
						$fieldSel = '';
					}
					$field .= '<option value="'.$selectOptions[$z].'"'.$fieldSel.'>'.$selectOptions[$z].'</option>';
				}
				$field .= '</select>';
			
			// Database Dropdown
			}elseif($ftype=="dbselect") {
				$field .= '<select id="custom'.$fid.'" name="custom'.$fid.'" class="inputbox">';
				
				if( strpos($fvalue, '|') === false ) {
					$sql = $fvalue;
					if( $ticketId ) {
						$sql = "SELECT id_client, id_user 
								FROM #__support_field_value 
								WHERE id_field='".$fid."' AND id_ticket='".$filter."'";
						$database->setQuery( $sql );
						$ticket_details = $database->loadObject();
						$ticket_client = $ticket_details->id_client;
						$ticket_user = $ticket_details->id_user;
					}else{
						$ticket_client = $is_client;
						$ticket_user = $logged->id;
					}
					$sql = str_replace( '%user%', $ticket_user, $sql );
					$sql = str_replace( '%client%', $ticket_client, $sql );
				}else{
					$fvalue = explode( '|', $fvalue );
					$where = '';
					if( isset($fvalue[2]) && $fvalue[2]!='' ) {
						$where = 'WHERE '.$fvalue[2];
						if( $ticketId ) {
							$sql = "SELECT id_client, id_user 
									FROM #__support_field_value 
									WHERE id_field='".$fid."' AND id_ticket='".$filter."'";
							$database->setQuery( $sql );
							$ticket_details = $database->loadObject();
							$ticket_client = $ticket_details->id_client;
							$ticket_user = $ticket_details->id_user;
						}else{
							$ticket_client = $is_client;
							$ticket_user = $logged->id;
						}
						$where = str_replace( '%user%', $ticket_user, $where );
						$where = str_replace( '%client%', $ticket_client, $where );
					}
					$sql = "select trim(`".$fvalue[0]."`) as value 
							from `".$fvalue[1]."` ".
							$where."
							order by `".$fvalue[0]."`";
				}
				$sql = str_replace('\"', '"', $sql);
				$sql = str_replace("\'", "'", $sql);
				$database->setQuery( $sql );
				$rows = $database->loadObjectList();
				
				for( $i=0; $i<count($rows); $i++ )
				{
					$row = $rows[$i];
					if( $row->value == $record_value ) {
						$fieldSel = ' selected';
					}else{
						$fieldSel = '';
					}
					$field .= '<option value="'.$row->value.'"'.$fieldSel.'>'.$row->value.'</option>';
				}
				$field .= '</select>';

			// Date
			}elseif($ftype=="date") {
				ob_start();
				echo JHTML::Calendar(($filter > 0 ? $record_value : $fvalue), 'custom'.$fid, 'custom'.$fid, '%Y-%m-%d', array('class'=>'inputbox', 'size'=>'12',  'maxlength'=>'10')); 
				$field .= ob_get_contents();
				ob_end_clean();
				
			// Textarea
			}elseif($ftype=="textarea") {
				$field .= '<textarea id="custom'.$fid.'" name="custom'.$fid.'" class="inputbox" style="width:'.$supportConfig->field_width.'px;" rows="7">'.($filter > 0 ? $record_value : $fvalue)."</textarea>";

			// HTML Editor
			}elseif($ftype=="htmleditor") {
				ob_start();
				echo $editor->display( "custom".$fid, ($filter > 0 ? $record_value : $fvalue), $fsize, '100', '5', '50', array('pagebreak', 'readmore') ) ;
				$htmlcode = ob_get_contents();
				$field .= $htmlcode;
				ob_end_clean();
				
			// Country
			}elseif($ftype=="country") {
				ob_start();
				include( JPATH_SITE.'/components/com_maqmahelpdesk/includes/countries.php' );
				$field .= ob_get_contents();
				ob_end_clean();
				
			// State
			}elseif($ftype=="state") {
				$field .= "state field here...";
				
			// Note
			}elseif($ftype=="note") {
				$field .= $fvalue;

			}
		} else {
				$field .= ($filter > 0 ? $record_value : ($exclude ? '<i>'.JText::_('field_not_editable').'</i>' : $fvalue))."<input type='hidden' name='custom".$fid."' value='".($filter > 0 ? $record_value : ($exclude ? '' : $fvalue))."' />";
		}
		

		return $field;
	}

	/**
	* Generates and outputs the page title and pathway below it
	*
	*
	*/
	function pageTitle($currlocation, $title_extension='', $extra_details='') {
		global $supportConfig, $is_support, $is_client, $workgroupSettings, $supportOptions, $clientOptions, $id_workgroup, $client, $print;
		
		$mainframe = JFactory::getApplication();
		$database = JFactory::getDBO();
		$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );

		// Variables
		$title = '';
		$title_separator = " / ";
		$pathway = $mainframe->getPathway();
		
		// Generate highest level first (true for workgroup)
		$link = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid;
		
		// If inside a workgroup, add longer pathway links
		switch( $currlocation )
		{
			case "showWorkgroups":
				$pathway->addItem( getWorkgroup($id_workgroup) );
				break;
			case "showWorkgroup":
				$pathway->addItem( getWorkgroup($id_workgroup) );
				$title = getWorkgroup($id_workgroup);
				break;
			case "showTimesheet":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('timesheet') );
				$title = JText::_('timesheet');
				break;
			case "showClients":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_clients') );
				$title = JText::_('pathway_clients');
				break;
			case "viewClients":
				if( !$print && $is_support ) {
					$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
					$pathway->addItem( JText::_('pathway_clients'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=client_list') );
					$pathway->addItem( $client->clientname );
					$title = $client->clientname;
				} else {
					$title = $client->clientname;
				}
				break;
			case "showAnnounces":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_announcements') );
				$title = JText::_('pathway_announcements');
				break;
			case "viewAnnouncements":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_announcements'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=announce_list') );
				$pathway->addItem( $title_extension );
				$title = $title_extension;
				break;
			case "showKB":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				if( $title_extension == '' ) {
					$pathway->addItem( JText::_('pathway_kb') );
					$title = JText::_('pathway_kb');
				}else{
					$pathway->addItem( JText::_('pathway_kb'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=kb_list') );
					$pathway->addItem( $title_extension );
					$title = $title_extension;
				}
				break;
			case "showFAQ":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_faq') );
				$title = JText::_('pathway_faq');
				break;
			case "showMyKB":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_kb'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=kb_list') );
				$pathway->addItem( JText::_('pathway_myarticles') );
				$title = JText::_('pathway_myarticles');
				break;
			case "searchKB":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_kb'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=kb_list') );
				$pathway->addItem( JText::_('pathway_search') );
				$title = JText::_('pathway_search');
				break;
			case "showTicketsManager":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_tickets_manager') );
				$title = JText::_('pathway_tickets_manager');
				break;
			case 'showMyBookmarks':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_my_bookmarks') );
				$title = JText::_('pathway_my_bookmarks');
				break;
			case 'viewTicket':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_tickets'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=ticket_my') );
				$pathway->addItem( JText::_('pathway_view') );
				$title = $title_extension;
				break;
			case 'analysisTicket':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_view') );
				$title = $title_extension;
				break;
			case 'OpenTickets':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_view') );
				break;
			case 'newTicket':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_tickets'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=ticket_my') );
				$pathway->addItem( JText::_('pathway_new') );
				$title = JText::_('pathway_new');
				break;
			case 'userTickets':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_tickets'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=ticket_my') );
				$pathway->addItem( JText::_('pathway_user_tickets') );
				$title = JText::_('pathway_user_tickets');
				break;
			case 'Troubleshooter':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_troubleshooter') );
				$title = ( $title_extension!='' ? $title_extension : JText::_('pathway_troubleshooter') );
				break;
			case 'Glossary':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_glossary') );
				$title = JText::_('pathway_glossary');
				break;
			case 'viewKB':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_kb'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=kb_list') );
				$pathway->addItem( JText::_('pathway_view') );
				$title = $title_extension;
				break;
			case 'viewFAQ':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_faq'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=kb_faq') );
				$pathway->addItem( JText::_('pathway_view') );
				$title = $title_extension;
				break;
			case 'newKB':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_kb'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=kb_list') );
				$pathway->addItem( JText::_('pathway_new') );
				$title = JText::_('pathway_new');
				break;
			case 'editKB':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_kb'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=kb_list') );
				$pathway->addItem( JText::_('pathway_edit') );
				$title = $title_extension;
				break;
			case 'newGlossary':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_glossary'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=kb_glossary') );
				$pathway->addItem( JText::_('pathway_new') );
				$title = JText::_('pathway_new');
				break;
			case 'editGlossary':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_glossary'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=kb_glossary') );
				$pathway->addItem( JText::_('pathway_edit') );
				$title = $title_extension;
				break;
			case 'showCalendar':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_tasks') );
				$title = JText::_('pathway_tasks');
				break;
			case 'editCalendar':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_tasks'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=calendar_view') );
				$pathway->addItem( JText::_('pathway_edit') );
				$title = $title_extension;
				break;
			case 'showDownloads':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				if( $title_extension == '' ) {
					$pathway->addItem( JText::_('pathway_downloads') );
					$title = JText::_('pathway_downloads');
				}else{
					$pathway->addItem( JText::_('pathway_downloads'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=downloads') );
					$pathway->addItem( $title_extension );
					$title = $title_extension;
				}
				break;
			case 'showDownload':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_downloads'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=downloads') );
				$pathway->addItem( $extra_details[0], JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=downloads_category&id='.$extra_details[1]) );
				$pathway->addItem( $title_extension );
				$title = $title_extension;
				break;
			case 'showSubscriptions':
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_downloads'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=downloads') );
				$pathway->addItem( JText::_('pathway_subscriptions') );
				$title = JText::_('pathway_subscriptions');
				break;
			case "showUserForm":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('wk_profile') );
				$title = JText::_('wk_profile');
				break;
			case "showReportTickets":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('report_tickets') );
				$title = JText::_('report_tickets');
				break;
			case "anonymousTicketManager":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('pathway_tickets_manager') );
				$title = JText::_('pathway_tickets_manager');
				break;
			case "showDiscussions":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('discussions') );
				$title = JText::_('discussions');
				break;
			case "viewDiscussion":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('discussions'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=discussions') );
				$pathway->addItem( $title_extension );
				$title = $title_extension;
				break;
			case "newDiscussion":
				$pathway->addItem( getWorkgroup($id_workgroup), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=workgroup_view') );
				$pathway->addItem( JText::_('discussions'), JRoute::_($link.'&id_workgroup='.$id_workgroup.'&task=discussions') );
				$pathway->addItem( JText::_('pathway_new') );
				$title = JText::_('pathway_new');
				break;
		}

		// Display the page title
		if( $title != '' ) { ?>
			<h2><?php echo $title; ?></h2><?php
		}
	}

	function shortdate($date) {
	 	global $supportConfig;
		$date = date($supportConfig->date_short, strtotime($date));
	  	return $date;
	}

	function longdate($date){
		global $supportConfig;
		$date = date($supportConfig->date_long, strtotime($date));
	  	return $date;
	}

	function returnMonthDesc($selmonth) {
		switch($selmonth)
		{
			case "01": return JText::_('month01'); break;
			case "02": return JText::_('month02'); break;
			case "03": return JText::_('month03'); break;
			case "04": return JText::_('month04'); break;
			case "05": return JText::_('month05'); break;
			case "06": return JText::_('month06'); break;
			case "07": return JText::_('month07'); break;
			case "08": return JText::_('month08'); break;
			case "09": return JText::_('month09'); break;
			case "10": return JText::_('month10'); break;
			case "11": return JText::_('month11'); break;
			case "12": return JText::_('month12'); break;
		}
	}

	function getDueDateIcon( $duedate, $priority, $assign, $status ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT status_group FROM #__support_status WHERE id='$status'" );
		$status = $database->loadResult();

		$due_date = mktime( substr($duedate, 11, 2), substr($duedate, 14, 2), 0, substr($duedate, 5, 2), substr($duedate, 8, 2), substr($duedate, 0, 4) );
		$cur_date = mktime( dateOffset("H"), dateOffset("i"), 0, dateOffset("m"), dateOffset("d"), dateOffset("Y") );

		if( $assign > 0 && $due_date <= $cur_date ) {
			$img = '5';
		}elseif( $assign > 0 && $due_date >= $cur_date ) {
			$img = '6';
		}elseif( $assign == 0 ) {
			$img = '3';
		}else{
			$img = '0';
		}

		return $img;
	}

	function getCategory( $id ) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT name FROM #__support_category WHERE id='$id'" );
		return ($database->loadResult()=='' ? JText::_('uncategorized') : $database->loadResult());
	}

	function BuildCategories( $id_category, $filter=false, $width=false, $multiple=false, $kb=false ) {
		global $id_workgroup, $supportConfig;

		$database = JFactory::getDBO();
		$user = JFactory::getUser();
		$task = JRequest::getVar( 'task', '', 'REQUEST', 'string' );
		$items = '';
		
		// Check categories permissions
		$categories = '';
		if( !$kb ) {
			$sql = "SELECT `id_category`
					FROM `#__support_permission_category`
					WHERE `id_workgroup`=$id_workgroup AND `id_user`=".$user->id;
			$database->setQuery($sql);
			$categories = $database->loadObjectList();
			$catpermissions = null;
			foreach( $categories as $rowcat ) 
			{
				$catpermissions[] = $rowcat->id_category;
			}
			$categories = ( count($catpermissions) ? 'AND c.id IN ('.implode(',', $catpermissions).')' : '' );
		}
		
		// To show in the ticket manager
		if( $task == 'ticket_my' && $supportConfig->support_workgroup_only==1 ) {	// if can search all workgroups, list them all
			$sql = "SELECT c.id, c.name, c.parent
					FROM #__support_category as c 
					WHERE c.show=1 AND c.parent=%s AND c.id_workgroup=$id_workgroup AND c.tickets=1 ".$categories."
					ORDER BY c.name";
					
			$items.= '<option value="">'.JText::_('all').'</option>';
			
			if( $supportConfig->use_uncategorized ) {
				$items.= '<option value="0">'.JText::_('uncategorized').'</option>';
			}
			
			$items.= '<option value="">'.JText::_('this_workgroup').'</option>';
			$items.= buildHierarchy($sql, $id_category);
			
			$sql = "SELECT c.id, c.name, c.parent
					FROM #__support_category as c 
					WHERE c.show=1 AND c.parent=%s AND c.id_workgroup<>$id_workgroup $categories
					ORDER BY c.name";
			$items.= '<option value="">'.JText::_('other_workgroup').'</option>';
			$items.= buildHierarchy($sql, $id_category);
			
			$parent = '<select id="'.($filter ? 'filter_category' : 'id_category').'" name="'.($filter ? 'filter_category' : 'id_category').'" class="inputbox styled" size="1" '.($width ? 'style="width:'.$supportConfig->field_width.'px;"' : '').'>'.$items.'</select>';
			
		// Other places
		} else {
			$sql = "SELECT c.id, c.name, c.show, c.parent
					FROM #__support_category as c
					WHERE c.show=1 AND c.parent=%s ".($id_workgroup!=0 ? "AND c.id_workgroup='".$id_workgroup."' " : '').($kb ? "AND c.kb=1" : "AND c.tickets=1 ".$categories)."
					ORDER BY c.name";
			if( $task != 'ticket_new' && $task != 'ticket_view' && !$kb ) {
				$items.= '<option value="">'.JText::_('all').'</option>';
			}elseif( !$kb ) {
				$items.= '<option value=""></option>';
			}
			
			if( $supportConfig->use_uncategorized && !$kb ) {
				$items.= '<option value="0" '.(!$id_category ? 'selected="selected"' : '').'>'.JText::_('uncategorized').'</option>';
			}
			
			$items.= buildHierarchy($sql, $id_category);
			
			if( $items != '' ) {
				$parent = '<select id="'.($filter ? 'filter_category' : 'id_category').'" name="'.($filter ? 'filter_category' : 'id_category').'" class="inputbox '.($task=='ticket_my' ? 'styled' : '').'" size="'.($multiple?10:1).'" '.($multiple?' multiple="multiple"':'').' '.($width ? 'style="width:'.$supportConfig->field_width.'px;"' : '').'>'.$items.'</select>';
			}else{
				$parent = "<input type='hidden' name='id_category' value='0' /> ".JText::_('workgroup_without_categories');
			}
		}
		
		return $parent;
	}
	
	function buildHierarchy($query, $selected=0, $id=0, $level=0) 
	{
		$database = JFactory::getDBO();
		$sql = sprintf($query, $id);
   		$database->setQuery( $sql );
   		$rows = $database->loadObjectList();
		$items = '';
   		$level++;
   		
		foreach( $rows as $row )
		{
			$items.= '<option value="'.$row->id.'" '.($selected==$row->id ? 'selected' : '').'>'.str_repeat('--',($level-1)).' '.$row->name.'</option>';
			$items.= buildHierarchy($query, $selected, $row->id, $level);
		}
		
		return $items;
	}

	// Limits strings based on character limit
	function strLimit($string, $chars='300', $footer='...',  $notags=1) {

		$notags ? $string = strip_tags($string) : '' ;
		$chars = $chars - strlen($footer);
		if ( strlen($string) > $chars ) {
			$string = substr($string, 0, $chars-1);
			$string .= $footer;
		}
		return $string;
	}

	// Notify data/variable substitution
	function parseTpl( $var_set, $tmplfile, $message='', $tpltype='mail' ) {
		global $id_workgroup;

		$database = JFactory::getDBO();

		// Initialize Template Engine
		if( $tmplfile ) {
			$message = getSCTemplate( $message, $id_workgroup, $tpltype.'/'.$tmplfile );
		}

		foreach ($var_set as $var => $var_value) {
			$message = str_replace( $var, $var_value, $message ); // Replaces the each variable
		}
		
		return $message;
	}

	function getSCTemplate( $msg, $id_workgroup, $tmplfile ) {
		global $id_workgroup;

		$database = JFactory::getDBO();

		// Get the workgroup theme
		$database->setQuery( "SELECT theme FROM #__support_workgroup WHERE id='".$id_workgroup."'" );
		$theme = $database->loadResult();

		// Anonymous access
		!isset( $theme ) ? $theme = 'default' : '';

		// Get the template from the file
		$tmplfile = JPATH_SITE.'/components/com_maqmahelpdesk/templates/'.$theme.'/'.$tmplfile.'.php';
		if( is_file($tmplfile) ) {
			ob_start();
			include($tmplfile);
			$tmpl_code = ob_get_contents();
			ob_end_clean();
		}else{
			$tmpl_code = '<small>'. JText::_('notemplatefile') . $tmplfile . '</small>';
		}

		return $tmpl_code;
	}

	function getUserEmail($id, $output=1) {
		$database = JFactory::getDBO();

		$database->setQuery( "SELECT name, email FROM #__users WHERE id='".$id."'" );
			$row = $database->loadObject();

		if (count($row) > 0) {
			if ($output == 1) {
				return $row->email;
			} elseif ($output == 2) {
				return $row->name;
			}
		}
	}

	function GlossaryPopup( $content ) {
		global $supportConfig;

		$database = JFactory::getDBO();

		if( !isset($supportConfig) ) {
			$supportConfig = GetConfig();
		}

		$find_exact = 1;
		$show_once_only = 0;
		$mosinfopop_entrytext = $content;
		$times = -1;

		// Get all terms from Glossary
		$query = "SELECT id, term, description, ucase(term) as uterm FROM #__support_glossary WHERE published='1'";
		$database->setQuery($query);
		$rows = $database->loadObjectList();

		if (count($rows)) {
			foreach ($rows as $row) {
				$keyword = htmlentities(trim($row->term));
				if ($keyword) {
					$escaped_keyword = str_replace('/','\\/',$keyword);
					if ($find_exact) 
						$regex='/(\b)'.$escaped_keyword.'(\b)/i';
					else 
						$regex='/'.$escaped_keyword.'/i';
					$key = strtoupper($keyword);
					$definition = preg_replace("/(\015\012)|(\015)|(\012)/",'&nbsp;<br />',$row->description);
					$glossary[$row->id]=array('id' => $row->id,'term' => $keyword, 'desc' => $definition, 'regex' => $regex, 'found' => false);
				}
			}
		}

		if ( isset($glossary) ) {
			if ( count($glossary) ) {
				$htmlregex = '#(<a .*?</a\ *>|<script .*?</script\ *>|</?.*?>|\<![ \r\n\t]*(--([^\-]|[\r\n]|-[^\-])*--[ \r\n\t]*)\>)#i';
				$bits = preg_split($htmlregex, $content);

				preg_match_all($htmlregex, $content, $matches);
				$newcontent="";
				$found=array();
				foreach ($bits as $i=>$bit) {
					foreach ($glossary as $elm) {
						if (!($times == '1' &&  isset($found[$elm['id']])) ) {
							$newpart = "{sc_glossary_replace ".$elm['id']."}";
							if (preg_match($elm['regex'],$bit)) {
								$found[$elm['id']] = $elm['term'];
							}
							$bit = preg_replace($elm['regex'],$newpart,$bit,$times);
						}
					}
					$newcontent .= $bit;
					if (isset($matches[0][$i])) $newcontent .= $matches[0][$i];
				}
				$content = $newcontent;

				$regex = '/{(sc_glossary_replace)\s*(.*?)}/i';
				$matches = array();
				preg_match_all( $regex, $content, $matches, PREG_SET_ORDER );

				foreach ($matches as $elm) {
					$id = $elm[2];
					if (isset($glossary[$id])) {
						$output = '<span class="editlinktip hasTip" title="<b>'.htmlspecialchars($glossary[$id]['term'].'</b>::<div style=\'width:200px;\'>'.$glossary[$id]['desc']).'</div>"><u>'.$glossary[$id]['term'].'</u></span>';
					} else {
						$output = "";
					}
					$content = preg_replace($regex, $output, $content, 1);
				}
			}
		}

		return $content;
	}

	/*
	* Convert provided date into a unix timestamp
	* Supported formats:
	*
	* %Y - year as a decimal number including the century
	* %m - month as a decimal number (range 01 to 12)
	* %d - day of the month as a decimal number (range 01 to 31)
	* %H - hour as a decimal number using a 24-hour clock (range 00 to 23)
	* %M - minute as a decimal number
	* %S - second as a decimal number
	*
	* Example: to convert Joomla standard format: parseDate( $joomlatimestamp,'%Y-%m-%d %H:%M:%S');
	*/
	function parseDate( $date, $format = "%Y-%m-%d %H:%M:%S" ) {
		// Builds up date pattern from the given $format, keeping delimiters in place.
		$datePattern = '';
		if( !preg_match_all( "/%([YmdHMSp])([^%])*/", $format, $formatTokens, PREG_SET_ORDER ) ) {
		   return false;
		}
		foreach( $formatTokens as $formatToken ) {
				$delimiter = '';
				isset ($formatToken[2]) ? $delimiter = preg_quote( $formatToken[2], "/" ) : '';
				$datePattern .= "(.*)".$delimiter;
		}
		// Splits up the given $date
		if( !preg_match( "/".$datePattern."/", $date, $dateTokens) ) {
		   return false;
		}

		$dateSegments = array();
		for($i = 0; $i < count($formatTokens); $i++) {
		   $dateSegments[$formatTokens[$i][1]] = $dateTokens[$i+1];
		}

		// Reformats the given $date into US English date format, suitable for strtotime()
		if( isset($dateSegments["Y"]) && isset($dateSegments["m"]) && isset($dateSegments["d"]) ) {
		   $dateReformated = $dateSegments["Y"]."-".$dateSegments["m"]."-".$dateSegments["d"];
		}
		else {
		   return false;
		}
		if( isset($dateSegments["H"]) && isset($dateSegments["M"]) ) {
		   $dateReformated .= " ".$dateSegments["H"].":".$dateSegments["M"].":".$dateSegments["S"];
		}

		return strtotime( $dateReformated );
	}

	function getWeekStart( $check_date, $start_day ) {
		// Vai partir a data
		$year = substr($check_date, 0, 4);
		$month = substr($check_date, 5, 2);
		$day = substr($check_date, 8, 2);

		// Vai obter o dia da semana de hoje
		$day_of_week = date("w", mktime(0,0,0,$month,$day,$year));
		$first_day_of_week = date("Y-m-d", mktime(0,0,0,$month, $day-$day_of_week+$start_day, $year));

		return $first_day_of_week;
	}

	function getWeek( $WEEK ) {
		$id_workgroup = JRequest::getInt( 'id_workgroup', 0 );
		$Itemid = JRequest::getInt( 'Itemid', 0 );

		// Split the date into variables
		$date = explode( '-', $WEEK );

		$first_day_of_week   = date("d/m/Y", mktime(0, 0, 0, $date[1], $date[2], $date[0]));
		$second_day_of_week  = date("d/m/Y", mktime(0, 0, 0, $date[1], $date[2] + 1, $date[0]));
		$third_day_of_week   = date("d/m/Y", mktime(0, 0, 0, $date[1], $date[2] + 2, $date[0]));
		$fourth_day_of_week  = date("d/m/Y", mktime(0, 0, 0, $date[1], $date[2] + 3, $date[0]));
		$fifth_day_of_week   = date("d/m/Y", mktime(0, 0, 0, $date[1], $date[2] + 4, $date[0]));
		$sixth_day_of_week   = date("d/m/Y", mktime(0, 0, 0, $date[1], $date[2] + 5, $date[0]));
		$seventh_day_of_week = date("d/m/Y", mktime(0, 0, 0, $date[1], $date[2] + 6, $date[0]));

		$sql_1 = date("Y-m-d", mktime(0, 0, 0, $date[1], $date[2], $date[0]));
		$sql_2 = date("Y-m-d", mktime(0, 0, 0, $date[1], $date[2] + 1, $date[0]));
		$sql_3 = date("Y-m-d", mktime(0, 0, 0, $date[1], $date[2] + 2, $date[0]));
		$sql_4 = date("Y-m-d", mktime(0, 0, 0, $date[1], $date[2] + 3, $date[0]));
		$sql_5 = date("Y-m-d", mktime(0, 0, 0, $date[1], $date[2] + 4, $date[0]));
		$sql_6 = date("Y-m-d", mktime(0, 0, 0, $date[1], $date[2] + 5, $date[0]));
		$sql_7 = date("Y-m-d", mktime(0, 0, 0, $date[1], $date[2] + 6, $date[0]));

		switch( date("w", mktime(0,0,0,$date[1],$date[2],$date[0])) )
		{
			case 0:
				$first_day_caption = JText::_('week_full_sunday');
				$second_day_caption = JText::_('week_full_monday');
				$third_day_caption = JText::_('week_full_tuesday');
				$fourth_day_caption = JText::_('week_full_wednesday');
				$fifth_day_caption = JText::_('week_full_thursday');
				$sixth_day_caption = JText::_('week_full_friday');
				$seventh_day_caption = JText::_('week_full_saturday');
				break;
			case 1:
				$first_day_caption = JText::_('week_full_monday');
				$second_day_caption = JText::_('week_full_tuesday');
				$third_day_caption = JText::_('week_full_wednesday');
				$fourth_day_caption = JText::_('week_full_thursday');
				$fifth_day_caption = JText::_('week_full_friday');
				$sixth_day_caption = JText::_('week_full_saturday');
				$seventh_day_caption = JText::_('week_full_sunday');
				break;
			case 2:
				$first_day_caption = JText::_('week_full_tuesday');
				$second_day_caption = JText::_('week_full_wednesday');
				$third_day_caption = JText::_('week_full_thursday');
				$fourth_day_caption = JText::_('week_full_friday');
				$fifth_day_caption = JText::_('week_full_saturday');
				$sixth_day_caption = JText::_('week_full_sunday');
				$seventh_day_caption = JText::_('week_full_monday');
				break;
			case 3:
				$first_day_caption = JText::_('week_full_wednesday');
				$second_day_caption = JText::_('week_full_thursday');
				$third_day_caption = JText::_('week_full_friday');
				$fourth_day_caption = JText::_('week_full_saturday');
				$fifth_day_caption = JText::_('week_full_sunday');
				$sixth_day_caption = JText::_('week_full_monday');
				$seventh_day_caption = JText::_('week_full_tuesday');
				break;
			case 4:
				$first_day_caption = JText::_('week_full_thursday');
				$second_day_caption = JText::_('week_full_friday');
				$third_day_caption = JText::_('week_full_saturday');
				$fourth_day_caption = JText::_('week_full_sunday');
				$fifth_day_caption = JText::_('week_full_monday');
				$sixth_day_caption = JText::_('week_full_tuesday');
				$seventh_day_caption = JText::_('week_full_wednesday');
				break;
			case 5:
				$first_day_caption = JText::_('week_full_friday');
				$second_day_caption = JText::_('week_full_saturday');
				$third_day_caption = JText::_('week_full_sunday');
				$fourth_day_caption = JText::_('week_full_monday');
				$fifth_day_caption = JText::_('week_full_tuesday');
				$sixth_day_caption = JText::_('week_full_wednesday');
				$seventh_day_caption = JText::_('week_full_thursday');
				break;
			case 6:
				$first_day_caption = JText::_('week_full_saturday');
				$second_day_caption = JText::_('week_full_sunday');
				$third_day_caption = JText::_('week_full_monday');
				$fourth_day_caption = JText::_('week_full_tuesday');
				$fifth_day_caption = JText::_('week_full_wednesday');
				$sixth_day_caption = JText::_('week_full_thursday');
				$seventh_day_caption = JText::_('week_full_friday');
				break;
		}

		$link = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=calendar_day&date=';
		ob_start(); ?>

		<table class="calendar">
		<tr>
			<td class="day_header">
				<a href="<?php echo $link.$sql_1 ?>"><?php echo $first_day_caption; ?><br><?php echo $first_day_of_week ?></a>
			</td>
			<td class="day_header">
				<a href="<?php echo $link.$sql_2 ?>"><?php echo $second_day_caption; ?><br><?php echo $second_day_of_week ?></a>
			</td>
			<td class="day_header">
				<a href="<?php echo $link.$sql_3 ?>"><?php echo $third_day_caption; ?><br><?php echo $third_day_of_week ?></a>
			</td>
			<td class="day_header">
				<a href="<?php echo $link.$sql_4 ?>"><?php echo $fourth_day_caption; ?><br><?php echo $fourth_day_of_week ?></a>
			</td>
			<td class="day_header">
				<a href="<?php echo $link.$sql_5 ?>"><?php echo $fifth_day_caption; ?><br><?php echo $fifth_day_of_week ?></a>
			</td>
			<td class="day_header">
				<a href="<?php echo $link.$sql_6 ?>"><?php echo $sixth_day_caption; ?><br><?php echo $sixth_day_of_week ?></a>
			</td>
			<td class="day_header">
				<a href="<?php echo $link.$sql_7 ?>"><?php echo $seventh_day_caption; ?><br><?php echo $seventh_day_of_week ?></a>
			</td>
		</tr>
		<tr style="min-height:30px; height:30px;">
			<td class="day_content"><?php echo GetTasksForDay( $sql_1 ); ?></td>
			<td class="day_content"><?php echo GetTasksForDay( $sql_2 ); ?></td>
			<td class="day_content"><?php echo GetTasksForDay( $sql_3 ); ?></td>
			<td class="day_content"><?php echo GetTasksForDay( $sql_4 ); ?></td>
			<td class="day_content"><?php echo GetTasksForDay( $sql_5 ); ?></td>
			<td class="day_content"><?php echo GetTasksForDay( $sql_6 ); ?></td>
			<td class="day_content"><?php echo GetTasksForDay( $sql_7 ); ?></td>
		</tr>
		</table><?php
		$content = ob_get_contents();
		ob_end_clean();

		return $content;
	}

	function small_calendar($month, $day, $year)
	{
		$database = JFactory::getDBO();

		//Get tasks for selected year and month
		$database->setQuery("SELECT * FROM #__support_task WHERE month(date_time)=".$database->quote($month)." AND year(date_time)=".$database->quote($year)." ORDER BY date_time ASC");
		$today_tasks = $database->loadObjectList();

		//If no parameter is passed use the current date.
		$this_month = getDate(mktime(0, 0, 0, $month, 1, $year));
		$next_month = getDate(mktime(0, 0, 0, $month + 1, 1, $year));

		//Find out when this month starts and ends.
		$first_week_day = $this_month["wday"];
		$days_in_this_month = round(($next_month[0] - $this_month[0]) / (60 * 60 * 24));

		$calendar_html = "<table class=\"adminform\">\n";
		$calendar_html .= "<tr><td colspan=\"7\"><div align=\"center\">" .
					   returnMonthDesc($month) . " " . $year . "</div></td></tr>\n";
		$calendar_html .= "<tr>\n";
		$calendar_html .= "<td style=\"background-color:#EEEEEE; border-bottom: 2px solid #CCCCCC; font-weight: bold;\" width=\"120\" height=\"20\"><div align=\"center\">".JText::_('week_smal_sunday')."</div></td>\n";
		$calendar_html .= "<td style=\"background-color:#EEEEEE; border-bottom: 2px solid #CCCCCC; font-weight: bold;\" width=\"120\" height=\"20\"><div align=\"center\">".JText::_('week_smal_monday')."</div></td>\n";
		$calendar_html .= "<td style=\"background-color:#EEEEEE; border-bottom: 2px solid #CCCCCC; font-weight: bold;\" width=\"120\" height=\"20\"><div align=\"center\">".JText::_('week_smal_tuesday')."</div></td>\n";
		$calendar_html .= "<td style=\"background-color:#EEEEEE; border-bottom: 2px solid #CCCCCC; font-weight: bold;\" width=\"120\" height=\"20\"><div align=\"center\">".JText::_('week_smal_wednesday')."</div></td>\n";
		$calendar_html .= "<td style=\"background-color:#EEEEEE; border-bottom: 2px solid #CCCCCC; font-weight: bold;\" width=\"120\" height=\"20\"><div align=\"center\">".JText::_('week_smal_thursday')."</div></td>\n";
		$calendar_html .= "<td style=\"background-color:#EEEEEE; border-bottom: 2px solid #CCCCCC; font-weight: bold;\" width=\"120\" height=\"20\"><div align=\"center\">".JText::_('week_smal_friday')."</div></td>\n";
		$calendar_html .= "<td style=\"background-color:#EEEEEE; border-bottom: 2px solid #CCCCCC; font-weight: bold;\" width=\"120\" height=\"20\"><div align=\"center\">".JText::_('week_smal_saturday')."</div></td>\n";
		$calendar_html .= "</tr>\n";
		$calendar_html .= "<tr>\n";

		//Fill the first week of the month with the appropriate number of blanks.
		for($week_day = 0; $week_day < $first_week_day; $week_day++)
		{
			$calendar_html .= "<td> </td>\n";
		}

		//Create calendar
		$week_day = $first_week_day;
		for($day_counter = 1; $day_counter <= $days_in_this_month; $day_counter++)
		{
			$week_day %= 7;

			if($week_day == 0)
				$calendar_html .= "</tr><tr>";

			$curday = '';
			$tasks = '';
			$i = 0;
			for($i=0; $i<count($today_tasks); $i++) {
				$today_task = $today_tasks[$i];
				$curday = substr($today_task->date_time, 8, 2);
				if($curday==$day_counter) {
					$tasks .= $today_task->task;
				}
			}

			//Do something different for the current day.
			if($day == $day_counter) {
				$curday = '';
				$i = 0;
				$show_hints = 0;
				for($i=0; $i<count($today_tasks); $i++) {
					$today_task = $today_tasks[$i];
					$curday = substr($today_task->date_time, 8, 2);
					if($curday == $day_counter) {
						$show_hints = 1;
					}
				}

				if($show_hints == 0) {
					$calendar_html .= "<td style=\"border:1px solid #CCCCCC; background:#CCCCCC;\"><div align=\"center\"><b>".$day_counter."</b></div></td>\n";
				}else{
					$calendar_html .= "<td style=\"background-color:#FAFAFA; border:1px solid #CCCCCC; background:#CCCCCC; cursor:hand; cursor:pointer;\" onmouseover=\"MM_showLayers('day".$day_counter."')\" onmouseout=\"MM_hideLayers('day".$day_counter."')\"><div align=\"center\"><b>".$day_counter."</b></div></td>\n";
				}
			}else{
				$curday = '';
				$i = 0;
				$show_hints = 0;
				for($i=0; $i<count($today_tasks); $i++) {
					$today_task = $today_tasks[$i];
					$curday = substr($today_task->date_time, 8, 2);
					if($curday == $day_counter) {
						$show_hints = 1;
					}
				}
				if($show_hints == 0) {
					$calendar_html .= "<td><div align=\"center\">" . $day_counter . "</div></td>\n";
				}else{
					$calendar_html .= "<td style=\"cursor:hand; cursor:pointer; background:url(../components/com_maqmahelpdesk/images/corner_bg.png) no-repeat 100% 100%;\" onmouseover=\"MM_showLayers('day".$day_counter."')\" onmouseout=\"MM_hideLayers('day".$day_counter."')\"><div align=\"center\"><b><u>".$day_counter."</u></b></div></td>\n";
				}
			}

			$week_day++;
		}

		$calendar_html .= "</tr>\n";
		$calendar_html .= "</table>\n<br>\n";

		//Create hints for the days
		$week_day = $first_week_day;
		for($day_counter = 1; $day_counter <= $days_in_this_month; $day_counter++)
		{
			$week_day %= 7;
			$curday = '';
			$tasks = '';
			$i = 0;
			$calendar_html .= "<div id='day".$day_counter."' name='day".$day_counter."' style='visibility: hidden; position: absolute;'>\n";

			for($i=0; $i<count($today_tasks); $i++) {
				$today_task = $today_tasks[$i];
				$curday = substr($today_task->date_time, 8, 2);

				if($curday==$day_counter) {
					$task_hours = substr($today_task->date_time, 11, 2);
					$task_minutes = substr($today_task->date_time, 14, 2);
					$task_decimal = str_replace('-','',substr($today_task->date_time, 0, 10)).$task_hours.'.'.$task_minutes;
					$cur_decimal = date("YmdH.i");
					$calendar_html .= ($today_task->status=='O' ? '<img src="'.JURI::root().'components/com_maqmahelpdesk/images/16px/flag-'.($day<=$day_counter && $task_decimal>$cur_decimal ? 'yellow' : 'red').'.png" align="absmiddle" border="0" />&nbsp;' : '<img src="'.JURI::root().'components/com_maqmahelpdesk/images/16px/flag-green.png" align="absmiddle" border="0" />&nbsp;')."<b>".$task_hours.':'.$task_minutes."</b> > ".substr($today_task->task,0, 100).($today_task->id_ticket > 0 ? '&nbsp;<img src="'.JURI::root().'components/com_maqmahelpdesk/images/menu/status.png" align="absmiddle" border="0" />' : '');
					$calendar_html .= "<br />\n";
				}
			}

			$calendar_html .= "</div>\n";

			$week_day++;
		}

		return($calendar_html);
	}

	function GetTasksForDay( $date, $module=0, $modclass_sfx='' ) {
		$id_workgroup = JRequest::getInt( 'id_workgroup', 0 );
		$Itemid = JRequest::getInt( 'Itemid', 0 );

		$database = JFactory::getDBO();
		$user = JFactory::getUser();

		$database->setQuery( "SELECT * FROM #__support_task WHERE substring(`date_time`,1,10)=".$database->quote($date)." AND id_user='".$user->id."' ORDER BY `date_time` ASC" );
		$today_tasks = $database->loadObjectList();

		$tasks_for_day = '';
		
		// fix 21.04.2009 JP
		if (count($today_tasks) == 0) {
			if( $module ) {
				$tasks_for_day .= '<tr align="left"><td>'.JText::_('no_open_tasks_today').'</td></tr>';
			}else{
				//$tasks_for_day .= "No tasks\n";
				$tasks_for_day .= "";
			}
		} else {
			for( $i=0; $i<count($today_tasks); $i++ ) {
				$today_task = $today_tasks[$i];
				$link = "index.php?option=com_maqmahelpdesk&Itemid=".$Itemid."&id_workgroup=".$id_workgroup."&task=calendar_edit&id=".$today_task->id;

				if( $module ) {
					$tasks_for_day .= '<tr align="left">';
					$tasks_for_day .= '<td>';
					$tasks_for_day .= '<a href="'.JRoute::_($link).'" class="sublevel'.$modclass_sfx.'">'.substr($today_task->date_time, 11, 5).'</a> '.substr($today_task->task,0, 100).($today_task->id_ticket > 0 ? ' <img src="'.JURI::root().'components/com_maqmahelpdesk/images/16px/status.png" align="absmiddle" border="0" />' : '');
					$tasks_for_day .= '</td>';
					$tasks_for_day .= '</tr>';
				}else{
					$tasks_for_day .= "<b><a href=\"".JRoute::_($link)."\">".substr($today_task->date_time, 11, 5)."</a></b> > ".substr($today_task->task,0, 100).($today_task->id_ticket > 0 ? ' <img src="'.JURI::root().'components/com_maqmahelpdesk/images/16px/status.png" align="absmiddle" border="0" />' : '').($today_task->status=='O' ? '&nbsp;<img src="'.JURI::root().'components/com_maqmahelpdesk/images/16px/flag-'.($i<date("d") ? 'yellow' : 'red').'.png" align="absmiddle" border="0" />' : '&nbsp;<img src="'.JURI::root().'components/com_maqmahelpdesk/images/16px/flag-green.png" align="absmiddle" border="0" />')."<br />\n";
				}
			}
		}

		return $tasks_for_day;
	}

	function getDay( $date ) {
		$date_part = explode( '-', $date );

		switch( date("w", mktime(0,0,0,$date_part[1],$date_part[2],$date_part[0])) )
		{
			case '0':
				$date_text = JText::_('week_full_sunday');
				break;
			case '1':
				$date_text = JText::_('week_full_monday');
				break;
			case '2':
				$date_text = JText::_('week_full_tuesday');
				break;
			case '3':
				$date_text = JText::_('week_full_wednesday');
				break;
			case '4':
				$date_text = JText::_('week_full_thursday');
				break;
			case '5':
				$date_text = JText::_('week_full_friday');
				break;
			case '6':
				$date_text = JText::_('week_full_saturday');
				break;
		}

		ob_start(); ?>
		<table class="calendar">
		<tr>
			<td class="day_header">
				<?php echo $date; ?> -
				<?php echo $date_text; ?>
			</td>
		</tr>
		<tr>
			<td class="day_content">
			<?php
				// JP 23.01.2009
				$TaskForDay = GetTasksForDay( $date ); 
				if ($TaskForDay=='') $TaskForDay = JText::_('no_tasks');
				echo $TaskForDay;
			?>
			</td>
		</tr>
		</table><?php
		$content = ob_get_contents();
		ob_end_clean();

		return $content;
	}

	function getList( $year, $month ) {
		ob_start(); ?>
		<table class="calendar">
		<tr>
			<td class="calendar_header" colspan="2">
				<?php echo returnMonthDesc($month); ?> <?php echo $year; ?>
			</td>
		</tr>
<?php
		
		$month = ($month<10)?"0".$month:$month;
		for( $i=1; $i<=getNumberOfDays( $year, $month ); $i++ ) {
			if( GetTasksForDay( $year.'-'.$month.'-'.($i<10?'0'.$i:$i) ) != '' ) { ?>
				<tr>
					<td class="day_header">
						<?php echo $year.'-'.$month.'-'.($i<10?'0'.$i:$i); ?>
					</td>
					<td class="day_content">
						<?php echo GetTasksForDay( $year.'-'.$month.'-'.($i<10?'0'.$i:$i) ); ?>
					</td>
				</tr>
<?php		}
		} ?>
		<tr><td colspan="2"></td></tr>
		</table><?php
		$content = ob_get_contents();
		ob_end_clean();

		return $content;
	}

	function generate_calendar( $year, $month, $day_name_length = 3, $month_href = NULL, $first_day = 0 ){
		$id_workgroup = JRequest::getInt( 'id_workgroup', 0 );
		$Itemid = JRequest::getInt( 'Itemid', 0 );

		$today = date('d');
		$days = array( 1=>array(NULL,'day',NULL), 2=>array(NULL,'day',NULL), 3=>array(NULL,'day',NULL), 4=>array(NULL,'day',NULL), 5=>array(NULL,'day',NULL), 6=>array(NULL,'day',NULL), 7=>array(NULL,'day',NULL), 8=>array(NULL,'day',NULL), 9=>array(NULL,'day',NULL), 10=>array(NULL,'day',NULL), 11=>array(NULL,'day',NULL), 12=>array(NULL,'day',NULL), 13=>array(NULL,'day',NULL), 14=>array(NULL,'day',NULL), 15=>array(NULL,'day',NULL), 16=>array(NULL,'day',NULL), 17=>array(NULL,'day',NULL), 18=>array(NULL,'day',NULL), 19=>array(NULL,'day',NULL), 20=>array(NULL,'day',NULL), 21=>array(NULL,'day',NULL),  22=>array(NULL,'day',NULL), 23=>array(NULL,'day',NULL), 24=>array(NULL,'day',NULL), 25=>array(NULL,'day',NULL), 26=>array(NULL,'day',NULL), 27=>array(NULL,'day',NULL), 28=>array(NULL,'day',NULL), 29=>array(NULL,'day',NULL), 30=>array(NULL,'day',NULL), 31=>array(NULL,'day',NULL), $today=>array(NULL,'today',NULL) );
		$first_of_month = gmmktime(0,0,0,$month,1,$year);
		$img_path = JURI::root().'components/com_maqmahelpdesk/images/16px/calendar.png';
		$link = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=calendar_week&date=';

		$day_names = array();
		for($n=0,$t=(3+$first_day)*86400; $n<7; $n++,$t+=86400)
			$day_names[$n] = ucfirst(gmstrftime('%A',$t)); #%A means full textual day name

		list($month, $year, $month_name, $weekday) = explode(',',gmstrftime('%m,%Y,%B,%w',$first_of_month));
		$weekday = ($weekday + 7 - $first_day) % 7;
		$title   = returnMonthDesc($month).'&nbsp;'.$year;

		#Begin calendar. Uses a real <caption>. See http://diveintomark.org/archives/2002/07/03
		$calendar = '<table class="calendar">'."\n".'<caption class="month">'.$title."</caption>\n<tr>";

		if($day_name_length){
			$calendar .= '<td class="weeklink"></td>';
			foreach($day_names as $d)
				$calendar .= '<td class="day_header" abbr="'.htmlentities($d).'">'.htmlentities($day_name_length < 4 ? substr($d,0,$day_name_length) : $d).'</td>';
			$calendar .= "</tr>\n<tr>";
		}

		// JP 15.04.2009 weekyear
		
		if($weekday > 0) {
			// JP 15.04.2009 weekyear
			//$calendar .= '<td class="weeklink"><a href="'.$link.$year.'-'.$month.'-'.date("d", mktime(0,0,0,$month,1-$weekday,$year)).'"><img src="'.$img_path.'" border="0" /></a></td>'.'<td colspan="'.($weekday).'">&nbsp;</td>';
			$weekyear = date("W", mktime(0, 0, 0, $month, 1-$weekday, $year));
			$calendar .= '<td class="weeklink" align="center"><a href="'.$link.$year.'-'.$month.'-'.date("d", mktime(0,0,0,$month,1-$weekday,$year)).'">'.JText::_('week').'<br />'.$weekyear.'</a></td>'.'<td colspan="'.($weekday).'">&nbsp;</td>';
		}else{
			// JP 15.04.2009 weekyear
			//$calendar .= '<td class="weeklink"><a href="'.$link.$year.'-'.$month.'-01"><img src="'.$img_path.'" border="0" /></a></td>';
			$weekyear = date("W", mktime(0, 0, 0, $month, 1-$weekday, $year));
			$calendar .= '<td class="weeklink" align="center"><a href="'.$link.$year.'-'.$month.'-01">'.JText::_('week').'<br />'.$weekyear.'</a></td>';
		}
		for($day=1,$days_in_month=gmdate('t',$first_of_month); $day<=$days_in_month; $day++,$weekday++){
			if($weekday == 7){
				$weekday   = 0; #start a new week
				$calendar .= "</tr>\n<tr>";
				// JP 15.04.2009 weekyear
				//$calendar .= '<td class="weeklink"><a href="index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=calendar_week&date='.$year.'-'.$month.'-'.($day<10 ? '0'.$day : $day).'"><img src="'.$img_path.'" border="0" /></a></td>';
				$weekyear = date("W", mktime(0, 0, 0, $month, $day, $year));
				$calendar .= '<td class="weeklink" align="center"><a href="index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=calendar_week&date='.$year.'-'.$month.'-'.($day<10 ? '0'.$day : $day).'">'.JText::_('week').'<br />'.$weekyear.'</a></td>';
			}
			if(isset($days[$day]) and is_array($days[$day])){
				@list($link, $classes, $content) = $days[$day];
				if(is_null($content))  $content  = $day;
				$calendar .= '<td'.($classes ? ' class="'.htmlspecialchars($classes).'">&nbsp;' : '>&nbsp;').$content.'<br />'.GetTasksForDay($year.'-'.$month.'-'.($content<10?'0':'').$content).'</td>';
			}
			else $calendar .= "<td>&nbsp;".$day."</td>";
		}
		if($weekday != 7) $calendar .= '<td colspan="'.(7-$weekday).'">&nbsp;</td>';

		return $calendar."</tr>\n</table>\n";
	}

	function fixTimes( $time, $show_zeros=1, $to_numeric=0 ) {
		$temp1 = number_format($time, 2);
		$temp_calc = explode( ".", $temp1 );
		$temp_calc = ($temp_calc[1]>=60 ? ($temp_calc[0]+1) : $temp_calc[0]).".".($temp_calc[1]>=60 ? ($temp_calc[1]-60) : $temp_calc[1]);

		if( $show_zeros ) {
			return ( !$to_numeric ? str_replace( '.', ':', number_format($temp_calc, 2) ) : number_format($temp_calc, 2) );
		}else{
			return ( $temp_calc == '0.00' ? '' : ( !$to_numeric ? str_replace( '.', ':', number_format($temp_calc, 2) ) : number_format($temp_calc, 2) ) );
		}
	}

	/*
	 * Function that calls the add-on's after the creation of a new ticket
	 * and the creation of a new reply and sends the information to the
	 * add-on to process it
	 * Params:
	 *		$new_ticket - indicates if it's a new ticket or a new reply
	 *		$ticket_id  - database id of the ticket
	 *		$reply_id	- database id of the reply
	 */
	function executeAddOns( $type, $addon_action, $ticket_id, $reply_id=0 ) {
		$database = JFactory::getDBO();

		// Get the ticket or the reply information
		$row = null;
		$sql = $addon_action ? "SELECT * FROM #__support_ticket WHERE id='".$ticket_id."'" : "SELECT t.ticketmask, t.id_user, t.assign_to, r.date, r.id_user, r.message, r.reply_summary, t.`an_name` FROM #__support_ticket_resp AS r INNER JOIN #__support_ticket AS t WHERE r.id='".$reply_id."' AND r.id_ticket='".$ticket_id."'";
		$database->setQuery( $sql );
		$row = $database->loadObject();

		// Get the add-on's to run
		// - the 'execution' field have different values:
		//		- 1: normal (not used here)
		//		- 2: after new tickets and new activities
		//		- 3: in support center pages
		$database->setQuery( "SELECT * FROM #__support_addon WHERE execution=".$database->quote($type)." AND publish='1'" );
		$addons = $database->loadObjectList();

		for( $i=0; $i<count($addons); $i++ )
		{
			$addon = $addons[$i];
			include( JPATH_SITE.'/components/com_maqmahelpdesk/addon/'.$addon->sname.'/'.$addon->sname.'.php' );
		}
	}

	// Verifies if the supplied email address is valid (format wise)
	function isValidEmail( $email_address) {
		if (preg_match('/\\b[A-Z0-9._%-]+@[A-Z0-9.-]+\\.[A-Z]{2,4}\\b/i', $email_address)) {
			return true;
		} else {
			return false;
		}
	}

	function mqm_do_upload( $id, $source, $file, $file_path, $desc='', $update=0, $public=1, $field='' ) {
		global $supportConfig, $is_support;

		$database = JFactory::getDBO();
		$user	= JFactory::getUser();

		$temp_name = $_FILES[$file]['tmp_name'];
		$file_name = $_FILES[$file]['name'];
		$file_type = substr(strrchr($file_name, '.'), 1);
		$file_size = $_FILES[$file]['size'];
		$result    = $_FILES[$file]['error'];

		if( $id && $source=='T' ) {
			// Get Ticket Details
			$database->setQuery( "SELECT ticketmask FROM #__support_ticket WHERE id='".$id."'" );
			$ticket = $database->loadObject();
		}

		// Check if user uploads are allowed
		if( !$update && $source != 'D' && $source != 'CA' && $source != 'CLI' && $source != 'C' && $source != 'K' && $source != 'W' ) {
			if( !$is_support && !$supportConfig->public_attach ){
				putGlobalMessage( JText::_('upload_notallowed'), 'e', JText::_('upload_notallowed') );
				return false;
				exit();
			}
		}
		// Check if the folder exists, if not creates it
		if( !is_dir($file_path) ){
			mkdir( $file_path );
		}
		//File Name Check
		if ( $file_name == "" ) {
			//putGlobalMessage( JText::_('upload_wrong'), 'e', JText::_('upload_wrong').': ' .$file_name );
			return false;
			exit();
		}
		//File Size Check
		else if ( $file_size > $supportConfig->maxAllowed) {
			putGlobalMessage( JText::_('upload_filesize'), 'e', JText::_('upload_filesize').': ' .$file_size );
			return false;
			exit();
		}
		//File Type Check
		else {
			$ext_error = false;
			$file_ext = explode( ',', $supportConfig->extensions );
			for ( $i=0, $n=count( $file_ext ); $i < $n; $i++ ) {
				if( $file_type == $file_ext[$i] ) {
					$ext_error = true;
				}
			}
			if( $ext_error == false ) {
				putGlobalMessage( JText::_('upload_filetype').$file_type, 'e', JText::_('upload_filetype').$file_type );
				return false;
				exit();
			}
		}
		
		isset($ticket) && $source=='T' ? $tkt_mask = $ticket->ticketmask.'_' : $tkt_mask = 'file_';
		
		$copy = '';
		$n = 0;
		while(file_exists($file_path.$tkt_mask.$copy.$file_name)) {
			$n++;
			$copy = $n.'_';
		}
		
		$file_name = $source!='U' ? $tkt_mask.$copy.$file_name : $file_name;
		
		$move_file = move_uploaded_file ($temp_name, $file_path.$file_name);

		if( $move_file && $ext_error ) {
			if( $source == 'T' || $source == 'K' ) {
				$sql = "INSERT INTO #__support_file(id, id_user, date, source, filename, description, public) 
						VALUES('".$id."', '".$user->id."', '".dateOffset("Y-m-d H:i:s")."',".$database->quote($source).", ".$database->quote($file_name).", ".$database->quote( $desc ).", ".$public.")";
				$database->setQuery( $sql );
				!$database->query() ? putGlobalMessage( $database->getErrorMsg(), 'e', $database->stderr(1) ) : '';

			}elseif( $source == 'C' ) {
				$available = JRequest::getInt( 'available', 0 );
				$database->setQuery( "INSERT INTO #__support_client_docs(id_client, date_created, description, filename, available) VALUES('".$id."', '".dateOffset("Y-m-d")."', ".$database->quote( $desc ).", ".$database->quote($file_name).", $available)" );
				!$database->query() ? putGlobalMessage( $database->getErrorMsg(), 'e', $database->stderr(1) ) : '';

			}elseif( $source == 'W' ) {
				$database->setQuery( "UPDATE #__support_workgroup SET logo=".$database->quote($file_name)." WHERE id='".$id."'" );
				!$database->query() ? putGlobalMessage( $database->getErrorMsg(), 'e', $database->stderr(1) ) : '';

			}elseif( $source == 'D' ) {
				$database->setQuery( "UPDATE #__support_dl SET ".$field."=".$database->quote($file_name)." WHERE id='".$id."'" );
				!$database->query() ? putGlobalMessage( $database->getErrorMsg(), 'e', $database->stderr(1) ) : '';

			}elseif( $source == 'CA' ) {
				$database->setQuery( "UPDATE #__support_dl_category SET ".$field."=".$database->quote($file_name)." WHERE id='".$id."'" );
				!$database->query() ? putGlobalMessage( $database->getErrorMsg(), 'e', $database->stderr(1) ) : '';
				
			}elseif( $source == 'V' ) {
				$database->setQuery( "UPDATE #__support_dl_version SET filename=".$database->quote($file_name).", filename_original=".$database->quote($_FILES[$file]['name'])." WHERE id='".$id."'" );
				!$database->query() ? putGlobalMessage( $database->getErrorMsg(), 'e', $database->stderr(1) ) : '';
			
			}elseif( $source == 'CLI' ) {
				$database->setQuery( "UPDATE #__support_client SET logo=".$database->quote($file_name)." WHERE id='".$id."'" );
				!$database->query() ? putGlobalMessage( $database->getErrorMsg(), 'e', $database->stderr(1) ) : '';
				
			}elseif( $source == 'U' ) {
				$database->setQuery( "UPDATE #__support_users SET avatar=".$database->quote(JURI::root().'components/com_maqmahelpdesk/images/avatars/'.$file_name)." WHERE id_user='".$user->id."'" );
				!$database->query() ? putGlobalMessage( $database->getErrorMsg(), 'e', $database->stderr(1) ) : '';
			}
		}else{
			putGlobalMessage( JText::_('upload_wrong'), 'e', JText::_('upload_wrong') );
			return false;
			exit();
		}
		unset($temp_name);
		return true;
	}

	// Replaces http/https/ftp and email addresses with hyperlinks (<a>)
	function text2hyperlinks ( $text ) {
		$text = preg_replace('/\\b(https?|ftp):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|]/i', '<a target="_blank" href="\\0">\\0</a>', $text);
		$text = preg_replace('/\\b(?:mailto:)?([A-Z0-9._%-]+@[A-Z0-9.-]+\\.[A-Z]{2,4})\\b/i', '<a href="mailto:\\1">\\0</a>', $text);
		return $text;
	}

	// Verifies current MySQL version against minimul required
	// Only works to one decimal point (ie 4.1 and not 4.11)
	function getMinReqMySQLVer ($min_ver) {
		$database = JFactory::getDBO();

		$sql = "SELECT VERSION()";
		$database->setQuery( $sql );
		$curr_ver_dirty = $database->loadResult();
		$curr_ver = substr( $curr_ver_dirty, 0, strpos($curr_ver_dirty, '.') );
		if ( ($min_ver * 100) > ($curr_ver * 100) ) {
			return false;
		} else {
			return true;
		}
	}

	// Converts ticket source from DB single char to proper name
	function switchSource( $src ) {
		$source = '';
		switch($src)
		{
			case 'P':
				$source = JText::_('phone');
				break;
			case 'F':
				$source = JText::_('fax');
				break;
			case 'M':
				$source = JText::_('email');
				break;
			case 'W':
				$source = JText::_('website');
				break;
			case 'O':
				$source = JText::_('other');
				break;
		}
		return $source;
	}

	// Verifies source variable contains only valid values
	function verifySource( $source ) {

		switch($source)
		{
			case 'P':
				break;
			case 'F':
				break;
			case 'M':
				break;
			case 'W':
				break;
			case 'O':
				break;
			default :
				$source = 'O';
				break;
		}
		return $source;
	}

	// Check if Client Manager notify is on
	function isNotifyClientMgr ($client_id) {
		$database = JFactory::getDBO();

		$sql = "SELECT manager from #__support_client WHERE id='" . $client_id . "'";
		$database->setQuery( $sql );
		$notify_mgr = $database->loadResult();
		return $notify_mgr;
	}

	function putGlobalMessage( $message, $msgtype='i', $debugmsg='', $userid='', $username=''){
		global $sysmsgs_user_location;

		$database = JFactory::getDBO();
		$user	= JFactory::getUser();

		if( strlen($message) > 0 ) {
			!$userid ? $userid=$user->id : '';			// Get clients user id
			!$username ? $username=$user->username : '';	// Get clients username
			$ipaddress = GetUserIPAddress();			// Get clients IP address
			$occurred = timestampOffset();				// Get current time with offset (if configured)

			$database->setQuery( "INSERT INTO #__support_sysmsgs(userid, location, username, ipaddress, msgtype, message, occurred, debugmsg) VALUES('$userid', '$sysmsgs_user_location', '$username', '$ipaddress', '$msgtype', ".$database->quote($message).", '$occurred', ".$database->quote($debugmsg).")" );
			!$database->query() ? showSCMessage( $database->getErrorMsg(), 'e' ) : '';
			return $database->insertid();
		}
	}

	function getGlobalMessage( $userid='', $username='' ) {
		global $sysmsgs_user_location, $supportConfig;

		$database = JFactory::getDBO();
		$user	= JFactory::getUser();

		!$userid ? $userid=$user->id : '';					// Get clients user id
		!$username ? $username=$user->username : '';			// Get clients username
		$ipaddress = GetUserIPAddress();					// Get clients IP address
		$time_current = timestampOffset();					// Get current time with offset (if configured)
		$display_limit = 1;									// Set display number limit (starts at 0)
		$time_old = timestampOffset() - 3600;				// Allow for upto an hour old messages
		$redirmsg =  JRequest::getVar( 'msg', 0, '', 'int' );	// MOSRedirect work around
		$redirmsg = str_replace( 'sysmsgs', '', $redirmsg );// MOSRedirect work around

		// Get available mssages
		$sql = "SELECT id, msgtype, message, occurred FROM #__support_sysmsgs WHERE userid='".$userid."' AND username='".$username."' AND ipaddress='".$ipaddress."' AND location='".$sysmsgs_user_location."' AND (displayed < '".$display_limit."')";
		$database->setQuery($sql);
		$globalmsgs = $database->loadObjectList();

		$supportConfig->date_short ? $date_format = $supportConfig->date_short : $date_format = 'd/m/Y H:i:s';

		for($i=0;$i<count($globalmsgs);$i++) {
			$globalmsg = $globalmsgs[$i];
			$globalmsg->message = '<small>'. dateOffset($date_format, $globalmsg->occurred ) .'</small><br />'. $globalmsg->message;
			showSCMessage( $globalmsg->message, $globalmsg->msgtype );	// Display available messages
			cleanGlobalMessage( $globalmsg->id );						// Clean out displayed messages
		}
	}

	function cleanGlobalMessage( $id ) {
		$database = JFactory::getDBO();

		$err_old = timestampOffset() - 7776000; // Keep 3 months worth of error messages
		$warn_old = timestampOffset() - 2592000; // Keep 1 month worth of warning messages
		$info_old = timestampOffset() - 604800; // Keep 1 week worth if info messages

		// Updates requested global message as displayed or updated all old undisplayed messages

		$database->setQuery( "UPDATE #__support_sysmsgs SET displayed=displayed+1, cleaned='1' WHERE id='$id'" );
		!$database->query() ? showSCMessage($database->getErrorMsg(), 'e') : '';

		// Clean out old messages
		$database->setQuery( "DELETE FROM #__support_sysmsgs WHERE (msgtype='e' AND occurred<$err_old) OR (msgtype='w' AND occurred<$warn_old) OR (msgtype='i' AND occurred<$info_old)" );
		!$database->query() ? showSCMessage($database->getErrorMsg(), 'e') : '';
	}

	// Filter by client and workgroup
	function GetTimeForDayInDecim( $date, $client, $workgroup, $user, $assign=0 ) {
		$database = JFactory::getDBO();

		// Check if it's for all clients
		$client_where = '';
		if( $client > 0 && $client != '-' ) {
			$client_where = " AND t.id_client='".$client."'";
		}
		//if( $client == '-' ) {
		//	$client_where = " AND t.id_client='0'";
		//}

		// Check if it's for all workgroups
		$wk_where = '';
		if( $workgroup > 0 ) {
			$wk_where = " AND t.id_workgroup='".$workgroup."'";
		}

		// Check if it's for all users
		$user_where = '';
		if( $user > 0 ) {
			$user_where = " AND r.id_user='".$user."'";
		}

		// Check the assigned user
		$assign_where = '';
		if( $assign > 0 ) {
			$assign_where = " AND t.assign_to='".$assign."'";
		}

		$sql = "SELECT	(
							(SUM(
								TIME_TO_SEC( REPLACE(r.timeused,'.', ':') )
							))
							+
							(SUM(
								TIME_TO_SEC( REPLACE(r.tickettravel,'.', ':') )
							))
						) / 3600

							FROM #__support_ticket_resp r, #__support_ticket t WHERE t.id=r.id_ticket AND substring(r.`date`, 1, 10)=".$database->quote($date)."".$user_where.$wk_where.$client_where.$assign_where;
		$database->setQuery($sql);
		if( $times = $database->loadResult() ) {
			return $times;
		}
	}

	function fetchLanguage( $tag ) {
		return JText::_($tag);
	}

	// Escapes strings for HTML
	function string2HTML( $string ) {
		htmlentities( $string, ENT_QUOTES );
		return $string;
	}

	// Following function NOT to be used in preference of the newer (see above)
	function escapeTextarea( $string ) {
		
		$string = addslashes( $string );
		return $string;
	}

	function getDateShortFrmt () {
		global $supportConfig;

		if( $supportConfig->date_short ) {
			$format = $supportConfig->date_short;
		} else {
			$format = 'j/n/Y G:i';
		}
		return $format;
	}

	function getDateLongFrmt () {
		global $supportConfig;

		if( $supportConfig->date_long ) {
			$format = $supportConfig->date_long;
		} else {
			$format = 'D jS M Y, h:i';
		}
		return $format;
	}

	function minutes2decimals( $minutes ) {
		return ($minutes / 60);
	}

	// Converts Hours:Minutes time to decimal format, requires : delimiter
	function convHHMMtoDEC($hhmm) 
	{
		$delimiter_pos = strpos($hhmm, ':');
		if( $delimiter_pos === false ) {
			$delimeter_pos = str_replace('.', ':', $hhmm);
			$delimiter_pos = strpos($hhmm, '.');
		}
		$hours = substr( $hhmm, 0, $delimiter_pos );
		$mins = substr( $hhmm, $delimiter_pos+1, strlen($hhmm) );
		$mins = round(($mins/60), 2)*100;
		$mins < 10 ? $mins = '0'.$mins : '';

		return $hours. '.' .$mins;
	}
	
	// Checks time
	function sc_checkTime( $time )
	{
		$time  = explode( ':', $time );
		$hours = $time[0];
		$mins  = $time[1];
		
		if( $mins >= 60 ) {
			$mins  = $mins - 60;
			$hours = $hours + 1;
		}
		
		if( strlen($mins) == 1 ) {
			$mins = '0'.$mins;
		}
		
		if( strlen($hours) == 1 ) {
			$hours = '0'.$hours;
		}
		
		return ($hours==''?'00':$hours).':'.($mins==''?'00':$mins);
	}

	// Converts decimal time to Hours:Minutes format
	function convDECtoHHMM($dectime, $separator=':') {
		if( $dectime > 0 ) {
			$hours = floor($dectime);
			$mins = $dectime - $hours;
		} elseif( $dectime == 0 ){
			$hours = '0';
			$mins = '00';
		} else {
			$hours = ceil($dectime);
			$hours == '0' ? $hours = '-'.$hours : '';
			$mins = $dectime*(-1) - $hours*(-1);
		}

		$mins = round( $mins * 60 );
		$mins < 10 ? $mins = '0'.$mins : '';

		return $hours.$separator.$mins;
	}

	// Returns hours portion of a time string (requires : delimiter)
	function getHours($time) {
		$delimiter_pos = strpos($time, ':');
		$hours = substr( $time, 0, $delimiter_pos );
		return $hours;
	}

	// Returns mins portion of a time string (requires : delimiter)
	function getMins($time) {
		$delimiter_pos = strpos($time, ':');
		$mins = substr( $time, $delimiter_pos+1, strlen($time) );
		$mins < 10 ? $mins = '0'.$mins : '';
		return $mins;
	}

	// Calculates total labour time in HH:MM format
	function getTotalTime($starttime, $endtime, $breaktime) {
		global $wkoptions;

		$starttime_h = getHours( $starttime );
		$starttime_m = getMins( $starttime );
		$endtime_h = getHours( $endtime );
		$endtime_m = getMins( $endtime );
		$breaktime_h = getHours( $breaktime );
		$breaktime_m = getMins( $breaktime );

		$starttime_decim  = $starttime_h + ($starttime_m / 60);
		$endtime_decim  = $endtime_h + ($endtime_m / 60);
		$breaktime_decim  = $breaktime_h + ($breaktime_m / 60);

		$totaltime_decim = $endtime_decim - $starttime_decim - $breaktime_decim;

		if( $totaltime_decim > 0 ) {
			$totaltime_h = floor( $totaltime_decim );
			$totaltime_m = ($totaltime_decim - $totaltime_h) * 60;
		} else {
			$totaltime_h = ceil( $totaltime_decim );
			$totaltime_m = ( ($totaltime_decim*(-1)) - ($totaltime_h*(-1)) ) * 60;
		}

		if( $totaltime_decim < 0 && $totaltime_h == '0' ) {
			$neg_hhmm = '-';
		} else {
			$neg_hhmm = '';
		}

		$totaltime_m < 10 ? $totaltime_m = '0'.$totaltime_m : '';

		$totaltime_hhmm = $neg_hhmm . $totaltime_h .':'. $totaltime_m;

		return $totaltime_hhmm;
	}

	// Checks if a ticket with supplied detail exists
	function isTicketExist($value, $variable='ticketmask') {

		$database = JFactory::getDBO();

		// Get Ticket Details
		$sql = "SELECT COUNT(*) FROM #__support_ticket WHERE $variable=".$database->quote($value);
		$database->setQuery( $sql );
		return $database->loadResult();
	}

	// Generates ticket mask (ticket number)
	function makeTicketMask( $param1='', $param2='', $param3='' ) {
		$ticket_dbid = $param1;

		$ticketmask = rand(10,99).$ticket_dbid.rand(1000,9999);

		while( isTicketExist($ticketmask) > 0 ) {
			$ticketmask = rand(10,99).$ticket_dbid.rand(1000,9999);
		}
		return $ticketmask;
	}

	function addHHMM( $time1, $time2, $format ) {
		$time1 = str_replace('.', ':', $time1);
		$time2 = str_replace('.', ':', $time2);

		$totaltime = convHHMMtoDEC( $time1 ) + convHHMMtoDEC( $time2 );
		$totaltime_hhmm = convDECtoHHMM( $totaltime );

		switch ($format) {
			case 'hhmm' :
				return $totaltime_hhmm;
				break;

			case 'decim' :
				return $totaltime;
				break;
		}
	}

	// Find if HTML editor is used, sets $mask parameter for mosGetParam
	function getParamMask () {
		global $supportConfig;

		// Set $mask to 2 (allow html) or 0 (no html, default) for mosGetParam filtering
		$mask = 2;

		return $mask;
	}

	// $return_datatype = 'numrecs' | 'duration' | 'dollarval'
	function getActivitiesTotals( $userid, $activity_id, $from_datetime, $to_datetime, $return_datatype, $assign=0, $client=-1 ) {
		$database = JFactory::getDBO();
		$supportConfig = GetConfig();
		
		// Check if it's for all clients
		$client_where = '';
		if( $client > 0 && $client != '-' ) {
			$client_where = " AND t.id_client='".$client."'";
		}
		if( $client == '-' ) {
			$client_where = " AND t.id_client='0'";
		}

		if( $assign > 0 ) {
			$assign_where = " AND t.assign_to='".$assign."'";
		} else {
			$assign_where = '';
		}

		if( $userid > 0 ) {
			$userid_where = " AND r.id_user='".$userid."'";
		} else {
			$userid_where = '';
		}

		if( $activity_id > 0 ) {
			$activity_where = " AND r.id_activity_type='".$activity_id."'";
		} else {
			$activity_where = '';
		}

/*		to be implemented later
		if( $client_id > 0 ) {
			$client_where = " AND t.id_user IN (SELECT u.id_user FROM #__support_client_users u WHERE u.id_client='".$client."')";
		} else {
			$client_where = '';
		}

		if( $wk_id > 0 ) {
			$wk_where = " AND t.id_workgroup='".$workgroup."'";
		} else {
			$wk_where = '';
		}
*/

		switch($return_datatype)
		{
			case 'numrecs':
				$sql = "SELECT COUNT(r.id) FROM #__support_ticket_resp r INNER JOIN #__support_ticket t ON t.id=r.id_ticket WHERE r.date>='".$from_datetime."' AND r.date<='".$to_datetime."'".$userid_where.$activity_where.$assign_where.$client_where;
				//.$client_where.$wk_where;
				$database->setQuery( $sql );
				$numrecs = $database->loadResult();
				if( $numrecs > 0 ) {
					return $numrecs;
				}
			break;

			case 'duration':
				$sql = "SELECT	(
					(SUM(
						TIME_TO_SEC( REPLACE(r.timeused,'.', ':') )
					))
					+
					(SUM(
						TIME_TO_SEC( REPLACE(r.tickettravel,'.', ':') )
					))
				) / 3600
					FROM #__support_ticket_resp r INNER JOIN #__support_ticket t ON t.id=r.id_ticket WHERE r.date>='".$from_datetime."' AND r.date<='".$to_datetime."'".$userid_where.$activity_where.$assign_where.$client_where;
				$database->setQuery($sql);
				$duration = $database->loadResult();
				if( $duration > 0 ) {
					return convDECtoHHMM( $duration );
				}
			break;

			case 'dollarval':
				$sql = "SELECT
						SUM(( r.timeused + r.tickettravel) * r.user_rate) AS money
					FROM #__support_ticket_resp r INNER JOIN #__support_ticket t ON t.id=r.id_ticket WHERE r.date>='".$from_datetime."' AND r.date<='".$to_datetime."'".$userid_where.$activity_where.$assign_where.$client_where;
					//die($sql);

				$database->setQuery($sql);
				$dollarval = $database->loadResult();
				return $supportConfig->currency.' '.number_format($dollarval,2);
			break;
		}
	}

	function GetUserIPAddress()
	{ 
		$ip = ""; 

		if( isset($_SERVER) ) { 
			if( isset($_SERVER["HTTP_X_FORWARDED_FOR"]) ) { 
				$ip = $_SERVER["HTTP_X_FORWARDED_FOR"]; 
			}elseif( isset($_SERVER["HTTP_CLIENT_IP"]) ) { 
				$ip = $_SERVER["HTTP_CLIENT_IP"]; 
			}else{ 
				$ip = $_SERVER["REMOTE_ADDR"]; 
			} 
		}else{ 
			if( getenv( 'HTTP_X_FORWARDED_FOR' ) ) { 
				$ip = getenv( 'HTTP_X_FORWARDED_FOR' ); 
			}elseif( getenv( 'HTTP_CLIENT_IP' ) ){ 
				$ip = getenv( 'HTTP_CLIENT_IP' ); 
			}else{ 
				$ip = getenv( 'REMOTE_ADDR' ); 
			} 
		} 
		return $ip; 
	}
	
	function buildHoursMinutes( $minutes_only=0, $value='' ) 
	{
		global $supportConfig;

		$sel1 = '';
		$supportConfig->minutes = ( $supportConfig->minutes == 0 ? 15 : $supportConfig->minutes );

		/*
		//return round($num / $multiple) * $multiple;
		$multiple = $supportConfig->minutes;		
		$teste = round($minuto / $multiple) * $multiple; 
		// dividir por 60, ser� essaa ordem
		*/
		
		if( !$minutes_only ) {
			for($i=0; $i <=23; $i++) {
				for($z=0; $z<=60; $z++) {
					if( $z < 60 ) {
						$sel1 .= '<option value="'.($i<10?'0'.$i:$i).':'.($z<10?'0'.$z:$z).'" '.($value==($i<10?'0'.$i:$i).':'.($z<10?'0'.$z:$z) ? ' selected' : '').'>'.($i<10?'0'.$i:$i).':'.($z<10?'0'.$z:$z).'</option>';
					}
					$z = $z + $supportConfig->minutes - 1;
				}
			}
		}else{
			for($z=0; $z<=60; $z++) {
				if( $z < 60 ) {
					$sel1 .= '<option value="'.($z<10?'0'.$z:$z).'" '.($value==($z<10?'0'.$z:$z) ? ' selected' : '').'>'.($z<10?'0'.$z:$z).'</option>';
				}
				$z = $z + $supportConfig->minutes - 1;
			}
		}
		
		return $sel1;
	}
	
	/* source: http://pt.php.net/copy */
	function dircopy($src_dir, $dst_dir,$UploadDate=false, $verbose = false, $use_cached_dir_trees = false)
	{   
		static $cached_src_dir;
		static $src_tree;
		static $dst_tree;
		$num = 0;

		if(($slash = substr($src_dir, -1)) == "\\" || $slash == "/") $src_dir = substr($src_dir, 0, strlen($src_dir) - 1);
		if(($slash = substr($dst_dir, -1)) == "\\" || $slash == "/") $dst_dir = substr($dst_dir, 0, strlen($dst_dir) - 1); 
		if (!$use_cached_dir_trees || !isset($src_tree) || $cached_src_dir != $src_dir)
		{
			$src_tree = get_dir_tree($src_dir,true,$UploadDate);
			$cached_src_dir = $src_dir;
			$src_changed = true; 
		}
		if (!$use_cached_dir_trees || !isset($dst_tree) || $src_changed)
			$dst_tree = get_dir_tree($dst_dir,true,$UploadDate);
		if (!is_dir($dst_dir)) mkdir($dst_dir, 0777, true); 

		  foreach ($src_tree as $file => $src_mtime)
		{
			if (!isset($dst_tree[$file]) && $src_mtime === false) 
				mkdir("$dst_dir/$file");
			elseif (!isset($dst_tree[$file]) && $src_mtime || isset($dst_tree[$file]) && $src_mtime > $dst_tree[$file])  
			{
				if (copy("$src_dir/$file", "$dst_dir/$file"))
				{
					if($verbose) echo "Copied '$src_dir/$file' to '$dst_dir/$file'<br>\r\n";
					touch("$dst_dir/$file", $src_mtime);
					$num++;
				} else
					echo "<font color='red'>File '$src_dir/$file' could not be copied!</font><br>\r\n";
			}       
		}
		return $num;
	}

	function get_dir_tree($dir, $root = true,$UploadDate)
	{
		static $tree;
		static $base_dir_length;
	  
		if ($root)
		{
			$tree = array(); 
			$base_dir_length = strlen($dir) + 1; 
		}

		if (is_file($dir))
		{
		   if($UploadDate!=false)
			{
				   if(filemtime($dir)>strtotime($UploadDate))
					$tree[substr($dir, $base_dir_length)] = date('Y-m-d H:i:s',filemtime($dir));    
			}
			else
				$tree[substr($dir, $base_dir_length)] = date('Y-m-d H:i:s',filemtime($dir));
		} 
		elseif ((is_dir($dir) && substr($dir, -4) != ".svn") && $di = dir($dir) )
		{
			if (!$root) $tree[substr($dir, $base_dir_length)] = false; 
			while (($file = $di->read()) !== false)
				if ($file != "." && $file != "..")
					get_dir_tree("$dir/$file", false,$UploadDate); 
			$di->close();
		}
		if ($root)
			return $tree;    
	}

	function get_formated_duration($time_in_sec) {
		if ($time_in_sec < 60*60) {
			$time_min = round(($time_in_sec/60),0);
			$formated_time = intval($time_min)." ".JText::_('times_mins');
		} elseif ($time_in_sec < 60*60*24) {
			$time_hour = floor($time_in_sec/(60*60));
			$time_min = fmod($time_in_sec,60*60)/60;
			$formated_time = intval($time_hour)." ".JText::_('times_hours')." ".intval($time_min)." ".JText::_('times_mins');
		} else {
			$time_day = floor($time_in_sec/(60*60*24));
			$time_hour = floor(($time_in_sec-$time_day*60*60*24)/(60*60));
			$time_min = round(($time_in_sec-($time_hour*60*60)-($time_day*60*60*24))/60,0);
			$formated_time = intval($time_day)." ".JText::_('times_days')." ".intval($time_hour)." ".JText::_('times_hours')." ".intval($time_min)." ".JText::_('times_mins');
		} 
		return $formated_time;
	}
	
	function timediff($date1 = null, $date2 = null) {
	    // Valores padr�o
	    if (is_null($date1)) $date1 = time();
	    if (is_null($date2)) $date2 = time();

	    // Verificando argumentos
	    if (!is_int($date1) || !is_int($date2)) return false;
	    if ($date2 >= $date1) return false;

	    // Diferen�a entre os timestamps
	    $diff = $date1 - $date2;

	    $time = array(0, 0, 0);

	    if ($diff >= 3600)
	        $time[0] = floor(($diff >= 86400) ? ($diff / 86400) * 24 : $diff / 3600);

	    if ($calc = ($diff % 3600)) {
	        $time[1] = floor($calc / 60);
	        $time[2] = $calc % 60;
	    }

	    return $time;
	}
	
	function ordinalNumber($i) {
        switch( floor($i/10) % 10 ) {
            default:
                switch( $i % 10 ) {
                    case 1: return 'st';
                    case 2: return 'nd';
                    case 3: return 'rd';  
                }
            case 1:
        }
        return 'th';
    }	

	function sec2hms($sec, $padHours = false, $days = false) {
		$hms = "";
		$hours = intval(intval($sec) / 3600);
		$hms .= ($padHours)
			  ? str_pad($hours, 2, "0", STR_PAD_LEFT). ':'
			  : $hours. ':';
		$minutes = intval(($sec / 60) % 60);
		$hms .= str_pad($minutes, 2, "0", STR_PAD_LEFT). ':';
		$seconds = intval($sec % 60);
		$hms .= str_pad($seconds, 2, "0", STR_PAD_LEFT);
		if( $days ) {
			if( $hours > 24 ) {
				$days = intval($hours / 24);
				$hours = $hours - ($days*24);
				$hms = "";
				$hms .= $days.' '.JText::_('times_days').' ';
				$hms .= ($padHours) ? str_pad($hours, 2, "0", STR_PAD_LEFT).' '.JText::_('times_hours').' ' : $hours. ':';
				$hms .= str_pad($minutes, 2, "0", STR_PAD_LEFT).' '.JText::_('times_mins').' ';
				$hms .= str_pad($seconds, 2, "0", STR_PAD_LEFT).' '.JText::_('seconds').'';
			}else{
				$hms = "";
				$hms .= ($padHours) ? str_pad($hours, 2, "0", STR_PAD_LEFT).' '.JText::_('times_hours').' ' : $hours. ':';
				$hms .= str_pad($minutes, 2, "0", STR_PAD_LEFT).' '.JText::_('times_mins').' ';
				$hms .= str_pad($seconds, 2, "0", STR_PAD_LEFT).' '.JText::_('seconds').'';
			}
		}
		return $hms;
	}
	
	// Get the ticket ID
	function getTicketID( $value ) {
		$database = JFactory::getDBO();
		$sql = "SELECT `id` FROM #__support_ticket WHERE `ticketmask`='".$value."'";
		$database->setQuery( $sql );
		return $database->loadResult();
	}

    /**
     * Generate HTML code for a checkbox
     *
     * @param string 	Name for the checkbox
     * @param mixed 	Current value of the checkbox
     * @param mixed 	Value to assign when checkbox is checked
     * @param mixed 	Value to assign when checkbox is not checked
     * @return string 	HTML code for checkbox
     */
    function mqm_switchcheckbox($type, $name, $captions, $values, $checked=0, $class=null, $change=null) {
		//$htmlcode = '<input type="checkbox" id="'.$name.'" name="'.$name.'" class="'.$class.'" value="'.$value.'" '.($checked==$value ? 'checked="checked" ' : '').($change!=null?'onchange="'.$change.'" ':'').' />';
		$htmlcode = '';
		for( $i=0; $i<count($values); $i++ )
		{
			$htmlcode.= '<label for="'.$name.$values[$i].'"><input type="'.$type.'" id="'.$name.$values[$i].'" name="'.$name.'" class="switch" value="'.$values[$i].'" '.($checked==$values[$i] ? 'checked ' : '').($change!=null?'onchange="'.$change.'" ':'').' /> '.$captions[$i].'</label> &nbsp;';
		}
		return $htmlcode;
    }
	
	/**
     * Generate HTML code for a select options only
     *
     * @param array 	Array with elements
     * @return string 	HTML code for checkbox
     */
    function mqm_selectoptions($rows) {
		$htmlcode = '';
		foreach( $rows as $row )
		{
			$htmlcode.= '<option value="'.$row->value.'">'.$row->text.'</option>';
		}
	   	return $htmlcode;
    }
	
	function mqm_timepassed($date) 
	{
		$now = date('Y-m-d H:i:s');
		$number_of_seconds = (strtotime($now) - strtotime($date));
		$number_of_minutes = $number_of_seconds / (60);
		$number_of_hours = $number_of_minutes / (60);
		$number_of_days_to_display = abs(intval($number_of_hours / 24));
		$number_of_hours_to_display = abs(intval($number_of_hours));
		$number_of_minutes_to_display = abs(intval($number_of_minutes - ($number_of_hours_to_display * 60)));
		$number_of_seconds_to_display = abs(intval($number_of_seconds / (60 * 60 * 24)));
		
		$timepassed = '';
		
		if( $number_of_days_to_display ) {
			$timepassed = sprintf(JText::_('asked_days'),$number_of_days_to_display);
		}
		if( $number_of_hours_to_display && $number_of_hours_to_display < 24 ) {
			$timepassed = sprintf(JText::_('asked_hours'),$number_of_hours_to_display);
		}
		if( $number_of_minutes_to_display && $number_of_minutes_to_display < 60 ) {
			$timepassed = sprintf(JText::_('asked_minutes'),$number_of_minutes_to_display);
		}
		if( $number_of_seconds_to_display && $number_of_seconds_to_display < 60 ) {
			$timepassed = sprintf(JText::_('asked_seconds'),$number_of_seconds_to_display);
		}
		
		return $timepassed;
	}
	
	function mqm_activitylog($client='', $section='', $action='', $id=0) 
	{
		global $is_support, $is_client;
		
		$user = JFactory::getUser();
		$database = JFactory::getDBO();
		$uri = JURI::getInstance();
		$link = $uri->toString(array('scheme', 'host', 'port', 'path', 'query', 'fragment'));
		
		$sql = "INSERT INTO `#__support_activities`(`id_user`, `ip_address`, `client`, `section`, `action`, `id_table`, `date_created`, `link`, `is_support`, `id_client`)
				VALUES(".$user->id.", '".GetUserIPAddress()."', '$client', '$section', '$action', '$id', '".dateOffset("Y-m-d H:i:s")."', '$link', '$is_support', '$is_client')";
		$database->setQuery( $sql );
		$database->query();
	}
	
	function mqm_getavatar( $id_user )
	{
		global $supportConfig;
		
		$database = JFactory::getDBO();
		$avatar = JURI::root().'components/com_maqmahelpdesk/images/avatars/anonymous.png';
		
		// JomSocial
		if( $supportConfig->use_jomsocial_avatars ) {
			$jspath = JPATH_ROOT.DS.'components'.DS.'com_community';
			include_once($jspath.DS.'libraries'.DS.'core.php');
			$jsuser = CFactory::getUser($id_user);
			$avatar = $jsuser->getThumbAvatar();
		
		// Community Builder
		}elseif( $supportConfig->use_cb_avatars ) {
			$sql = "SELECT `avatar`
					FROM `#__comprofiler`
					WHERE `avatarapproved`=1 AND `user_id`=".(int)$id_user;
			$database->setQuery( $sql );
			$avatar = $database->loadResult();
			if( $avatar != '' ) {
				$avatar = JURI::root().'images/com_profiler/tn'.$avatar;
			}
		
		// MaQma
		}else{
			$sql = "SELECT `avatar`
					FROM `#__support_users`
					WHERE `id_user`=".(int)$id_user;
			$database->setQuery( $sql );
			$row = $database->loadResult();
			if( $row != '' ) {
				$avatar = $row;
			}
		}
		
		return $avatar;
	}
	
	function mqm_jomsocial_post($id_user,$title,$message)
	{
		$database = JFactory::getDBO();
		
		// Get privacy param
        $sql = "SELECT `params`
                FROM `#__community_users`
                WHERE `userid`='".$id_user."'";
        $database->setQuery( $sql );
        $userParams = $database->loadResult();
        $params = new JParameter( $userParams );
		
        // Insert message
        $sql = "INSERT INTO `#__community_activities` (`actor`, `target`, `title`, `content`, `app`, `cid`, `created`, `access`, `params`, `points`, `archived`)
                VALUES(".$id_user.", 0, ".$database->quote($title).", ".$database->quote($message).", 'helpdesk', 1, '".date("Y-m-d H:i:s")."', ".$params->get('privacyProfileView',0).", '\r\n\r\n', 0, 0);";
        $database->setQuery( $sql );
        $database->query();
	}
	
	function mqm_profile_required()
	{
		global $supportConfig, $Itemid, $Itemid;
		
		$mainframe = JFactory::getApplication();
		$database = JFactory::getDBO();
		$user = JFactory::getUser();
		
		if( $supportConfig->profile_required && ( $supportConfig->rf_phone || $supportConfig->rf_fax || $supportConfig->rf_mobile || $supportConfig->rf_address1 || $supportConfig->rf_address2 || $supportConfig->rf_zipcode || $supportConfig->rf_location || $supportConfig->rf_country || $supportConfig->rf_city ) ) {
			$where = '';
			$where.= ( $supportConfig->rf_phone    ? " `phone`=='' OR"    : '');
			$where.= ( $supportConfig->rf_fax      ? " `fax`=='' OR"      : '');
			$where.= ( $supportConfig->rf_mobile   ? " `mobile`=='' OR"   : '');
			$where.= ( $supportConfig->rf_address1 ? " `address1`=='' OR" : '');
			$where.= ( $supportConfig->rf_address2 ? " `address2`=='' OR" : '');
			$where.= ( $supportConfig->rf_zipcode  ? " `zipcode`=='' OR"  : '');
			$where.= ( $supportConfig->rf_location ? " `location`=='' OR" : '');
			$where.= ( $supportConfig->rf_country  ? " `country`=='' OR"  : '');
			$where.= ( $supportConfig->rf_city     ? " `city`=='' OR"     : '');
			$where = ( $where != '' ? ' AND ('.substr( $where, 0, strlen($where)-3 ).')' : '' );
			
			$sql = "SELECT COUNT(*)
					FROM `#__support_users`
					WHERE `id_user`=".$user->id.$where;
			$database->setQuery( $sql );
			$require = $database->loadResult();
			
			if( $require ) {
				$mainframe->redirect( JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=users_profile&msgtype=w&msgtype='.JText::_('profile_required_access')) );
			}
		}
	}
	
	function mqm_check_stopspam( $email=null, $ip=null )
	{
		if( !function_exists('json_decode') ) {
			return true;
		}
		
		$url = 'http://www.stopforumspam.com/api?f=json'.( $ip != '' ? '&ip='.$ip : '' ).( $email != '' ? '&email='.$email : '' );
		$process = curl_init($url);
		curl_setopt($process, CURLOPT_HEADER, 0);
		curl_setopt($process, CURLOPT_TIMEOUT, 10);
		curl_setopt($process, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($process, CURLOPT_SSL_VERIFYPEER, false);
		@curl_setopt($process, CURLOPT_FOLLOWLOCATION, 1);
		@curl_setopt($process, CURLOPT_MAXREDIRS, 20);
		$data = curl_exec($process);
		curl_close($process);
		$data = json_decode($data);
		
		// IP check
		if( $ip != '' && $data->ip->appears ){
			return false;
		}
		
		// E-mail check
		if( $email != '' && $data->email->appears ){
			return false;
		}
		
		return true;
	}
	
	function mqm_check_emailid( $id )
	{
		$database = JFactory::getDBO();
		
		$sql = "SELECT COUNT(*) 
				FROM `#__support_mail_log` 
				WHERE `emailid`=".$database->quote($id);
		$database->setQuery( $sql );
        $check = $database->loadResult();
		
		return $check;
	}
	
	function decode_utf_8( $string ) 
	{ 
		$string = strip_tags($string);
		if (function_exists('iconv')) 
			return iconv("UTF-8", "ISO-8859-1", $string);
		else 
			return utf8_decode($string);
	}

	function prepare_txt( $text ) 
	{
		return decode_utf_8 ($text); 
	}
	
	function mqm_user_online( $id_user )
	{
		$database = JFactory::getDBO();
		
		$sql = "SELECT userid 
				FROM #__session 
				WHERE userid = ".$id_user;
		$database->setQuery( $sql );
        $check = $database->loadResult();
		
		return $check;
	}
	
	function mqm_digistore_license()
	{
		$database = JFactory::getDBO();
		$user = JFactory::getUser();
		
		$sql = "SELECT COUNT(*)
				FROM `#__digistore_licenses` AS l 
					 INNER JOIN `#__digistore_products` AS p ON p.`id`=l.`productid`
				WHERE l.`userid`=".(int)$user->id."
				  AND (l.`expires`>=NOW() OR l.`expires` IS NULL)";
		$database->setQuery( $sql );
        $check = $database->loadResult();
		
		return $check;
	}
	
	function mqm_digistore_domain()
	{
		$database = JFactory::getDBO();
		$user = JFactory::getUser();
		
		$sql = "SELECT COUNT(*)
				FROM `#__digistore_licenses` AS l 
					 INNER JOIN `#__digistore_products` AS p ON p.`id`=l.`productid`
				WHERE l.`userid`=".(int)$user->id."
				  AND (l.`expires`>=NOW() OR l.`expires` IS NULL) 
				  AND l.`domain`!=''";
		$database->setQuery( $sql );
        $check = $database->loadResult();
		
		return $check;
	}
	
	function mqm_create_alias($title) 
	{
		$alias = JFilterOutput::stringURLSafe($title);
		return $alias;
	}
}
