<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: ticket.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** Set flag that this is a parent file */
define( "_JEXEC", 1 );

require_once ( '../../../administrator/includes/auth.php' );
include_once ( JPATH_SITE . '/components/com_maqmahelpdesk/includes/tmpl-ticket.php' );
include_once ( JPATH_SITE . '/components/com_maqmahelpdesk/includes/common.php' );

$CONFIG = new JConfig();
jimport('joomla.database.database');
$options	= array ( 'driver' => $CONFIG->dbtype, 'host' => $CONFIG->host, 'user' => $CONFIG->user, 'password' => $CONFIG->password, 'database' => $CONFIG->db, 'prefix' => $CONFIG->dbprefix, 'select' => true	);
$database = & JDatabase::getInstance( $options );
$database->debug( $CONFIG->debug );

$id    = JRequest::getVar( 'id', 0, '', 'int' );
$css    = JRequest::getVar( 't', '', '', 'string' );
$database->setQuery( "SELECT * FROM #__support_ticket WHERE id='$id'" );
$row = null;
$row = $database->loadObject();
print $database->getErrorMsg();

// Get Support Center Configuration
$supportConfig = null;
$database->setQuery( "SELECT * FROM #__support_config WHERE id='1'" );
$supportConfig = $database->loadObject();

// Get Ticket Messages
$ticketMsgs[0]->name = $row->an_name;
$ticketMsgs[0]->date = $row->date;
$ticketMsgs[0]->message = $row->message;
$ticketMsgs[0]->timeused = 0;
$ticketMsgs[0]->travel_time = 0;
$ticketMsgs[0]->tickettravel = 0;
$ticketMsgs[0]->acttype = '';
$ticketMsgs[0]->actrate = '';
$ticketMsgs[0]->multiplier = 0;
$ticketMsgs[0]->user_rate = 0;
$database->setQuery( "SELECT u.name, r.date, r.message, r.timeused, r.travel_time, r.tickettravel, t.description as acttype, ra.description as actrate, ra.multiplier, r.user_rate FROM #__support_ticket_resp as r LEFT JOIN #__users as u ON r.id_user=u.id LEFT JOIN #__support_activity_type t ON t.id=r.id_activity_type LEFT JOIN #__support_activity_rate ra ON ra.id=r.id_activity_rate WHERE r.id_ticket='".$row->id."' ORDER BY r.id" );
$ticketMsgs = array_merge( $ticketMsgs, $database->loadObjectList() );
print $database->getErrorMsg();

// Get Ticket Rating
$database->setQuery( "SELECT * FROM #__support_rate WHERE id_table='".$row->id."' AND source='T'" );
$ticketRate = $database->loadObjectList();
print $database->getErrorMsg();

// Get Ticket Attachments
$database->setQuery( "SELECT * FROM #__support_file WHERE id='".$row->id."' AND source='T' ORDER BY filename" );
$ticketAttachs = $database->loadObjectList();
print $database->getErrorMsg();

// Get Ticket Notes
$database->setQuery( "SELECT n.id, n.date_time, n.note, n.show, u.name FROM #__support_note as n, #__users as u WHERE n.id_ticket='".$row->id."' AND n.id_user=u.id ORDER BY n.id" );
$ticketNotes = $database->loadObjectList();
print $database->getErrorMsg();

// Get Ticket Log
$database->setQuery( "SELECT l.id, l.date_time, l.log, u.name FROM #__support_log as l, #__users as u WHERE l.id_user=u.id AND l.id_ticket='".$row->id."' ORDER BY l.id DESC" );
$ticketLogs = $database->loadObjectList();
print $database->getErrorMsg();

// Get Ticket Tasks of all users because we are on administration
$database->setQuery( "SELECT t.id, t.date_time, t.task, t.status, u.name, t.start_time, t.end_time, t.break_time, t.traveltime, t.timeused, t.start_time, t.end_time, t.break_time, t.id_activity_type, t.id_activity_rate, t.end_date FROM #__support_task as t INNER JOIN #__users AS u ON t.id_user = u.id LEFT JOIN #__support_activity_type as y ON y.id=t.id_activity_type LEFT JOIN #__support_activity_rate as ra ON ra.id=t.id_activity_rate WHERE t.id_ticket='".$row->id."' ORDER BY t.id" );
$ticketTasks = $database->loadObjectList();
print $database->getErrorMsg();

// Get Custom Fields for the Workgroup
$database->setQuery( "SELECT w.id_workgroup, w.id_field, w.required, c.caption, c.ftype, c.value, c.size, c.maxlength, v.newfield FROM #__support_wk_fields as w, #__support_custom_fields as c, #__support_field_value as v WHERE w.id_field=c.id AND v.id_field=c.id AND v.id_ticket='".$id."' ORDER BY w.id_workgroup, w.ordering" );
$customfields = $database->loadObjectList();
print $database->getErrorMsg();

// Get Ticket Rate
$rate = 0;
$database->setQuery( "SELECT rate FROM #__support_rate WHERE id_table='".$row->id."' AND source='T'" );
$rate = $database->loadResult();
if( $rate == "" ) {
	$rate = 0;
}
print $database->getErrorMsg();

// Get Ticket Replies and Tasks Travel Sum Value
$database->setQuery( "SELECT SUM(k.traveltime) FROM #__support_task as k, #__support_ticket as t WHERE t.id=k.id_ticket AND t.id=".$row->id );
$traveltime = $database->loadResult();
print $database->getErrorMsg();
$database->setQuery( "SELECT SUM(r.tickettravel) FROM #__support_ticket_resp as r, #__support_ticket as t WHERE t.id=r.id_ticket AND t.id=".$row->id );
$traveltime = $traveltime + $database->loadResult();
print $database->getErrorMsg();

// Get Travel Time on Tickets and Tasks Value
$database->setQuery( "SELECT c.travel_time FROM #__support_client as c, #__support_client_users as u, #__support_ticket as t WHERE c.id=u.id_client AND t.id_user=u.id_user AND t.id=".$row->id );
$clienttravel = $database->loadResult();
print $database->getErrorMsg();

// Get Ticket Messages Values by Activity Type
$database->setQuery( "SELECT SUM(r.timeused * r.user_rate * ra.multiplier) AS total, t.description AS acttype FROM #__support_ticket_resp as r, #__support_activity_type as t, #__support_activity_rate as ra WHERE t.id=r.id_activity_type AND ra.id=r.id_activity_rate AND r.id_ticket='".$row->id."' GROUP BY t.description ORDER BY t.description" );
$ticketValues = $database->loadObjectList();
print $database->getErrorMsg();

// Get Tasks Values by Activity Type
$database->setQuery( "SELECT SUM(r.timeused * r.rate * ra.multiplier) AS total, t.description AS acttype FROM #__support_task as r, #__support_activity_type as t, #__support_activity_rate as ra WHERE t.id=r.id_activity_type AND ra.id=r.id_activity_rate AND r.id_ticket='".$row->id."' GROUP BY t.description ORDER BY t.description" );
$taskValues = $database->loadObjectList();
print $database->getErrorMsg();

$ticketValues = array_merge($ticketValues, $taskValues);
$ticketValues2 = array();
$prevact = '';
$prevind = 0;

for($i=0; $i<count($ticketValues); $i++) {
	$xpto = $ticketValues[$i];
	
	if($xpto->acttype==$prevact) {
		$ticketValues2[$prevind]->acttype = $xpto->acttype;
		$ticketValues2[$prevind]->total   = $ticketValues2[$prevind]->total + $xpto->total;
	}else{
		$prevact = $xpto->acttype;
		$prevind = $i;
		$ticketValues2[$i]->acttype = $xpto->acttype;
		$ticketValues2[$i]->total   = $xpto->total;
	}
}

// Get Ticket Messages Times by Activity Type
$database->setQuery( "SELECT SUM(r.timeused) AS total, t.description AS acttype FROM #__support_ticket_resp as r, #__support_activity_type as t, #__support_activity_rate as ra WHERE t.id=r.id_activity_type AND ra.id=r.id_activity_rate AND r.id_ticket='".$row->id."' GROUP BY t.description ORDER BY t.description" );
$ticketTimes = $database->loadObjectList();
print $database->getErrorMsg();

// Get Tasks Times by Activity Type
$database->setQuery( "SELECT SUM(r.timeused) AS total, t.description AS acttype FROM #__support_task as r, #__support_activity_type as t, #__support_activity_rate as ra WHERE t.id=r.id_activity_type AND ra.id=r.id_activity_rate AND r.id_ticket='".$row->id."' GROUP BY t.description ORDER BY t.description" );
$taskTimes = $database->loadObjectList();
print $database->getErrorMsg();

$ticketTimes = array_merge($ticketTimes, $taskTimes);
$ticketTimes2 = array();
$prevact = '';
$prevind = 0;

for($i=0; $i<count($ticketTimes); $i++) {
	$xpto = $ticketTimes[$i];
	
	if($xpto->acttype==$prevact) {
		$ticketTimes2[$prevind]->acttype = $xpto->acttype;
		$ticketTimes2[$prevind]->total   = $ticketTimes2[$prevind]->total + $xpto->total;
	}else{
		$prevact = $xpto->acttype;
		$prevind = $i;
		$ticketTimes2[$i]->acttype = $xpto->acttype;
		$ticketTimes2[$i]->total   = $xpto->total;
	}
}

// ==================================================================================================================
// Get the template for the page
$tmpl_code->htmlcode = getSCTemplate( $id_workgroup, 'tickets/print_version' );
// ==================================================================================================================

$tmpl = new TicketPrintTmpl();			// Inicialize the TicketTemplate class
$tmpl->HTML = $ticket_tmpl->message;	// Sets the html code of the template
$tmpl->BreakParts();					// Break the html code into parts
$tmpl->BuildNotes( $ticketNotes );		// Build the html code of the notes
$tmpl->BuildAttachs( $ticketAttachs );	// Build the html code of the attachments
$tmpl->BuildLog( $ticketLogs );			// Build the html code of the activity log
$tmpl->BuildCustom( $customfields );	// Build the html code of the custom fields
$tmpl->BuildActivity( $ticketMsgs );	// Build the html code of the custom fields
$tmpl->BuildTimes( $ticketTimes2, $traveltime );	// Build the html code of the times
$tmpl->BuildValues( $ticketValues2 );	// Build the html code of the values
$tmpl->Build();							// Build the final html code with all the parts

// Set the variables
$tmpl->SetVar('ticket',	$row->ticketmask);
$tmpl->SetVar('subject', $row->subject);
$tmpl->SetVar('update', $row->last_update);
$tmpl->SetVar('date', $row->date);
$tmpl->SetVar('duedate', ReturnDueDate( substr($row->date, 0, 4), substr($row->date, 5, 2), substr($row->date, 8, 2), substr($row->date, 11, 2), substr($row->date, 14, 2), $row->id_priority ).':00');

$tmpl->SetVar('workgroup', getWorkgroup($row->id_workgroup));
$tmpl->SetVar('status', getStatus($row->id_status));
$tmpl->SetVar('priority', getPriority($row->id_priority));
$tmpl->SetVar('assign', getAssign($row->assign_to));
$tmpl->SetVar('client', getClient($row->id_user));
$tmpl->SetVar('user', getUser($row->id_user));

$source_desc = '';
if($row->source=="M") {
	$source_desc = JText::_('email');
}elseif($row->source=="F") {
	$source_desc = JText::_('fax');
}elseif($row->source=="O") {
	$source_desc = JText::_('other');
}elseif($row->source=="W") {
	$source_desc = JText::_('website');
}elseif($row->source=="P") {
	$source_desc = JText::_('phone');
}
$tmpl->SetVar('source', $source_desc);

$tmpl->SetVar('rating', '<img src="../images/rating/'.$rate.'star.png" />');

$iso = split( '=', _ISO );

// xml prolog
echo '<?xml version="1.0" encoding="'. $iso[1] .'"?' .'>';
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Ticket</title>
<?php 
echo $ticket_tmpl->stylecode;			// Print the style code
?>
</head>

<body>

<?php 
echo $tmpl->HTML;						// Print the final html code
?>

<table align="center" width="160" cellspacing="2" cellpadding="2" border="0">
<tr>
	<td align="center">
		<a href="#" onClick="window.print()">Print</a> 
		<a href="#" onClick="window.close()">Close</a>
	</td>
</tr>
</table>
</body>
</html>
