<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: maqmahelpdesk.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// Ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

$mainframe = JFactory::getApplication();
$document = JFactory::getDocument();
$session = JFactory::getSession();
$database = JFactory::getDBO();
$user = JFactory::getUser();

include_once ( JPATH_SITE . '/components/com_maqmahelpdesk/includes/common.php' );

$lang = JFactory::getLanguage();
$language_tag = $lang->getTag();
$lang->load( 'com_maqmahelpdesk', JPATH_SITE, $language_tag, true );

$format = JRequest::getVar( 'format', '', '', 'string' );
$tmpl = JRequest::getWord( 'tmpl', '' );
$Itemid = JRequest::getInt( 'Itemid', 0 );

// Include files
require_once( JPATH_SITE.'/components/com_maqmahelpdesk/maqmahelpdesk.class.php' );

$task = JRequest::getCmd( 'task', '', '', 'string' );

if( $task == 'rss' || $task == 'discussions_rss' || $task == 'activities_rss' ) {
	require_once( JPATH_SITE.'/components/com_maqmahelpdesk/'.$task.'.php' );
	return;
}

@list( $function, $task ) = explode( '_', $task, 2 );

$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
$msg = urldecode( JRequest::getVar( 'msg', '', '', 'string' ) );
$msgtype = JRequest::getVar( 'msgtype', '', '', 'string' );

// Get config
$supportConfig = GetConfig();
$GLOBALS['supportConfig'] = $supportConfig;

// Set our location as front end for the global messages, f=front end, a=administration
$GLOBALS['sysmsgs_user_location'] = 'f';
if( $task != 'download' && $task != 'getfile' && $format != 'pdf' && $function != 'ajax' && $task != 'checkticket' && $format != 'raw' ) {
	$document->addScriptDeclaration('var SITEURL = "'.JURI::root().'";');
	echo '<script type="text/javascript" src="'.JURI::root().'components/com_maqmahelpdesk/js/jquery-1.7.min.js"></script>';
	echo '<script type="text/javascript" src="'.JURI::root().'components/com_maqmahelpdesk/js/maqmahelpdesk.js"></script>';
	echo '<script type="text/javascript" src="'.JURI::root().'components/com_maqmahelpdesk/js/jquery.gritter.min.js"></script>';
	echo '<script type="text/javascript" src="'.JURI::root().'components/com_maqmahelpdesk/js/duedate_frontend.js"></script>';
	echo '<link rel="stylesheet" href="'. JURI::root() .'components/com_maqmahelpdesk/css/gh-buttons.css" media="screen" type="text/css" />';
	if($lang->isRTL()){
		echo '<link rel="stylesheet" href="'. JURI::root() .'components/com_maqmahelpdesk/css/gh-buttons_rtl.css" media="screen" type="text/css" />';
	}
}

$is_support     = 0;	// Indicates if the user is from the support staff
$is_manager     = 0;	// Indicates if the user if manager from Support or from a Client
$is_client      = 0;	// Indicates the ID of the client if the user belongs to a Client
$clientWK		= 0;	// Indicates if the client user has access to the workgroup
$supportWK		= 0;	// Indicates if the support user has access to the workgroup
$supportOptions = null;	// Gets the user permissions for the workgroup
$clientOptions  = null;	// Gets the user info
$usertype = '';			// Client user = 1; Client Mgr = 2; Support user = 5; Support team leader = 6; Support mgr = 7;

if( $user->id == 0 && $supportConfig->unregister == 0 && $function != 'forms' && $function != 'ajax' && $function != 'addon' ) {
	$task     = 'noaccess';
	$function = 'warning';
	noAccessQuit();
}else{
	$database->setQuery( "SELECT COUNT(*) FROM #__support_permission p, #__support_workgroup w WHERE p.id_user='".$user->id."' AND w.id = p.id_workgroup AND w.id=".$id_workgroup );
	$is_support = $database->loadResult();
	
	if ($task == '') {
		$database->setQuery( "SELECT COUNT(*) FROM #__support_permission p, #__support_workgroup w WHERE p.id_user='".$user->id."' AND w.id = p.id_workgroup" );
		$is_support = ($database->loadResult()?1:0);
	}
	
	$database->setQuery( "SELECT u.id_client FROM #__support_client_users u, #__support_client c WHERE u.id_user='".$user->id."' AND c.id=u.id_client" );
	$database->loadResult() ? $is_client = $database->loadResult() : '' ;

	if( $is_support > 0 ) {
		if ( $is_client > 0 ) {
			showSCMessage(JText::_('client_and_support'), 'e');
			$is_client = 0;
		}
	}
}

// Workgroup permissions
if( $id_workgroup ) {
	// Get the settings of the Workgroup 
	$workgroupSettings = null;
	$database->setQuery( "SELECT * FROM #__support_workgroup WHERE id='".$id_workgroup."'" );
	$workgroupSettings = $database->loadObject();
	
	// If user is from support gets his permissions to the workgroup
	if( $is_support ) {
		// Permission checks
		$supportWK = 0;
		$database->setQuery( "SELECT COUNT(*) FROM #__support_permission WHERE id_user='".$user->id."' AND id_workgroup='".$id_workgroup."'" );
		$supportWK = $database->loadResult();
		if( $supportWK == 0) {
			$task     = 'noaccess';
			$function = 'warning';
			noAccessQuit();
		}

		$database->setQuery( "SELECT p.manager FROM #__support_permission p, #__support_workgroup w  WHERE p.id_user='".$user->id."' AND p.id_workgroup='".$id_workgroup."' AND p.id_workgroup=w.id" );
		$supportOptions = null;
		$supportOptions = $database->loadObject();
		if ($supportOptions) {
			$is_manager = $supportOptions->manager;
			$usertype = $is_manager; //Set support staff user type (Support user = 5; Support team leader = 6; Support mgr = 7;)
		}
	}
	
	// If user is a client gets his permissions to the workgroup and his info
	if( $is_client ) {
		// Get the user information
		$database->setQuery( "SELECT cu.id_client, cu.manager, u.phone, u.fax, u.mobile FROM #__support_client_users cu INNER JOIN #__support_client c ON c.id=cu.id_client LEFT JOIN #__support_users u ON u.id_user=cu.id_user WHERE cu.id_user='".$user->id."'" );
		$clientOptions = null;
		$clientOptions = $database->loadObject();
		$is_manager = $clientOptions->manager;
		$client_id = $clientOptions->id_client;
		$GLOBALS['client_id'] = $client_id;
		
		$is_manager ? $usertype = 2 : $usertype = 1; //Set usetype to Client manager or Client user
		
		// Check if the client have access to the workgroup
		$sql = "SELECT COUNT(*) 
				FROM `#__support_client_wk` c
					 LEFT JOIN `#__support_workgroup` w ON w.`id`=c.`id_workgroup` 
				WHERE c.`id_client`=".(int)$client_id." 
				  AND ( c.`id_workgroup`=".(int)$id_workgroup." OR c.`id_workgroup`=0 )";
		$database->setQuery( $sql );
		$clientWK = $database->loadResult();
		if( !$clientWK ) {
			$task     = 'noaccess';
			$function = 'warning';
			noAccessQuit();
		}

		// Check the contract information
		if( $workgroupSettings->contract ) {
			// Try to auto-enable a contract
			if( !isValidContract($user->id) ) {
				makeContractActive( $is_client, 0 );
			}
			// Shows a warning message if no valid contract but still have access
			if( !isValidContract($user->id) && !$workgroupSettings->contract_total_disable ) {
				showSCMessage(JText::_('wkcontractwarn'),'w');
			}
			// If access is completelly blocked block it
			if( !isValidContract($user->id) && $workgroupSettings->contract_total_disable ) {
				$task     = 'nocontract';
				$function = 'warning';
				noAccessQuit();
			}
		}

		// Check if client is blocked
		$database->setQuery( "SELECT block FROM #__support_client WHERE id='".$is_client."'" );
		if( $database->loadResult() == 1 ) {
			$task     = 'noaccess';
			$function = 'warning';
			noAccessQuit();
		}
	
	// The user doesn't belong to any client and the access to the workgroup
	// will be checked by returning if there are records in the restriction of this 
	// workgroup with clients, if there is then the user don't have access to the
	// workgroup, if there's no records then the access is allowed except if it's only for
	// contracts. Only users from clients can have contracts.
	} else {
		if ($workgroupSettings) {
			if( $workgroupSettings->contract && $is_client > 0 ) {
				$task     = 'nocontract';
				$function = 'warning';
				noAccessQuit();
			}
		}
	}
}

// Globals
$GLOBALS['is_manager'] = $is_manager;
$GLOBALS['is_support'] = $is_support;
$GLOBALS['is_client'] = $is_client;

// Set usertype to 1 for users who do not belong to a client or support 
if (!$is_client && !$is_support && $user->id > 0 ) {
	$usertype = 1;
}

// Check mobile
require_once( JPATH_SITE.'/components/com_maqmahelpdesk/classes/mobile.class.php' );
$mcheck = new MobileDetect();
/*print "<p>-".$is_support;
print "<p>-".$supportConfig->mobile_interface;
print "<p>-".$mcheck->IsMobile();*/
if( $is_support && $supportConfig->mobile_interface && $mcheck->IsMobile() ) {
	$session->set("helpdesk_mobile",true);
	// May need to recall the page with format=raw
	if( $format != 'raw' ) {
		$mainframe->redirect("index.php?option=com_maqmahelpdesk&Itemid=".$Itemid."&format=raw");
	}
}else{
	$session->set("helpdesk_mobile",false);
}

$GLOBALS['clientOptions'] = $clientOptions;
$GLOBALS['usertype'] = $usertype;

// Shows message if there's any
if( $msg != '' && $msgtype != '' ) {
	showSCMessage( $msg, $msgtype );
}elseif( $msg != '' && $msgtype == '' ) {
	showTplMessage( $msg, $id_workgroup );
}

// Display global system messages
if( $function != 'ajax' ) {
	getGlobalMessage();
}

// ADDED
if (isset($supportOptions)) $GLOBALS['supportOptions'] = $supportOptions;

$GLOBALS['workgroupSettings'] = (isset($workgroupSettings))? $workgroupSettings : 0;
if (isset($id_workgroup)) $GLOBALS['id_workgroup'] = $id_workgroup;
if (isset($userInfo)) $GLOBALS['userInfo'] = $userInfo;
if (isset($supportConfig)) $GLOBALS['supportConfig'] = $supportConfig;

// Calls the required function page
if( $task != 'noaccess' ) {
	require_once( JPATH_SITE."/components/com_maqmahelpdesk/functions/".($function!='' ? $function : 'workgroup').".php" );
}

if ( !$supportConfig->hide_powered && $task != 'getfile' && $function != 'ajax' && $tmpl != 'component' ) {
	$powered_msg = '<br /><br />';
	$powered_msg .= '<span style="text-align:center; width:100%; font-size:10px;"><a href="http://www.imaqma.com/joomla/helpdesk-component.html" title="MaQma Helpdesk component for Joomla!" target="_blank">Powered by MaQma HelpDesk</a></span><br /><br />';
	echo $powered_msg;
}

if( isset($workgroupSettings) && $task != 'getfile' && $function != 'ajax' && $task != 'checkticket' && $format != 'raw' && $task != 'noaccess' ) {
	print '<link rel="stylesheet" href="'. JURI::root() .'components/com_maqmahelpdesk/templates/'.$workgroupSettings->theme.'/css/'.$workgroupSettings->theme.'.css" media="screen" type="text/css" />'."\n";
	if($lang->isRTL()){
		print '<link rel="stylesheet" href="'. JURI::root() .'components/com_maqmahelpdesk/templates/'.$workgroupSettings->theme.'/css/'.$workgroupSettings->theme.'_rtl.css" media="screen" type="text/css" />'."\n";
	}
}elseif( !isset($workgroupSettings) && $task != 'getfile' && file_exists(JPATH_SITE.'/components/com_maqmahelpdesk/templates/default/css/default.css') && $function != 'ajax' && $task != 'checkticket' && $format != 'raw' && $task != 'noaccess' ) {
	print '<link rel="stylesheet" href="'. JURI::root() .'components/com_maqmahelpdesk/templates/default/css/default.css" media="screen" type="text/css" />'."\n";
	if($lang->isRTL()){
		print '<link rel="stylesheet" href="'. JURI::root() .'components/com_maqmahelpdesk/templates/default/css/default_rtl.css" media="screen" type="text/css" />'."\n";
	}
}
