<?php
/**
* @copyright	Copyright (C) 2009 - 2011 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* @package		PayPlans
* @subpackage	Frontend
* @contact 		shyam@readybytes.in
* website		http://www.jpayplans.com
* Technical Support : Forum -	http://www.jpayplans.com/support/support-forum.html
*/
if(defined('_JEXEC')===false) die();

jimport('joomla.filesystem.file');

class PayplansHelperPatch
{
	static function getMapper()
	{
		$_mapper = array();
		// when add new patch update the definition
		
		$_mapper  = Array(
						'secondPatch',
						'patch_enable_plugins',
						'patch_enable_modules',
						'patch_20_001_create_email_attachment_dir',
						'patch_20_002_remove_previous_theme_folders',
						'patch_20_003_remove_installer_message_file',
                        'patch_20_004_mexican_currency_code_change',
						'patch_20_005_modified_discount_amount',
						'patch_20_006_spell_correction',
						'patch_20_007_add_tax_type',
						'patch_20_008_remove_data_redundancy',
						'patch_20_009_add_expiration_type',
						'patch_20_010_delete_unused_invoices',
						'patch_20_011_update_confirm_invoices',
						'patch_20_012_update_invoice_counter',
						'patch_20_013_add_expiration_time',
						'patch_20_014_update_modifier_frequency',
						'patch_20_015_utilize_wallet_balance',
						'patch_20_016_equate_wallet_balance',
						'patch_20_017_update_order_total',
						'patch_20_018_update_invoice_amount',
						'patch_20_019_make_transaction_date',
						'patch_21_001_remove_formatter_files',	
                        'patch_21_002_remove_module',
						'patch_21_003_indexing_of_tables',
						'patch_21_004_encode_params_userDetail',
						'patch_21_005_remove_dummy_invoices',
						'patch_21_006_indexing_of_subscription_tables',
						'patch_21_007_add_upgrade_params_in_orders',
						'patch_21_008_utilize_unused_balance',
						'patch_21_009_update_config_param',
		 				'patch_22_001_alter_log_table',
						'patch_22_002_uninstall_charts_module',
						'patch_23_001_uninstall_search_module'
						);
		return $_mapper;
	}
	
	static function applyPatches($class='PayplansHelperPatch', $mapper=null)
	{
		if($mapper === null){
			$mapper = self::getMapper();
		}
		
		$lastPatch = XiHelperPatch::queryPatch();
		$key 	   = array_search($lastPatch, $mapper);
		
		$key++;
		
		while (isset($mapper[$key])){
			$nextPatch = $mapper[$key];
			if(method_exists($class, $nextPatch)===false){
				return false;
			}
			// XITODO : handle false return 
			$result = call_user_func(array($class, $nextPatch));
			//if some error return false
			if($result === false){
				return false;
			}
			//update current patch to database
			XiHelperPatch::updatePatch($nextPatch);			
			$key++;
		}
		
		return true;
	}

	//do install install.sql
	static function firstPatch()
	{
		return XiHelperPatch::applySqlFile(dirname(__FILE__).DS.'patch'.DS.'sql'.DS.'install.sql');
	}


	//install system data
	static function secondPatch()
	{
		// check if admin payment app already exists 
		// if exists then do nothing other wise insert it
		$query 	= new XiQuery();
		$result = $query->select('app_id')
						->from('#__payplans_app')
						->where(' `type` = "adminpay" ')
						->dbLoadQuery()->loadObjectList();
						
		if(empty($result)){
			$db = XiFactory::getDBO();
			$sql = "INSERT IGNORE INTO `#__payplans_app` 
					(`title`, `type`, `description`, `core_params`, `app_params`, `ordering`, `published`) 
					VALUES
					('Admin Payment', 'adminpay', 'Through this application Admin can create payment from back-end. There is no either way to create payment from back-end. This application can not be created, changed and deleted. And can not be used for fron-end payment.', 'applyAll=1\n\n', '\n', 1, 1)";
			$db->setQuery($sql);
			$db->query();
		}
		return XiHelperPatch::applySqlFile(dirname(__FILE__).DS.'patch'.DS.'sql'.DS.'system-data.sql');
	}

	static function patch_enable_plugins()
	{
		$enable=1;
		$plugins = array( 
						array('system',		'payplans'),
					 	array('payplans',	'discount'),
					 	array('payplansmigration',	'sample'),
					//	array('payplansregistration', 'joomla'),
					   // array('payplansregistration', 'jomsocial'),
					    array('payplansregistration', 'auto'),
					    array('payplans', 'appmanager')
					  );
						
		foreach($plugins as $plugin){
			$folder = $plugin[0];
			$pluginName = $plugin[1];
			XiHelperPatch::changePluginState($pluginName, $enable, $folder);
		}

		return true;
	}
	
	static function patch_enable_modules()
	{
		$enable=1;
		$modules	= array(
					'mod_payplans_quickicon'	=> 'icon'
				);
		foreach($modules as $module=>$position){
			XiHelperPatch::changeModuleState($module, $position, $enable);
		}

		// special case order mod_payplans_setup at least order
		XiHelperPatch::changeModuleOrder(-100, 'mod_payplans_setup');
		return true;
	}
		
    //enbale only system plugin during upgradation
	static function patch_enable_system_plugin($enable=1)
	{
		XiHelperPatch::changePluginState('payplans', $enable, 'system');
        return true;
	}
	static function patch_20_001_create_email_attachment_dir()
	{
		$path = JPATH_SITE.DS.'media'.DS.'payplans'.DS.'app'.DS.'email';
		//check if folder exist or not. If not exists then create it.
		if(JFolder::exists($path)==false)
		    {	
		    	return JFolder::create($path);
		    }
		return true;
	}
	static function patch_20_002_remove_previous_theme_folders()
	{
		$theme = null;
		$value = XiFactory::getConfig()->theme;
		if($value == 'orange'){
			$theme = 'default_ef723b';
		}elseif ($value == 'orange_dark'){
			$theme = 'dark_ef723b';
		}
		
		if($theme !== null){
			PayplansConfig::getInstance(PAYPLANS_CONFIG_CUSTOMIZATION)
						->bind(array('config'=>array('theme'=>$theme)))
						->save();
		}
		
		$folders = array(PAYPLANS_PATH_MEDIA.DS.'themes'.DS.'orange',
									 PAYPLANS_PATH_MEDIA.DS.'themes'.DS.'orange_dark');
		
		foreach ($folders as $folder){
			XiHelperPatch::removeDir($folder);
		}
	}
	
	static function patch_20_003_remove_installer_message_file()
	{
		XiHelperPatch::removeFile(PAYPLANS_PATH_COMPONENT_ADMIN.DS.'installer'.DS.'message.php');
	}
     
    static function patch_20_004_mexican_currency_code_change()
	{
		$db		= XiFactory::getDBO();
		
	    $query =  "INSERT INTO". $db->quoteName('#__payplans_currency'). 
		          "values ('MXN', 'Mexican Peso','1','NULL','NULL')
                  ON DUPLICATE KEY UPDATE currency_id = 'MXN'";
		$db->setQuery($query);
		
		if(!$db->query()){
			return false;
		}
		
		$query="DELETE FROM".$db->quoteName('#__payplans_currency').
		       "WHERE currency_id = 'MXP'";
		$db->setQuery($query);
		if(!$db->query()){
			return false;
		}
		
		return true;
	}
	
	/**
	 * Patch regarding Migration issue.
	 * ## change -ive amount into discount amount.
	 */
    static function patch_20_005_modified_discount_amount()
	{
		$db		= XiFactory::getDBO();
		$query	= new XiQuery;
		// IMP:: Dont change spell.
		$query->update('#__payplans_modifier')
			  ->set("amount=-amount")
			  ->where("`type`='dicount'");
		
		if(!$query->dbLoadQuery()->query()){
			return false;
		}
		return true;
	}
	
	/**
	 * Patch regarding Migration issue
	 * ## Change Discount spell {dicount=>discount}
	 */
    static function patch_20_006_spell_correction()
	{
		$db		= XiFactory::getDBO();
		$query  = new XiQuery;
		$query->update('#__payplans_modifier')
			  ->set("type='discount'")
			  ->where("`type`='dicount'");
		
		if(!$query->dbLoadQuery()->query()){
			return false;
		}
		return true;
	}

	/**
	 * Patch regarding Migration issue
	 * ## Add tax type
	 */
    static function patch_20_007_add_tax_type()
	{
		$db		= XiFactory::getDBO();
		$query  = new XiQuery;
		// default is null
		$tax_type = '';
		
		$basic_tax = PayplansHelperApp::getAvailableApps('basictax');
		if(!empty($basic_tax)){
			$tax_type = 'basictax';
		}
		
		$euvat_tax = PayplansHelperApp::getAvailableApps('euvat');
		if(!empty($euvat_tax)){
			$tax_type = 'euvat';
		}
		
		$condition = "`serial` BETWEEN ".PayplansModifier::FIXED_TAX . ' AND '. PayplansModifier::PERCENT_TAX;
		$query->update('#__payplans_modifier')
			  ->set("type='$tax_type'")
			  ->where($condition);
		
		if(!$query->dbLoadQuery()->query()){
			return false;
		}
		return true;
	}


	/**
	 * Patch regarding Migration issue
	 * ## Remove duplicate entries
	 */
    static function patch_20_008_remove_data_redundancy()
	{
		$db		= XiFactory::getDBO();
		$query  = new XiQuery;
		$query->select('GROUP_CONCAT( CONVERT( `modifier_id` , CHAR( 8 ) ) ) AS modifier_id')
			  ->select('invoice_id')
			  ->select('type')
			  ->from('#__payplans_modifier')
			  ->group(array('invoice_id' , 'type'))
			  ->having("count( * ) >1");
			  
			  
		$results = $query->dbLoadQuery()->loadobjectlist('invoice_id');
		$delete_modifiers = Array();
		
		foreach ($results as $result){
			$modifier = explode(',', $result->modifier_id);
			// we dont delete last element
			array_pop($modifier);
			$delete_modifiers = array_merge($delete_modifiers, $modifier);
		}
		
		if(!empty($delete_modifiers)){
			$conditions = '`modifier_id` IN ( '. implode(',', $delete_modifiers).')';
			$query->delete()
				  ->from('#__payplans_modifier')
				  ->where($conditions);
			if(!$query->dbLoadQuery()->query()){
				return false;
			}
		}
		return true;
	}
	
	/**
	 * Set expiration type
	 * Fix:: Ticket Number #1562
	 */
	static function patch_20_009_add_expiration_type($limit, $offset=0)
	{
//		$db		 = XiFactory::getDBO();
//		$query	 = new XiQuery;
//		
//		//get all plans with their expiration types
//		$query->select('*')
//			  ->from('#__payplans_plan');
//	
//		$plans = $query->dbLoadQuery()->loadObjectList('plan_id');
//		foreach($plans as $plan_id=>$plan){
//			$plan_params 	=  (array) JRegistryFormatXiINI::stringToObject($plan->details);
//			$plans[$plan_id]->expirationtype = $plan_params['expirationtype'];
//		}
//		$query->clear();
//		
//		// Get orders according to limit
//		$query->select('orders.`order_id`, subs.`plan_id`')
//			  ->from('`#__payplans_order` as orders')
//			  ->innerJoin('	`#__payplans_subscription` as subs
//							 ON orders.`order_id`= subs.`order_id`')
//			  ->order('order_id')
//			  ->limit($limit,$offset);
//
//		// Pair:: Array([Order_id]=>stdClass(order_id,plan_id))
//		$order_ids = $query->dbLoadQuery()->loadObjectList('order_id');
//		$query->clear();
//		
//		if(empty($order_ids)){
//			JRequest::setVar('offset', 0);
//			return true;
//		}
//
//		$order_array = array_keys($order_ids);
//		// Get all invoice according to order_ids 
//		$condition = 'object_id IN ('.implode(',', $order_array).')';
//		$query->select('*')
//			  ->from('#__payplans_invoice')
//			  ->where($condition);
//		
//		$invoices = $query->dbLoadQuery()->loadobjectlist('invoice_id');
//		$query->clear();
//		
//		//Pair: Array(Order_id=>Array('all invoices'))
//		$orders = Array();
//		foreach ($invoices as $invoice_id=>$invoice){
//			$orders[$invoice->object_id][$invoice_id] = $invoice;
//		}
//		//Applied Patch : Add expiration type
//		$message= XiText::_('COM_PAYPLANS_PATCH_FOR_ADD_EXPIRATION_TYPE');
//		// unusual expiration type for this patch
//		$expiration_type =Array('recurring','recurring_trial_1','recurring_trial_2','fixed');		
//		
//		foreach ($orders as $order_id => $invoices){
//			// sorted invoice id
//			ksort($invoices);
//			// $flag :: trial type is missing.
//			$flag = false;
//			foreach ($invoices as $invoice_id=>$invoice){
//				// invoice params 
//				$params = (array) JRegistryFormatXiINI::stringToObject($invoice->params);
//
//				if(isset($params['expirationtype']) && in_array($params['expirationtype'], $expiration_type)){
//					$flag = true;				
//					continue;
//				}
//			
//				$params['expirationtype'] = $plans[$order_ids[$invoice->object_id]->plan_id]->expirationtype;
//			
//				if( $params['expirationtype'] == 'recurring_trial_1' ) {
//					$expirationType = ($flag)? 'recurring' : $params['expirationtype'];
//					$flag = true;
//				}
//				
//				$params = (object)$params;
//				$params = JRegistryFormatXiINI::objectToString($params,null);
//			
//				$params  = (PAYPLANS_JVERSION_15) ? $db->getEscaped($params) : $db->escape($params);
//				$pre_invoice = PayplansInvoice::getInstance($invoice_id);
//				XiFactory::cleanStaticCache(true);
//				// UPDATE EXPIRATION TYPE
//				$query->update('#__payplans_invoice')
//					    ->set("`params`='$params'")
//					    ->where("`invoice_id`=$invoice_id");
//				  
//				if(!$query->dbLoadQuery()->query()){
//					return false;
//				}
//				// IMP :: Dont remove it 
//				$query->clear();
//				// Maintain log information 
//				$current_invoice = PayplansInvoice::getInstance($invoice_id);
//				$content = XiFormatter::writer($pre_invoice, $current_invoice);
//				PayplansHelperLogger::log(XiLogger::LEVEL_INFO, $message,$current_invoice ,$content,'PayplansFormatterLibInvoice');
//			}	
//		}
//		
//		JRequest::setVar('offset', $offset+$limit);
		return true;
	}
	
	/**
	 * 
	 * Delete unused confirm invoice 
	 * ticket #1586
	 * @param $limit
	 * @param $offset
	 */	

	static function patch_20_010_delete_unused_invoices($limit, $offset=0)
	{
		
		// get a reference to the database
		$db     = XiFactory::getDBO();
		$query  = new XiQuery;
		
		$records =	$query->select("`object_id`, GROUP_CONCAT(CONVERT(`invoice_id`,CHAR)) as invoice")
						  ->from('#__payplans_invoice')
						  ->where('(`status`= 401 OR `status` = 0)')
						  ->where('`object_id` <> 0')
						  ->group('object_id')
						  ->having('COUNT(*) >1')
						  ->dbLoadQuery()
						  ->loadObjectList();
						  
		if(empty($records)){
			return true;
		}
		
		$unused_invoices = Array();
		foreach ($records as $record){
			$query->clear();
			//Don't delete those invoice which are exists into Payment tables
			$invoices = $query->select('invoice_id')
							  ->from('#__payplans_payment')
							  ->where("`invoice_id` IN ($record->invoice)")
							  ->dbLoadQuery()
							  ->loadColumn();
			$invoices_filter  = explode(',', $record->invoice);
			$unused_invoices = array_merge($unused_invoices, array_diff($invoices_filter,$invoices));					  
		}
		
		$query->clear();
		
	    if(empty($unused_invoices)){ continue;}
		
		$db = $query->delete()
			  ->from('#__payplans_invoice')
			  ->where('invoice_id IN ('.implode(',',$unused_invoices).')')
			  ->dbLoadQuery();
					  
		if(!$db->query()){
			return false;
		}		
		
		$query->clear();
		$db = $query->delete()
			  ->from('#__payplans_transaction')
			  ->where('current_invoice_id IN ('.implode(',',$unused_invoices).')')
			  ->dbLoadQuery();
					  
		if(!$db->query()){
			return false;
		}
		
		return true;
	}
	
	
	/**
	 * 
	 * Replace confirm invoice by next paid/refund invoice
	 * Ticket #1587
	 * @param unknown_type $limit
	 * @param unknown_type $offset
	 */
	static function patch_20_011_update_confirm_invoices($limit, $offset=0)
	{
		
		// get a reference to the database
		$db     = XiFactory::getDBO();
		$query  = new XiQuery;
		
		$orders = $query->select('object_id')
						->from('#__payplans_invoice')
						->where('`status` = 401')
						->where('`object_id` <> 0')
						->dbLoadQuery()
						->loadColumn();
		$query->clear();
		
		if(empty($orders)){
			return true;
		}
		
		$records =	$query->select("*")
						  ->from('#__payplans_invoice')
						  ->where('`status` IN ( 402,403)')
						  ->where('`object_id` <> 0')
						  ->where('`object_id`  IN ( '. implode(',', $orders) .')')
						  ->group('object_id')
						  ->dbLoadQuery()
						  ->loadObjectList('object_id');
		
		$query->clear();
		
		if(empty($records)){
			return true;
		}
		
		$object_ids = array_keys($records);
		
		$confirm_invoices =	$query->select("*")
								  ->from('#__payplans_invoice')
								  ->where('`status` = 401')
								  ->where('`object_id` IN ('.implode(',',$object_ids).')')
								  ->dbLoadQuery()
								  ->loadObjectList('object_id');
						  
		if(empty($confirm_invoices)){
			return true;
		}
	
		$delete_invoices = Array();
		foreach ($records as $object_id =>$record){
			// We do not delete those invoice (paid/refund) which are created  before confirme invoice. 
			if($record->invoice_id > $confirm_invoices[$object_id]->invoice_id){
				continue;
			}
			
			$query->clear();			

			$delete_invoices[] = $record->invoice_id;
			$query->update('#__payplans_invoice')
				  ->set("status = {$record->status}")
				  ->where("invoice_id = {$confirm_invoices[$object_id]->invoice_id}");

			if(!$query->dbLoadQuery()->query()){
				return false;
			}

			$query->clear();
			$query->update('#__payplans_transaction')
				  ->set("current_invoice_id = {$confirm_invoices[$object_id]->invoice_id}")
				  ->where("current_invoice_id = $record->invoice_id");

			if(!$query->dbLoadQuery()->query()){
				return false;
			}
			
			$query->clear();
			$query->update('#__payplans_transaction')
				  ->set("invoice_id = {$confirm_invoices[$object_id]->invoice_id}")
				  ->where("invoice_id = $record->invoice_id");

			if(!$query->dbLoadQuery()->query()){
				return false;
			}
			
			$query->clear();
			$query->update('#__payplans_wallet')
				  ->set("invoice_id = {$confirm_invoices[$object_id]->invoice_id}")
				  ->where("invoice_id = $record->invoice_id");

			if(!$query->dbLoadQuery()->query()){
				return false;
			}
		}
		
		
		$query->clear();

		if(empty($delete_invoices)){ return true;}

		$db = $query->delete()
			  ->from('#__payplans_invoice')
			  ->where('invoice_id IN ('.implode(',',$delete_invoices).')')
			  ->dbLoadQuery();
					  
		if(!$db->query()){
			return false;
		}
				
		return true;
	}
	
	/**
	 * Ticket #1588
	 * @param unknown_type $limit
	 * @param unknown_type $offset
	 */		
	static function patch_20_012_update_invoice_counter($limit,$offset=0)
	{
	        // get a reference to the database
	        $db     = XiFactory::getDBO();
	        $query  = new XiQuery;
	       
	        $records = $query->select('object_id as order_id,  GROUP_CONCAT(invoice_id) as invoice_ids')
	                                  ->from('#__payplans_invoice')
	                                  ->where('`object_id` <> 0')
	                                  ->group('object_id')
	                                  ->limit($limit,$offset)
	                                  ->dbLoadQuery()
	                                  ->loadObjectList();
	                                  
	        if(empty($records)){
	        	JRequest::setVar('offset', 0);
	        	return true;
	        }
	        
	        foreach($records as $record){
	            $invoice_ids = explode(',', $record->invoice_ids);
	            sort($invoice_ids);
	            
	            $counter = 1;
	            foreach($invoice_ids as $invoice_id)
	            {
	                $query->clear();
	                 $query->update('#__payplans_invoice')
		                    ->set('counter = '.$counter)
		                    ->where("invoice_id = $invoice_id")
		                    ->dbLoadQuery()
		                    ->query();	
	                $counter++;
	            }
	        }
	
	        JRequest::setVar('offset', $offset+$limit);
	        return true;
	}
	
	/**
	 * Set expiration type, expiration and recurrenc count
	 * Fix:: Ticket Number #1585
	 */
	static function patch_20_013_add_expiration_time($limit, $offset=0)
	{
		$db		 = XiFactory::getDBO();
		$query	 = new XiQuery;
		
		// Patch applicable when your system migrated from PayPlans 1.4 to PayPlans 2.0
		$db->setQuery("SHOW TABLES LIKE 'bk_payplans_subscription'");
		$result = $db->loadColumn();
		if(empty($result)){
			return true;
		}
		
		//get all subscription from back up table
		$records = $query->select('old.subscription_id as subscription_id ,old.plan_id AS plan_id, old.params AS old_params ,new.params AS new_params')
		  				 ->from('bk_payplans_subscription AS old')
		  				 ->from('#__payplans_subscription AS new')
		  				 ->where('old.subscription_id = new.subscription_id')
		  				 ->limit($limit, $offset)
		  				 ->dbLoadQuery()
		  				 ->loadObjectList('subscription_id');
			  				 
		$query->clear();


		if(empty($records)){
			JRequest::setVar('offset', 0);
			return true;
		}

		$plans 	= $query->select('*')
			  			->from('#__payplans_plan')
			  			->dbLoadQuery()
			  			->loadObjectList('plan_id');
		
		$query->clear();
		
		$plan_params = Array();
		foreach ($plans as $plan_id=>$plan) {
			$plan_params[$plan_id] = (array) JRegistryFormatXiINI::stringToObject($plan->details);
		}

		$sub_params = array();
		foreach($records as $record){
			$old_params = (array) JRegistryFormatXiINI::stringToObject($record->old_params);
			$new_params = (array) JRegistryFormatXiINI::stringToObject($record->new_params);
			
			$new_params['expiration'] = $plan_params[$record->plan_id]['expiration'];
			
			$new_params['expirationtype'] =  isset($old_params['expirationtype'])
												? $old_params['expirationtype'] 
												: $plan_params[$record->plan_id]['expirationtype'];
			
			if(isset($old_params['expiration_time'])){
				$new_params['expiration'] = $old_params['expiration_time'];
			}
			
			if(!isset($old_params['expirationtype']) ){
				$new_params['expirationtype'] = $plan_params[$record->plan_id]['expirationtype'];
			}
			
			if('UNDEFINED' != $old_params['first_price']) {
				$new_params['expirationtype'] = 'recurring_trial_1';
			}
			
			if('000000000000' == $new_params['expiration'] && $new_params['expirationtype'] != 'forever'){
				$new_params['expiration'] = $plan_params[$record->plan_id]['expiration'];
			}
			
			if(-1 == $new_params['recurrence_count']){
				$new_params['recurrence_count'] = 0;
			}
			// utilize into invoice param
			$sub_params[$record->subscription_id] = $new_params;
			
			$new_params = (object) $new_params;
			$new_params = JRegistryFormatXiINI::objectToString($new_params,null);
			
			
			if(! $query->update('#__payplans_subscription')
						->set("params = '$new_params'")
						->where("subscription_id = $record->subscription_id ")
						->dbLoadQuery()
						->query())
			{	return false;	}

			$query->clear();
		}
		
		$subscription_ids = array_keys($records);

		
		$invoices = $query->select('invoice.invoice_id as invoice_id, subs.subscription_id as subscription_id, invoice.params as params,invoice.counter as counter')
							->from('#__payplans_invoice as invoice')
							->innerJoin("#__payplans_order as ord on ( ord.order_id = invoice.object_id)")
							->innerJoin("#__payplans_subscription as subs on ( subs.order_id = ord.order_id)")
							->where('subs.subscription_id IN ('.implode(',', $subscription_ids).')')
							->dbLoadQuery()
							->loadObjectList();
		$query->clear();
		
		//if(empty($invoices)){	return true;	}
		
		$recurr_expiration_type = Array('recurring','recurring_trial_1');
		
		foreach($invoices as $id => $invoice){
			$params 				= (array) JRegistryFormatXiINI::stringToObject($invoice->params);
			//Expiration time
			$params['expiration'] 	= $sub_params[$invoice->subscription_id]['expiration'];
			// Expiration Type
			$params['expirationtype'] = $sub_params[$invoice->subscription_id]['expirationtype'];
			// if counter is greater than one and expiration type is {'recurring' OR 'recurring_trial_1'} 
			// then set Expiration type is recurring  
			if($invoice->counter > 1  && in_array($params['expirationtype'], $recurr_expiration_type )){
				$params['expirationtype'] = 'recurring';
			}
			
			if(-1 == $params['recurrence_count']){
				$params['recurrence_count'] = 0;
			}

			$params 				= (object) $params;
			$params 				= JRegistryFormatXiINI::objectToString($params,null);
			
			if(!$query->update('#__payplans_invoice')
					 ->set("params = '$params'")
					 ->where('invoice_id = '.$invoice->invoice_id)
					 ->dbLoadQuery()
					 ->query())
			{	 return false; }
			$query->clear();
		}
				
		JRequest::setVar('offset', $offset+$limit);
		return true;
	}
	
	
	static function patch_20_014_update_modifier_frequency($limit, $offset =0)
	{
		$db		 = XiFactory::getDBO();
		$query	 = new XiQuery;
		
		// Patch applicable when your system migrated from PayPlans 1.4 to PayPlans 2.0
		if(!XiHelperPatch::isTableExist('bk_payplans_subscription')){
			return true;
		}
		
		$query = $query->select('S.`subscription_id`')
					   ->select('I.`object_id` AS order_id')
					   ->select('GROUP_CONCAT(convert( I.`invoice_id` , CHAR )) AS invoice_id')
					   ->select('S.`params`')
					   ->select('S.`user_id`')
					   ->from('`bk_payplans_subscription` AS S')
					   ->innerJoin('`#__payplans_invoice` AS I ON S.`order_id` = I.`object_id`')
					   ->group('I.`object_id`')
					   ->limit($limit,$offset);
					   
		$records = $query->dbLoadQuery()->loadObjectList('order_id');
		
		$query->clear();
		
		if(empty($records)){
			JRequest::setVar('offset', 0);
			return true;
		}
		
		foreach($records as $order_id => $record)
		{
			$sub_params  = JRegistryFormatXiINI::stringToObject($record->params);
			$invoice_ids = explode(',', $record->invoice_id);
			sort($invoice_ids);
			//delete modifiers
			$query->delete()
				  ->from('#__payplans_modifier')
				  ->where("invoice_id IN ({$record->invoice_id})")
				  ->where("`type` = 'discount'");
				  
			if(!$query->dbLoadQuery()->query()){
				return false;
			}
			
			$query->clear();
			// modifier should not be created if we dont have any discount   
			$insert = ' INSERT INTO `#__payplans_modifier`
									( `user_id`, `invoice_id`, `amount`, `type`, `percentage`, `frequency`, `serial`) ';
			
			$values = '';
			if(isset($sub_params->discount) && $sub_params->discount > 0){
				foreach ($invoice_ids as $invoice_id){
							$values .= "( {$record->user_id}, $invoice_id , 
									  	 -{$sub_params->discount} , 'discount',
									   	  0,'".PayplansModifier::FREQUENCY_EACH_TIME."',".PayplansModifier::FIXED_DISCOUNT.'),';
						}
				if(!empty($values)){
					// remove last character (,)
					$values = substr($values,0,strrpos($values,','));
				}
			}				
			elseif(isset($sub_params->first_price_discount) && $sub_params->first_price_discount > 0){
				$first_invoice = array_shift($invoice_ids);
				$values = "( {$record->user_id}, $first_invoice , 
							-{$sub_params->first_price_discount} , 'discount',
							 0,'".PayplansModifier::FREQUENCY_ONE_TIME."',".PayplansModifier::FIXED_DISCOUNT.')'; 
			}
			// Dont create any Modifier
			if(empty($values)){
				continue;
			}	
			$insert_query = " $insert VALUES  $values ";
			$db->setQuery($insert_query);
			if(!$db->query()){
				return false;
			}
		}
		// For multi-request
		JRequest::setVar('offset', $offset+$limit);
		return true;
	}
	
	/**
	 * Ticket #1589
	 * @param unknown_type $limit
	 * @param unknown_type $offset
	 */
	static function patch_20_015_utilize_wallet_balance($limit, $offset=0)
	{		
		//XiTODO::  Don't hard coded 
		$limit = 2;
		// get a reference to the database
		$db     = XiFactory::getDBO();
		$query  = new XiQuery;
		
		$query->select('T.*')
			  ->from('#__payplans_transaction AS T ')
			  ->innerJoin('#__users AS U ON  T.`user_id` = U.`id`')
			  ->innerJoin('(SELECT *  FROM `#__payplans_wallet` AS W GROUP BY W.`user_id` HAVING sum(W.`amount`) > 0) AS UW ON T.`user_id` = UW.`user_id`')
			  ->where('`current_invoice_id` = 0')
			  ->where('T.`amount` > 0')
			  ->group('T.`user_id`'); 
		// IMP : Group it so we process only one transaction for wallet having balance, 
		// after consuming this transaction if wallet still have balance, 
		// the next time next transaction will be triggered for this user
		
		$transactions = $query->dbLoadQuery()->loadObjectList('transaction_id');

		// Session will give (utilized)transaction id.
		$utilized_ids  = XiHelperPatch::get_session_value(__FUNCTION__,Array());

		foreach ($transactions as $transaction_id){
			if(in_array($transaction_id, $utilized_ids)){
				unset($transactions[$transaction_id]);
			}
		}
		
		if(empty($transactions)){
			XiHelperPatch::clear_session_value(__FUNCTION__);
			JRequest::setVar('offset', 0);
			return true;
		}

		//Applied Patch : Wallet utilization
		$message= XiText::_('COM_PAYPLANS_PATCH_FOR_WALLET_UTILIZATION');

		// limit
		$counter = 0;
		foreach ($transactions as $transaction_id=>$transaction){
			
			$transaction = PayplansTransaction::getInstance($transaction_id,null,$transaction);
			$amount = $transaction->getAmount();
			$args = array($transaction, $amount);
			PayplansHelperEvent::trigger('onPayplansWalletUpdate', $args);

			// prepare logs
//			$current_transaction = PayplansTransaction::getInstance()->load($transaction_id);
//			$content = XiFormatter::writer($transaction, $current_transaction);
//			PayplansHelperLogger::log(XiLogger::LEVEL_INFO, $message,$current_transaction ,$content,'PayplansFormatterLibInvoice');
			$counter++;
			if($counter > $limit){
				break;
			}
			$utilized_ids[] = $transaction_id;
		}
		// transaction ids will be maintained by  Session
		XiHelperPatch::set_session_value( __FUNCTION__, $utilized_ids);
		// For multi-request
		JRequest::setVar('offset', $offset+$limit);
		return true;
	}

	/**
	 * Ticket #1601
	 */
	static function patch_20_016_equate_wallet_balance($limit, $offset=0)
	{		
		$db     = XiFactory::getDBO();
		$query  = new XiQuery;
		
		$query->select(' `user_id`, sum(`amount`) as balance')
			  ->from('#__payplans_wallet')
			  ->group('`user_id`')
			  ->having(" sum(`amount`) < 0 ");

		$records = $query->dbLoadQuery()->loadObjectList('user_id');
		$query->clear();
		
		foreach ($records as $record){
			$query->insert('#__payplans_wallet')
				  ->set(" `amount` = -$record->balance ")
				  ->set(" `user_id` = $record->user_id ")
				  ->set(" `invoice_id` = 0 ")
				  ->set(" `message` = 'COM_PAYPLANS_WALLET_MESSAGE_REFUNDED_FOR_INVOICE' ");
				  
			$query->dbLoadQuery()->query();	
			$query->clear();
		}
		
		return true;
	}
	
	static function patch_20_017_update_order_total($limit, $offset=0)
	{
		// Patch applicable when your system migrated from PayPlans 1.4 to PayPlans 2.0
		if(!XiHelperPatch::isTableExist('bk_payplans_order')){
			return true;
		}
		
		$query = new XiQuery();
		
		$query->update('`#__payplans_order` as new
							 INNER JOIN `bk_payplans_order` as old ON old.`order_id` = new.`order_id`')
			  ->set('new.`total`= old.`subtotal`');
						
		if(!$query->dbLoadQuery()->query()){
			return false;
		}				
		return true;
	}

	/**
	 * update subtotal and total
	 */
	static function patch_20_018_update_invoice_amount($limit, $offset=0)
	{
		// Patch applicable when your system migrated from PayPlans 1.4 to PayPlans 2.0
		if(!XiHelperPatch::isTableExist('bk_payplans_payment')){
			return true;
		}
		
		$query = new XiQuery();
		$query->select(' payment.`order_id` , invoice.`invoice_id`')
			  ->from(' `bk_payplans_payment` AS payment')
			  ->innerJoin(' `#__payplans_invoice` AS invoice ON payment.`order_id` = invoice.`object_id`')
			  ->where(' payment.`status` IN ( 801, 802, 803, 804 ) ')
			  ->group(' invoice.`invoice_id`')
			  ->limit($limit,$offset);
			  
		$records = $query->dbLoadQuery()->loadObjectList('invoice_id');
		$query->clear();
		
		if(empty($records)){
			JRequest::setVar('offset', 0);
			return true;
		}
		
		foreach($records as $invoice_id=>$record){
			$invoice = PayplansInvoice::getInstance($invoice_id);
			$invoice->set('subtotal',$invoice->getPrice());
			$invoice->set('total',$invoice->getTotal());
			$invoice->save();
		}

		JRequest::setVar('offset', $offset+$limit);
		return true;	
	}

	static function patch_20_019_make_transaction_date($limit, $offset=0)
	{
		$query = new XiQuery();
		
		$query->update('`#__payplans_transaction` as T
						 INNER JOIN `#__payplans_invoice` as I ON I.`invoice_id` = T.`current_invoice_id`')
			  ->set('T.`created_date`= I.`created_date`')
			  ->where(" T.`created_date`= '0000-00-00 00:00:00' ")
			  ->where('T.`current_invoice_id` <> 0');
				
		if(!$query->dbLoadQuery()->query()){
			return false;
		}				
		return true;
	}

	static function patch_21_001_remove_formatter_files()
	{
		$folders = array(PAYPLANS_PATH_FORMATTER.DS.'app',PAYPLANS_PATH_FORMATTER);
		foreach ($folders as $folder){
			XiHelperPatch::removeDir($folder);
		}
	}

    static function patch_21_002_remove_module()
	{
		XiHelperPatch::uninstallModule('Setup Checklist', '1');
		XiHelperPatch::uninstallModule('Import Data', '1');
	}
	
	static function patch_21_003_indexing_of_tables()
	{
		if(!XiHelperPatch::dropIndex('#__payplans_modifier', 'idx_user_id')){
			return false;
		}	

		$toBeIndexed = array('#__payplans_wallet' 		=> 'invoice_id',
							 '#__payplans_transaction'	=> 'invoice_id',
							 '#__payplans_modifier'		=> array('user_id', 'invoice_id'));
		$result=true;		
		foreach($toBeIndexed as $table => $columns){
			if(!is_array($columns)){
				$columns = array($columns);
			}
			
			foreach($columns as $column){
				if(!XiHelperPatch::createIndex($table, $column)){
					$result=false;
				}
			}
		}
		
		return $result;
	}
	
	static function patch_21_004_encode_params_userDetail()
	{
		$query  = new XiQuery();
		$apps   = $query->select('*')
		                ->from('`#__payplans_app`')
		                ->where('`type` = "userdetail"')
		                ->dbLoadQuery()
		                ->loadAssocList();
		// encode param 'additional'
		foreach ($apps as $app){
			$app_params 			  = PayplansHelperParam::iniToArray($app['app_params']);
			$app_params['additional'] = base64_encode($app_params['additional']);
			$app['app_params']        = PayplansHelperParam::arrayToIni($app_params);
			PayplansFactory::getInstance('app', 'model')->save($app,$app['app_id']);
		}        
		        
	}

	static function patch_21_005_remove_dummy_invoices()
	{
		$invoices = XiFactory::getInstance('invoice','model')->loadRecords();
		foreach ($invoices as $invoice)
		{
			if(!(PayplansOrder::getInstance($invoice->object_id))){
				PayplansInvoice::getInstance($invoice->invoice_id,null,$invoice)->delete();
			}
		}
		return true;
	}
	
	static function patch_21_006_indexing_of_subscription_tables()
	{
		$table  = '#__payplans_subscription';
		$column = 'user_id';
		if(!XiHelperPatch::createIndex($table, $column)){
			return false;
		}
		
		return true;
	}

	static function patch_21_007_add_upgrade_params_in_orders($limit, $offset=0)
	{
		$query = new XiQuery();
		
		$query = $query->select('order_id')
						->select('params')
						->from('#__payplans_order')
						->limit($limit, $offset);
									
		//Step 1 :- get all orders
		$records = $query->dbLoadQuery()->loadObjectList('order_id');
		$query->clear();
		
		if(empty($records)){
			JRequest::setVar('offset', 0);
			return true;
		}

		foreach($records as $order_id => $record)
		{
			// Step 2 :- get new order params
			$order_params  = JRegistryFormatXiINI::stringToObject($record->params);
			if(isset($order_params->upgrading_from) && $order_params->upgrading_from){
				// Step 3 :- get subscription which is related with new order
				$new_sub_id =  $query->select('subscription_id')
									->from('#__payplans_subscription')
									->where('`order_id`='.$order_id)
									->dbLoadQuery()
									->loadResult();
				$query->clear();
				
				// Step 4 :- convert old subscription key into id 
				$old_sub_id 					= intval(XiHelperUtils::getIdFromKey($order_params->upgrading_from));
				$order_params->upgrading_from 	= $old_sub_id;
				$order_params					= JRegistryFormatXiINI::objectToString($order_params,null);
				
				// Step 5 :- Now get old order and its params
				$query->select('order_id')
					->select('params')
					->from('#__payplans_order')
					->where("`order_id` IN (select `order_id` from `#__payplans_subscription` where `subscription_id` =$old_sub_id)");

				$old_order = $query->dbLoadQuery()->loadObject();
				$query->clear();
				
				// if previous order do not find then update new order params and continue. 
				if(empty($old_order)){
					// Update new order params
					$query->update('#__payplans_order')
							->set("params='$order_params'")
							->where("order_id=$order_id");
					if(!$query->dbLoadQuery()->query()){
						return false;
					}
					$query->clear();
					continue;
				}
				
				$old_order_params 			   = JRegistryFormatXiINI::stringToObject($old_order->params);
				$old_order_params->upgraded_to = intval($new_sub_id);
				$old_order_params			   = JRegistryFormatXiINI::objectToString($old_order_params, null);
				
				// Step 6 :- Update old order params
				$query->update('#__payplans_order')
					->set("params='$old_order_params'")
					->where("order_id=$old_order->order_id");
				
				if(!$query->dbLoadQuery()->query()){
					return false;
				}
				$query->clear();
				
				// Step 7 :- Update new order params
				$query->update('#__payplans_order')
						->set("params='$order_params'")
						->where("order_id=$order_id");
				
				if(!$query->dbLoadQuery()->query()){
					return false;
				}
				$query->clear();
				
			}
		}
		
		JRequest::setVar('offset', $offset+$limit);
		return true;
		
	}

	public static function patch_21_008_utilize_unused_balance()
	{
		//XiTODO::  Don't hard coded 
		$limit = 50;
		// get a reference to the database
		$db     = XiFactory::getDBO();
		$query  = new XiQuery;
		
		$user_sql = (string)$query->select('user_id')
							->from('#__payplans_wallet')
							->group('user_id')
							->having('sum( `amount` ) > 0')
							->limit($limit);
							
		$query->clear();
		$subscriptions = $query->select('*')
								->from('#__payplans_subscription')
								->where('user_id IN ('. $user_sql .')')
								->where('status = '.PayplansStatus::SUBSCRIPTION_EXPIRED)
								->dbLoadQuery()
								->loadObjectList();

		foreach($subscriptions as $subscription){
			$params = PayplansHelperParam::iniToArray($subscription->params);
			
			// if expiration type is not recurringthen continue
			if(!isset($params['expirationtype']) 
					|| !in_array($params['expirationtype'], array('recurring', 'recurring_trial_1', 'recurring_trial_2'))){
				continue;											 	
			}
			
			if(!isset($params['recurrence_count']) || $params['recurrence_count'] != 0){
				continue;
			}
			
			$query->clear();
			$query->update('#__payplans_subscription')
					->set('status = '. PayplansStatus::SUBSCRIPTION_ACTIVE)
					->where('subscription_id = '. $subscription->subscription_id)
					->dbLoadQuery()
					->query();			
		}
		
		PayplansHelperCron::doSubscriptionExpiry();
		return true;
	}
	
	public static function patch_21_009_update_config_param()
	{
		$display_order_status = XiFactory::getConfig()->order_status;
		$display_order_status = is_array($display_order_status) ? $display_order_status : array($display_order_status);
		if(isset($display_order_status)){
			
			// Step 1 :- create mapper for subscription and order status
			$status_mapper = array('0' => '0',
									'301' => '0',
									'302' => '1601',
									'303' => '1601',
									'304' => '1602',
									'305' => '1603',
									'306' => '1601'
								);
			// Step 2 :- collect proper subscription status 
			$display_subscription_status = array();
			foreach ($display_order_status as $order_status){
					$display_subscription_status[] = $status_mapper[$order_status];
			}
			
			$display_subscription_status = array_values(array_unique($display_subscription_status));
			
			// Step 3 :- save order_status and subscription_status
			PayplansConfig::getInstance(PAYPLANS_CONFIG_CUSTOMIZATION)
						->bind(array('config'=>array('subscription_status'=>$display_subscription_status)))
						->bind(array('config'=>array('order_status'=>array('0'))))
						->save();
		}
	}
	
	public static function patch_22_001_alter_log_table()
	{
		$db     	= XiFactory::getDBO();
		$sql 		= 'show columns from #__payplans_log';
		$db->setQuery($sql);

		$columns = $db->loadColumn();

		if(!in_array('read', $columns)){
			$sql 	= "ALTER table ". $db->quoteName('#__payplans_log')
		 		 	." ADD `read` tinyint(1) DEFAULT '0'";
	     		$db->setQuery($sql);
			
			if(!$db->query()){
				return false;
			}
		}
		 return true;
	}
	
	public static function patch_22_002_uninstall_charts_module()
	{
		return XiHelperPatch::uninstallModule('mod_payplans_chart');
	}
	
	public static function patch_23_001_uninstall_search_module()
	{
		return XiHelperPatch::uninstallModule('mod_payplans_search');
	}
	
}
