<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		shyam@readybytes.in
*/
if(defined('_JEXEC')===false) die();

/**
 * Base class for all payplans-apps who have multiple instances
 * @author Meenal Devpura
 *
 */
class PayplansConfig extends XiLib
{
	protected	$config_id	 = 0 ;
	protected	$title		 = '';
	protected	$key		 = '';
	protected	$componentname   = XI_COMPONENT_NAME;
	protected	$path		 = '';

	/**
	 * @var XiParameter
	 */
	protected $config	= 	null;

	/**
	 * @return PayplansConfig
	 * @param string $dummy is added just for removing warning with development mode(XiLib::getInstance is having 4 parameters)
	 */
	static public function getInstance($id=0, $type=null, $bindData=null,$dummy=null)
	{
		return parent::getInstance('config',$id, $type, $bindData);
	}
	
	public function bind($data, $ignore=array())
	{
		if(is_object($data)){
			$data = (array) ($data);
		}

		// Only load when its not already set
		if($this->config === null){
			$xmlPath = JPATH_ROOT .DS. $data['path'];
			XiError::assert(isset($xmlPath), "$xmlPath NOT SET");
			$this->config = PayplansHelperParam::getParamObject($xmlPath);
		}

		return parent::bind($data, $ignore);
	}

	// Reset to construction time.
	public function reset($config=array())
	{
		$this->config_id	 = 0 ;
		$this->title		 = '';
		$this->key		 	 = '';
		$this->config		 = null;
		$this->componentname = XI_COMPONENT_NAME;
		$this->path	 	 	 = '';

		return $this;
	}
	
	public function getTitle()
	{
		return $this->title;
	}
	
	public function getKey()
	{
		return $this->key;
	}
	
	public function getPath()
	{
		return $this->path;
	}
	
	public function getConfig()
	{
		return $this->config;
	}
	
	public function getComponentname()
	{
		return $this->componentname;
	}
	
	public function renderToArray($key= null)
	{
		return $this->config->renderToArray($key);
	}
}

class PayplansConfigFormatter extends PayplansFormatter
{
	function reader($content)
	{
		$content = unserialize(base64_decode(array_shift($content)));
		
		if(is_array($content) && (array_key_exists('previous', $content) || array_key_exists('current', $content)))
		{
			return $content;
		}
		
		return false;
	}

	function getIgnoredata()
	{
		$ignore = array('dbtype', 'host', 'user', 'password', 'db', 'dbprefix', 'ftp_host', 'ftp_port',
						 'ftp_user', 'ftp_pass', 'ftp_root', 'ftp_enable', 'tmp_path', 'log_path', 'mailer', 
						 'mailfrom', 'fromname', 'sendmail', 'smtpauth', 'smtpsecure', 'smtpport', 'smtppass', 
						 'smtpuser', 'smtphost', 'debug', 'caching', 'cachetime', 'language', 'secret', 'editor',
						 'offset', 'lifetime', 'offline', 'offline_message', 'sitename', 'list_limit', 'legacy', 
						 'debug_lang', 'live_site', 'gzip', 'error_reporting', 'helpurl', 'xmlrpc_server', 'force_ssl',
						 'offset_user', 'cache_handler', 'MetaDesc', 'MetaTitle', 'MetaKeys' ,'MetaAuthor', 'sef', 
						 'sef_rewrite', 'sef_suffix', 'feed_limit', 'feed_email', 'session_handler', 'memcache_settings','jpayplansPassword' );
		return $ignore;
	}
	
	// get rules to apply
	function getVarFormatter()
	{
		$rules = array( 'order_status'      => array('formatter'=> 'PayplansOrderFormatter',
										       	   'function' => 'getOrderStatusName')
						);
		return $rules;
	}
}
