<?php
/**
 * @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * @package		PayPlans
 * @subpackage	Frontend
 * @contact 		shyam@readybytes.in
 */
if(defined('_JEXEC')===false) die();
?>
<div class="pp-grid_12 pp-secondary pp-color pp-left">
	<h3 class="contentheading pp-heading pp-secondary pp-color pp-background pp-border">
		<?php echo XiText::_('COM_PAYPLANS_ORDER_CONFIRM_ORDER_SUMMARY');?>
	</h3>
		
	<div class="pp-name pp-grid_5 ">
		<?php echo $invoice->getTitle(); ?>
	</div>
		
	<?php $regular_counter = $invoice->getCounter();
			if ($recurring === PAYPLANS_RECURRING_TRIAL_1) :
				$regular_counter = $invoice->getCounter() + 1;
			elseif($recurring === PAYPLANS_RECURRING_TRIAL_2):
				$regular_counter = $invoice->getCounter() + 2;
			endif;
	?>
	
	<div class="pp-price pp-grid_7 ">
			<span class="pp-float-left pp-grid_3 pp-first-amount">
				<?php $amount = $invoice->getPrice($regular_counter);?>
				<?php echo $this->loadTemplate('partial_amount', compact('currency', 'amount'));?>	
			</span>
			<span class="pp-prefix_1 pp-grid_6 pp-suffix_2"><?php echo ($recurring)? XiText::_('COM_PAYPLANS_PLAN_PRICE_TIME_SEPERATOR') : XiText::_('COM_PAYPLANS_PLAN_PRICE_TIME_SEPERATOR_FOR') ;?>&nbsp;
			<?php echo PayplansHelperFormat::planTime($invoice->getExpiration()); ?>
			</span>
	</div>
	
	<div class="clear"></div>

	<div class="pp-description pp-prefix_5 pp-grid_7 pp-primary pp-reverse pp-color">
			<?php $class = (!in_array($recurring, array(PAYPLANS_RECURRING_TRIAL_1, PAYPLANS_RECURRING_TRIAL_2))) 
								? " hide " : " show ";?>
			
			<div class="<?php echo $class; ?>">
				<!-- for recurring plans -->
				<?php if ($recurring) :?>
					<!-- plan have trials -->	
					<?php if(in_array($recurring, array(PAYPLANS_RECURRING_TRIAL_1, PAYPLANS_RECURRING_TRIAL_2))) :?>
							<span class="pp-first-amount">
								<?php $amount = $invoice->getPrice();?>
								<?php echo $this->loadTemplate('partial_amount', compact('currency', 'amount'));?>	
							</span>
							<span class=""> <?php echo XiText::sprintf('COM_PAYPLANS_ORDER_CONFIRM_FIRST_CHARGABLE_AMOUNT', PayplansHelperFormat::planTime($invoice->getExpiration(PAYPLANS_RECURRING_TRIAL_1)));?></span>
						<!-- plan have 2 trials -->	
						<?php if($recurring === PAYPLANS_RECURRING_TRIAL_2) :?>
							<span class="pp-second-amount">
								<?php $amount = $invoice->getPrice($invoice->getCounter() + 1);?>
								<?php echo $this->loadTemplate('partial_amount', compact('currency', 'amount'));?>	
							</span>
							<span class=""> <?php echo XiText::sprintf('COM_PAYPLANS_ORDER_CONFIRM_SECOND_CHARGABLE_AMOUNT', PayplansHelperFormat::planTime($invoice->getExpiration(PAYPLANS_RECURRING_TRIAL_2)));?></span>
						<?php endif;?>
						
					<?php else :?>
						<!-- plan do not have trials -->
						<span><?php echo XiText::sprintf('COM_PAYPLANS_ORDER_CONFIRM_FIRST_TRIAL_AMOUNT', PayplansHelperFormat::planTime($invoice->getExpiration()));?></span>	
					<?php endif;?>
				<?php endif;?>	
			</div>
			
			<?php if($recurring):?>
				<?php $recurrence_count = $invoice->getRecurrenceCount();?>
				<?php $amount = $invoice->getPrice($regular_counter);?>
				<?php $amountHtml =  $this->loadTemplate('partial_amount', compact('currency', 'amount'));?>	
								
				<?php if($recurrence_count <= 0 ) :?>
					<span><?php echo XiText::sprintf('COM_PAYPLANS_ORDER_CONFIRM_FIRST_RECURRENCE_COUNT_ZERO_RECURRENCE_COUNT',$amountHtml,PayplansHelperFormat::planTime($invoice->getExpiration()));?></span>
				<?php else:?>
					<span><?php echo XiText::sprintf('COM_PAYPLANS_ORDER_CONFIRM_FIRST_RECURRENCE_COUNT',$amountHtml,PayplansHelperFormat::planTime($invoice->getExpiration()), $recurrence_count);?></span>
				<?php endif;?>
			<?php endif; ?>	
	</div>
	
	<div class="clear"></div>
	
	<?php $position = 'product-details'; ?>
	<?php echo $this->loadTemplate('partial_position', compact('plugin_result','position'));?>
	
	<div class="pp-invoice-calculation pp-secondary pp-reverse pp-light pp-color clearfix pp-alpha pp-omega">
	
		<div class="pp-subtotal clearfix" >
			<label class="pp-label pp-grid_5"><?php echo XiText::_('COM_PAYPLANS_ORDER_CONFIRM_SUBTOTAL');?></label>
			<span class="pp-grid_7">
				<?php $amount = $subtotal;?>
				<?php echo $this->loadTemplate('partial_amount', compact('currency', 'amount'));?>
			</span>
		</div>
	
		<div class="pp-discount clearfix">
			<label class="pp-label pp-grid_5"><?php echo XiText::_('COM_PAYPLANS_ORDER_CONFIRM_DISCOUNT');?>&nbsp;(-)</label>
			<span class="pp-grid_7 discount-amount">
				<?php $amount = $discount;?>
				<?php echo $this->loadTemplate('partial_amount', compact('currency', 'amount'));?>
			</span>
		</div>
		
		
		<div class="pp-tax clearfix">
			<label class="pp-label pp-grid_5"><?php echo XiText::_('COM_PAYPLANS_ORDER_CONFIRM_TAX');?>&nbsp;(+)</label>
			<span class="pp-grid_7 tax-amount">
				<?php $amount = $tax_amount;?>
				<?php echo $this->loadTemplate('partial_amount', compact('currency', 'amount'));?>
			</span>
		</div>
	
		<div class="clearfix pp-hr pp-secondary pp-color pp-border"></div>
	
		<div class="pp-payable clearfix pp-secondary pp-color">
			<label class="pp-label pp-grid_5"><?php echo XiText::_('COM_PAYPLANS_ORDER_CONFIRM_AMOUNT_PAYABLE');?></label>
			<div class="pp-grid_7">
				<span class="payable first-amount">
					<?php $amount = $total;?>
					<?php echo $this->loadTemplate('partial_amount', compact('currency', 'amount'));?>
				</span>
			</div>
		</div>
		
		<div class="pp-total clearfix pp-secondary pp-color">
			<label class="pp-label pp-grid_5"><?php echo XiText::_('COM_PAYPLANS_ORDER_CONFIRM_REGULAR_TOTAL');?></label>
			<div class="pp-grid_7">
				<span class="regular-amount">
					<?php $amount = $invoice->getPrice($regular_counter);?>
					<?php echo $this->loadTemplate('partial_amount', compact('currency', 'amount'));?>
				</span>
			</div>
		</div>
	</div>

	
	<div class="pp-position clearfix">
		<?php if(XiFactory::getConfig()->enableDiscount): ?>
				<?php echo $this->loadTemplate('discount'); ?>
	    <?php endif;?>
		
		<?php $position = 'payplans_order_confirm_payment'; ?>
		<?php echo $this->loadTemplate('partial_position', compact('plugin_result','position'));?>
	</div>
	
	<div class="pp-payments">	
		<div class="pp-methods clearfix">
			<label class="pp-grid_5 pp-title" ><?php echo XiText::_('COM_PAYPLANS_ORDER_MAKE_PAYMENT_FROM');?></label>
			<span class="pp-grid_7 pp-value"><?php echo (!($invoice->isRecurring()) && (floatval(0) == floatval($total))) ? XiText::_('COM_PAYPLANS_ORDER_NO_PAYMENT_METHOD_NEEDED') : PayplansHtml::_('select.genericlist', $payment_apps, 'app_id', '' , 'id', 'title');?></span>
		</div>
		
		<div class="pp-prefix_4 pp-grid_5 pp-suffix_3 pp-paynow clearfix pp-primary pp-reverse pp-light pp-color pp-border pp-background">
			<input type="hidden" name="payplans_invoice_confirm" value="1" />
			<input type="hidden" name="invoice_key" value="<?php echo $invoice->getKey();?>" />
			
			<button type="submit" id="payplans-order-confirm" class="pp-button ui-widget-icon">
				<i class="pp-icon-shopping-cart"></i>
				<?php echo XiText::_('COM_PAYPLANS_ORDER_CONFIRM_BTN')?>
			</button>
		</div>
	</div>

	<div class="clear"></div>
</div>
<div class="clear"></div>
<?php 
