<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		shyam@readybytes.in
*/
if(defined('_JEXEC')===false) die();

class PayplanssiteViewDashboard extends XiView
{
	function _displayList()
	{
		return true;
	}

	function display($tpl=null)
	{
		return true;
	}

	function _basicFormSetup()
	{
		// which template to load in main section
		$this->set('dashboard_main_template', $this->getTpl());
		$this->set('dashboard_messages', XiFactory::getDashboardMessage());
		
		$this->setTpl(null);
		
		return true;
	}
	
	public function noaccess()
	{
		return true;
	}
	
	public function frontview()
	{
		$userId = XiFactory::getUser()->id ;
		$user = PayplansUser::getInstance($userId);
		
		$allowedStatus = XiFactory::getConfig()->subscription_status;
		$allStatus	= array(PayplansStatus::NONE, PayplansStatus::SUBSCRIPTION_ACTIVE, PayplansStatus::SUBSCRIPTION_HOLD, PayplansStatus::SUBSCRIPTION_EXPIRED);
		
		// if there is not set any subscription status at configuartion then collect records according to all subscription status
		if(!isset($allowedStatus) || empty($allowedStatus)){
			$allowedStatus = $allStatus;
		}

		$allowedStatus =  is_array($allowedStatus) ? $allowedStatus : array($allowedStatus);
		$filter       = array('user_id' => $userId , 'status' =>array(array('IN', '('.implode(",", $allowedStatus).')')));
		$subscriptionRecords = XiFactory::getInstance('subscription','model')->loadRecords($filter);
		$this->assign('subscription_records', $subscriptionRecords);
		$this->assign('user', $user);
		
		$widget = new XiWidget();
		$widget->id($userId);
		$widget->setOption('title',XiText::_('COM_PAYPLANS_DASHBOARD_SUBSCRIPTION'));
		if(!$userId){
			$html= $this->loadTemplate('widget_order_nonsubscriber');
		}
		else{
			$html = $this->loadTemplate('widget_order');
		}
			
		$widget->html($html);
	    $this->assign('widget_html', $widget->draw());
	    
		//XiTODO: ask widget related parameters from configuration
 	    if(XiFactory::getConfig()->walletWidget && $userId){
	    	$this->walletWidget($user, $userId);
	    }

	    return true;
	}
	
	public function walletWidget($user, $userId)
	{
		$walletBalance = $user->getWalletBalance();
		$currency = XiFactory::getCurrency(XiFactory::getConfig()->currency);
		$currency = PayplansHelperFormat::currency($currency);
		$walletWidget = new XiWidget();
		$walletWidget->id('Wallet Balance'.$userId);
		$walletWidget->setOption('style_class', 'pp-wallet-widget-balance');
		$walletWidget->setOption('title', XiText::_('COM_PAYPLANS_DASHBOARD_WALLET_DETAILS'));
		$walletWidget->setOption('class_suffix', ' pp-dashboard-alert pp-dashboard-alert-info pp-secondary pp-border pp-color clearfix');
		$position = 'payplans-dashboard-right';
		$this->assign('currency', $currency);
		$this->assign('wallet_balance', $walletBalance);
		$walletHtml= $this->loadTemplate('widget_balance');
		$walletWidget->html($walletHtml);
	    $this->assign('plugin_result',  array($position => $walletWidget->draw()));
	} 
	
}