<?php

/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	Helpdesk
* @contact		payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Helpdesk Plugin
 */
class plgPayplansHelpdesk extends XiPlugin
{
	const DO_NOTHING = -1;
	const ALLOWED 	 =  1;
	const BLOCKED    =  0;
     public function onPayplansSystemStart()
	{
		//add helpdesk app path to app loader
		$appPath = dirname(__FILE__).DS.'helpdesk'.DS.'app';
		PayplansHelperApp::addAppsPath($appPath);

		return true;
	}
	function onContentPrepare($context, &$row, &$params, $page = 0)
	{
		if(!is_a($row,'stdClass')){
			return false;
		}

		$option		 = JRequest::getVar('option',      false);
		$task		 = JRequest::getVar('task',        false);
		$id          = JRequest::getVar('id',        false);
				
		if($option=='com_maqmahelpdesk' && $task=='kb_view'){
			$userid 	= XiFactory::getUser()->id;
			$user = PayplansUser::getInstance($userid);
		    if($user->isAdmin()){
				return true;
			}
			if(array_key_exists($userid, $this->getSupportStaff())){
				return true;
			}
			$userSubs  = $user->getPlans();
			$knowledgebaseaclApp = PayplansHelperApp::getAvailableApps('knowledgebaseacl');
			foreach ($knowledgebaseaclApp as $app){
				$allowedkb=$app->getAppParam('knowledgebaseacl',0);
				if ($allowedkb=='0'){
						return  true;
				}
				$allowedkb = is_array($allowedkb) ? $allowedkb : array($allowedkb);		
				if(in_array($id,$allowedkb )){
					$allowedOrNot = $this->_isUserAllowed($app,$userid,$userSubs);
					if($allowedOrNot == self::ALLOWED){
						return true;
				    }
					if($allowedOrNot == self::BLOCKED){
						$url  = XiRoute::_('index.php?option=com_payplans&view=plan');
						if(strpos($row->text,'<hr id='.'"system-readmore" />') == false){
							$row->text = "<a href='$url'>".XiText::_('COM_PAYPLANS_APP_KNOWLEDGEBASEACL_SUBSCRIBE_TO_READ')."</a>";
							return true;
						}
						$displaydata = explode('<hr id='.'"system-readmore" />', $row->text); 
						$row->text = $displaydata[0]."<a href='$url'>".XiText::_('COM_PAYPLANS_APP_KNOWLEDGEBASEACL_SUBSCRIBE_TO_READ_MORE')."</a>";
						return true;
					}	
				}	
		   	}
		}
		return true;
	}
	
	// checks whether user is allowed to access the content or not.
		function _isUserAllowed($app,$userid,$userSubs)
	{	
		$plans 	    = $app->getPlans();
		if(!$userid){
			$checkplans = empty($plans);
			
			// If no user is login and app is not applicable on all plans , then return true if no plans are mentioned.
		if( ($app->getParam('applyAll',false)==false) && $checkplans){
			return true;
			}
			return false;
		}
				
		// return false when user is non-subscriber
		if(empty($userSubs)){
			return false;
		}
		
		// return true when app is core app,
		// no need to check whether plan is attached with this app or not
		if($app->getParam('applyAll',false) != false){
			return true;
		}
		else {
			if(empty($plans)){
				return true;
				}
		// if user have an active subscription of the plan attached with the app then return true
			foreach($userSubs as $sub){
				if(in_array($sub, $plans)){
					return true;
				}
			}
		}

		return false;
	}
	
   // Get user id of support staff
	function  getSupportStaff()
	{
		$query = new XiQuery();
		return $query->select('*')
					 ->from('`#__support_permission`')
					 ->dbLoadQuery()
					 ->loadObjectList('id_user');
	}
}
