<?php
/**
* @copyright	Copyright (C) 2009 - 2012 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @contact 		payplans@readybytes.in
*/	


// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

class JElementXiList extends XiElement
{
	/**
	 * Element type
	 *
	 * @var    string
	 */
	protected $_name = 'Xilist';

	/**
	 * Get the options for the element
	 *
	 */
	
	protected function _getOptions(&$node)
	{
		$options = array();
		foreach ($node->children() as $option)
		{
			$val  = $option->attributes('value');
			$text = $option->data();
			$options[] = PayplansHtml::_('select.option', $val, JText::_($text));
		}
		return $options;
	}

	public function fetchElement($name, $value, &$node, $control_name)
	{
		$ctrl = $control_name . '[' . $name . ']';
		$attribs = ' ';

		if ($v = $node->attributes('size'))
		{
			$attribs .= 'size="' . $v . '"';
		}
		if ($v = $node->attributes('class'))
		{
			$attribs .= 'class="' . $v . '"';
		}
		else
		{
			$attribs .= 'class="inputbox"';
		}
		if ($m = $node->attributes('multiple'))
		{
			$attribs .= 'multiple="multiple"';
			$ctrl .= '[]';
		}

		return XiHtml::_(
			'select.genericlist',
			$this->_getOptions($node),
			$ctrl,
			array('id' => $control_name . $name, 'list.attr' => $attribs, 'list.select' => $value)
		);
	}
}

class JFormFieldXiList extends XiField
{
	public $type = 'Xilist'; 
}
